#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 19);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return b;
}

void Solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <int>> g(n);
	vector <ll> c(n);
	for (int i = 0; i < n; i++)
		cin >> c[i];
	for (int i=0;i < m ;i++ ){
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].push_back(b);
	}
	ll ans = 0;

	for (int mask = 0; mask < (1 << n); mask++) {
		ll s = 0;
		for (int j = 0; j < n; j++) {
			if (mask & (1 << j)) {
				for (int i : g[j]) {
					s += c[i];
				}
			}
		}
		ans = gcd(ans, s);
	}
	cout << ans;
}

int main() {
	IOOptimize();
	int t;
	cin >> t;
	for (int i =0; i < t; i++)
		Solve();
}