#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int maxn = 5e5 + 1000;
const ll alpha = 29;

void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector<ll> mod = {(ll) 1e9 + 7, (ll) 1e9 + 9};
ll deg[2][maxn];
int lastpok[maxn];

struct ST {
    vector<vector<int>> st;

    ST(vector<int> &foo) {
        int n = foo.size();
        st.resize(lastpok[n] + 1, vector<int>(n, 0));
        st[0] = foo;
        for (int lev = 1; lev < st.size(); lev++) {
            for (int i = 0; i + (1 << lev) <= n; i++) {
                st[lev][i] = min(st[lev - 1][i], st[lev - 1][i + (1 << (lev - 1))]);
            }
        }
    }

    int getmin(int l, int r) {
        int len = r - l;
        int lev = lastpok[len];
        int deg = (1 << lev);
        return min(st[lev][l], st[lev][r - deg]);
    }
};


struct String {
    vector<int> H[2];

    String(string &s) {
        for (int i = 0; i < 2; i++) {
            int n = s.size();
            H[i].resize(n + 1);
            for (int j = 0; j < n; j++) {
                H[i][j + 1] = (H[i][j] * alpha + s[j] - 'a' + 1) % mod[i];
            }
        }
    }

    pair<ll, ll> geth(int l, int r) {
        vector<ll> ans(2);
        for (int i = 0; i < 2; i++) {
            ans[i] = (H[i][r] - (H[i][l] * deg[i][r - l]) % mod[i] + mod[i]) % mod[i];
        }
        return {ans[0], ans[1]};
    }
};

ll myrand() {
    ll ran = rand();
    return (ran << 16) ^ rand();
}

void precalc() {
    for (int i = 0; i < 2; i++) {
        deg[i][0] = 1;
        for (int j = 1; j < maxn; j++) {
            deg[i][j] = (deg[i][j - 1] * alpha) % mod[i];
        }
    }
    for (int i = 0; (1 << i) < maxn; i++) {
        lastpok[1 << i] = i;
    }
    for (int i = 1; i < maxn; i++) {
        if (lastpok[i] == 0)
            lastpok[i] = lastpok[i - 1];
    }
}

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

int main() {
    init();
    precalc();

    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<int>> g(n);
        vector<ll> a(n);
        for (auto &ev: a)
            cin >> ev;

        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            u--, v--;
            g[u].pb(v);
        }
        ll ans = -1;
        for (int mask = 1; mask < (1 << n); mask++){
            vector<int> cur;
            for (int i = 0; i< n; i++){
                if ((mask & (1 << i)) > 0)
                    cur.pb(i);
            }
            vector<bool> used(n, false);
            ll sum = 0;
            for (auto ev: cur)
                for (auto v: g[ev]){
                    if (used[v])
                        continue;
                    used[v] = true;
                    sum += a[v];
                }
            if (ans == -1){
                ans = sum;
                continue;
            }
            ans = gcd(ans, sum);
            if (ans == 1)
                break;
        }
        cout << ans << endl;
    }
    return 0;
}