#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) solve();
}

int n, m;
vector<vector<int>> g;
vector<int> u;
vector<ll> c;

ll calc(int mask) {
    ll res = 0;

    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            for (auto &j: g[i]) {
                if (u[j] < mask) {
                    res += c[j];
                }
                u[j] = mask;
            }
        }
    }

    return res;
}

void solve() {
    g.clear();
    u.clear();
    c.clear();

    cin >> n >> m;
    g.resize(n);
    u.resize(n);
    c.resize(n);

    for (auto &i: c) cin >> i;

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
    }

    int mask_end = 1 << n;
    ll ans = 0;

    for (int i = 1; i < mask_end; ++i) {
        ans = __gcd(ans, calc(i));
    }

    cout << ans nl;
}
