#include <iostream>
#include <vector>
#include <algorithm>

#pragma GCC optimization("Ofast")

using namespace std;
using ll = long long;

void rec(const vector <vector <int>> &g, const vector <ll> &c, vector <bool> &used, vector <ll> &sums, int ind)
{
    if (ind == g.size())
    {
        vector <bool> u(c.size(), false);
        sums.push_back(0);
        for (int i = 0; i < used.size(); ++i)
            if (used[i])
                for (int v : g[i])
                    if (!u[v])
                    {
                        sums.back() += c[v];
                        u[v] = true;
                    }
    }
    else
    {
        rec(g, c, used, sums, ind + 1);
        used[ind] = true;
        rec(g, c, used, sums, ind + 1);
        used[ind] = false;
    }
}

ll gcd(ll a, ll b)
{
    while (b != 0)
    {
        ll r = a % b;
        a = b;
        b = r;
    }

    return a;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int t = 0;
    cin >> t;
    while (t--)
    {
        int n = 0, m = 0;
        cin >> n >> m;
        vector <ll> c(n);
        for (int i = 0; i < n; ++i)
            cin >> c[i];
        vector <vector <int>> g(n);
        for (int i = 0; i < m; ++i)
        {
            int u = 0, v = 0;
            cin >> u >> v;
            --u, --v;
            g[u].push_back(v);
        }

        vector <ll> sums;
        vector <bool> used(n, false);
        rec(g, c, used, sums, 0);

        ll ans = sums[0];
        for (int i = 1; i < sums.size(); ++i)
            ans = gcd(sums[i], ans);

        cout << ans << '\n';
    }

    return 0;
}