#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
ll GCD(ll x, ll y) {
	return (x == 0 ? y : GCD(y%x, x));
}
const int MAXN = 25; //5007;
bitset<MAXN> G[MAXN], cur;
vector<int> cover[MAXN];
ll c[MAXN];
int n, m;
void solve() {
	cin >> n >> m;
	for(int i = 0; i < n; ++i) {
		cin >> c[i];
		G[i].reset();
		cover[i].clear();
	}
	for(int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		G[v][u] = 1;
		cover[u].emplace_back(v);
	}
	ll answ = 0;
	/*for(int u = 0; u < n; ++u) {
		cur.set();
		for(auto& v: cover[u]) cur &= G[v];
		ll sum = 0;
		for(int i = 0; i < n; ++i) if(cur[i]) sum += c[i];
		answ = GCD(answ, sum);
	}*/
	for(int msk = 1; msk < (1 << n); ++msk) {
		cur.set();
		for(int v = 0; v < n; ++v) {
			if((msk>>v)&1) cur &= G[v];
		}
		ll sum = 0;
		for(int u = 0; u < n; ++u) if(cur[u]) sum += c[u];
		answ = GCD(answ, sum);
	}
	cout << answ << '\n';
}
int main() {
	fastIO();
	int T; cin >> T;
	while(T--) {
		solve();
	}
	return 0;
}
