#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;

const long long Q = 2286661337, p = 1e6 + 3;

long long gcd(long long a, long long b) {
	return (b == 0 ? a : gcd(b, a % b));
}

long long get_hash(vector <int>& a) {
	long long ans = 0;
	sort(a.begin(), a.end());
	for (auto u : a)
		ans = (ans * p + u) % Q;
	return ans;
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int n, m;
		cin >> n >> m;
		vector <long long> c(n);
		for (auto& u : c)
			cin >> u;
		vector <vector <int>> G(n);
		for (int i = 0; i < m; i++) {
			int u, v;
			cin >> u >> v, u--, v--;
			G[v].emplace_back(u);
		}
		map <long long, long long> sums;
		for (int i = 0; i < n; i++) {
			if (G[i].size())
				sums[get_hash(G[i])] += c[i];
		}
		long long ans = 0;
		for (auto u : sums)
			ans = gcd(ans, u.second);
		cout << ans << '\n';
	}
}