#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>


using namespace std;


#define int long long


int gcd(int a, int b) {
    int t;
    while (b) {
        t = a;
        a = b;
        b = t % b;
    }

    return a;
}


const int MAXN = 5e5 + 5;


const int M = (int)1e9 + 7;
const int P = 179;

int PPOW[MAXN];


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


signed main() {
    PPOW[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        PPOW[i] = PPOW[i - 1] * P % M;
    }

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while (t--) {
        int n, m;
        cin >> n >> m;

        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }

        vector<int> hs(n);

        int from, to;
        for (int i = 0; i < m; ++i) {
            cin >> from >> to;

            --from;
            --to;

            hs[to] = (hs[to] + (from + 1) * PPOW[from]) % M;
        }

        map<int, vector<int>> cls;
        for (int i = 0; i < n; ++i) {
            cls[hs[i]].push_back(i);
        }

        vector<int> sums;

        for (auto p : cls) {
            int cs = 0;
            for (int x : p.second) {
                cs += a[x];
            }

            sums.push_back(cs);
        }

        int answ = 0;
        for (int x : sums) {
            answ = gcd(answ, x);
        }

        cout << answ << '\n';
    }

    return 0;
}
