#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <iterator>
#include <iomanip>
#include <utility>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <climits>
#include <numeric>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
using namespace std;
#define int long long
vector<bool> used, covered;
vector<int> matched;
vector<vector<int>> g;
bool trykuhn(int v) {
	used[v] = true;
	for (auto x : g[v]) {
		if (matched[x] == -1 || !used[matched[x]]) {
			used[x] = true;
			if (matched[x] == -1 || trykuhn(matched[x])) {
				matched[x] = v;
				return true;
			}
		}
	}
	return false;
}
struct fenwick {
	int n;
	vector<int> f;
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
	void add(int i, int val) {
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i)
			ans += f[i];
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
};
int gcd(int a, int b) {
	int r;
	while (b != 0) {
		r = a % b;
		a = b;
		b = r;
	}
	return a;
}
void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> c(n);
	for (int i = 0; i < n; ++i) cin >> c[i];
	vector<vector<int>> g(2 * n);
	for (int i = 0; i < m; ++i) {
		int q, w;
		cin >> q >> w;
		--q, --w;
		g[q].push_back(w + n);
		g[w + n].push_back(q);
	}
	int ans = -1;
	for (int mask = 0; mask < (1 << n); ++mask) {
		int sum = 0;
		for (int i = 0; i < n; ++i) {
			for (auto x : g[n + i]) {
				if (mask & (1 << x)) {
					sum += c[i];
					break;
				}
			}
		}
		if (ans == -1) ans = sum;
		else ans = gcd(ans, sum);
	}
	cout << ans << '\n';
	return;
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	srand(time(0));
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}