#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

#define int long long

const int N = 5e5;

int n, m;
int s[N];
set<int> g[N];
bool used[N];

int gcd(int a, int b) {
    return b == 0 ? a : gcd(b, a % b);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        cin >> n >> m;
        for (int i = 0; i < n; ++i) {
            cin >> s[i];
            g[i].clear();
            used[i] = false;
        }
        int ans = 0;
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u;
            --v; --u;
            g[v].insert(u);
            ans += !used[u] * 1LL * s[u];
            used[u] = true;
        }
        for (int v = 0; v < n; ++v) {
            for (int u = 0; u < n; ++u) {
                int cur = 0;
                for (int k = 0; k < n; ++k) {
                    cur += s[k] * (g[v].find(k) != g[v].end() || g[u].find(k) != g[u].end());
                }
                ans = gcd(ans, cur);
            }
        }
        cout << ans << '\n';
    }
    return 0;
}