#include <iostream>
#include <random>
#include <algorithm>
#include <unordered_set>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        run();
    }
}

void run() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gr(n + 1);
    vector<vector<bool>> link(n + 1, vector<bool>(n + 1));
    auto c = arr<long long>(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> c[i];
    }
    int *deg = arr<int>(n + 1, 0);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        gr[u].push_back(v);
        link[u][v] = true;
        deg[v]++;
    }
    auto taken = arr<int>(n + 1, -1);
    auto d = arr<long long>(n + 1, 0);
    for (int u = 1; u <= n; u++) {
        if (!deg[u])
            continue;
        if (taken[u] == -1)
            taken[u] = u;
        d[taken[u]] += c[u];
        for (int v = u + 1; v <= n; v++) {
            bool same = true;
            for (int k = 1; k <= n; k++) {
                if (link[k][u] != link[k][v]) {
                    same = false;
                    break;
                }
            }
            if (!same)
                continue;
            taken[v] = u;
        }
    }
    long long ans = -1;
    for (int v = 1; v <= n; v++) {
        if (d[v] == 0)
            continue;
        ans = ans == -1 ? d[v] : __gcd(ans, d[v]);
    }
    cout << ans << endl;
}