#include <iostream>
#include <time.h>
#include <vector>
using namespace std;

double tt;

const int N = 500000;
vector<int> g[N];
bool used[N];
int c[N];

inline int gcd(int a, int b) {return b ? a ? gcd(b, a % b) : 0 : a;}

void solve(double limit)
{
    //cout << "solving with deadline " << limit << ", on clock " << clock() << '\n';
    int n, m;
    cin >> n >> m;
    //n = rand() % 100 + 1, m = rand() % (n * n / 2 + 1);
    //cout << n << ' ' << m << '\n';
    for (int i = 0; i < n; ++i)
        cin >> c[i];
    for (int i = 0; i < n; ++i)
    {
        vector<int> v;
        g[i].swap(v);
    }
    for (int i = 0; i < m; ++i)
    {
        int u, v;
        cin >> u >> v;
        //u = rand() % n + 1, v = rand() % n + 1;
        //cout << u << ' ' << v << '\n';
        g[--u].push_back(--v);
    }
    int u = 0;
    while (clock() < limit && u - 1)
    {
        fill(used, used + n, false);
        bool ok = false;
        for (int i = 0; i < n; ++i)
        {
            if (rand() % 2 || i == n - 1 && !ok)
            {
                ok = true;
                for (int y: g[i])
                    used[y] = true;
            }
        }
        int a = 0;
        for (int i = 0; i < n; ++i)
            if (used[i])
                a += c[i];
        u = gcd(u, a);
    }
    cout << (u ? u : 1) << "\n";
    return;
}

int main()
{
    ios::sync_with_stdio(0);
    tt = clock();
    int t, n, m;
    cin >> t;
    for (int i = 0; i < t; ++i)
        solve(clock() + (1.99 * CLOCKS_PER_SEC - clock() + tt) / (t - i));
    return 0;
}
