#define _CRT_SECURE_NO_WARNINGS
#define USE_MATH_DEFINES
#include <iostream>
#include <map>
#include <vector>
#include <stack>
#include <cassert>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <random>
#include <string>
#include <ctime>

#pragma GCC optimize("Ofast")
#pragma GCC target("sse")

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

mt19937 gen(34);

int t, n, m;
ll c[100000];
vector <vector <int>> gr;

ll euclid(ll a, ll b)
{
	while (b != 0) 
	{
		a %= b;
		swap(a, b);
	}
	return a;
}

ll solve()
{
	vector <char> used(n);
	used.assign(n, false);
	for (int i = 0; i < n; i++)
		if (gen() & 1ll)
			for (int to : gr[i])
				used[to] = true;
	ll S = 0;
	for (int i = 0; i < n; i++)
		S += c[i] * used[i];
	return S;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> t;
	while (t--)
	{
		gr.clear();
		cin >> n >> m;
		ld time_for_test = ld(2) * ld(n) / 10000;
		ld cur = clock();
		gr.resize(n);
		ll d = 0;
		for (int i = 0; i < n; i++) 
		{
			cin >> c[i];
			d = euclid(d, c[i]);
		}
		for(int i = 0; i < m; i++)
		{
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			gr[u].pb(v);
		}
		for (int i = 0; i < n; i++)
			c[i] /= d;
		ll nod = 0;
		for(int i = 0; i < n; i++)
		{
			ll S = 0;
			for (int to : gr[i])
				S += c[to];
			nod = euclid(nod, S);
		}
		for (int i = 0; i < 10000; i++) 
		{
			if (i % 34 == 0)
				if ((clock() - cur) / CLOCKS_PER_SEC > time_for_test)
					break;
			nod = euclid(nod, solve());
		}
		cout << d * nod << '\n';
	}
	return 0;
}
