#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll p = 999983;
const ll mod = 1e9 + 7;
vector<ll> powers;

int n, m;
vector<ll> c;
vector<vector<ll>> g;

void init_powers() {
	powers = vector<ll>(2*n+1, 1);
	for ( int i = 0; i < 2*n; ++i ) powers[i+1] = (powers[i] * p) % mod;
}

ll get_hash(const vector<ll> & v) {
	ll ans = 0;
	for ( ll x : v ) ans = (ans + powers[x]) % mod;
	return ans;
}

ll nod(ll a, ll b) {
	if ( (a == 0) || ( b == 0 ) ) return a + b;
	if ( a > b ) swap(a, b);

	while ( (a != 0) && (b != 0) ) {
		b = b % a;
		swap(a, b);
	}

	return a + b;
}

void solve() {
	int n, m; // n - right m - left
	cin >> n >> m;
	init_powers();
	c = vector<ll>(n);
	for ( int i = 0; i < n; ++i ) cin >> c[i];

	g = vector<vector<ll>>(n, vector<ll>());
	for ( int i = 0; i < m; ++i ) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		g[v].push_back(u);
	}

	vector<pair<ll, ll>> right(n);
	for ( int i = 0; i < n; ++i ) right[i] = { get_hash(g[i]), i };

	sort(right.begin(), right.end());
	vector<ll> reses = {c[right[0].second]};

	for ( int i = 1; i < n; ++i ) {
		if ( right[i].first == right[i-1].first ) reses[reses.size() - 1] += c[right[i].second];
		else reses.push_back(c[right[i].second]);
	}

	ll ans = reses[0];
	for ( ll x : reses ) ans = nod(ans, x);

	cout << ans << endl;
}

int main() {
	int t;
	cin >> t;

	for ( int i = 0; i < t; ++i ) {
		solve();
	}
	return 0;
}