#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,avx")

using namespace std;

int n, m;
vector<long long> numbers;
vector<vector<int>> graph;

long long gcd(long long a, long long b) {
    if (a == 0) return b;
    return gcd(b % a, a);
}

long long gcd(vector<long long> &a) {
    long long now = 0;
    for (const long long &e : a) {
        now = gcd(now, e);
    }
    return now;
}

long long stupid() {
    long long answer = 0;
    for (int i = 0; i < (1 << n); ++i) {        // 2 ** 20
        long long now = 0;
        vector<bool> was(n, false);
        for (int j = 0; j < n; ++j) {           // n
            if (!((1 << j) & i)) continue;
            for (int u : graph[j]) {
                if (!was[u])
                    now += numbers[u];
                was[u] = true;
            }
        }
        answer = gcd(answer, now);
    }
    return answer;
}

void clean_data() {
    numbers.clear();
    graph.clear();
}

void read() {
    cin.tie();
    cout.tie();
    iostream::sync_with_stdio(false);

    cin >> n >> m;
    numbers.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> numbers[i];
    }
    graph.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        graph[a].emplace_back(b);
    }
}


int32_t main() {
    int t;
    cin >> t;           // t = 5
    for (int i = 0; i < t; ++i) {
        clean_data();
        read();
        cout << stupid() << '\n';
    }
}