#include <iostream>
#include <random>
#include <algorithm>
#include <unordered_set>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        run();
    }
}

const int MOD1 = 1e9 + 21;
const int MOD2 = 1e9 + 7;

int fpw(int a, int k, int m) {
    if (k == 0) {
        return 1;
    } else if (k % 2 == 0) {
        return fpw((long long) a * a % m, k / 2, m);
    } else {
        return (long long) a * fpw(a, k - 1, m) % m;
    }
}

pair<int, int> get_hash(vector<int> &a) {
    pair<int, int> res = {0, 0};
    for (int i : a) {
        res.first = (res.first + fpw(2, i, MOD1)) % MOD1;
        res.second = (res.second + fpw(2, i, MOD2)) % MOD2;
    }
    return res;
}

void run() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gr(n + 1);
    vector<vector<int>> rgr(n + 1);
    auto c = arr<long long>(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> c[i];
    }
    int *deg = arr<int>(n + 1, 0);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        gr[u].push_back(v);
        rgr[v].push_back(u);
        deg[v]++;
    }
    auto h = arr<pair<int, int>>(n + 1);
    for (int v = 1; v <= n; v++) {
        h[v] = get_hash(rgr[v]);
    }
    auto taken = arr<int>(n + 1, -1);
    auto d = arr<long long>(n + 1, 0);
    for (int u = 1; u <= n; u++) {
        if (!deg[u])
            continue;
        if (taken[u] == -1)
            taken[u] = u;
        d[taken[u]] += c[u];
        for (int v = u + 1; v <= n; v++) {
            bool same = rgr[v].size() == rgr[u].size() && h[v] == h[u];
            if (!same)
                continue;
            taken[v] = taken[u];
        }
    }
    long long ans = -1;
    for (int v = 1; v <= n; v++) {
        if (d[v] == 0)
            continue;
        ans = ans == -1 ? d[v] : __gcd(ans, d[v]);
    }
    cout << ans << endl;
}
/*
1
3 6
42 33 20
1 1
1 2
1 3
3 1
3 2
3 3
 */