#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;
mt19937 gen(42);

struct Solver {
    vector<vector<int>> g;
    vector<int> c;
    int n, t;
    clock_t start;
    ld have_time;

    Solver(auto g, auto c, int t): g(g), c(c), t(t) {
        n = c.size();
        start = clock();
        have_time = 1.0/(ld)(t);
    }

    vector<int> get_mask() {
        vector<int> mask(n, 0);
        for(int i = 0; i < n; ++i) mask[i] = gen() % 2;
        return mask;
    }

    int solve() {
        int gcd = 0;
        while((ld)(clock()-start)/(CLOCKS_PER_SEC) < have_time) {
            vector<int> mask = get_mask();
            unordered_set<int> s;

            for(int i = 0; i < n; ++i) {
                if(!mask[i]) continue;
                for(int j : g[i])
                    s.insert(j);
            }

            int cur = 0;
            for(int i : s)
                cur += c[i];

            if(cur != 0) gcd = __gcd(gcd, cur);
        }

        return gcd;
    }
};

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = (stress ? 100 : 1);
    if((local || true) && (!stress)) cin >> tests;

    for(int test = 0; test < tests; ++test) {
        if(!stress) {
            int n, m;
            cin >> n >> m;

            vector<int> c(n, 0);
            for(int i = 0; i < n; ++i)
                cin >> c[i];

            vector<vector<int>> g(n);
            for(int i = 0; i < m; ++i) {
                int u, v;
                cin >> u >> v;
                u--; v--;

                g[u].push_back(v);
            }

            Solver solver(g, c, tests);
            int res = solver.solve();
            cout << res << "\n";

        } else {}
    }

    return 0;
}
