#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int t;
int n, m;
ll curr_sum;
vector<int> used;
int curr_time;
vector<int> gph[MAX];
vector<ll> val;

signed main() {
    boot_up();

    cin >> t;
    while (cin >> n >> m) {
        solve();
    }
}

void solve() {
    init(val, n + 1);
    init(used, 2 * n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> val[i];
    }

    for (int i = 1; i <= 2 * n; ++i) {
        gph[i].clear();
    }

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;

        gph[u].emplace_back(v + n);
        gph[v + n].emplace_back(u);
    }

    ll g = -1;

    for (int mask = 1; mask <= (1 << n) - 1; ++mask) {
        vector<int> verts;
        for (int i = 0; i < n; ++i) {
            if ((int)((mask >> i) & 1) == 1) {
                verts.emplace_back(i + 1);
            }
        }

        curr_sum = 0;

        for (const auto & v : verts) {
            for (auto & u : gph[v]) {
                if (used[u - n] != curr_time + 1) {
                    curr_sum += val[u - n];
                    used[u - n] = curr_time + 1;
                }
            }
        }

        ++curr_time;

        if (g == -1) {
            g = curr_sum;
        }
        else {
            g = __gcd(curr_sum, g);
        }

        if (g == 1) {
            break;
        }
    }

    cout << g << '\n';
}