#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

using ll = long long;

const int N = 500;
const ll inf = 1e18;

template <typename T> using sset =
__gnu_pbds::tree <T, __gnu_pbds::null_type,
    less <T>, __gnu_pbds::rb_tree_tag,
    __gnu_pbds::tree_order_statistics_node_update>;

ll gcd(ll a, ll b) {
    while (a > 0 && b > 0) {
        if (a > b)
            a %= b;
        else
            b %= a;
    }

    return a + b;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector <vector <int> > g(n, vector <int>());

    map <set <int>, set <int> > mp;
    vector <set <int> > who(n);

    vector <ll> ci(n);
    for (ll& x: ci)
        cin >> x;

    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        g[from].push_back(to);
    }

    for (int i = 0; i < n; i++) {
        for (int to: g[i]) {
            if (!who[to].empty())
                mp[who[to]].erase(to);
            who[to].insert(i);
            mp[who[to]].insert(to);
        }
    }

    ll ans = 0;
    for (auto& e: mp) {
        ll sum = 0;
        for (int x: e.second)
            sum += ci[x];
        ans = gcd(ans, sum);
    }
    cout << ans << '\n';
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
