#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
#include <map>
#include <vector>
//#include <unordered_set>
#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
#include <queue>
//#include <utility>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

using ll = long long;
#define all(c) c.begin(),c.end()

//mt19937_64 rng(228);

int gcd(int x, int y) {
    if (x == 0) return y;
    if (y == 0) return x;
    return gcd(y, x % y);
}

void _tmain([[maybe_unused]] int test_id) {
    int test_case_cnt;
    cin >> test_case_cnt;
    while (test_case_cnt--) {
        int n, m;
        cin >> n >> m;
        vector<int> cost(n);
        for (int &x : cost) { cin >> x; }
        vector<int> g(n);
        for (int i = 0; i < m; ++i) {
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            g[u]|=(1<<v);
        }
        int ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            int tot = 0;
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    tot |= g[i];
                }
            }
            int res = 0;
            for (int j = 0; j < n; ++j){
                if (tot & (1 << j)) {
                    res += cost[j];
                }
            }
            ans = gcd(ans, res);
        }
        cout << ans << "\n";
    }
}
