#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long
#define ll long long

using namespace std;

const int N = 1e6 + 10;
const int inf = 1e9;

int q;
int n, m;
int a[N];
vector<int> g[N];

void clear()
{
    for (int i = 0; i < 2 * n; ++i)
        g[i].clear();
}

int __gcd(int a, int b)
{
    if (a < b)
        swap(a, b);

    if (b == 0)
        return a;

    return __gcd(b, a % b);
}

int calc(vector<int>& v)
{
    map<int, bool> used;

    int res = 0;

    for(auto i : v)
        for(auto u : g[i])
            if (!used[u - n])
            {
                used[u - n] = true;
                res += a[u - n];
            }

    return res;
}

void solve()
{
    int ans = -1;

    for (int msk = 0; msk < (1ll << n); ++msk)
    {
        vector<int> tmp;

        for (int b = 0; b < n; ++b)
            if ((1ll << b) & msk)
                tmp.push_back(b);

        if (ans == -1)
            ans = calc(tmp);
        else
            ans = __gcd(ans, calc(tmp));

        if (ans == 1)
            break;
    }

    cout << ans << endl;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> q;

    while (q--)
    {
        cin >> n >> m;

        for (int i = 0; i < n; ++i)
            cin >> a[i];

        for (int i = 0; i < m; ++i)
        {
            int v, u;

            cin >> v >> u;

            --v;
            --u;

            g[v].push_back(u + n);
        }

        solve();
        clear();
    }
}
