
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}

int gcd(int a, int b) {
	if (!b) {
		return a;
	}
	return gcd(b, a % b);
}

bool comp(pair<vector<int>, int> &a, pair<vector<int>, int> &b) {
	if (a.first.size() < b.first.size()) {
		return true;
	}

	if (b.first.size() < a.first.size()) {
		return false;
	}

	for (int i = 0; i < (int)a.first.size(); i++) {
		if (a.first[i] < b.first[i]) {
			return true;
		}

		if (a.first[i] > b.first[i]) {
			return false;
		}
	}

	return a.second < b.second;

	//return true;
}

int now = 0;

vector<vector<int>> good_pair(500000);
vector<int> cost(500000);
vector<bool> used(500000);

void dfs(int v) {
	now += cost[v];
	used[v] = true;
	//cout << "DFS " << v << endl;
	for (auto u : good_pair[v]) {
		if (used[u]) {
			continue;
		}
		dfs(u);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;

	vector<pair<vector<int>, int>> g(n);

	for (int i = 0; i < n; i++) {
        cin >> cost[i];
        used[i] = false;
        good_pair[i].clear();
        g[i].second = i;
	}
	int kek = 0;
	vector<int> arr(n);

	vector<bool> used1(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		used1[b] = true;
		g[b].first.push_back(a);
		g[b].second = b;
	}

	for (int i = 0; i < n; i++) {
		sort(g[i].first.begin(), g[i].first.end());
	}

	sort(g.begin(), g.end(), comp);

	/*for (int i = 0; i < n - 1; i++) {
		if (g[i].first.size() == 0) {
			continue;
		}
		if (g[i].first.size() == g[i + 1].first.size()) {
			bool good = true;

			for (int k = 0; k < g[i].first.size(); k++) {
				if (g[i].first[k] != g[i + 1].first[k]) {
					good = false;
				}
			}

			if (good) {
                good_pair[g[i].second].push_back(g[i + 1].second);
                good_pair[g[i + 1].second].push_back(g[i].second);
               // cout << g[i].second << " " << g[i + 1].second << endl;
                //cout << i << " " << j << endl;
            }
		}

	}

	//cout << endl;

	int ans = 0;

	for (int i = 0; i < n; i++) {
		if (!used[i] && used1[i]) {
			now = 0;
			dfs(i);
			//cout << now << endl;
			ans = gcd(ans, now);
		}
	}*/

	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (g[i].first.size() == g[j].first.size()) {
				bool good = true;
				for (int k = 0; k < g[i].first.size(); k++) {
					if (g[i].first[k] != g[j].first[k]) {
						good = false;
					}
				}

				if (good) {
					good_pair[g[i].second].push_back(g[j].second);
					good_pair[g[j].second].push_back(g[i].second);

					//cout << i << " " << j << endl;
				}
			}
		}
	}

	int ans = 0;

	for (int i = 0; i < n; i++) {
		if (!used[i] && used1[i]) {
			used[i] = true;
			int now = cost[i];

			for (auto u : good_pair[i]) {
				now += cost[u];
				used[u] = true;
			}
			ans = gcd(ans, now);
		}
	}

	cout << ans << endl;

}
signed main() {
	//fast_io();

	int t;
	cin >> t;

	for (int i = 0; i < t; i++) {
		solve();
	}
    return 0;
}
