#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>
#include <random>
#include <cassert>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <map>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <iomanip>
#include <bitset>
#include <stack>
#include <list>

#pragma warning (disable : 4996)
using namespace std;

#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define nl '\n'
#define sz(a) (int)(a).size()
#define maxeq(a, b) (a) = max(a, b);
#define mineq(a, b) (a) = min(a, b);

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
const dl PI = acos(-1);
mt19937 rnd(5625445);
mt19937_64 rnd64(3465467567);

template <typename T, typename D>
istream &operator >> (istream &in, pair<T, D> &a) {
	in >> a.first >> a.second;
	return in;
}

template <typename T, typename D>
ostream &operator << (ostream &out, pair<T, D> &a) {
	out << a.first << " " << a.second;
	return out;
}

template <typename T>
istream &operator >> (istream &in, vector<T> &a) {
	for (auto &i : a)
		in >> i;
	return in;
}

void IO() {
#ifdef _SEVA
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _SEVA
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = (int)2e6 + 10;
vector<int> gl[N], gr[N];
int maskr[N];
ll sm[N];

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void solve1(int n, int m, const vector<ll> &c) {
	maskr[0] = 0;
	sm[0] = 0;
	ll res = 0;
	for (int mask = 1; mask < (1 << n); mask++) {
		int d = 0;
		while (!((mask >> d) & 1))
			d++;
		int tmask = mask ^ (1 << d);
		maskr[mask] = maskr[tmask];
		sm[mask] = sm[tmask];
		for (auto &to : gl[d + 1]) {
			if ((maskr[mask] >> (to - 1)) & 1)
				continue;
			maskr[mask] |= (1 << (to - 1));
			sm[mask] += c[to - 1];
		}
		res = gcd(res, sm[mask]);
	}
	cout << res << nl;
}

int main() {
	IO();
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<ll> c(n);
		cin >> c;
		for (int i = 1; i <= n; i++) {
			gl[i].clear();
		}
		for (int i = 0; i < m; i++) {
			int u, v;
			cin >> u >> v;
			gl[u].push_back(v);
		}
		solve1(n, m, c);
	}
	return 0;
}
