#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,mmx,sse,sse2")
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
ll GCD(ll x, ll y) {
	return (x == 0 ? y : GCD(y%x, x));
}
const int MAXN = 5007;
bitset<MAXN> G[MAXN], H[MAXN], basis[MAXN], cur;
ll c[MAXN];
int n, m;
mt19937 rng;
int getRand() {
	return rng();
}
void solve() {
	cin >> n >> m;
	for(int i = 0; i < n; ++i) {
		cin >> c[i];
		G[i].reset();
		basis[i].reset();
	}
	for(int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		G[v][u] = 1;
	}
	ll answ = 0;
	/*for(int msk = 1; msk < (1 << n); ++msk) {
		cur.set();
		for(int v = 0; v < n; ++v) {
			if((msk>>v)&1) cur &= G[v];
		}
		ll sum = 0;
		for(int u = 0; u < n; ++u) if(cur[u]) sum += c[u];
		answ = GCD(answ, sum);
	}*/
	for(int v = 0; v < n; ++v) {
		ll sum = 0;
		for(int u = 0; u < n; ++u) if(G[v][u]) sum += c[u];
		answ = GCD(answ, sum);
	}
	{
		cur.reset();
		for(int v = 0; v < n; ++v) cur |= G[v];
		ll sum = 0;
		for(int u = 0; u < n; ++u) if(cur[u]) sum += c[u];
		answ = GCD(answ, sum);
		for(int v = 0; v < n; ++v) H[v] = G[v] ^ cur;
	}
	for(int v = 0; v < n; ++v) {
		for(int j = 0; j < n; ++j) {
			if(G[v][j]) {
				if(basis[j][j]) {
					G[v] ^= basis[j];
				} else {
					basis[j] = G[v];
					break;
				}
			}
		}
		for(int j = 0; j < n; ++j) {
			if(H[v][j]) {
				if(basis[j][j]) {
					H[v] ^= basis[j];
				} else {
					basis[j] = H[v];
					break;
				}
			}
		}
	}
	for(int j = 0; j < n; ++j) {
		ll sum = 0;
		for(int u = 0; u < n; ++u) if(basis[j][u]) sum += c[u];
		answ = GCD(answ, sum);
	}
	cout << answ << '\n';
}
int main() {
	fastIO();
	int T; cin >> T;
	while(T--) {
		solve();
	}
	return 0;
}
