#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int n, m;
vector<long long> numbers;
vector<vector<int>> adjList;

void read() {
    cin >> n >> m;
    numbers.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> numbers[i];
    }
    adjList.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        adjList[i].clear();
    }
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        adjList[u].emplace_back(v);
    }
}

void solve() {
    long long answer = 0;
    for (int mask = 1; mask < (1 << n); mask++) {
        set<int> nodes;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                for (int adjNode : adjList[i + 1]) {
                    nodes.emplace(adjNode);
                }
            }
        }
        long long sum = 0;
        for (int node : nodes) {
            sum += numbers[node];
        }
        answer = __gcd(answer, sum);
    }
    cout << answer << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        read();
        solve();
    }

    return EXIT_SUCCESS;
}
