#include <iostream>
#include <vector>
#include <cstdint>
#include <set>
#include <algorithm>

int64_t get_nod(int64_t a, int64_t b){
    if (b == 0){
        return a;
    }
    if (a % b == 0){
        return b;
    }
    return get_nod(b, a % b);
}

int main() {
    int t;
    std::cin >> t;
    for (; t > 0; t--){
        int n, m;
        std::cin >> n >> m;
        std::vector<int64_t> c(n);
        std::vector<int64_t> num(n, 0);
        std::vector<std::set<int>> connections(n);
        for (int i = 0; i < n; i++){
            std::cin >> c[i];
        }
        for (int i = 0; i < m; i++){
            int u, v;
            std::cin >> u >> v;
            num[u - 1] += c[v - 1];
            connections[u - 1].insert(v - 1);
        }
        int64_t nod = num[0];
        for (int i = 1; i < n; i++){
            nod = get_nod(std::max(nod, num[i]), std::min(nod, num[i]));
        }
        for (int i = 0; i < n; i++){
            for (int j = i + 1; j < n; j++){
                std::vector<int> us;
                std::set_union(connections[i].begin(), connections[i].end(),
                        connections[j].begin(), connections[j].end(), std::back_inserter(us));
                int64_t s = 0;
                for (auto& e : us){
                    s += c[e];
                }
                nod = get_nod(std::max(nod, s), std::min(nod, s));
                if (nod == 1){
                    break;
                }
            }
            if (nod == 1){
                break;
            }
        }
        std::cout << nod << std::endl;


    }
    return 0;
}