#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

const int MAXN = 25;

void updateGCD(long long &gcd, long long y)
{
    if(gcd==0) gcd = y;
    else gcd = __gcd(gcd, y);
}

int n, m;
long long c[MAXN];
vector <int> graph[MAXN];

int used[MAXN];
void apply(int x, int sign)
{
    for(int y: graph[x])
    {
        used[y] += sign;
    }
}

long long answer = 0;
void bruteForce(int ind)
{
    if(ind==n+1)
    {
        long long curr = 0;
        for(int i = 1;i<=n;i++)
        {
            if(used[i]>0) curr += c[i];
        }

        updateGCD(answer, curr);
        return;
    }

    bruteForce(ind+1);

    apply(ind, +1);
    bruteForce(ind+1);
    apply(ind, -1);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int T;
    cin >> T;

    while(T--)
    {
        cin >> n >> m;
        for(int i = 1;i<=n;i++)
        {
            graph[i].clear();
        }
        for(int i = 1;i<=n;i++)
        {
            cin >> c[i];
        }
        for(int i = 0;i<m;i++)
        {
            int u, v;
            cin >> u >> v;

            graph[u].push_back(v);
        }

        answer = 0;
        bruteForce(1);

        cout << answer << '\n';
    }
}
