#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 1000007;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

int n, m;
vector<int> graph[20 + 7];
int c[20 + 7];

int sum_mask(int mask) {
    bool used[27];
    for (int i = 0; i < n; ++i) {
        used[i] = false;
    }
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            for(auto v :graph[i]) {
                used[v] = true;
            }
        }
    }
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        if (used[i]) {
            ans += c[i];
        }
    }
    return ans;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        graph[u].push_back(v);
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        ans = gcd(ans, sum_mask(mask));
       // cout << sum_mask(mask) << '\n';
    }
    //cout << '\n';
    cout << ans << '\n';
}

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}