#define _CRT_SECURE_NO_WARNINGS
#define REL

#pragma GCC optimize ("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <bitset>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <algorithm> 
#include <queue>
#include <deque>

using namespace std;

#define endl "\n"
#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T>
bool uin(T &a, const T &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uax(T &a, const T &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

mt19937_64 rnd;

const int LOG = 25;
const LL LINF = 1e18;
const int N = (int)5e5 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

///////////////////////////////////////////////////////////////////////

int p = 998244353, m1 = (int)1e9 + 7, m2 = (int)1e9 + 9;
int p1[N], p2[N];

void precalc() {
	p1[0] = p2[0] = 1;
	for (int i = 1; i < N; i++) {
		p1[i] = 1LL * p1[i - 1] * p % m1;
		p2[i] = 1LL * p2[i - 1] * p % m2;
	}
}

struct Hash {
	int r1, r2;
	Hash() {};
	Hash(int r1, int r2) :
		r1(r1), r2(r2) {};
};

bool operator < (const Hash &a, const Hash &b) {
	return mp(a.r1, a.r2) < mp(b.r1, b.r2);
}

Hash operator + (const Hash & a, const Hash & b) {
	return Hash(a.r1 + b.r1 - m1 * (a.r1 + b.r1 >= m1), a.r2 + b.r2 - m2 * (a.r2 + b.r2 >= m2));
}

Hash operator * (const Hash &a, int x) {
	return Hash(1LL * a.r1 * p1[x] % m1, 1LL * a.r2 * p2[x] % m2);
}

LL a[N];
int n, m;
vector <int> gr[N];

void read() {
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		gr[v - 1].push_back(u);
	}
}

Hash get_hash(vector <int> &v) {
	sort(all(v));
	Hash res(0, 0);
	for (int i = 0; i < size(v); i++) {
		Hash cur(v[i], v[i]);
		cur = cur * i;
		res = res + cur;
	}
	return res;
}

LL gcd(LL a, LL b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

void solve() {
	map <Hash, LL> mep;
	for (int i = 0; i < n; i++) {
		if (size(gr[i]) == 0)
			continue;
		Hash h = get_hash(gr[i]);
		mep[h] += a[i];
	}
	LL ans = 0;
	for (auto it : mep)
		ans = gcd(ans, it.second);
	cout << ans << endl;
	for (int i = 0; i < n; i++)
		gr[i].clear();
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	rnd.seed(time(0));
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	precalc();
	int t; cin >> t;
	while (t--) {
		read();
		solve();
	}
}