#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <random>
#include <ctime>

using namespace std;

typedef int64_t ll;

mt19937 rng(666);

ll gcd(ll x, ll y) {
	return y == 0 ? x : gcd(y, x % y);
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> a(n);
	for (ll& i : a) {
		cin >> i;
	}
	vector<vector<ll>> g(n);
	for (ll i = 0; i < m; ++i) {
		ll v, u;
		cin >> v >> u;
		--v;
		--u;
		g[v].emplace_back(u);
	}
	for (ll v = 0; v < n; ++v) {
		sort(g[v].begin(), g[v].end());
	}
	random_shuffle(g.begin(), g.end());
	ll result = 0;
	for (ll v = 0; v < n; ++v) {
		if (clock() > 1.9 * CLOCKS_PER_SEC) {
			break;
		}
		for (ll u = v; u < n; ++u) {
			if (clock() > 1.9 * CLOCKS_PER_SEC) {
				break;
			}
			for (ll w = u; w < n; ++w) {
				vector<ll> id;
				for (ll e : g[v]) {
					id.emplace_back(e);
				}
				for (ll e : g[u]) {
					id.emplace_back(e);
				}
				for (ll e : g[w]) {
					id.emplace_back(e);
				}
				sort(id.begin(), id.end());
				id.resize(unique(id.begin(), id.end()) - id.begin());
				ll sum = 0;
				for (ll i : id) {
					sum += a[i];
				}
				result = gcd(sum, result);
			}
		}
	}
	cout << result << endl;
}

int main() {
	ll t;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
