#include<bits/stdc++.h>


using std::vector;
using std::string;
using std::pair;
using std::cin;
using std::cout;
using std::cerr;

using ll = long long;
using ld = long double;

const int INF = 1e9;

struct Tree {
	vector<int> tr;
	int n;

	Tree (int n) : n(n) {
		tr.resize(4 * n, INF);
	}

	void set (int i, int x, int v = 0, int vl = 0, int vr = 0) {
		if (v == 0)
			vr = n;
		if (vl > i || i >= vr)
			return;
		if (vr - vl == 1) {
			tr[v] = x;
			return;
		}
		int m = (vl + vr) / 2;
		set(i, x, v * 2 + 1, vl, m);
		set(i, x, v * 2 + 2, m, vr);
		tr[v] = std::min(tr[v * 2 + 1], tr[v * 2 + 2]);
	}
	
	int get (int l, int x, int v = 0, int vl = 0, int vr = 0) {
		if (v == 0)
			vr = n;
		if (vr <= l)
			return INF;
		if (l <= vl) {
			if (vr - vl == 1) {
				if (tr[v] < x)
					return vl;
				else
					return INF;
			}
			int m = (vl + vr) / 2;
			if (tr[v * 2 + 1] < x)
				return get(l, x, v * 2 + 1, vl, m);
			else
				return get(l, x, v * 2 + 2, m, vr);
		}
		int m = (vl + vr) / 2;
		return std::min(get(l, x, v * 2 + 1, vl, m), get(l, x, v * 2 + 2, m, vr));
	}
};

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<vector<int>> v(n, vector<int> (m));

	for (auto &s : v)
		for (int &i : s) {
			char a, b;
			cin >> a >> b;
			i = a * 256 + b;
		}
	
	vector<Tree> left(m, Tree (n));
	vector<Tree> down(n, Tree (m));

	for (int i = 0; i < n; ++i) {
		std::deque<int> q;
		std::map<int, bool> used;
		for  (int j = m - 1; j >= 0; --j) {
			if (!used[v[i][j]]) {
				q.push_back(v[i][j]);
				used[v[i][j]] = true;
			} else {
				while (q.front() != v[i][j]) {
					used[q.front()] = false;
					q.pop_front();
				}
				q.pop_front();
				q.push_back(v[i][j]);
			}
			left[j].set(i, q.size() - 1 - i);
		}
	}

	for (int i = 0; i < m; ++i) {
		std::deque<int> q;
		std::map<int, bool> used;
		for  (int j = n - 1; j >= 0; --j) {
			if (!used[v[j][i]]) {
				q.push_back(v[j][i]);
				used[v[j][i]] = true;
			} else {
				while (q.front() != v[j][i]) {
					used[q.front()] = false;
					q.pop_front();
				}
				q.pop_front();
				q.push_back(v[j][i]);
			}
			down[j].set(i, q.size() - 1 - i);
		}
	}


	ll ans = 0;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j) {
			//int a = down[i].get(j, -j) - j;
			//int b = left[j].get(i, -i) - i;
			std::set<int> s;
			std::vector<std::set<int>> st(n), cl(m);
			for (int k = 0; k < std::min(n - i, m - j); ++k) {
				for (int q = 0; q < k + 1; ++q) {
					s.insert(v[i + k][j + q]);
					cl[q].insert(v[i + k][j + q]);
					st[k].insert(v[i + k][j + q]);
				}
				for (int q = 0; q < k + 1; ++q) {
					s.insert(v[i + q][j + k]);
					st[q].insert(v[i + q][j + k]);
					cl[k].insert(v[i + q][j + k]);
				}
				bool f = true;
				for (int q = 0; q < k + 1; ++q)
					if(st[q].size() != k + 1 || cl[q].size() != k + 1)
						f = false;
				if (s.size() == k + 1 && f)
					++ans;
			}
		}
	cout << ans;
	return 0;
}