#include <iostream>
#include <algorithm>
#include <cstdint>
#include <cstdlib>
#include <vector>
#include <cstring>
#include <cassert>
using namespace std;

class solver
{
private:
    vector<vector<uint32_t>> ltor;
    vector<uint64_t> c;

    uint64_t get_sum (uint32_t ubmask)
    {
        uint64_t sum=0;
        vector<bool> used(ltor.size());
        for(uint32_t i=0; (((uint32_t)1)<<i)<=ubmask; i++)
        {
            if(ubmask&(((uint32_t)1)<<i))
            {
                for(uint32_t j=0; j<ltor[i].size(); j++)
                {
                    if(used[ltor[i][j]]==false)
                    {
                        used[ltor[i][j]]=true;
                        sum+=c[ltor[i][j]];
                    }
                }
            }
        }

        return sum;
    }

public:
    solver()
    {
        uint32_t n, m;
        cin>>n>>m;
        assert(n<=20);
        assert(m<=400);
        ltor.resize(n);
        c.resize(n);
        for(uint32_t i=0; i<n; i++)
            cin>>c[i];

        for(uint32_t i=0; i<m; i++)
        {
            uint32_t u, v;
            cin>>u>>v;
            u--;v--;
            ltor[u].push_back(v);
        }
    }

    uint64_t solve()
    {
        uint64_t res = get_sum(1);
        for(uint32_t i=2; i<(((uint32_t)1)<<ltor.size())-1; i++)
        {
            res = __gcd<uint64_t >(res, get_sum(i));
        }

        return res;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t t;
    cin>>t;

    for(uint32_t i=0; i<t; i++)
    {
        solver s;
        cout<<s.solve()<<'\n';
        //cout.flush();
    }

    return 0;
}