#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <random>
#include <ctime>

using namespace std;

typedef int64_t ll;

mt19937 rng(666);

ll gcd(ll x, ll y) {
	return y == 0 ? x : gcd(y, x % y);
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> a(n);
	for (ll& i : a) {
		cin >> i;
	}
	vector<vector<ll>> g1(n);
	vector<vector<ll>> g2(n);
	for (ll i = 0; i < m; ++i) {
		ll v, u;
		cin >> v >> u;
		--v;
		--u;
		g1[v].emplace_back(u);
		g2[u].emplace_back(v);
	}
	ll result = 0;
	for (ll v = 0; v < n; ++v) {
		vector<ll> id1;
		for (ll u : g2[v]) {
			id1.emplace_back(u);
		}
		if (id1.empty()) {
			continue;
		}
		vector<ll> cnt(n);
		for (ll u : id1) {
			for (ll x : g1[u]) {
				++cnt[x];
			}
		}
		ll sum1 = 0;
		ll sum2 = 0;
		for (ll v = 0; v < n; ++v) {
			if (cnt[v]) {
				sum1 += a[v];
			}
			if (cnt[v] == id1.size()) {
				sum2 += a[v];
			}
		}
		result = gcd(result, gcd(sum1, sum2));
	}
	cout << result << endl;
}

int main() {
	ll t;
	cin >> t;
	for (ll i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
