#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
#include <map>
#include <vector>
//#include <unordered_set>
#include <unordered_map>
#include <bitset>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
#include <queue>
//#include <utility>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

using ll = long long;
#define all(c) c.begin(),c.end()

//mt19937_64 rng(228);

ll ggcd(ll x, ll y) {
    if (x == 0) return y;
    if (y == 0) return x;
    return ggcd(y, x % y);
}

using BS = bitset<5000>;
//uniform_int_distribution<int> gen_cnt_nodes(1, 5);
//uniform_int_distribution<int> gen_cnt_edges(1, 10);
//uniform_int_distribution<ll> gen_cost(1, 1000);

void _tmain([[maybe_unused]] int test_id) {
    int test_case_cnt;
    //test_case_cnt = 1;
    cin >> test_case_cnt;
    while (test_case_cnt--) {
        int n, m;
        //n = gen_cnt_nodes(rng);
        // m = min(n * n, gen_cnt_edges(rng));
        cin >> n >> m;
        vector<ll> cost(n);
        for (ll &x : cost) {
            cin >> x;
            // x = gen_cost(rng);
        }
        vector<BS> g(n);
        vector<BS> gr(n);
        /*vector<pair<int, int>> all_edges;
        for (int i = 0; i < n; ++i) {
            for (int v = 0; v < n; ++v) {
                all_edges.emplace_back(i, v);
            }
        }*/
        // shuffle(all(all_edges), rng);
        for (int _i = 0; _i < m; ++_i) {
            int u, v;
            cin >> u >> v;
            --u;
            --v;
            /*
            auto[u, v] = all_edges[_i];*/
            g[u][v] = true;
            gr[v][u] = true;
        }
        ll ans = 0;
        unordered_map<BS, ll> mp;
        for (int j = 0; j < n; ++j) {
            mp[gr[j]] += cost[j];
        }
        for (auto[ttt, res] :mp) {
            if (ttt.none()) continue;
            ans = ggcd(ans, res);
        }
        cout << ans << "\n";

        if (false) {

            ll corr = 0;
            vector<BS> masks;
            for (int i = 0; i < n; ++i) {
                BS x = g[i];
                int k = masks.size();
                for (int j = 0; j < k; ++j) {
                    BS per = masks[j] & x;
                    if (per == 0) {
                        continue;
                    }
                    masks[j] ^= per;
                    x ^= per;
                    masks.push_back(per);
                }
                if (x.any()) {
                    masks.push_back(x);
                }
            }
            for (BS mask :masks) {
                ll res = 0;
                for (int j = 0; j < n; ++j) {
                    if (mask[j]) {
                        res += cost[j];
                    }
                }
                corr = ggcd(corr, res);
            }
            if (ans != corr) {
                printf("mismatch\n");
                exit(1);
            }
        }
    }
}