#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    int *t;
    int default_value = 0;
    int n;

    int merge(int a, int b) {
        return a + b;
    }

private:
    void build(int v, int l, int r, int *arr) {
        if (r == l + 1) {
            t[v] = arr[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, arr);
        build(v * 2 + 1, m, r, arr);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos < l || pos >= r) {
            return;
        }
        if (r == l + 1) {
            t[v] = pos;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int al, int ar) {
        if (al <= l && r <= ar) {
            return t[v];
        }
        if (ar <= l || r <= al) {
            return default_value;
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, al, ar),
                     get(v * 2 + 1, m, r, al, ar));
    }

public:
    DO(int n, int *arr) : n(n) {
        t = new int[4 * n];
        build(1, 0, n, arr);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

};

#define MAXN 20
vector<int> g[MAXN];
int gc[MAXN];
long long c[MAXN];
int n;
long long ans = 0;
int all[MAXN];

void done() {
    long long sum = 0;
    for (int i = 0; i < n; ++i) {
        if(all[i]){
            sum += c[i];

        }
    }
    ans = __gcd(ans, sum);
}

void gen(int x) {
    if (x == n) {
        done();
        return;
    }
    for (int i = 0; i < 2; ++i) {
        if (i == 1) {
            for (auto u:g[x]) {
                all[u]++;
            }
        }
        gc[x] = i;
        gen(x + 1);
        if (i == 1) {
            for (auto u:g[x]) {
                all[u]--;
            }
        }
    }
}

void clear() {
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        g[i].shrink_to_fit();
    }
    ans = 0;
}

void solve() {
    int m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
    }
    gen(0);
    cout << ans << "\n";

    clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}