#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

ll n, m, ans = -1;
vector <ll> c;
vector <bool> u;
vector <vector <ll>> gr;

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void solve(ll v) {
    if (v == n) {
        ll otv = 0;
        vector <ll> u2(n);
        for (ll i = 0; i < n; i++) {
            if (!u[i])
                continue;
            for (auto to : gr[i])
                if (!u2[to]) {
                    otv += c[to];
                    u2[to] = true;
                }
        }
        if (ans == -1)
            ans = otv;
        else ans = gcd(ans, otv);
        return;
    }
    u[v] = true;
    solve(v + 1);
    u[v] = false;
    solve(v + 1);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll t;
    cin >> t;
    while (t--) {
        ans = -1;
        cin >> n >> m;
        c.resize(n);
        gr.clear();
        gr.resize(n);
        for (ll i = 0; i < n; i++)
            cin >> c[i];
        for (ll i = 0; i < m; i++) {
            ll a, b;
            cin >> a >> b, a--, b--;
            gr[a].push_back(b);
        }
        u.assign(n, false);
        solve(0);
        cout << ans << '\n';
    }
    return 0;
}