#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

mt19937 gen(0);

struct node {
    ll val, pr, sz;
    node *l;
    node *r;

    node() {}

    node(ll x) {
        l = r = nullptr;
        val = x, pr = gen() * 13;
        sz = 1;
    }
};

ll get_size(node *v) {
    if (v == nullptr)
        return 0;
    return v->sz;
}

ll get_val(node *v) {
    if (v == nullptr)
        return -1;
    return v->val;
}

node *update(node *v) {
    if (v == nullptr)
        return v;
    v->sz = 1 + get_size(v->l) + get_size(v->r);
    return v;
}

pair<node *, node *> split(node *now, ll value) {
    if (now == nullptr) {
        return {nullptr, nullptr};
    }
    if (value > now->val) {
        auto[a, b] = split(now->r, value);
        a = update(a), b = update(b);
        now->r = a;
        now = update(now);
        return {now, b};
    } else {
        auto[a, b] = split(now->l, value);
        a = update(a), b = update(b);
        now->l = b;
        now = update(now);
        return {a, now};
    }
}

node *merge(node *a, node *b) {
    if (a == nullptr)
        return b;
    if (b == nullptr)
        return a;
    if (a->pr > b->pr) {
        node *v = merge(a->r, b);
        v = update(v);
        a->r = v;
        a = update(a);
        return a;
    } else {
        node *v = merge(a, b->l);
        v = update(v);
        b->l = v;
        b = update(b);
        return b;
    }
}

inline node *add(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    node *nw = new node(v);
    node *tmp = merge(r1, nw);
    root = merge(tmp, r2);
    return root;
}

inline pair<ll, node *> get_less(node *root, ll v) {
    auto[r1, r2] = split(root, v);
//    cout << v << ' ' << get_val(r1) << ' ' << get_val(r2) << ' ' << get_size(r1) << ' ' << get_size(r2) << endl;
    ll ans = get_size(r1);
    root = merge(r1, r2);
    return {ans, root};
}

inline pair<ll, node *> get_gr_or_eq(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    ll ans = get_size(r2);
    root = merge(r1, r2);
    return {ans, root};
}

void print(node *root) {
    if (root == nullptr)
        return;
    print(root->l);
    cout << root->val << ' ' << root->pr << '\n';
    print(root->r);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector<ll> c(n);
        for (int i = 0; i < n; ++i) {
            cin >> c[i];
        }
        vector<vector<ll>> nodes(n);
        for (int i = 0; i < m; ++i) {
            ll u, v;
            cin >> u >> v;
            nodes[u - 1].push_back(v - 1);
        }
        ll ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            vector<bool> used(n, false);
            for (int i = 0; i < n; ++i) {
                if ((mask & (1 << i))) {
                    for (auto j : nodes[i])
                        used[j] = true;
                }
            }
            ll sum = 0;
            for (int i = 0; i < n; ++i)
                sum += c[i] * used[i];
            ans = __gcd(ans, sum);
        }
        cout << ans << endl;
    }
}