#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int gcd(int a, int b) {
	return b == 0 ? a : gcd(b, a % b);
}

int getsum(vector <int> x, vector <vector <int>>& w, vector <int>& c) {
	set <int> y;
	for (int u : x) {
		for (int v : w[u]) {
			y.insert(v);
		}
	}
	int sum = 0;
	for (int i : y) sum += c[i];
	return sum;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <int> c(n);
	for (int& i : c) cin >> i;
	vector <vector <int>> w(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		w[u].push_back(v);
	}
	int ans = getsum({ 0 }, w, c);
	for (int i = 0; i < n; ++i) {
		ans = gcd(ans, getsum({ i }, w, c));
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			ans = gcd(ans, getsum({ i, j }, w, c));
		}
	}
	cout << ans;
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}