#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;
mt19937 gen(42);

struct Solver {
    vector<vector<int>> g;
    vector<int> c;
    int n, t;
    clock_t start;
    ld have_time;

    Solver(auto g, auto c, int t): g(g), c(c), t(t) {
        n = c.size();
        start = clock();
        have_time = 1.5/(ld)(t);
    }

    int solve_mask(vector<int> mask) {
        unordered_set<int> s;
        for(int i = 0; i < n; ++i) {
            if(mask[i]) {
                for(int u : g[i])
                    s.insert(u);
            }
        }

        int sum = 0;
        for(int i : s)
            sum += c[i];

        return sum;
    }

    int solve() {
        int gcd = 0;

        for(int i = 0; i < pow(2, n); ++i) {
            vector<int> v(n, 0);
            for(int j = 0; j < n; ++j) v[j] = (i>>j)&1;
            gcd = __gcd(gcd, solve_mask(v));
            if(gcd == 1) return gcd;
        }

        return gcd;
    }
};

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = (stress ? 100 : 1);
    if((local || true) && (!stress)) cin >> tests;

    for(int test = 0; test < tests; ++test) {
        if(!stress) {
            int n, m;
            cin >> n >> m;

            vector<int> c(n, 0);
            for(int i = 0; i < n; ++i)
                cin >> c[i];

            vector<vector<int>> g(n);
            for(int i = 0; i < m; ++i) {
                int u, v;
                cin >> u >> v;
                u--; v--;

                g[u].push_back(v);
            }

            Solver solver(g, c, tests);
            int res = solver.solve();
            cout << res << "\n";

        } else {}
    }

    return 0;
}
