#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;
mt19937 gen(42);

struct Solver {
    vector<vector<int>> g;
    vector<int> c;
    int n, t;
    clock_t start;
    ld have_time;

    Solver(auto g, auto c, int t): g(g), c(c), t(t) {
        n = c.size();
        start = clock();
        have_time = 1.5/(ld)(t);
    }

    vector<int> cnt;
    int sum;
    int gcd;

    void _solve(int i, int b) {
        if(i == n) {
            gcd = __gcd(sum, gcd);
            return;
        }

        if(b) {
            for(int u : g[i]) {
                if(cnt[u] == 0) sum += c[u];
                cnt[u]++;
            }

            _solve(i+1, 0);
            _solve(i+1, 1);

            for(int u : g[i])
                cnt[u]--;
        } else {
            _solve(i+1, 0);
            _solve(i+1, 1);
        }
    }

    int solve() {
        gcd = 0, sum = 0;
        cnt.assign(n, 0);
        for(int i = 0; i < 2; ++i)
            _solve(0, i);
        return gcd;
    }
};

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = (stress ? 100 : 1);
    if((local || true) && (!stress)) cin >> tests;

    for(int test = 0; test < tests; ++test) {
        if(!stress) {
            int n, m;
            cin >> n >> m;

            vector<int> c(n, 0);
            for(int i = 0; i < n; ++i)
                cin >> c[i];

            vector<vector<int>> g(n);
            for(int i = 0; i < m; ++i) {
                int u, v;
                cin >> u >> v;
                u--; v--;

                g[u].push_back(v);
            }

            Solver solver(g, c, tests);
            int res = solver.solve();
            cout << res << "\n";

        } else {}
    }

    return 0;
}
