#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MAXN = 5002;

int n, m;
vector<long long> numbers;
vector<vector<int>> adjList;

void read() {
    cin >> n >> m;
    numbers.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> numbers[i];
    }
    adjList.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        adjList[i].clear();
    }
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        adjList[u].emplace_back(v);
    }
}

void solve() {
    vector<bitset<MAXN>> nodeSets(n + 1);
    vector<long long> sum(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        for (int adjNode : adjList[i]) {
            sum[i] += numbers[adjNode];
            nodeSets[i][adjNode] = true;
        }
    }
    long long answer = 0;
    for (int i = 1; i <= n; i++) {
        answer = __gcd(answer, sum[i]);
    }
    for (int i = 1; i < n; i++) {
        for (int j = i + 1; j <= n; j++) {
            long long currSum = sum[i] + sum[j];
            bitset<MAXN> intersection = nodeSets[i] & nodeSets[j];
            for (int k = 1; k <= n; k++) {
                if (intersection[k]) {
                    currSum -= numbers[k];
                }
            }
            answer = __gcd(answer, currSum);
        }
    }
    cout << answer << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        read();
        solve();
    }

    return EXIT_SUCCESS;
}
