#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long
#define ll long long

using namespace std;

const int N = 1e6 + 10;
const int inf = 1e18;

int q;
int n, m;
int a[N];
vector<int> g[N];
pair<int, vector<bool>> dp[N];

void clear()
{
    for (int i = 0; i < 2 * n; ++i)
        g[i].clear();

    for (int i = 0; i < 2 * n; ++i)
    {
        dp[i].x = 0;
        dp[i].y.clear();
    }
}

int __gcd(int a, int b)
{
    if (a < b)
        swap(a, b);

    if (b == 0)
        return a;

    return __gcd(b, a % b);
}

pair<int, vector<bool>> calc(vector<bool> &used, int x)
{
    vector<bool> us = used;

    int res = 0;

        for (auto u : g[x])
            if (!us[u - n])
            {
                us[u - n] = true;
                res += a[u - n];
            }

    return move(make_pair(res, move(us)));
}

void solve()
{
    int ans = 0;

    dp[0].x = 0;
    dp[0].y = vector<bool>(n + 1, false);

    int flmask = (1ll << n) - 1;

    for (int msk = 1; msk < (1ll << n); ++msk)
    {
        for (int b = 0; b < n; ++b)
            if ((1ll << b) & msk)
            {
                int mskw = msk ^ (1ll << b);

                auto p = calc(dp[mskw].y, b);
                dp[msk].x = p.x;
                dp[msk].y = p.y;
                break;
            }

        ans = __gcd(ans, dp[msk].x);

        if (ans == 1)
            break;
    }

    cout << ans << endl;
}

int32_t main()
{
    cin >> q;

    while (q--)
    {
        cin >> n >> m;

        for (int i = 0; i < n; ++i)
            cin >> a[i];

        for (int i = 0; i < m; ++i)
        {
            int v, u;

            cin >> v >> u;

            --v;
            --u;

            g[v].push_back(u + n);
        }

        solve();
        clear();
    }
}