#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 5000;

int arr[MAXN];
int graph[MAXN][MAXN];
int gsz[MAXN];
int sm[MAXN];
int sm2[MAXN][MAXN];
vector<int> gg[MAXN][MAXN];
int verts[MAXN];
int verts2[MAXN];

random_device rddev;

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int  t;
  cin >> t;
  while (t--) {
    int n, m;
    cin >> n >> m;
    int TIME = n * CLOCKS_PER_SEC * 1.99 / 10000;
    int tic = clock();
    iota(verts, verts + n, 0);
    iota(verts2, verts2 + n, 0);
    for (int i = 0; i < n; ++i) {
      gsz[i] = 0;
      sm[i] = 0;
      memset(sm2[i], 0, n);
      swap(verts[i], verts[rddev() % n]);
      swap(verts2[i], verts2[rddev() % n]);
    }
    for (int i = 0; i < n; ++i)
      cin >> arr[verts[i]];
    for (int i = 0; i < m; ++i) {
      int v, u;
      cin >> v >> u;
      v = verts2[v - 1], u = verts[u - 1];
      sm[v] += arr[u];
      graph[v][gsz[v]++] = u;
    }
    for (int i = 0; i < m; ++i) {
      sort(graph[i], graph[i] + gsz[i]);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
      ans = gcd(sm[i], ans);
    }
    for (int i = 0; i < n; ++i) {
      for (int j = i + 1; j < n; ++j) {
        int pi = 0, pj = 0;
        int s = 0;
        while (pi < gsz[i] && pj < gsz[j]) {
          int l = graph[i][pi];
          int r = graph[j][pj];
          if (l < r)
            pi++;
          else if (l > r)
            pj++;
          else {
            s += arr[l];
            pi++;
            pj++;
          }
        }
        sm2[i][j] = s;
        ans = gcd(sm[i] + sm[j] - s, ans);
      }
    }
    bool time = true;
    for (int i = 0; i < n && time; ++i) {
      for (int j = i + 1; j < n && time; ++j) {
        for (int k = j + 1; k < n && time; ++k) {
          int pi = 0, pj = 0, pk = 0;
          int s = 0;
          bool upd = true;
          while (upd && pi < gsz[i] && pj < gsz[j] && pk < gsz[k]) {
            upd = false;
            int l = graph[i][pi];
            int r = graph[j][pj];
            int h = graph[k][pk];
            while (pi + 1 < gsz[i] && (l < r || l < h))
              l = graph[i][++pi], upd = true;
            while (pj + 1 < gsz[j] && (r < l || r < h))
              r = graph[j][++pj], upd = true;
            while (pk + 1 < gsz[k] && (h < l || h < r))
              h = graph[k][++pk], upd = true;
            if (h == l && l == r) {
              s += arr[l];
              pi++;
              pj++;
              pk++;
              upd = true;
            }
          }
          ans = gcd(sm[i] + sm[j] + sm[k] - sm2[i][j] - sm2[j][k] - sm2[i][k] + s, ans);
          time &= clock() - tic < TIME;
        }
      }
    }
    cout << ans << '\n';
  }
  return 0;
}