//#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <sstream>
#include <random>
#include <bitset>
#include <time.h>

using namespace std;

#define int ll
#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
typedef long long ll;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

struct fenwick {
    int n;
    vector<int> f;
    fenwick (int _n) {
        n = _n;
        f.assign(n,0);
    }
    void update(int i, int v) {
        for (; i <= n; i += i & (-i)) {
            f[i] += v;
        }
    }
    int get_sum(int i) {
        int s = 0;
        for (; i > 0; i -= i & (-i)) {
            s += f[i];
        }
        return s;
    }
    int get(int L, int R) {
        return get_sum(R) - get_sum(L - 1);
    }
};

ll gcd(ll a, ll b) {
    return (b == 0 ? a : gcd(b, a % b));
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n + 1);
    vector<ll> cost(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
    }
    ll ans = 0;
    for (int mask = 1; mask < (1 << n); ++mask) {
        vector<int> used(n + 1, 0);
        ll s = 0;
        for (int bit = 0; bit < n; ++bit) {
            if (mask & (1 << bit)) {
                int v = bit + 1;
                for (auto u: g[v]) {
                    if (!used[u]) {
                        used[u] = 1;
                        s += cost[u];
                    }
                }
            }
        }
        ans = gcd(s, ans);
    }
    cout << ans << en;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    srand(time(0));
    int t = 1, D = 0;
    cin >> t;
    while (t--) solve();
    return 0;
}