#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <cassert>
#include <unordered_set>

using namespace std;

typedef long long ll;

const int N = 500010;
const ll MOD = (int)1e9 + 7;

const int INF = (int)1e9 + 10;

vector < int > g[N];

ll c[N];

const ll P1 = N + 13;
const ll P2 = N + 17;

ll st1[N], st2[N];

pair < ll, ll > get_hash(const vector < int > &v) {
	pair < ll, ll > h = { 0, 0 };
	for (int i = 0; i < v.size(); ++i) {
		h.first = P1 * h.first + (ll)v[i];
		h.second = P2 * h.second + (ll)v[i];
		h.first %= MOD;
		h.second %= MOD;
	}
	return h;
}

map < pair < ll, ll >, int > s;

int nn;

struct SNM {
	int par[N];
	void clr() {
		fill(par, par + (nn + 1), -1);
	}
	void make(int x) {
		par[x] = x;
	}
	int find(int x) {
		if (par[x] == x)
			return x;
		else
			return par[x] = find(par[x]);
	}
	void merge(int a, int b) {
		a = find(a), b = find(b);
		par[b] = a;
	}
} snm;

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	st1[0] = 1;
	for (int i = 1; i < N; ++i) {
		st1[i] = (st1[i - 1] * P1) % MOD;
	}
	st2[0] = 1;
	for (int i = 1; i < N; ++i) {
		st2[i] = (st2[i - 1] * P2) % MOD;
	}
	int t;
	cin >> t;
	while (t--) {
		snm.clr();
		s.clear();
		int n, m;
		cin >> n >> m;
		nn = n;
		for (int i = 0; i <= n; ++i) {
			g[i].clear();
		}
		for (int i = 0; i < n; ++i) {
			cin >> c[i];
		}
		for (int i = 0; i < m; ++i) {
			int v, to;
			cin >> v >> to;
			--v, --to;
			g[to].push_back(v);
		}
		for (int i = 0; i < n; ++i) {
			sort(g[i].begin(), g[i].end());
			snm.make(i);
		}
		for (int i = 0; i < n; ++i) {
			if (g[i].empty())
				continue;
			auto it = s.find(get_hash(g[i]));
			if (it != s.end()) {
				snm.merge(it->second, i);
				c[it->second] += c[i];
			} else {
				s[get_hash(g[i])] = i;
			}
		}
		ll ans = 0;
		for (int i = 0; i < n; ++i) {
			if (g[i].empty())
				continue;
			if (snm.find(i) != i)
				continue;
			ans = gcd(ans, c[i]);
		}
		cout << ans << '\n';
	}
}