#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>


using namespace std;


#define int long long


int gcd(int a, int b) {
    int t;
    while (b) {
        t = a;
        a = b;
        b = t % b;
    }

    return a;
}


const int MAXN = 5e5 + 5;


const int C = 3;


const int M[C] = { (int)1e9 + 7, (int)1e8 + 9, (int)1e9 + 7 };
const int P[C] = { 179, 57, 67 };

int PPOW[C][MAXN];


signed main() {
    for (int c = 0; c < C; ++c) {
        PPOW[c][0] = 1;
        for (int i = 1; i < MAXN; ++i) {
            PPOW[c][i] = PPOW[c][i - 1] * P[c] % M[c];
        }
    }

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while (t--) {
        int n, m;
        cin >> n >> m;

        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }

        vector<int> hs[C];
        for (int c = 0; c < C; ++c) {
            hs[c].resize(n);
        }

        int from, to;
        for (int i = 0; i < m; ++i) {
            cin >> from >> to;

            --from;
            --to;

            for (int c = 0; c < C; ++c) {
                hs[c][to] = (hs[c][to] + (from + 1) * PPOW[c][from]) % M[c];
            }
        }

        map<pair<int, pair<int, int>>, vector<int>> cls;
        for (int i = 0; i < n; ++i) {
            cls[{hs[0][i], { hs[1][i], hs[2][i] }}].push_back(i);
        }

        vector<int> sums;

        for (auto p : cls) {
            if (p.first == pair<int, pair<int, int>>(0, {0, 0})) {
                continue;
            }

            int cs = 0;
            for (int x : p.second) {
                cs += a[x];
            }

            sums.push_back(cs);
        }

        int answ = 0;
        for (int x : sums) {
            answ = gcd(answ, x);
        }

        cout << answ << '\n';
    }

    return 0;
}
