#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;

const int maxn = 2002;
const int inf = 1e9;

int dop[200];
int mdown[maxn][maxn];
int mleft[maxn][maxn];


struct node {
    int l, r, mmin;
    node *left, *right;
};

node *root_down[maxn];
node *root_left[maxn];

node *build2(int l, int r, int i){
    node *res = new node;
    res->l = l;
    res->r = r;
    if(l == r){
        res->mmin = mleft[l][i];
        res->right = res->left = nullptr;
    }
    else {
        int mid = (l+r) / 2;
        res->left = build2(l, mid, i);
        res->right = build2(mid+1, r, i);
        res->mmin = min(res->left->mmin, res->right->mmin);
    }
    return res;
}

node *build(int l, int r, int i){
    node *res = new node;
    res->l = l;
    res->r = r;
    if(l == r){
        res->mmin = mdown[i][l];
        res->right = res->left = nullptr;
    }
    else {
        int mid = (l+r) / 2;
        res->left = build(l, mid, i);
        res->right = build(mid+1, r, i);
        res->mmin = min(res->left->mmin, res->right->mmin);
    }
    return res;
}

int query(node *root, int l, int r){
    if(root->l > r || root->r < l)return inf;
    if(root->l >= l  && root->r <= r)return root->mmin;
    return min(query(root->left, l, r), query(root->right, l, r));
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<string> v(n);
    for(int c=0; c<n; c++)
        cin >> v[c];
    for(int c=0; c<m; c++){
        for(int i=0; i<200; i++)
            dop[i] = n;
        for(int i=n-1; i>=0; i--){
            mdown[i][c] = dop[v[i][c]] - i;
            dop[v[i][c]] = i;
        }
    }
    for(int c=0; c<n; c++){
        for(int i=0; i<200; i++)
            dop[i] = m;
        for(int i=m-1; i>=0; i--){
            mleft[c][i] = dop[v[c][i]] - i;
            dop[v[c][i]] = i;
        }
    }
    for(int c=0; c<n; c++){
        root_down[c] = build(0, m-1, c);
    }
    for(int c=0; c<m; c++){
        root_left[c] = build2(0, n-1, c);
    }
    int ans = 0;
    for(int c=0; c<n; c++){
        for(int i=0; i<m; i++){
            int l = 0, r = min(n, m)+1;
            while(l + 1 < r){
                int mid = (l+r) / 2;
                int res1 = query(root_down[c], i, i+mid);
                int res2 = query(root_left[i], c, c+mid);
                if(min(res1, res2) >= mid)l = mid;
                else r = mid;
            }
            ans += l;
        }
    }
    cout << ans;
    return 0;
}
/*
4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC
*/
