#include <bits/stdc++.h>
using namespace std;

random_device rddev;
mt19937 rd(rddev());

using ll = long long;
using ldb = long double;


vector<vector<int>> calcDown(vector<vector<int>> arr) {
	int n = arr.size();
	int m = arr[0].size();
	vector<vector<int>> closest(n, vector<int> (m, n));
	for (int j = 0; j < m; j++) {
		map<char, int> last;
		last[arr[n - 1][j]] = n - 1;
		for (int i = n - 2; i >= 0; i--) {
			if (last.count(arr[i][j]) == 0) {
				closest[i][j] = n;
			} else {
				closest[i][j] = last[arr[i][j]];
			}
			last[arr[i][j]] = i;
		}
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int j = 0; j < m; j++) {
			closest[i][j] = min(closest[i][j], closest[i + 1][j]);
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			closest[i][j] -= i;
		}
	}
	return closest;
}

void print(vector<int> arr) {
	for (int el : arr) {
		cout << el << " ";
	}
	cout << endl;
}

void print(vector<vector<int>> arr) {
	for (auto &el : arr) {
		print(el);
	}
}

vector<vector<int>> transpose(vector<vector<int>> arr) {
	int a = arr.size();
	int b = arr[0].size();
	vector<vector<int>> arr2(b, vector<int> (a));
	for (int i = 0; i < a; i++) {
		for (int j = 0; j < b; j++) {
			arr2[j][i] = arr[i][j];
		}
	}
	return arr2;
}

vector<vector<int>> calcRight(vector<vector<int>> arr) {
	auto arr2 = transpose(arr);
	auto arr3 = calcDown(arr2);
	auto arr4 = transpose(arr3);
	return arr4;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> arr(n, vector<int> (m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c;
			char c2;
			cin >> c >> c2;
			arr[i][j] = c * 256 + c2;
		}
	}
	auto down = calcDown(arr);
	auto right = calcRight(arr);
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			set<int> cur;
			int k = 0;
			int max_k = INT_MAX;
			while (true) {
				if (i + k == n || j + k == m) {
					break;
				}
				max_k = min(max_k, down[i][j + k]);
				max_k = min(max_k, right[i + k][j]);
				if (k >= max_k) {
					break;
				}
				for (int j1 = j; j1 < j + k + 1; j1++) {
					cur.insert(arr[i + k][j1]);
				}
				for (int i1 = i; i1 < i + k + 1; i1++) {
					cur.insert(arr[i1][j + k]);
				}
				k++;
				if (cur.size() <= k) {
					ans++;
				}
			}
		}
	}
	cout << ans << endl;
}
