#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


#define int long long


const int MAXN = 2001;
const int ALP = 94;
const int MAXS = ALP * ALP + 1;


int a[MAXN][MAXN];
int hhash[MAXN][MAXN];
int vhash[MAXN][MAXN];


const int M = (int)1e9 + 7;
const int P = 179;

int PPOW[MAXS];


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


int hh(int i, int j, int len) {
    return mod(hhash[i][j + len] - hhash[i][j]);
}

int vh(int i, int j, int len) {
    return mod(vhash[i + len][j] - vhash[i][j]);
}


signed main() {
    PPOW[0] = 1;
    for (int i = 1; i < MAXS; ++i) {
        PPOW[i] = PPOW[i - 1] * P % M;
    }

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    char c1, c2;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> c1 >> c2;
            
            c1 -= 33;
            c2 -= 33;

            a[i][j] = 1 + c1 * ALP + c2;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int cur = a[i][j];

            hhash[i][j + 1] = (hhash[i][j] + cur * PPOW[cur]) % M;
            vhash[i + 1][j] = (vhash[i][j] + cur * PPOW[cur]) % M;
        }
    }

    int answ = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            vector<int> used(MAXS);

            for (int k = 0; k < min(n - i, m - j); ++k) {
                int cur = a[i][j + k];

                if (used[cur]) {
                    break;
                }

                used[cur] = 1;

                int ch = hh(i, j, k + 1);

                bool b = true;
                for (int ci = i; ci <= i + k; ++ci) {
                    if (hh(ci, j, k + 1) != ch) {
                        b = false;

                        break;
                    }
                }

                for (int cj = j; cj <= j + k; ++cj) {
                    if (vh(i, cj, k + 1) != ch) {
                        b = false;

                        break;
                    }
                }

                answ += b;
            }
        }
    }

    cout << answ;

    return 0;
}
