#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

void update(vector<int> &vec, int &cnt, int x, bool add)
{
    if (add)
    {
        if (vec[x] == 0)
            cnt++;
        vec[x]++;
    }
    else
    {
        if (vec[x] == 1)
            cnt--;
        vec[x]--;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> matrix(n, vector<int>(m));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            char x, y;
            cin >> x >> y;

            matrix[i][j] = (x - 33) * 100 + (y - 33);
        }
    }

    int ans = 0;
    for (int k = 2; k <= min(n, m); k++)
    {
        deque<vector<int>> rows(n, vector<int>(1e4, 0));
        deque<vector<int>> cols(m, vector<int>(1e4, 0));
        vector<int> full(1e4);
        vector<int> cntr(n, 0);
        vector<int> cntc(m, 0);
        int cntf = 0;

        for (int i = 0; i + k - 1 < n; i++)
        {
            // even - right
            // odd - left

            int start, end, delta;
            if (i % 2 == 0)
            {
                start = 0;
                end = m - k;
                delta = 1;
            }
            else
            {
                start = m - k;
                end = 0;
                delta = -1;
            }

            for (int j = start; j != end + delta; j += delta)
            {
                if (j == start)
                {
                    if (i == 0) // Init
                    {
                        for (int x = 0; x < k; x++)
                        {
                            for (int y = 0; y < k; y++)
                            {
                                update(rows[x], cntr[x], matrix[x][y], true);
                                update(cols[y], cntc[y], matrix[x][y], true);
                                update(full, cntf, matrix[x][y], true);
                            }
                        }
                    }
                    else // Moving down
                    {
                        for (int y = j; y < j + k; y++)
                        {
                            update(rows[i - 1], cntr[i - 1], matrix[i - 1][y], false);
                            update(cols[y], cntc[y], matrix[i - 1][y], false);
                            update(full, cntf, matrix[i - 1][y], false);

                            update(rows[i + k - 1], cntr[i + k - 1], matrix[i + k - 1][y], true);
                            update(cols[y], cntc[y], matrix[i + k - 1][y], true);
                            update(full, cntf, matrix[i + k - 1][y], true);
                        }
                    }
                }
                else if (delta == 1) // Moving right
                {
                    for (int x = i; x < i + k; x++)
                    {
                        update(rows[x], cntr[x], matrix[x][j - 1], false);
                        update(cols[j - 1], cntc[j - 1], matrix[x][j - 1], false);
                        update(full, cntf, matrix[x][j - 1], false);

                        update(rows[x], cntr[x], matrix[x][j + k - 1], true);
                        update(cols[j + k - 1], cntc[j + k - 1], matrix[x][j + k - 1], true);
                        update(full, cntf, matrix[x][j + k - 1], true);
                    }
                }
                else // Moving left
                {
                    for (int x = i; x < i + k; x++)
                    {
                        update(rows[x], cntr[x], matrix[x][j + k], false);
                        update(cols[j + k], cntc[j + k], matrix[x][j + k], false);
                        update(full, cntf, matrix[x][j + k], false);

                        update(rows[x], cntr[x], matrix[x][j], true);
                        update(cols[j], cntc[j], matrix[x][j], true);
                        update(full, cntf, matrix[x][j], true);
                    }
                }

                if (cntf != k)
                    continue;

                bool flag = false;
                for (int x = i; x < i + k; x++)
                {
                    if (cntr[x] != k)
                    {
                        flag = true;
                        break;
                    }
                }

                if (flag)
                    continue;

                for (int y = j; y < j + k; y++)
                {
                    if (cntc[y] != k)
                    {
                        flag = true;
                        break;
                    }
                }

                if (!flag)
                    ans++;
            }
        }
    }

    cout << ans + n * m << endl;

    return 0;
}