#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

const int p = 127;

int n, m;
vector<vector<int>> a;

bool check(int i, int j, int k, int l) {
    set<int> x;

    for (int r = i; r <= k; ++r) {
        set<int> s;
        for (int t = j; t <= l; ++t) {
            if (s.count(a[r][t])) {
                return false;
            }
            s.insert(a[r][t]);
            x.insert(a[r][t]);
        }
    }

    if (x.size() != k - i + 1) return false;

    for (int t = j; t <= l; ++t) {
        set<int> s;
        for (int r = i; r <= k; ++r) {
            if (s.count(a[r][t])) {
                return false;
            }
            s.insert(a[r][t]);
        }
    }
    return true;
}

void solve() {
    cin >> n >> m;
    a.resize(n, vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char x, y;
            cin >> x >> y;
            a[i][j] = (x - 33 + 1) * p + (y - 33 + 1);
        }
    }

    int ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = i; k < n; ++k) {
                for (int l = j; l < m; ++l) {
                    if (k - i != l - j) continue;
                    /*if (check(i, j, k, l)) {
                        cout << i+1 sp j+1 sp k+1 sp l+1 nl;
                        ans++;
                    }*/
                    ans += check(i, j, k, l);
                }
            }
        }
    }

    cout << ans nl;
}

/**

4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

**/
