#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define left left228

const int MAXN = 2e3;

pair<char, char> matrix[MAXN][MAXN];
int up[MAXN][MAXN], left[MAXN][MAXN];

inline int up_max(int i, int j, int k) {
    int ans = -1;
    for (int c = 0; c < k; c++) {
        for (int t = 0; t < k; t++) {
            ans = max(up[i + c][j + t], ans);
        }
    }
    return ans;
}

inline int left_max(int i, int j, int k) {
    int ans = -1;
    for (int c = 0; c < k; c++) {
        for (int t = 0; t < k; t++) {
            ans = max(left[i + c][j + t], ans);
        }
    }
    return ans;
}

inline int different(int i, int j, int k) {
    set<pair<char, char>> x;
    for (int c = 0; c < k; c++) {
        for (int t = 0; t < k; t++) {
            x.emplace(matrix[i + c][j + t]);
        }
    }
    return x.size();
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> matrix[i][j].first >> matrix[i][j].second;
            if (matrix[i][j].first > matrix[i][j].second) {
                swap(matrix[i][j].first, matrix[i][j].second);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        map<pair<char, char>, int> prev;
        for (int j = 0; j < m; j++) {
            if (prev.find(matrix[i][j]) == prev.end()) {
                left[i][j] = -1;
            } else {
                left[i][j] = prev[matrix[i][j]];
            }
            prev[matrix[i][j]] = j;
        }
    }
    for (int j = 0; j < m; j++) {
        map<pair<char, char>, int> prev;
        for (int i = 0; i < n; i++) {
            if (prev.find(matrix[i][j]) == prev.end()) {
                up[i][j] = -1;
            } else {
                up[i][j] = prev[matrix[i][j]];
            }
            prev[matrix[i][j]] = i;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int l = 0, r = min(n, m) + 1;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if (i + mid > n || j + mid > m || left_max(i, j, mid) >= j || up_max(i, j, mid) >= i) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            int cur = 1;
            while (i + cur <= n && j + cur <= m) {
//                cout << i << ' ' << j << ' ' << cur << ' ' << different(i, j, cur) << endl;
                if (different(i, j, cur) == cur) {
                    cur++;
                    ans++;
                } else {
                    cur++;
                }
            }
        }
    }
    cout << ans;
    return 0;
}