#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef int64_t ll;

const ll N = 2'001;

ll power(ll x, ll n) {
	if (n == 0) {
		return 1;
	}
	if (n & 1) {
		return x * power(x * x, n >> 1);
	}
	return power(x * x, n >> 1);
}

ll n, m;
ll arr[N][N];
ll used[N][N];

inline ll get(ll x1, ll y1, ll x2, ll y2) {
	return arr[x2][y2] - arr[x1 - 1][y2] - arr[x2][y1 - 1] + arr[x1 - 1][y1 - 1];
}

int main() {
	ll result = 0;
	cin >> n >> m;
	for (ll i = 1; i <= n; ++i) {
		for (ll j = 1; j <= m; ++j) {
			char x, y;
			cin >> x >> y;
			arr[i][j] = power(1'000'000'009, x * 100 + y);
		}
	}
	for (ll x = 1; x <= n; ++x) {
		for (ll y = 1; y <= m; ++y) {
			arr[x][y] = arr[x][y] + arr[x - 1][y] + arr[x][y - 1] - arr[x - 1][y - 1];
		}
	}
	for (ll len = 1; len <= min(n, m); ++len) {
		for (ll x1 = 1, x2 = len; x2 <= n; ++x1, ++x2) {
			vector<ll> y(m + 1);
			for (ll i = 1; i <= m; ++i) {
				y[i] = get(x1, i, x2, i);
			}
			vector<ll> p = y;
			for (ll i = 1; i <= m; ++i) {
				p[i] = p[i - 1] + p[i];
			}
			for (ll i = 1; i + len - 1 <= m; ++i) {
				if (p[i + len - 1] - p[i] == y[i] * (len - 1)) {
					used[x1][i] = len;
				}
			}
		}
		for (ll y1 = 1, y2 = len; y2 <= m; ++y1, ++y2) {
			vector<ll> x(n + 1);
			for (ll i = 1; i <= n; ++i) {
				x[i] = get(i, y1, i, y2);
			}
			vector<ll> p = x;
			for (ll i = 1; i <= n; ++i) {
				p[i] = p[i - 1] + p[i];
			}
			for (ll i = 1; i + len - 1 <= n; ++i) {
				if (p[i + len - 1] - p[i] == x[i] * (len - 1) && used[i][y1] == len) {
					++result;
				}
			}
		}
	}
	cout << result << endl;
	return 0;
}
