#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
#include <map>
#include <vector>
//#include <unordered_set>
#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
#include <queue>
//#include <utility>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

using ll = long long;
#define all(c) c.begin(),c.end()

//mt19937_64 rng(228);

void _tmain([[maybe_unused]] int test_id) {
    int n, m;
    cin >> n >> m;
    vector<string> table(n);
    for (string &s : table) { cin >> s; }
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            a[i][j] = (table[i][2 * j] - 33) + (table[i][2 * j + 1] - 33) * 94;
        }
    }
    int max_coord = 0;
    {
        vector<int> compr;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                compr.push_back(a[i][j]);
            }
        }
        sort(all(compr));
        compr.erase(unique(all(compr)), compr.end());
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                int x = a[i][j];
                int cx = lower_bound(all(compr), x) - compr.begin();
                a[i][j] = cx;
                $ printf("%d ", cx);
            }
            $ printf("\n");
        }
        max_coord = compr.size();
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 1; i + k <= n && j + k <= m; ++k) {
                bool ok = true;
                for (int s1 = 0; s1 < k; ++s1) {
                    vector<bool> cnt;
                    cnt.assign(max_coord, false);
                    for (int s2 = 0; s2 < k; ++s2) {
                        if (cnt[a[i + s1][j + s2]]) { ok = false; }
                        cnt[a[i + s1][j + s2]] = true;
                    }
                    cnt.assign(max_coord, false);
                    for (int s2 = 0; s2 < k; ++s2) {
                        if (cnt[a[i + s2][j + s1]]) { ok = false; }
                        cnt[a[i + s2][j + s1]] = true;
                    }
                }
                if (ok) {
                    set<int> diff;
                    for (int s1 = 0; s1 < k; ++s1) {
                        for (int s2 = 0; s2 < k; ++s2) {
                            diff.insert(a[i + s1][j + s2]);
                        }
                    }
                    if (diff.size() > k) {
                        ok = false;
                    }
                }
                if (ok) {
                    ++ans;
                    // $ printf("(%d, %d), size %d\n", i, j, k);
                }
            }
        }
    }
    cout << ans << "\n";
}
