#include <bits/stdc++.h>


using namespace std;


#define int long long


void warp()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


const int maxp = 1e5;
bool prime[maxp];
const int MOD = 1791791791;
const int maxc = 1e4;
int cnt[maxc];


int calc(int n, int m, int l, vector<vector<int> > &f, vector<int> &p)
{
    vector<vector<int> > horizHash(n, vector<int> (m));
    vector<vector<int> > vertHash(n, vector<int> (m));
    int ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            horizHash[i][j] = 1;
            for (int k = j; k < j + l; k++)
            {
                if (k >= m)
                {
                    horizHash[i][j] = -1;
                    break;
                }
                horizHash[i][j] *= p[f[i][k]];
                horizHash[i][j] %= MOD;
            }
            vertHash[i][j] = 1;
            for (int k = i; k < i + l; k++)
            {
                if (k >= n)
                {
                    vertHash[i][j] = -1;
                    break;
                }
                vertHash[i][j] *= p[f[k][j]];
                vertHash[i][j] %= MOD;
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (horizHash[i][j] == -1 || vertHash[i][j] == -1) continue;
            if (horizHash[i][j] != vertHash[i][j]) continue;
            bool flag = true;
            for (int k = i; k < i + l; k++)
            {
                int cur = f[k][j];
                if (cnt[cur] > 0) flag = false;
                if (horizHash[i][j] != horizHash[k][j]) flag = false;
                cnt[cur]++;
            }
            for (int k = i; k < i + l; k++)
            {
                int cur = f[k][j];
                cnt[cur]--;
            }
            for (int k = j; k < j + l; k++)
            {
                int cur = f[i][k];
                if (cnt[cur] > 0) flag = false;
                if (vertHash[i][j] != vertHash[i][k]) flag = false;
                cnt[cur]++;
            }
            for (int k = j; k < j + l; k++)
            {
                int cur = f[i][k];
                cnt[cur]--;
            }
            ans += flag;
        }
    }
    return ans;
}


signed main()
{
    warp();
    for (int i = 0; i < maxc; i++) cnt[i] = 0;
    for (int i = 0; i < maxp; i++)
    {
        prime[i] = true;
    }
    prime[0] = false;
    prime[1] = false;
    vector<int> p;
    for (int i = 2; i < maxp; i++)
    {
        if (!prime[i]) continue;
        p.push_back(i);
        for (int j = 2; i * j < maxp; j++) prime[i * j] = false;
    }
    random_shuffle(p.begin(), p.end());
    int n, m;
    cin >> n >> m;
    vector<vector<int> > f(n, vector<int> (m));
    int temp = 126 - 33;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            char a, b;
            cin >> a >> b;
            a -= 33;
            b -= 33;
            f[i][j] = a * temp + b;
        }
    }
    int ans = 0;
    for (int l = 1; l <= min(n, m); l++) ans += calc(n, m, l, f, p);
    cout << ans << endl;
    return 0;
}
