//#pragma GCC optimize "-O3"
#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v)
		os << x << " ";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y << " ";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v)
		is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

mt19937 rng(37163);
uniform_int_distribution<ll> dst(0LL, (ll)1e18);
const int N = 2000;
int n, m;

ull v[N][N];
ull pr[N][N];
int id[N][N];
int where[100 * 100];
int row[N][N];
int col[N][N];

ull dict[100][100];
int used[100 * 100];

void init_pr() {
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			pr[i][j] = v[i][j];
			if (i - 1 >= 0) {
				pr[i][j] += pr[i - 1][j];
			}
			if (j - 1 >= 0) {
				pr[i][j] += pr[i][j - 1];
			}
			if (i - 1 >= 0 && j - 1 >= 0) {
				pr[i][j] -= pr[i - 1][j - 1];
			}
		}
}

ull get_sum(int xl, int yl, int xr, int yr) {
	ull S = pr[xr][yr];
	if (xl - 1 >= 0) S -= pr[xl - 1][yr];
	if (yl - 1 >= 0) S -= pr[xr][yl - 1];
	if (xl - 1 >= 0 && yl - 1 >= 0) S += pr[xl - 1][yl - 1];
	return S;
}

bool stp(int xl, int yl, int xr, int yr) {
	set<int> diff;
	for (int i = xl; i <= xr; i++)
		for (int j = yl; j <= yr; j++)
			diff.insert(id[i][j]);
	if (le(diff) != xr - xl + 1) return false;
	for (int i = xl; i <= xr; i++)
		for (int j = yl; j <= yr; j++)
			for (int k = j + 1; k <= yr; k++)
				if (id[i][j] == id[i][k]) return false;
	for (int j = yl; j <= yr; j++)
		for (int i = xl; i <= xr; i++)
			for (int k = i + 1; k <= xr; k++)
				if (id[i][j] == id[k][j]) return false;
	return true;
}

void run() {
	for (int i = 0; i < 100; i++)
		for (int j = 0; j < 100; j++)
			dict[i][j] = dst(rng);
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		string s; cin >> s;
		for (int j = 0; j < le(s); j += 2) {
			v[i][j / 2] = dict[s[j] - 33][s[j + 1] - 33];
			id[i][j / 2] = (int)(s[j] - 33) * 100 + (int)(s[j + 1] - 33);
		}
	}
	init_pr();
	for (int i = 0; i < n; i++) {
		memset(where, -1, sizeof where);
		for (int j = m - 1; ~j; j--) {
			if (j == m - 1) row[i][j] = 1;
			else row[i][j] = row[i][j + 1] + 1;
			if (where[id[i][j]] != -1) {
				row[i][j] = min(row[i][j], where[id[i][j]] - j);
			}
			where[id[i][j]] = j;
		}
	}
	for (int j = 0; j < m; j++) {
		memset(where, -1, sizeof where);
		for (int i = n - 1; ~i; i--) {
			if (i == n - 1) col[i][j] = 1;
			else col[i][j] = col[i + 1][j] + 1;
			if (where[id[i][j]] != -1) {
				col[i][j] = min(col[i][j], where[id[i][j]] - i);
			}
			where[id[i][j]] = i;
		}
	}
	int total = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ull L = 0, R = 0; int bar = 1e9;
			for (int k = 1; i + k <= n && j + k <= m; k++) {
				bar = min(bar, row[i + k - 1][j]);
				bar = min(bar, col[i][j + k - 1]);
				if (k > bar) break;
				L += v[i][j + k - 1];
				R += v[i + k - 1][j];
				if (L == R) {
					if (stp(i,j, i + k - 1, j + k - 1)) {
						total++;
					}	
				}
			}
		}
	}
	cout << total << endl;
}

signed main(int argc, char const *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	//freopen("test.in", "r", stdin);
	run();
}