#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto tstart = chrono::high_resolution_clock::now();
#define tend chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(tend - tstart).count()

int n, m;
map<string, int> enc;
int ind = 1;
vector<vector<int> > table;

void solve() {
    cin >> n >> m;
    table.resize(n, vector<int> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c1, c2;
            cin >> c1 >> c2;
            if (enc.count({c1, c2}) == 0) {
                enc[{c1, c2}] = ind++;
            }
            table[i][j] = enc[{c1, c2}];
        }
    }
    vector<vector<vector<set<int> > > > dif1(n, vector<vector<set<int> > > (m, vector<set<int> > (m + 1)));
    vector<vector<vector<set<int> > > > dif2(n, vector<vector<set<int> > > (m, vector<set<int> > (n + 1)));
    vector<vector<vector<set<int> > > > dif3(n, vector<vector<set<int> > > (m, vector<set<int> > (m + 1)));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            dif3[i][j][1].insert(table[i][j]);
        }
    }
    //cout << "DIF3\n";
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int sz = 2; sz + i <= n && sz + j <= m; ++sz) {
                int i1 = i + sz, j1 = j + sz;
                dif3[i][j][sz] = dif3[i][j][sz - 1];
                for (int k = i; k < i1; ++k) {
                    dif3[i][j][sz].insert(table[k][j1 - 1]);
                }
                for (int k = j; k < j1; ++k) {
                    dif3[i][j][sz].insert(table[i1 - 1][k]);
                }
//                cout << "Index: " << i << ' ' << j << ' ' << sz << '\n';
//                for (int num : dif3[i][j][sz]) {
//                    cout << num << ' ';
//                }
//                cout << '\n';
            }
        }
    }
    //cout << "DIF1\n";
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            dif1[i][j][1].insert(table[i][j]);
            dif2[i][j][1].insert(table[i][j]);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int sz = 2; sz + j <= m; ++sz) {
                dif1[i][j][sz] = dif1[i][j][sz - 1];
                dif1[i][j][sz].insert(table[i][j + sz - 1]);
//                cout << "Index: " << i << ' ' << j << ' ' << sz << '\n';
//                for (int num : dif1[i][j][sz]) {
//                    cout << num << ' ';
//                }
//                cout << '\n';
            }
        }
    }
    //cout << "DIF2\n";
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int sz = 2; sz + i <= n; ++sz) {
                dif2[i][j][sz] = dif2[i][j][sz - 1];
                dif2[i][j][sz].insert(table[i + sz - 1][j]);
//                cout << "Index: " << i << ' ' << j << ' ' << sz << '\n';
//                for (int num : dif2[i][j][sz]) {
//                    cout << num << ' ';
//                }
//                cout << '\n';
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int sz = 1; sz + i <= n && sz + j <= m; ++sz) {
                if (dif3[i][j][sz].size() == sz) {
                    bool flag = true;
                    int i1 = i + sz, j1 = j + sz;
                    for (int k = i; k < i1; ++k) {
                        if (dif1[k][j][sz].size() != sz) {
                            flag = false;
                            break;
                        }
                    }
                    for (int k = j; k < j1; ++k) {
                        if (dif2[i][k][sz].size() != sz) {
                            flag = false;
                            break;
                        }
                    }
                    if (flag) {
                        cnt++;

                    }

                }
            }
        }
    }
    cout << cnt;
}

int main() {
//    freopen("input.in", "r", stdin);
//    freopen("output.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
}