#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>

using namespace std;

const int MAX_N = 2'000, MIN_ALPHA = 0, MAX_ALPHA = 8837, ALPH = 126 - 33 + 1;

vector <vector <int>> sum[MAX_ALPHA];

int dif(int x, int y, int a) {
	int ans = 0;
	for (int i = MIN_ALPHA; i < MAX_ALPHA; i++) {
		int val = sum[i][x + a - 1][y + a - 1];
		if (x)
			val -= sum[i][x - 1][y + a - 1];
		if (y)
			val -= sum[i][x + a - 1][y - 1];
		if (x && y)
			val += sum[i][x - 1][y - 1];
		if (val)
			ans++;
	}
	return ans;
}

int dif(int x, int y, int a, int b) {
	int ans = 0;
	for (int i = MIN_ALPHA; i < MAX_ALPHA; i++) {
		int val = sum[i][x + a - 1][y + b - 1];
		if (x)
			val -= sum[i][x - 1][y + b - 1];
		if (y)
			val -= sum[i][x + a - 1][y - 1];
		if (x && y)
			val += sum[i][x - 1][y - 1];
		if (val)
			ans++;
	}
	return ans;
}

bool check(int x, int y, int a) {
	for (int i = x; i < x + a; i++) {
		if (dif(i, y, 1, a) != a)
			return 0;
	}
	for (int i = y; i < y + a; i++) {
		if (dif(x, i, a, 1) != a)
			return 0;
	}
	return 1;
}

void build(vector <string> a) {
	for (auto& u : a)
		for (auto& w : u)
			w -= 33;
	for (int k = MIN_ALPHA; k < MAX_ALPHA; k++) {
		sum[k][0][0] = (a[0][0] * ALPH + a[0][1] == k ? 1 : 0);
		for (int i = 1; i < a.size(); i++)
			sum[k][i][0] = sum[k][i - 1][0] + (a[i][0] * ALPH + a[i][1] == k ? 1 : 0);
		for (int i = 2; i < a[0].size(); i += 2) {
			sum[k][0][i / 2] = sum[k][0][i / 2 - 1] + 
				(a[0][i] * ALPH + a[0][i + 1] == k ? 1 : 0);
		}
		for (int i = 1; i < a.size(); i++) {
			for (int j = 2; j < a[i].size(); j += 2) {
				sum[k][i][j / 2] = sum[k][i - 1][j / 2] + sum[k][i][j / 2 - 1] -
					sum[k][i - 1][j / 2 - 1] + (a[i][j] * ALPH + a[i][j + 1] == k ? 1 : 0);
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = MIN_ALPHA; i < MAX_ALPHA; i++) {
		sum[i].resize(n, vector <int>(m, 0));
	}
	vector <string> a(n);
	for (auto& u : a)
		cin >> u;
	build(a);
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int a = 1; a + i <= n && a + j <= m && a < MAX_ALPHA - MIN_ALPHA; a++) {
				if (dif(i, j, a) == a && check(i, j, a)) {
					ans++;
				}
			}
		}
	}
	cout << ans;
}