#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

const int p = 127;

int n, m;
vector<vector<int>> a;

bool check(int i, int j, int k, int l) {
    set<int> x;

    for (int r = i; r <= k; ++r) {
        set<int> s;
        for (int t = j; t <= l; ++t) {
            if (s.count(a[r][t])) {
                return false;
            }
            s.insert(a[r][t]);
            x.insert(a[r][t]);
        }
    }

    if (x.size() != k - i + 1) return false;

    for (int t = j; t <= l; ++t) {
        set<int> s;
        for (int r = i; r <= k; ++r) {
            if (s.count(a[r][t])) {
                return false;
            }
            s.insert(a[r][t]);
        }
    }
    return true;
}

void solve() {
    cin >> n >> m;
    a.resize(n, vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char x, y;
            cin >> x >> y;
            a[i][j] = (x - 33 + 1) * p + (y - 33 + 1);
        }
    }

    int ans = n * m;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int k = 1;

            //cout << "i,j" sp i+1 sp j+1 nl;

            set<int> gl;
            vector<set<int>> x, y;

            x.push_back({a[i][j]});
            y.push_back({a[i][j]});
            gl.insert(a[i][j]);

            while (i + k < n && j + k < m) {
                for (int f = 0; f < k; ++f) {
                    x[f].insert(a[i + f][j + k]);
                    gl.insert(a[i + f][j + k]);
                }

                for (int f = 0; f < k; ++f) {
                    y[f].insert(a[i + k][j + f]);
                    gl.insert(a[i + k][j + f]);
                }

                x.push_back(set<int>());
                y.push_back(set<int>());

                for (int f = 0; f <= k; ++f) {
                    x[k].insert(a[i + k][j + f]);
                    gl.insert(a[i + k][j + f]);
                }

                for (int f = 0; f <= k; ++f) {
                    y[k].insert(a[i + f][j + k]);
                    gl.insert(a[i + f][j + k]);
                }

                bool flag = true;

                for (int f = 0; f <= k; ++f) {
                    flag &= x[f].size() == k + 1;
                    flag &= y[f].size() == k + 1;
                }

                if (gl.size() == k + 1 && flag) {
                    //cout << "k" sp k nl;
                    ans += 1;
                }

                k += 1;
            }
        }
    }

    cout << ans nl;
}

/**

4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

**/
