#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cassert>
#include <algorithm>
#include <cstring>
#include <iomanip>
#include <random>


#pragma GCC optimize("Ofast")
#pragma GCC optimize("avx2")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("popcnt")

#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define fx(x, a) for (auto &x : a)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<string> vs;
typedef vector<char> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;


#ifdef LOCAL
const int MX = 200;
const int D = 5;
const int INF = 200;
const ll BIG = 400;
#else
const int MX = 2001;
const int D = 340;
const int INF = (int)1e9 + 50;
const int BIG = (long long)2e18 + 50;
#endif

mt19937_64 rnd(228 + 1337);

const int ALP = 94;

int t[MX][MX];
int tor[MX][MX];
int tod[MX][MX];

int cnt[ALP * ALP];

inline void z() {
    memset(cnt, 0, sizeof(int) * ALP);
}

ull hs[ALP * ALP];
ull hsum[MX][MX];


inline ull get(int i1, int j1, int i2, int j2) {
    ull ans = 0;
    ans += hsum[i2 + 1][j2 + 1];
    ans -= hsum[i1][j2 + 1];
    ans -= hsum[i2 + 1][j1];
    ans += hsum[i1][j1];
    return ans;
}

int main() {
#ifdef LOCAL
    freopen("C:\\Users\\olymp\\CLionProjects\\open\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    fi(0, ALP * ALP) {
        hs[i] = rnd();
    }
    int n, m;
    cin >> n >> m;
    fi(0, n) {
        fj(0, 2 * m) {
            char x;
            cin >> x;
            x -= 33;
            int jj = j / 2;
            if (j % 2 == 0)
                t[i][jj] += (int)x * ALP;
            else {
                t[i][jj] += x;
                hsum[i + 1][jj + 1] = hsum[i + 1][jj] + hsum[i][jj + 1] - hsum[i][jj] + hs[t[i][jj]];
            }
        }
    }

    fi(0, n) {
        int r = 0;
        int l = 0;
        z();
        while (l < m) {
            if (l >= r)
                ++cnt[t[i][l]];
            r = max(r, l + 1);
            while (r < m && cnt[t[i][r]] == 0) {
                ++cnt[t[i][r]];
                ++r;
            }
            tor[i][l] = r - l;
            --cnt[t[i][l]];
            ++l;
        }
    }
    fj(0, m) {
        int l = 0;
        int r = 0;
        z();
        while (l < n) {
            if (l >= r)
                ++cnt[t[l][j]];
            r = max(r, l + 1);
            while (r < n && cnt[t[r][j]] == 0) {
                ++cnt[t[r][j]];
                ++r;
            }
            tod[l][j] = r - l;
            --cnt[t[l][j]];
            ++l;
        }
    }
    int ans = 0;
    fi(0, n) {
        fj(0, m) {
            if (j == 1)
                ++--j;
            int rb = j;
            int mn = INF;
            while (rb < m) {
                if (tod[i][rb] < mn)
                    mn = tod[i][rb];
                if (mn < rb - j + 1)
                    break;
                ++rb;
            }
            mn = INF;
            int db = i;
            while (db < n) {
                if (tor[db][j] < mn)
                    mn = tor[db][j];
                if (mn < db - i + 1)
                    break;
                ++db;
            }
            ull mxk = min(rb - j, db - i);
            ull cursum = 0;
            for (ull k = 2; k <= mxk; ++k) {
                ull ksum = get(i, j, i + k - 1, j + k - 1);
                cursum += hs[t[i][j + k - 1]];
                if (ksum == k * cursum) {
                    ++ans;
                }
            }
        }
    }
    cout << ans + n * m;

}