#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>

using namespace std;

typedef int ll;

const ll N = 2'001;

ll power(ll x, ll n) {
	if (n == 0) {
		return 1;
	}
	if (n & 1) {
		return x * power(x * x, n >> 1);
	}
	return power(x * x, n >> 1);
}

ll sum_x[N][N];
ll sum_y[N][N];
bitset<N> used[N];
int16_t arr0[N][N];

inline ll get_x(ll x1, ll x2, ll y) {
	return sum_x[y][x2] - sum_x[y][x1 - 1];
}

inline ll get_y(ll y1, ll y2, ll x) {
	return sum_y[x][y2] - sum_y[x][y1 - 1];
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);

	ll n, m;

	int64_t result = 0;
	cin >> n >> m;
	for (ll i = 1; i <= n; ++i) {
		for (ll j = 1; j <= m; ++j) {
			char x, y;
			cin >> x >> y;
			arr0[i][j] = (x - 33) * 100 + (y - 33);
			ll z = power(179, x * 100 + y);
			sum_x[j][i] = z;
			sum_y[i][j] = z;
		}
	}
	for (ll x = 1; x <= n; ++x) {
		vector<ll> id(10'666, N + 666);
		for (ll y = m; y > 0; --y) {
			ll z = arr0[x][y];
			arr0[x][y] = id[z];
			id[z] = y;
		}
		int16_t mn = N + 666;
		for (ll y = m; y > 0; --y) {
			arr0[x][y] = min(mn, arr0[x][y]);
			mn = min(arr0[x][y], mn);
		}
	}
	for (ll x = 1; x <= n; ++x) {
		for (ll y = 1; y <= m; ++y) {
			sum_y[x][y] = sum_y[x][y] + sum_y[x][y - 1];
		}
	}
	for (ll y = 1; y <= m; ++y) {
		for (ll x = 1; x <= m; ++x) {
			sum_x[y][x] = sum_x[y][x] + sum_x[y][x - 1];
		}
	}
	for (ll len = 1; len <= min(n, m); ++len) {
		for (ll x1 = 1, x2 = len; x2 <= n; ++x1, ++x2) {
			vector<ll> y(m + 1);
			for (ll i = 1; i <= m; ++i) {
				y[i] = get_x(x1, x2, i);
			}
			vector<ll> p(m + 1);
			for (ll i = 1; i <= m; ++i) {
				if (y[i] == y[i - 1]) {
					p[i] = p[i - 1] + 1;
				} else {
					p[i] = 1;
				}
			}
			for (ll i = 1; i + len - 1 <= m; ++i) {
				if (p[i + len - 1] >= len) {
					used[x1][i] = (len & 1);
				} else {
					used[x1][i] = ((len & 1) ^ 1);
				}
			}
		}
		for (ll y1 = 1, y2 = len; y2 <= m; ++y1, ++y2) {
			vector<ll> x(n + 1);
			for (ll i = 1; i <= n; ++i) {
				x[i] = get_y(y1, y2, i);
			}
			vector<ll> p(n + 1);
			for (ll i = 1; i <= n; ++i) {
				if (x[i] == x[i - 1]) {
					p[i] = p[i - 1] + 1;
				} else {
					p[i] = 1;
				}
			}
			for (ll i = 1; i + len - 1 <= n; ++i) {
				if (p[i + len - 1] >= len && used[i][y1] == (len & 1)) {
					if (arr0[i][y1] > y2) {
						++result;
					}
				}
			}
		}
	}
	cout << result << endl;
	return 0;
}
