#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>
#include<set>
#include<string>

using namespace std;

long long gcd(long long a, long long b) {
	if (a < b) {
		swap(a, b);
	}
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

int main() {
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector<vector<int>> p(n,vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char a, b;
			cin >> a >> b;
			p[i][j] = (a - 33) * 100 + b - 33;
		}
	}
	vector<vector<int>> lx(n, vector<int>(m));
	vector<vector<int>> ly(n, vector<int>(m));
	map<int, int> mp;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			lx[i][j] = mp[p[i][j]];
			mp[p[i][j]] = j + 1;
		}
		for (int j = 0; j < m; j++) {
			mp[p[i][j]] = 0;
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			ly[j][i] = mp[p[j][i]];
			mp[p[j][i]] = j + 1;
		}
		for (int j = 0; j < n; j++) {
			mp[p[j][i]] = 0;
		}
	}
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int minx = 0, miny = 0;
			set<int> se;
			for (int sz = 1; sz < 1e9; sz+=1) {
				if (i - sz + 1 < 0 || j - sz + 1 < 0 || minx > j - sz + 1 || miny > i - sz + 1) {
					break;
				}
				int x1 = i - sz + 1;
				int y1 = j - sz + 1;
				for (int i1 = i - sz + 1; i1 <= i; i1++) {
					minx = max(minx, lx[i1][y1]);
					miny = max(miny, ly[i1][y1]);
					se.insert(p[i1][y1]);
				}
				for (int j1 = j - sz + 1; j1 <= j; j1++) {
					minx = max(minx, lx[x1][j1]);
					miny = max(miny, ly[x1][j1]);
					se.insert(p[x1][j1]);
				}
				if (se.size() == sz && minx <= j - sz + 1 && miny <= i - sz + 1) {
					ans++;
					if (minx > j - 2 * sz + 1 || miny > i - 2 * sz + 1) {
						break;
					}
				}
			}
		}
	}
	cout << ans;
}