#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx")

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;
typedef pair<unsigned short, unsigned short> pus;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pus>> f(n, vector<pus>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c1, c2;
            cin >> c1 >> c2;
            f[i][j].first = (int)c1;
            f[i][j].second = (int)c2;
        }
    }
    int ans = n * m;
    for (int x = 0; x < n; ++x) {
        for (int y = 0; y < m; ++y) {
            vector<set<pus>> st, col;
            st.push_back({ f[x][y] });
            col.push_back({ f[x][y] });
            for (int len = 1; x + len < n && y + len < m; ++len) {
                bool ok = true;
                st.push_back({ });
                col.push_back({ });
                for (int i = 0; i <= len; ++i) {
                    /*ok &= st[i].find(f[x + i][y + len]) == st[i].end();
                    ok &= col[i].find(f[x + len][y + i]) == col[i].end();*/
                    st[i].insert(f[x + i][y + len]);
                    col[len].insert(f[x + i][y + len]);
                    col[i].insert(f[x + len][y + i]);
                    st[len].insert(f[x + len][y + i]);
                    if (st[i].size() != len + 1 || col[i].size() != len + 1) {
                        ok = false;
                        break;
                    }
                }
                if (!ok)
                    break;
                for (int i = 1; i <= len; ++i) {
                    if (st[i] != st[0] || col[i] != col[0]) {
                        ok = false;
                        break;
                    }
                }
                if (ok && st[0] == col[0]) {
                    ++ans;
                    //cout << x << ' ' << y << '\n';
                }
            }
        }
    }
    cout << ans << '\n';
}