#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <numeric>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>
#include <unordered_map>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e15;
const ll P = 179, Q = 239;
const ll mod = 1e9 + 7;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

ll mul(ll a, ll b) {
	return (a * b) % mod;
}

ll n, m, k;
vector <bool> used;
vector <vector <ull>> rpref, cpref;
vector <ull> p;

ull getr(ll l, ll r, ll i) {
	if (!l) return rpref[i][r];
	return rpref[i][r] - rpref[i][l - 1];
}

ull getc(ll l, ll r, ll i) {
	if (!l) return cpref[i][r];
	return cpref[i][r] - cpref[i][l - 1];
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> m;
	vector <vector <ll>> f(n, vector <ll>(m));
	for (auto& x : f) {
		for (auto& y : x) {
			char a, b;
			cin >> a >> b;
			y = a * 1000 + b;
		}
	}
//	cerr << "Read\n";
	p.resize(200000, 1);
	for (int i = 1; i < 200000; ++i) {
		p[i] = p[i - 1] * P;
	}
//	cerr << "p done\n";
	rpref.resize(n, vector <ull>(m));
	for (int i = 0; i < n; ++i) {
		rpref[i][0] = p[f[i][0]];
	}
	cpref.resize(m, vector <ull>(n));
	for (int i = 0; i < m; ++i) {
		cpref[i][0] = p[f[0][i]];
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 1; j < m; ++j) {
			rpref[i][j] = rpref[i][j - 1] + p[f[i][j]];
		}
	}
	for (int i = 0; i < m; ++i) {
		for (int j = 1; j < n; ++j) {
			cpref[i][j] = cpref[i][j - 1] + p[f[j][i]];
		}
	}
//	cerr << "Calcuated\n";
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
//			cout << "At " << i << ' ' << j << " found \n";
//			cout << n - i << ' ' << m - j << '\n';
			for (int k = 0; k < mmin(n - i, m - j); ++k) {
//				cout << "Tried " << k << '\n';
				set <ll> el;
				bool ok = true;
				for (int l = j; l <= j + k; ++l) {
					if (el.find(f[i][l]) != el.end()) {
						ok = false;
						break;
					}
					el.insert(f[i][l]);
				}
				if (!ok) {
					break;
				}
//				cout << "Different\n";
//				cout << getr(j, j + k, i) << '\n';
				for (int l = i; l <= i + k; ++l) {
					if (getr(j, j + k, l) != getr(j, j + k, i)) {
//						cout << "Row " << l << " differs: " << getr(j, j + k, l) << '\n';
						ok = false;
						break;
					}
				}
				for (int l = j; l <= j + k; ++l) {
					if (getc(i, i + k, l) != getr(j, j + k, i)) {
//						cout << "Column " << l << " differs: " << getc(i, i + k, l) << '\n';
						ok = false;
						break;
					}
				}
				if (ok) {
//					cout << k << '\n';
					++ans;
				}
			}
		}
	}
	cout << ans << '\n';
	return 0;
}
/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9

2 2
1 2 
0 0
2 1 -100 -100

5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -3 -5 3 10 -4

4 5
AABBAAAACC
BBAABBCCAA
AABBCCAABB
BBCCAABBCC

5 10
!"#$%&'()*+,-./01234
56789:;<=>?@ABCDEFGH
IJKLMNOPQRSTUVWXYZ[\
]^_'abcdefghijklmnop
qrstuvwxyz{|}~!"#$%&
*/