#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define left left228

const int MAXN = 2e3;

pair<char, char> matrix[MAXN][MAXN];
int up[MAXN][MAXN], left[MAXN][MAXN];

inline int up_max(int i, int j, int k) {
    int ans = -1;
    for (int c = 0; c < k; c++) {
        for (int t = 0; t < k; t++) {
            ans = max(up[i + c][j + t], ans);
        }
    }
    return ans;
}

inline int left_max(int i, int j, int k) {
    int ans = -1;
    for (int c = 0; c < k; c++) {
        for (int t = 0; t < k; t++) {
            ans = max(left[i + c][j + t], ans);
        }
    }
    return ans;
}

inline int different(int i, int j, int k) {
    set<pair<char, char>> x;
    for (int c = 0; c < k; c++) {
        for (int t = 0; t < k; t++) {
            x.emplace(matrix[i + c][j + t]);
        }
    }
    return x.size();
}

inline short to_short(pair<char, char> p) {
    return (short(p.first) << 8) + short(p.second);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> matrix[i][j].first >> matrix[i][j].second;
        }
    }
    for (int i = 0; i < n; i++) {
        map<pair<char, char>, int> prev;
        for (int j = 0; j < m; j++) {
            if (prev.find(matrix[i][j]) == prev.end()) {
                left[i][j] = -1;
            } else {
                left[i][j] = prev[matrix[i][j]];
            }
            prev[matrix[i][j]] = j;
        }
    }
    for (int j = 0; j < m; j++) {
        map<pair<char, char>, int> prev;
        for (int i = 0; i < n; i++) {
            if (prev.find(matrix[i][j]) == prev.end()) {
                up[i][j] = -1;
            } else {
                up[i][j] = prev[matrix[i][j]];
            }
            prev[matrix[i][j]] = i;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int k = 0;
            unordered_set<short> cur;
            int left_max = -1, up_max = -1;
            while (i + k < n && j + k < m) {
                for (int t = 0; t <= k; t++) {
                    cur.emplace(to_short(matrix[i + t][j + k]));
                    up_max = max(up_max, up[i + t][j + k]);
                    left_max = max(left_max, left[i + t][j + k]);
                    cur.emplace(to_short(matrix[i + k][j + t]));
                    up_max = max(up_max, up[i + k][j + t]);
                    left_max = max(left_max, left[i + k][j + t]);
                }
                if (left_max >= j || up_max >= i) {
                    break;
                }
                if (cur.size() == k + 1) {
                    ans++;
                }
                k++;
            }
        }
    }
    cout << ans;
    return 0;
}