#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

ll n, m, ans = 0, sz;
vector <vector <ll>> all(2001, vector <ll>(2001));
map <ll, ll> te;
vector <map <ll, ll>> str;
vector <map <ll, ll>> sto;

void fis() {
    for (ll i = 0; i < sz; i++)
        for (ll j = 0; j < sz; j++) {
            te[all[i][j]]++;
            str[i][all[i][j]]++; sto[j][all[i][j]]++;
        }
}

void gor(ll u, ll l) {
    for (ll i = u; i < u + sz; i++) {
        te[all[i][l - 1]]--;
        sto[(l - 1) % sz][all[i][l - 1]]--;
        sto[(l + sz - 1) % sz][all[i][l + sz - 1]]++;
        str[i % sz][all[i][l - 1]]--;
        str[i % sz][all[i][l + sz - 1]]++;
        te[all[i][l + sz - 1]]++;
        if (sto[(l - 1) % sz][all[i][l - 1]] == 0)
            sto[(l - 1) % sz].erase(all[i][l - 1]);
        if (str[i % sz][all[i][l - 1]] == 0)
            str[i % sz].erase(all[i][l - 1]);
        if (te[all[i][l - 1]] == 0) {
            te.erase(all[i][l - 1]);
            continue;
        }
    }
}

void gol(ll u, ll r) {
    for (ll i = u; i < u + sz; i++) {
        te[all[i][r + 1]]--;
        te[all[i][r - sz + 1]]++;
        sto[(r + 1) % sz][all[i][r + 1]]--;
        sto[(r - sz + 1) % sz][all[i][r - sz + 1]]++;
        str[i % sz][all[i][r + 1]]--;
        str[i % sz][all[i][r - sz + 1]]++;
        if (sto[(r + 1) % sz][all[i][r + 1]] == 0)
            sto[(r + 1) % sz].erase(all[i][r + 1]);
        if (str[i % sz][all[i][r + 1]] == 0)
            str[i % sz].erase(all[i][r + 1]);
        if (te[all[i][r + 1]] == 0) {
            te.erase(all[i][r + 1]);
            continue;
        }
    }
}

void god(ll u, ll l) {
    for (ll i = l; i < l + sz; i++) {
        te[all[u][i]]--;
        te[all[u + sz][i]]++;
        sto[i % sz][all[u][i]]--;
        sto[i % sz][all[u + sz][i]]++;
        str[u % sz][all[u][i]]--;
        str[(u + sz) % sz][all[u + sz][i]]++;
        if (te[all[u][i]] == 0) {
            te.erase(all[u][i]);
            continue;
        }
        if (sto[i % sz][all[u][i]] == 0)
            sto[i % sz].erase(all[u][i]);
        if (str[u % sz][all[u][i]] == 0)
            str[u % sz].erase(all[u][i]);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m;
    ans += n * m;
    ll x = rand();
    for (ll i = 0; i < n; i++)
        for (ll j = 0; j < m; j++) {
            char q, w;
            cin >> q >> w;
            all[i][j] = (q - 32) * x + (w - 32);
        }
    for (sz = 2; sz <= min(n, m); sz++) {
        te.clear();
        str.clear(); sto.clear();
        str.resize(sz); sto.resize(sz);
        fis();
        if (te.size() == sz) {
            ll err = 0;
            for (ll i = 0; i < sz; i++)
                if (str[i].size() != sz) {
                    err++;
                    break;
                }
            if (err == 0) {
                for (ll i = 0; i < sz; i++)
                    if (sto[i].size() != sz) {
                        err++;
                        break;
                    }
                if (err == 0)
                    ans++;
            }
        }
        for (ll u = 0; u < n; u++) {
            if (u + sz - 1 >= n)
                break;
            if (u % 2 == 0) {
                for (ll l = 1; l < m; l++) {
                    if (l + sz - 1 >= m)
                        break;
                    gor(u, l);
                    if (te.size() == sz) {
                        ll err = 0;
                        for (ll i = 0; i < sz; i++)
                            if (str[i].size() != sz) {
                                err++;
                                break;
                            }
                        if (err == 0) {
                            for (ll i = 0; i < sz; i++)
                                if (sto[i].size() != sz) {
                                    err++;
                                    break;
                                }
                            if (err == 0)
                                ans++;
                        }
                    }
                }
                god(u, m - sz);
            } else {
                for (ll r = m - 2; r >= 0; r--) {
                    if (r - sz + 1 < 0)
                        break;
                    gol(u, r);
                    if (te.size() == sz) {
                        ll err = 0;
                        for (ll i = 0; i < sz; i++)
                            if (str[i].size() != sz) {
                                err++;
                                break;
                            }
                        if (err == 0) {
                            for (ll i = 0; i < sz; i++)
                                if (sto[i].size() != sz) {
                                    err++;
                                    break;
                                }
                            if (err == 0)
                                ans++;
                        }
                    }
                }
                god(u, 0);
            }
            if (te.size() == sz) {
                ll err = 0;
                for (ll i = 0; i < sz; i++)
                    if (str[i].size() != sz) {
                        err++;
                        break;
                    }
                if (err == 0) {
                    for (ll i = 0; i < sz; i++)
                        if (sto[i].size() != sz) {
                            err++;
                            break;
                        }
                    if (err == 0)
                        ans++;
                }
            }
        }
    }
    cout << ans;
    return 0;
}