#pragma GCC optimize("unroll-loops,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,mmx,abm")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()
#define hash hash228

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

const int MAXN = 2010;
int n, m;
int table[MAXN][MAXN];

int nxt[2][MAXN][MAXN];
const int MAXVAL = (126 - 33) * (126 - 33 + 1) + (126 - 33) + 228;
int last[MAXVAL];

mt19937 rnd(time(0));

//const int MOD = 1e9 + 7;
const unsigned ll base = rnd() % 1000 + 228 + 1337;

unsigned ll hash[2][MAXN][MAXN];
unsigned ll pows[MAXVAL];

int Read() {
	char c;
	scanf("%c",&c);
	int ans = c - 33;
	ans *= 126 - 33 + 1;
	scanf("%c",&c);
	ans += c;
	return ans;
}

void read() {
	scanf("%d%d", &n, &m);
	char x;
	scanf("%c", &x);
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			table[i][j] = Read();

		}
		char x;
		scanf("%c", &x);
	}
}

void build_nxt() {
	for (int i = 0; i < MAXVAL; i++)
		last[i] = n + 1;
	for (int j = 1; j <= m; j++) {
		for (int i = n; i >= 1; i--) {
			nxt[0][i][j] = last[table[i][j]];
			last[table[i][j]] = i;
		}
		for (int i = n; i >= 1; i--) {
			last[table[i][j]] = n + 1;
		}
	}

	for (int i = 0; i < MAXVAL; i++)
		last[i] = m + 1;
	for (int i = 1; i <= n; i++) {
		for (int j = m; j >= 1; j--) {
			nxt[1][i][j] = last[table[i][j]];
			last[table[i][j]] = j;
		}
		for (int j = m; j >= 1; j--) {
			last[table[i][j]] = m + 1;
		}
	}
}
/*
int add(int a, int b, int MOD) {
	a += b;
	if (a >= MOD)
		a -= MOD;
	return a;
}

int sub(int a, int b, int MOD) {
	a -= b;
	if (a < 0)
		a += MOD;
	return a;
}

int mul(int a, int b, int MOD) {
	return (ll) a * b % MOD;
}
*/
void build_hash() {
	pows[0] = 1;
	for (int i = 1; i < MAXVAL; i++) {
		//pows[i] = mul(pows[i - 1], base, MOD);
		pows[i] = pows[i - 1] * base;
	}
	for (int i = 1; i <= n; i++) {
		hash[0][i][0] = 0;
		for (int j = 1; j <= m; j++) {
			//hash[0][i][j] = add(pows[table[i][j]], hash[0][i][j - 1], MOD);
			hash[0][i][j] = pows[table[i][j]] + hash[0][i][j - 1];
		}
	}
	for (int j = 1; j <= m; j++) {
		hash[1][0][j] = 0;
		for (int i = 1; i <= n; i++) {
			//hash[1][i][j] = add(pows[table[i][j]], hash[1][i - 1][j], MOD);
			hash[1][i][j] = pows[table[i][j]] + hash[1][i - 1][j];
		}
	}
}

void build() {
	build_nxt();
	build_hash();
}

unsigned ll get_hash_r(int x, int y1, int y2) {
	//return sub(hash[0][x][y2], hash[0][x][y1 - 1], MOD);
	return hash[0][x][y2] - hash[0][x][y1 - 1];
}

unsigned ll get_hash_c(int y, int x1, int x2) {
	//return sub(hash[1][x2][y], hash[1][x1 - 1][y], MOD);
	return hash[1][x2][y] - hash[1][x1 - 1][y];
}

int dp[2][MAXN][MAXN];

void calc_dp(int len) {
	for (int i = n - len + 1; i >= 1; i--) {
		for (int j = m; j >= 1; j--) {
			if (nxt[0][i][j] - i >= len)
				dp[0][i][j] = 1;
			else
				dp[0][i][j] = 0;
			if (j + 1 <= m) {
				if (get_hash_c(j, i, i + len - 1) == get_hash_c(j + 1, i, i + len - 1)) {
					dp[0][i][j] = dp[0][i][j + 1] + 1;
					chkmin(dp[0][i][j], nxt[1][i][j] - j);
				}
			}
		}
	}
	for (int i = n; i >= 1; i--) {
		for (int j = m - len + 1; j >= 1; j--) {
			if (nxt[1][i][j] - j >= len) 
				dp[1][i][j] = 1;
			else
				dp[1][i][j] = 0;
			if (i + 1 <= n) {
				if (get_hash_r(i, j, j + len - 1) == get_hash_r(i + 1, j, j + len - 1)) {
					dp[1][i][j] = dp[1][i + 1][j] + 1;
					chkmin(dp[1][i][j], nxt[0][i][j] - i);
				}
			}
		}
	}
}

ll calc(int len) {
	calc_dp(len);
	ll ans = 0;
	for (int i = 1; i + len -1 <= n; i++) {
		for (int j = 1; j + len - 1 <= m; j++) {
			if (dp[0][i][j] >= len && dp[1][i][j] >= len) {
				ans++;
			}
		}
	}
	return ans;
}

ll ans;

void run() {
	build();
	for (int len = 1; len <= min(n, m); len++) {
		ans += calc(len);
	}
}

void write() {
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}