#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

//#define int long long

const int MAXN = 100;
const int MAXC1 = 94;
const int MAXC = MAXC1 * MAXC1;
int arr[MAXN][MAXN];
int hsh[MAXN][MAXN][MAXN + 1][2];
int nums[MAXC];

const int MOD = 1791791791;
random_device rddev;
const int P = rddev() % 444 + 179;
long long pows[MAXC];

void calcpows() {
  pows[0] = 1;
  for (int i = 1; i < MAXC; ++i) {
    pows[i] = (pows[i - 1] * P) % MOD;
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  calcpows();
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      char c1, c2;
      cin >> c1 >> c2;
      int x = ((int)c1 - 33) * MAXC1 + ((int)c2 - 33);
      arr[i][j] = x;
    }
  }
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      fill(nums, nums + MAXC, 0);
      long long hs = 0;
      for (int len = 1; j + len <= m; ++len) {
        int k = j + len - 1;
        nums[arr[i][k]]++;
        if (hs == -1 || nums[arr[i][k]] > 1)
          hs = -1;
        else
          hs = (hs + pows[arr[i][k]]) % MOD;
        hsh[i][j][len][0] = hs;
      }
      fill(nums, nums + MAXC, 0);
      hs = 0;
      for (int len = 1; i + len <= n; ++len) {
        int k = i + len - 1;
        nums[arr[k][j]]++;
        if (hs == -1 || nums[arr[k][j]] > 1)
          hs = -1;
        else
          hs = (hs + pows[arr[k][j]]) % MOD;
        hsh[i][j][len][1] = hs;
      }
    }
  }

  int ans = 0;
  for (int i = 0; i < n; ++i)  {
    for (int j = 0; j < m; ++j) {
      for (int len = 1; i + len <= n && j + len <= m; ++len) {
        int hs = hsh[i][j][len][0];
        bool isok = hs != -1;
        for (int k = i; k < i + len && isok; ++k) {
          int nhs = hsh[k][j][len][0];
          isok &= hs == nhs;
        }
        for (int k = j; k < j + len && isok; ++k) {
          int nhs = hsh[i][k][len][1];
          isok &= hs == nhs;
        }
        ans += isok;
      }
    }
  }
  cout << ans;
  return 0;
}