#include <bits/stdc++.h>

using namespace std;

const int MAXN = 10001;

const long long P = 10007, MOD = 1e9 + 21;

long long p[MAXN];

void precalc() {
    p[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        p[i] = (p[i - 1] * P) % MOD;
    }
}

void solve() {
    precalc();
    int n, m;
    cin >> n >> m;
    vector<vector<long long>> pole(n, vector<long long>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char a, b;
            cin >> a >> b;
            pole[i][j] = (int(a) - 33) * 94 + int(b) - 33;
        }
    }
    vector<vector<long long>> flat(n, vector<long long>(m + 1));
    vector<vector<long long>> down(n + 1, vector<long long>(m));
    vector<vector<vector<char>>> all_unique_f(n, vector<vector<char>>(m, vector<char>(m + 1)));
    vector<vector<vector<char>>> all_unique_d(m, vector<vector<char>>(n, vector<char>(n + 1)));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            flat[i][j + 1] = (flat[i][j] + p[pole[i][j]]) % MOD;
            vector<int> cnt(P);
            for (int k = j; k < m; ++k)
                if (cnt[pole[i][k]]++)
                    break;
                else
                    all_unique_f[i][j][k + 1] = 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            down[i + 1][j] = (down[i][j] + p[pole[i][j]]) % MOD;
            vector<int> cnt(P);
            for (int k = i; k < n; ++k)
                if (cnt[pole[k][j]]++)
                    break;
                else
                    all_unique_d[j][i][k + 1] = 1;
        }
    }
    long long ans = n * m;
    for (int k = 2; k <= min(n, m); ++k)
        for (int i = 0; i + k <= n; ++i) {
            for (int j = 0; j + k <= m; ++j) {
                bool cool = true;
                long long ghash = (flat[i][j + k] - flat[i][j] + MOD) % MOD;
                for (int x = 0; x < k && cool; ++x)
                    if (!all_unique_f[i][j][j + x + 1])
                        cool = false;
                    else if (!all_unique_d[j][i][i + x + 1])
                        cool = false;
                    else if ((flat[i + x][j + k] - flat[i + x][j] + MOD) % MOD != ghash)
                        cool = false;
                    else if ((down[i + k][j + x] - down[i][j + x] + MOD) % MOD != ghash)
                        cool = false;
                if (cool) {
                    ++ans;
                }
            }
        }
    cout << ans << '\n';
}

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
