#include <bits/stdc++.h>
using namespace std;

random_device rddev;
mt19937 rd(rddev());

using ll = long long;
using ldb = long double;

const int MOD = 1e9 + 7;
const int p = 517;
const int MAXN = 10000000;
int ppow[MAXN];

vector<vector<int>> calcDown(vector<vector<int>> arr) {
	int n = arr.size();
	int m = arr[0].size();
	vector<vector<int>> closest(n, vector<int> (m, n));
	for (int j = 0; j < m; j++) {
		map<int, int> last;
		last[arr[n - 1][j]] = n - 1;
		for (int i = n - 2; i >= 0; i--) {
			if (last.count(arr[i][j]) == 0) {
				closest[i][j] = n;
			} else {
				closest[i][j] = last[arr[i][j]];
			}
			last[arr[i][j]] = i;
		}
	}
	for (int i = n - 2; i >= 0; i--) {
		for (int j = 0; j < m; j++) {
			closest[i][j] = min(closest[i][j], closest[i + 1][j]);
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			closest[i][j] -= i;
		}
	}
	return closest;
}

vector<vector<int>> calc(vector<vector<int>> arr, int k) {
	int n = arr.size();
	int m = arr[0].size();
	vector<vector<int>> h(n + 1, vector<int> (m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			h[i + 1][j] = h[i][j] + ppow[arr[i][j]];
			h[i + 1][j] %= MOD;
		}
	}
	vector<vector<int>> ok1(n, vector<int> (m));
	vector<vector<int>> ok2 = ok1;
	for (int i = k - 1; i < n; i++) {
		int last = 0;
		for (int j = 1; j < m; j++) {
			if (h[i + 1][j] + h[i + 1 - k][j - 1] - h[i + 1][j - 1] - h[i + 1 - k][j] == 0) {
				ok1[i][j] = 1;
				last++;
			} else {
				last = 0;
			}
			if (last >= k - 1) {
				ok2[i][j] = 1;
			}
		}
	}
	return ok2;
}

vector<vector<int>> transpose(vector<vector<int>> arr) {
	int a = arr.size();
	int b = arr[0].size();
	vector<vector<int>> arr2(b, vector<int> (a));
	for (int i = 0; i < a; i++) {
		for (int j = 0; j < b; j++) {
			arr2[j][i] = arr[i][j];
		}
	}
	return arr2;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ppow[0] = 1;
	for (int i = 1; i < MAXN; i++) {
		ppow[i] = 1LL * ppow[i - 1] * p % MOD;
	}
	int n, m;
	cin >> n >> m;
	vector<vector<int>> arr(n, vector<int> (m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			unsigned char c;
			unsigned char c2;
			cin >> c >> c2;
			arr[i][j] = c * 256 + c2;
		}
	}
	ll ans = n * m;
	for (int k = 2; k <= min(n, m); k++) {
		auto arr1 = calc(arr, k);
		auto arr2 = transpose(calc(transpose(arr), k));
		auto down = calcDown(arr);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				arr1[i][j] *= arr2[i][j];
				if (i >= k - 1 && down[i + 1 - k][j] < k) {
					arr1[i][j] = 0;
				}
				ans += arr1[i][j];
			}
		}
	}
	cout << ans << endl;
}
