#pragma optimize("Ofast")
#pragma optimize("fast-math")
#pragma optimize("unroll-loops")
#pragma optimize("unswitch-loops")
#pragma target("avx,avx2,sse,sse2,ssse3,sse4,popcnt")
#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

#define right aksdjfslafj

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e3) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}

class SegmentTree {
private:
    int size;
    vector<int> seg;

    void build(vector<int> & a, int v, int vl, int vr) {
        if (vl == vr) {
            seg[v] = a[vl];
            return;
        }

        int vm = vl + (vr - vl) / 2;

        build(a, 2 * v, vl, vm);
        build(a, 2 * v + 1, vm + 1, vr);

        seg[v] = min(seg[2 * v], seg[2 * v + 1]);
    }

    int get(int v, int vl, int vr, int l, int r) {
        if (r < vl || vr < l) {
            return INF_INT;
        }

        if (l <= vl && vr <= r) {
            return seg[v];
        }

        int vm = vl + (vr - vl) / 2;

        int left_child  = get(2 * v, vl, vm, l, r);
        int right_child = get(2 * v + 1, vm + 1, vr, l, r);

        return min(left_child, right_child);
    }
public:
    SegmentTree() {}

    SegmentTree(vector<int> & a) : size(len(a)) {
        init(seg, 4 * size);

        build(a, 1, 0, size - 1);
    }

    int get(int l, int r) {
        return get(1, 0, size - 1, l, r);
    }
};

int n, m;
char fld[2][MAX][MAX];
int down[MAX][MAX];
int right[MAX][MAX];
SegmentTree line_right[MAX];
SegmentTree line_down[MAX];
SegmentTree column_right[MAX];
SegmentTree column_down[MAX];

signed main() {
    boot_up();

    while (cin >> n >> m) {
        solve();
    }
}

void solve() {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> fld[0][i][j] >> fld[1][i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        map<pair<char, char>, int> cnt;
        for (int j = m - 1; j >= 0; --j) {
            if (cnt.find({fld[0][i][j], fld[1][i][j]}) == cnt.end()) {
                right[i][j] = INF_INT;
            }
            else {
                right[i][j] = cnt.at({fld[0][i][j], fld[1][i][j]});
            }

            cnt[{fld[0][i][j], fld[1][i][j]}] = j;
        }
    }

    for (int i = 0; i < m; ++i) {
        map<pair<char, char>, int> cnt;
        for (int j = n - 1; j >= 0; --j) {
            if (cnt.find({fld[0][j][i], fld[1][j][i]}) == cnt.end()) {
                down[j][i] = INF_INT;
            }
            else {
                down[j][i] = cnt.at({fld[0][j][i], fld[1][j][i]});
            }

            cnt[{fld[0][j][i], fld[1][j][i]}] = j;
        }
    }

    for (int i = 0; i < n; ++i) {
        vector<int> rgt, dwn;
        for (int j = 0; j < m; ++j) {
            rgt.emplace_back(right[i][j]);
            dwn.emplace_back(down[i][j]);
        }

        line_right[i] = SegmentTree(rgt);
        line_down[i] = SegmentTree(dwn);
    }

    for (int i = 0; i < m; ++i) {
        vector<int> rgt, dwn;
        for (int j = 0; j < n; ++j) {
            rgt.emplace_back(right[j][i]);
            dwn.emplace_back(down[j][i]);
        }

        column_down[i] = SegmentTree(dwn);
        column_right[i] = SegmentTree(rgt);
    }


    int ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            bool kill = true;
            int right_min = INF_INT;
            int down_min = INF_INT;
            set<pair<char, char>> diff;
            for (int k = 1; kill && i + k - 1 < n && j + k - 1 < m; ++k) {
                // (i, j) (i + k - 1) (j + k - 1)
                int get1 = column_right[j + k - 1].get(i, i + k - 1);
                chkmin(right_min, get1);
                int get2 = line_right[i + k - 1].get(j, j + k - 1);
                chkmin(right_min, get2);

                int get3 = column_down[j + k - 1].get(i, i + k - 1);
                chkmin(down_min, get3);
                int get4 = column_down[i + k - 1].get(j, j + k - 1);
                chkmin(down_min, get4);

                if (right_min <= j + k - 1 || down_min <= i + k - 1) {
                    kill = false;
                }

                if (!kill) {
                    break;
                }

                for (int jj = j; jj <= j + k - 1; ++jj) {
                    diff.insert({fld[0][i + k - 1][jj], fld[1][i + k - 1][jj]});
                }

                for (int ii = i; ii <= i + k - 1; ++ii) {
                    diff.insert({fld[0][ii][j + k - 1], fld[1][ii][j + k - 1]});
                }

                if (len(diff) == k) {
                    ++ans;
                }
            }
        }
    }


    cout << ans << '\n';
}