#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

mt19937 gen(0);

struct node {
    ll val, pr, sz;
    node *l;
    node *r;

    node() {}

    node(ll x) {
        l = r = nullptr;
        val = x, pr = gen();
        sz = 1;
    }
};

ll get_size(node *v) {
    if (v == nullptr)
        return 0;
    return v->sz;
}
ll get_val(node *v) {
    if (v == nullptr)
        return -1;
    return v->val;
}

node *update(node *v) {
    if (v == nullptr)
        return v;
    v->sz = 1 + get_size(v->l) + get_size(v->r);
    return v;
}

pair<node *, node *> split(node *now, ll value) {
    if (now == nullptr) {
        return {nullptr, nullptr};
    }
    if (value > now->val) {
        auto[a, b] = split(now->r, value);
        a = update(a), b = update(b);
        now->r = a;
        now = update(now);
        return {now, b};
    } else {
        auto[a, b] = split(now->l, value);
        a = update(a), b = update(b);
        now->l = b;
        now = update(now);
        return {a, now};
    }
}

node *merge(node *a, node *b) {
    if (a == nullptr)
        return b;
    if (b == nullptr)
        return a;
    if (a->pr > b->pr) {
        node *v = merge(a->r, b);
        v = update(v);
        a->r = v;
        a = update(a);
        return a;
    } else {
        node *v = merge(a, b->l);
        v = update(v);
        b->l = v;
        b = update(b);
        return b;
    }
}

node *add(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    node *nw = new node(v);
    node *tmp = merge(r1, nw);
    root = merge(tmp, r2);
    return root;
}

pair<ll, node *> get_less(node *root, ll v) {
    auto[r1, r2] = split(root, v);
//    cout << v << ' ' << get_val(r1) << ' ' << get_val(r2) << ' ' << get_size(r1) << ' ' << get_size(r2) << endl;
    ll ans = get_size(r1);
    root = merge(r1, r2);
    return {ans, root};
}

pair<ll, node *> get_gr_or_eq(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    ll ans = get_size(r2);
    root = merge(r1, r2);
    return {ans, root};
}



void print(node*root) {
    if(root == nullptr)
        return;
    print(root->l);
    cout << root->val << ' ' << root->pr << '\n';
    print(root->r);
}

ll tb[2000][2000];
ll n, m;
void typo() {
    ll ans = 0;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            for(int k = 1; k < min(n, m); ++k) {
                ll i1 = i + k - 1, j1 = j + k - 1;
                if(i1 >= n || j1 >= m)
                    break;
                bool ok = true;
                set <ll> all;
                for(int ti = i; ti <= i1; ++ti) {
                    set <ll> st;
                    for(int tj = j; tj <= j1; ++tj) {
                        st.insert(tb[ti][tj]);
                        all.insert(tb[ti][tj]);
                    }
                    if(st.size() != k)
                        ok = false;
                }
                for(int tj = j; tj <= j1; ++tj) {
                    set <ll> st;
                    for(int ti = i; ti <= i1; ++ti) {
                        st.insert(tb[ti][tj]);
                        all.insert(tb[ti][tj]);
                    }
                    if(st.size() != k)
                        ok = false;
                }
                if(all.size() != k)
                    ok = false;
                ans += ok;
            }
        }
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            char a, b;
            cin >> a >> b;
            tb[i][j] = a * 1000  + b;
        }
    }
    typo();
    return 0;
    ll ans = 0;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            vector <set <ll>> rows, cols;
            set <ll> all;
            ll k = 1;
            while(i + k - 1 < n && j + k - 1 < m) {
                rows.push_back({});
                cols.push_back({});
                bool ok = true;
                for(int ni = i; ni < i + k; ++ni) {
                    rows[ni - i].insert(tb[ni][j + k - 1]);
                    cols[k - 1].insert(tb[ni][j + k - 1]);
                    all.insert(tb[ni][j + k - 1]);
                }
                for(int nj = j; nj < j + k; ++nj) {
                    cols[nj - j].insert(tb[i + k - 1][nj]);
                    rows[k - 1].insert(tb[i + k - 1][nj]);
                    all.insert(tb[i + k - 1][nj]);
                }
                for(int ni = i; ni < i + k - 1; ++ni) {
                    if(rows[ni - i].size() != k)
                        ok = false;
                }
                for(int nj = j; nj < j + k - 1; ++nj) {
                    if(cols[nj - j].size() != k)
                        ok = false;
                }
                if(all.size() != k)
                    ok = false;
//                if(i == 0 && j == 0) {
//                    cout << k << ' ' << all.size() << ' ' << ok << '\n';
//                    for(auto c : cols) {
//                        cout << c.size() << ' ';
//                    }
//                    cout << '\n';
//                    for(auto r : rows) {
//                        cout << r.size() << ' ';
//                    }
//                    cout << "\n\n\n";
//                }
//                if(k == 1 && !ok) {
//                    cout << i << ' ' << j << endl;
//                }
                ans += ok;
                ++k;
            }
        }
    }
    cout << ans;
}