#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>
#include <random>
#include <cassert>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <map>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <iomanip>
#include <bitset>
#include <stack>
#include <list>

#pragma warning (disable : 4996)
using namespace std;

#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define nl '\n'
#define sz(a) (int)(a).size()
#define maxeq(a, b) (a) = max(a, b);
#define mineq(a, b) (a) = min(a, b);

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
const dl PI = acos(-1);
mt19937 rnd(5625445);
mt19937_64 rnd64(3465467567);

template <typename T, typename D>
istream &operator >> (istream &in, pair<T, D> &a) {
	in >> a.first >> a.second;
	return in;
}

template <typename T, typename D>
ostream &operator << (ostream &out, pair<T, D> &a) {
	out << a.first << " " << a.second;
	return out;
}

template <typename T>
istream &operator >> (istream &in, vector<T> &a) {
	for (auto &i : a)
		in >> i;
	return in;
}

void IO() {
#ifdef _SEVA
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _SEVA
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = 2000 + 10;

int field[N][N];

int getNum(char a, char b) {
	return (a - 33) * (127 - 33) + (b - 33);
}

void solve() {

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char a, b;
			cin >> a >> b;
			field[i][j] = getNum(a, b);
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int k = 1; i + k <= n && j + k <= m; k++) {
				set<int> st1;
				for (int t = i; t < i + k; t++) {
					st1.insert(field[t][j]);
				}
				if (sz(st1) != k)
					continue;
				bool lans = true;
				for (int t = i; t < i + k; t++) {
					set<int> st;
					for (int u = j; u < j + k; u++) {
						st.insert(field[t][u]);
					}
					lans &= st == st1;
				}
				for (int u = j; u < j + k; u++) {
					set<int> st;
					for (int t = i; t < i + k; t++) {
						st.insert(field[t][u]);
					}
					lans &= st == st1;
				}
				ans += lans;
			}
		}
	}
	cout << ans << nl;
}

int main() {
	IO();
	solve();
	return 0;
}
