#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,avx")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template <typename T>
struct Test {
    T data;
    bool is_ans_unique = false;
    int expected_ans = -1;
    Test(T d, bool ans, int exp) : data(d), is_ans_unique(ans), expected_ans(exp) {};
};

const bool IS_LOCAL = true;
const bool IS_TESTING = false;

typedef int TEST_TYPE;
typedef int RESULT_TYPE;

int n, m;
vector<vector<int>> field;

RESULT_TYPE solve() {
    return 0;
}

bool is_square(int x, int y, int k) {
    set<int> all;
    vector<set<int>> suck(k);
    for (int i = x; i < x + k; ++i) {
        set<int> now;
        for (int j = y; j < y + k; ++j) {
            now.insert(field[i][j]);
            all.insert(field[i][j]);
            suck[j - y].insert(field[i][j]);
        }
        if (now.size() != k) return false;
    }
    if (all.size() != k) return false;
    for (auto e : suck) {
        if (e.size() != k) return false;
    }
    return true;
}

const int p = 43, mod = 1500000001;
vector<vector<long long>> line_hash, column_hash;
vector<vector<int>> max_len_super;

bool is_square_2(int x, int y, int k) {
    if (max_len_super[x][y + k - 1] < k) return false;
    long long b_h = (line_hash[x][y + k] - line_hash[x][y] + mod) % mod;
    for (int i = x; i < x + k; ++i) {
        if ((line_hash[i][y + k] - line_hash[i][y] + mod) % mod != b_h) return false;
    }
    for (int j = y; j < y + k; ++j) {
        if ((column_hash[j][x + k] - column_hash[j][x] + mod) % mod != b_h) return false;
    }
    return is_square(x, y, k);
}

const int FUN = 179179179;

void prepare() {
    line_hash.resize(n);
    for (int i = 0; i < n; ++i) {
        line_hash[i].emplace_back(FUN);
        for (int j = 0; j < m; ++j) {
            line_hash[i].emplace_back((line_hash[i][j] + field[i][j] * field[i][j] * field[i][j] + FUN) % mod);
        }
    }
    column_hash.resize(m);
    for (int i = 0; i < m; ++i) {
        column_hash[i].emplace_back(FUN);
        for (int j = 0; j < n; ++j) {
            column_hash[i].emplace_back((column_hash[i][j] + field[j][i] * field[j][i] * field[j][i] + FUN) % mod);
        }
    }
    max_len_super.resize(n);
    for (int i = 0; i < n; ++i) {
        int now_left = 0;
        map<int, int> cnt;
        for (int j = 0; j < m; ++j) {
            cnt[field[i][j]]++;

            if (cnt[field[i][j]] > 1) {
                while (field[i][now_left] != field[i][j]) {
                    cnt[field[i][now_left]]--;
                    now_left++;
                }
                cnt[field[i][now_left]]--;
                now_left++;
            }
            max_len_super[i].emplace_back(j - now_left + 1);
        }
    }
}

RESULT_TYPE stupid() {
    prepare();
    int answer = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 2; k <= min(n - i, m - j); ++k) {
                answer += is_square_2(i, j, k);
            }
        }
    }
    return answer + (n * m);
}

void gen_test() {

}

void read() {
    if (!IS_LOCAL) {
        cin.tie();
        cout.tie();
        iostream::sync_with_stdio(false);
    }
    cin >> n >> m;
    field.resize(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char t;
            cin >> t;
            int now = t * 127;
            cin >> t;
            now += t;
            field[i].emplace_back(now);
        }
    }
}

bool check(RESULT_TYPE stupid_ans, RESULT_TYPE smart_ans) {
    return true;
}

bool load_test(TEST_TYPE t) {
    return true;
}

void clean_data() {

}

vector<Test<TEST_TYPE>> pretests = {};

bool check_pretests(bool is_smart) {
    for (Test<TEST_TYPE> test : pretests) {
        if (!is_smart && !test.is_ans_unique) {
            continue;
        }
        clean_data();
        load_test(test.data);
        RESULT_TYPE stupid_ans = stupid();
        if (is_smart) {
            clean_data();
            load_test(test.data);
            RESULT_TYPE smart_ans = solve();

        } else {

        }
    }
    return true;
}

void precalc() {

}

int main() {
    precalc();
    if (IS_TESTING) {
        check_pretests(false);
    } else {
        read();
        cout << stupid() << '\n';
    }

}