#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 500 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;
const ll base = 10007;

int n, m, a[MAXN][MAXN];

int h_row[MAXN][MAXN], h_col[MAXN][MAXN];
int pw[base];

int mul(int x, int y) {
	return (ll)x * (ll)y % MOD;
}

int add(int x, int y) {
	x += y;
	if (x < 0)
		x += MOD;
	if (x >= MOD)
		x -= MOD;
	return x;
}

int hh_row[MAXN][MAXN][MAXN], hh_col[MAXN][MAXN][MAXN];
//int same_row[MAXN][MAXN][MAXN], same_col[MAXN][MAXN][MAXN];

void gen() {
	pw[0] = 1;
	for (int i = 1; i < base; i++) {
		pw[i] = mul(pw[i - 1], base);
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) 
			h_row[i][j] = add((j == 0 ? 0 : h_row[i][j - 1]), pw[a[i][j]]); 
	}
	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) 
			h_col[i][j] = add((i == 0 ? 0 : h_col[i - 1][j]), pw[a[i][j]]);
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int len = 1; len <= m - j; len++) {
				hh_row[i][j][len] = add(h_row[i][j + len - 1], (j == 0 ? 0 : -h_row[i][j - 1]));   
			}
			for (int len = 1; len <= n - i; len++) {
				hh_col[i][j][len] = add(h_col[i + len - 1][j], (i == 0 ? 0 : -h_col[i - 1][j]));   
			}
		}
	}
	
}

int calc(int x, int y) {
	set <int> was;
	int res = 0;
	for (int len = 1; len <= (n - x, m - y); len++) {
		if (was.find(a[x][y + len - 1]) != was.end())
			return res;
		was.insert(a[x][y + len - 1]);
		int obr = hh_row[x][y][len];
		bool bad = 0;
		for (int i = x + 1; i < x + len; i++) {
			int cur = hh_row[i][y][len];
			if (cur != obr)
				bad = 1; 
	 	}
	 	for (int i = y; i < y + len; i++) {
	 		int cur = hh_col[x][i][len];
	 		if (cur != obr)
				bad = 1;
	 	}
	 	if (!bad) {
	 		res++;
	 	}
	}
	return res;
}

int main() {
	fastIO();
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < 2 * m; j += 2) {
			a[i][j / 2] = (s[j] - 33) * 94 + (s[j + 1] - 33);
		}
	}
	gen();
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++)
			ans += calc(i, j);
	}
	cout << ans;
	
	
	return 0;

}