#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 1

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

vector<ll> rt;

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

void rec(int pos, int n, vector<bool> &s, const vector<vector<int>> &g, ll &ans) {
    if (pos >= n) {
        ll sum = 0;
        vector<bool> used(n);
        for (int i = 0; i < n; ++i) {
            if (!s[i])
                continue;
            for (int to : g[i]) {
                if (!used[to]) {
                    used[to] = true;
                    sum += rt[to];
                }
            }
        }
        if (ans == INF1 && sum != 0)
            ans = sum;
        else
            ans = gcd(ans, sum);
        return;
    }
    rec(pos + 1, n, s, g, ans);
    s[pos] = true;
    rec(pos + 1, n, s, g, ans);
    s[pos] = false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    rt.resize(n);
    for (ll &i : rt)
        cin >> i;
    vector<vector<int>> gr(n), gl(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        gr[b].push_back(a);
        gl[a].push_back(b);
    }
    ll ans = INF1;
    vector<bool> s(n);
    rec(0, n, s, gl, ans);
    cout << ans << '\n';
}