#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>
#include <queue>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

const int INF = 2e9;
const int MB = 20;
const int MOD = 1e9 + 7;

using namespace std;
int n, m;
bool check(int x, int y, vector<vector<pair<char, char>>> &a, int d) {
    if (x + d - 1 >= n || y + d - 1 >= m) return false;
    set<pair<char, char>> used;
    set<pair<char, char>> q;
    for (int i = x; i < x + d; i++) {
        used.clear();
        for (int j = y; j < y + d; j++) {
            if (used.count(a[i][j])) return false;
            used.insert(a[i][j]);
            q.insert(a[i][j]);
        }
    }
    if (q.size() != d) return false;
    for (int j = y; j < y + d; j++) {
        used.clear();
        for (int i = x; i < x + d; i++) {
            if (used.count(a[i][j])) return false;
            used.insert(a[i][j]);
        }
    }

    return true;
}

void solve() {
    cin >> n >> m;
    vector<vector<pair<char, char>>> a(n, vector<pair<char, char>>(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0, c = 0; j < m * 2; j += 2, c++) {
            a[i][c] = { s[j], s[j + 1] };
        }
    }

    vector<vector<bool>> left(n, vector<bool>(m)), right(n, vector<bool>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i && j && a[i][j] == a[i - 1][j - 1]) left[i][j] = true;
            if (i && j < m - 1 && a[i][j] == a[i - 1][j + 1]) right[i][j] = true;
        }
    }

    vector<vector<int>> prefLeftCol(n, vector<int>(m)), prefLeftRow(n, vector<int>(m)), prefRightCol(n, vector<int>(m)), prefRightRow(n, vector<int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            prefLeftCol[i][j] = prefLeftRow[i][j] = left[i][j];
            if(i) prefLeftCol[i][j] += prefLeftCol[i - 1][j];
            if (j) prefLeftRow[i][j] += prefLeftRow[i][j - 1];
        }
    }

    for (int i = 0; i < n;i++) {
        for (int j = m - 1; j >= 0; j--) {
            prefRightCol[i][j] = prefRightRow[i][j] = right[i][j];
            if (i) prefRightCol[i][j] += prefRightCol[i - 1][j];
            if (j < m - 1) prefRightRow[i][j] += prefRightRow[i][j + 1];
        }
    }

    int ans = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            map<pair<char, char>, int> mp;
            int now = 0;
            for (int d = 1; i + d <= n && j + d <= m && d < min(n, m) + 1; d++) {
                int x = i + d - 1;
                int y = j + d - 1;
                bool good = true;
                if (prefLeftCol[x][y] - prefLeftCol[i][y] < d - 1) good = false;
                if (prefLeftRow[x][y] - prefLeftRow[x][j] < d - 1) good = false;
                mp[a[i][y]]++;
                if (mp[a[i][y]] == 1) now++;
                else if (mp[a[i][y]] == 2) now--;
                else break;

                if (d != 1) {
                    mp[a[x][j]]++;
                    if (mp[a[x][j]] == 1) now++;
                    else if (mp[a[x][j]] == 2) now--;
                    else break;
                }
                
                if (good && now == 1) ans++;
            }
        }
    }

    for (int i = 1; i < n; i++) {
        for (int j = 3; j < m; j++) {
            map<pair<char, char>, int> mp;
            int now = 0;
            for (int d = 1;i + d - 1 < n && j - d + 1 >= 0 && d < min(n, m) + 1; d++) {
                int x = i + d - 1;
                int y = j - d + 1;
                bool good = true;
                if (prefRightCol[x][y] - prefRightCol[i][y] < d - 1) good = false;
                if (prefRightRow[x][y] - prefRightRow[x][j] < d - 1) good = false;

                mp[a[x][j]]++;
                if (mp[a[x][j]] == 1) now++;
                else if (mp[a[x][j]] == 2) now--;
                else break;

                if (d > 1) {
                    mp[a[i][y]]++;
                    if (mp[a[i][y]] == 1) now++;
                    else if (mp[a[i][y]] == 2) now--;
                    else break;
                }
               

                if(good && now == 1 && d > 2) ans++;
            }
        }
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    solve();
}

/*
    Спокойствие, только спокойствие!
*/