#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int C = 256;
const int CC = C * C;
const int mx = 2010;
const int lg = 20;
int n, m, a[mx][mx], hor_val[mx][mx], vert_val[mx][mx], sq_val[mx][mx];

int last_occ[CC], color[CC];
int color_ptr;

void add(int pos, int val) {
	last_occ[val] = pos;
	color[val] = color_ptr;
}

int get(int val, int def) {
	return (color[val] != color_ptr ? def : last_occ[val]);
}

void clear() {
	color_ptr++;
}

void calc_hor_val() {
	for (int i = 0; i < n; ++i) {
		clear();
		for (int j = m - 1; j >= 0; --j) {
			hor_val[i][j] = min(hor_val[i][j + 1] + 1, get(a[i][j], m) - j);
			add(j, a[i][j]);
		}
	}
	// cerr << "hor_val" << endl;
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cerr << hor_val[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }
}

void calc_vert_val() {
	for (int i = 0; i < m; ++i) {
		clear();
		for (int j = n - 1; j >= 0; --j) {
			vert_val[j][i] = min(vert_val[j + 1][i] + 1, get(a[j][i], n) - j);
			add(j, a[j][i]);
		}
	}
	// cerr << "vert_val" << endl;
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cerr << vert_val[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }
}

int upd_sq_val(int x, int y) {
	if (x + sq_val[x][y] >= n || y + sq_val[x][y] >= m) {
		return 0;
	}
	for (int i = x; i <= x + sq_val[x][y]; ++i) {
		if (hor_val[i][y] < sq_val[x][y] + 1) {
			return 0;
		}
	}
	for (int i = y; i <= y + sq_val[x][y]; ++i) {
		if (vert_val[x][i] < sq_val[x][y] + 1) {
			return 0;
		}
	}
	sq_val[x][y]++;
	return 1;
}

void calc_sq_val() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			sq_val[i][j] = 1;
			if (i) {
				chkmax(sq_val[i][j], sq_val[i - 1][j] - 1);
			}
			if (j) {
				chkmax(sq_val[i][j], sq_val[i][j - 1] - 1);
			}
			if (i && j) {
				chkmax(sq_val[i][j], sq_val[i - 1][j - 1] - 1);
			}
			while (upd_sq_val(i, j)) {}
		}
	}
	// cerr << "sq_val" << endl;
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cerr << sq_val[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }
}

mt19937 rng(58);
ll mask[CC];

void gen_masks() {
	for (int i = 0; i < CC; ++i) {
		mask[i] = (rng() << 32) ^ rng();
	}
}

ll pref_mask[mx][mx];

void calc_pref_masks() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			pref_mask[i + 1][j] = (pref_mask[i][j] ^ mask[a[i][j]]);
		}
	}
}

ll ans;

void solve(int l, int r) {
	int cnt = 0;
	int k = r - l + 1;
	for (int i = 0; i < m; ++i) {
		if (i == 0 || (pref_mask[r + 1][i] ^ pref_mask[r + 1][i - 1] ^ pref_mask[l][i] ^ pref_mask[l][i - 1])) {
			cnt = 1;
		} else {
			cnt++;
		}
		if (cnt >= k && sq_val[l][i - k + 1] >= k) {
			ans++;
		}
	}
}

void solve() {
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			solve(i, j);
		}
	}
}

signed main() {
	fast_io();
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j ++) {
			a[i][j] = (int)s[2 * j] * C + (int)s[2 * j + 1];
		}
	}
	calc_hor_val();
	calc_vert_val();
	calc_sq_val();
	gen_masks();
	calc_pref_masks();
	solve();
	cout << ans << endl;
}
