#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;

struct Solver {
    int n, m;
    vector<vector<int>> t;

    Solver(auto t): t(t) {
        n = t.size(), m = t[0].size();
    }

    vector<vector<vector<int>>> get_r() {
        vector<vector<vector<int>>> res(n, vector<vector<int>> (m, vector<int> (m, 0)));
        for(int i = 0; i < n; ++i) {
            for(int l = 0; l < m; ++l) {
                unordered_set<int> s;
                for(int r = l; r < m; ++r) {
                    s.insert(t[i][r]);
                    res[i][l][r] = s.size();
                }
            }
        }

        return res;
    }

    vector<vector<vector<int>>> get_c() {
        vector<vector<vector<int>>> res(m, vector<vector<int>> (n, vector<int> (n, 0)));
        for(int i = 0; i < m; ++i) {
            for(int l = 0; l < n; ++l) {
                unordered_set<int> s;
                for(int r = l; r < n; ++r) {
                    s.insert(t[r][i]);
                    res[i][l][r] = s.size();
                }
            }
        }

        return res;
    }

    int solve() {
        vector<vector<vector<int>>> r = get_r();
        vector<vector<vector<int>>> c = get_c();

        int res = 0;
        for(int x = 0; x < n; ++x) {
            for(int y = 0; y < m; ++y) {
                unordered_set<int> s;
                for(int k = 0; k <= min(n-x-1, m-y-1); ++k) {
                    for(int i = x; i <= x+k; ++i)
                        s.insert(t[i][y+k]);
                    for(int i = y; i <= y+k; ++i)
                        s.insert(t[x+k][i]);

                    if((s.size() == k+1) && (c[y][x][x+k] == k+1) && (r[x][y][y+k] == k+1)) res++;
                }
            }
        }

        return res;
    }
};

int n_from_c(char a, char b) {
    return (a-33)*(126-33+1) + (b-33);
}

const int local = 0, stress = 0;
int32_t main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = (stress ? 100 : 1);
    if((local) && (!stress)) cin >> tests;

    while(tests--) {
        if(!stress) {
            int n, m;
            cin >> n >> m;

            vector<vector<int>> t(n, vector<int> (m, 0));
            for(int i = 0; i < n; ++i) {
                string s;
                cin >> s;

                for(int j = 0; j < m; ++j)
                    t[i][j] = n_from_c(s[2*j], s[2*j+1]);
            }

            Solver solver(t);
            int res = solver.solve();
            cout << res << "\n";

        } else {}
    }

    return 0;
}
