#include<iostream>
#include<random>
#include<map>
#include<set>

using namespace std;

const int MAXN = 2005;

mt19937 rnd(222);

int n, m;
pair <char, char> a[MAXN][MAXN];

long long sum[MAXN][MAXN];
int downVal[MAXN][MAXN], rightVal[MAXN][MAXN];

long long getSum(int r1, int c1, int r2, int c2)
{
    if(r1==0 && c1==0) return sum[r2][c2];
    if(r1==0) return sum[r2][c2] - sum[r2][c1-1];
    if(c1==0) return sum[r2][c2] - sum[r1-1][c2];
    return sum[r2][c2] - sum[r1-1][c2] - sum[r2][c1-1] + sum[r1-1][c1-1];
}

void Init()
{
    map <pair <char, char>, long long> code;
    for(char c1 = 33;c1<=126;c1++)
    {
        for(char c2 = 33;c2<=126;c2++)
        {
            code[{c1, c2}] = rnd();
            //cout << c1 << " " << c2 << " -> " << code[{c1, c2}] << '\n';
        }
    }

    sum[0][0] = code[ a[0][0] ];
    for(int i = 1;i<n;i++)
    {
        sum[i][0] = sum[i-1][0] + code[ a[i][0] ];
    }
    for(int j = 1;j<m;j++)
    {
        sum[0][j] = sum[0][j-1] + code[ a[0][j] ];
    }
    for(int i = 1;i<n;i++)
    {
        for(int j = 1;j<m;j++)
        {
            sum[i][j] = sum[i-1][j] + sum[i][j-1] - sum[i-1][j-1] + code[ a[i][j] ];
        }
    }


    for(int j = 0;j<m;j++)
    {
        map <pair <char, char>, int> last;
        for(int i = n-1;i>=0;i--)
        {
            if(last.count(a[i][j])==false)
            {
                downVal[i][j] = n;
            }
            else
            {
                downVal[i][j] = last[ a[i][j] ];
            }

            last[ a[i][j] ] = i;
        }
    }

    for(int i = 0;i<n;i++)
    {
        map <pair <char, char>, int> last;
        for(int j = m-1;j>=0;j--)
        {
            if(last.count(a[i][j])==false)
            {
                rightVal[i][j] = m;
            }
            else
            {
                rightVal[i][j] = last[ a[i][j] ];
            }

            last[ a[i][j] ] = j;
        }
    }
}

void solveSpecial()
{
    cout << n*m << '\n';
}

bool check(int x, int y, int side)
{
    set <pair <char, char>> all;
    for(int i = x;i<x+side;i++)
    {
        for(int j = y;j<y+side;j++)
        {
            all.insert(a[i][j]);
        }
    }
    if(all.size()!=side)
    {
        return false;
    }

    for(int i = x;i<x+side;i++)
    {
        set <pair <char, char>> curr;
        for(int j = y;j<y+side;j++)
        {
            if(curr.count(a[i][j])==true) return false;
            curr.insert(a[i][j]);
        }
    }

    for(int j = y;j<y+side;j++)
    {
        int minVal = MAXN;
        for(int i = x;i<x+side;i++)
        {
            minVal = min(minVal, downVal[i][j]);
        }

        if(minVal<x+side) return false;
    }

    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<m;j++)
        {
            cin >> a[i][j].first >> a[i][j].second;
        }
    }
    Init();

    int answer = 0;
    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<m;j++)
        {
            int minRight = MAXN, minDown = MAXN;
            for(int p = j;p<m && i+p-j<n;p++)
            {
                if(check(i, j, p-j+1)==true)
                {
                    answer++;
                }

                /*
                cout << i << " " << j << " -> " << p << '\n';
                for(int k = 0;k<=p-j;k++)
                {
                    cout << "update: " << i+k << " " << p << '\n';

                    minRight = min(minRight, min(rightVal[i+p-j][j+k], rightVal[i+k][p]));
                    minDown = min(minDown, min(downVal[i+p-j][j+k], downVal[i+k][p]));
                }
                if(minRight<p || minDown<i+p-j) break;

                long long squareSum = getSum(i, j, i+p-j, p);
                long long rowSum = getSum(i, j, i, p);

                bool fail = false;
                for(int k = i;k<=i+p-j;k++)
                {
                    if(getSum(k, j, k, p)!=rowSum)
                    {
                        fail = true;
                        break;
                    }
                }

                //cout << i << " " << j << " " << p << " -> " << rowSum << " " << squareSum << '\n';
                if(fail==false)
                {
                    //if(j!=p) cout << i << " " << j << " -> " << p << '\n';
                    answer++;
                }
                */
            }
        }
    }

    cout << answer << '\n';
}
