#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int C = 256;
const int CC = C * C;
const int mx = 2010;
const int lg = 12;
int n, m, a[mx][mx], hor_val[mx][mx], vert_val[mx][mx], sq_val[mx][mx];

int last_occ[CC], color[CC];
int color_ptr;

void add(int pos, int val) {
	last_occ[val] = pos;
	color[val] = color_ptr;
}

int get(int val, int def) {
	return (color[val] != color_ptr ? def : last_occ[val]);
}

void clear() {
	color_ptr++;
}

int pw2[mx], hor_scp[mx][mx][lg], vert_scp[mx][mx][lg];

void init_pw2() {
	for (int i = 2; i < mx; ++i) {
		pw2[i] = pw2[i / 2] + 1;
	}
}

void calc_hor_val() {
	for (int i = 0; i < n; ++i) {
		clear();
		for (int j = m - 1; j >= 0; --j) {
			hor_val[i][j] = min(hor_val[i][j + 1] + 1, get(a[i][j], m) - j);
			add(j, a[i][j]);
		}
	}
	for (int i = 0; i < m; ++i) {
		for (int j = n - 1; j >= 0; --j) {
			hor_scp[j][i][0] = hor_val[j][i];
			for (int it = 1; it < lg; ++it) {
				int j1 = (j + (1 << (it - 1)));
				hor_scp[j][i][it] = hor_scp[j][i][it - 1];
				if (j1 < m) {
					chkmin(hor_scp[j][i][it], hor_scp[j1][i][it - 1]);
				}
			}
		}
	}
	// cerr << "hor_val" << endl;
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cerr << hor_val[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }
}

int hor_min(int i, int l, int r) {
	int deg = pw2[r - l + 1];
	return min(hor_scp[l][i][deg], hor_scp[r - (1 << deg) + 1][i][deg]);
}

void calc_vert_val() {
	for (int i = 0; i < m; ++i) {
		clear();
		for (int j = n - 1; j >= 0; --j) {
			vert_val[j][i] = min(vert_val[j + 1][i] + 1, get(a[j][i], n) - j);
			add(j, a[j][i]);
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = m - 1; j >= 0; --j) {
			vert_scp[i][j][0] = vert_val[i][j];
			for (int it = 1; it < lg; ++it) {
				int j1 = (j + (1 << (it - 1)));
				vert_scp[i][j][it] = vert_scp[i][j][it - 1];
				if (j1 < m) {
					chkmin(vert_scp[i][j][it], vert_scp[i][j1][it - 1]);
				}
			}
		}
	}
	// cerr << "vert_val" << endl;
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cerr << vert_val[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }
}

int vert_min(int i, int l, int r) {
	int deg = pw2[r - l + 1];
	return min(vert_scp[i][l][deg], vert_scp[i][r - (1 << deg) + 1][deg]);
}

int upd_sq_val(int x, int y) {
	if (x + sq_val[x][y] >= n || y + sq_val[x][y] >= m) {
		return 0;
	}
	// for (int i = x; i <= x + sq_val[x][y]; ++i) {
	// 	if (hor_val[i][y] < sq_val[x][y] + 1) {
	// 		return 0;
	// 	}
	// }
	if (hor_min(y, x, x + sq_val[x][y]) <= sq_val[x][y]) {
		return 0;
	}
	if (vert_min(x, y, y + sq_val[x][y]) <= sq_val[x][y]) {
		return 0;
	}
	// for (int i = y; i <= y + sq_val[x][y]; ++i) {
	// 	if (vert_val[x][i] < sq_val[x][y] + 1) {
	// 		return 0;
	// 	}
	// }
	sq_val[x][y]++;
	return 1;
}

void calc_sq_val() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			sq_val[i][j] = 1;
			if (i) {
				chkmax(sq_val[i][j], sq_val[i - 1][j] - 1);
			}
			if (j) {
				chkmax(sq_val[i][j], sq_val[i][j - 1] - 1);
			}
			if (i && j) {
				chkmax(sq_val[i][j], sq_val[i - 1][j - 1] - 1);
			}
			while (upd_sq_val(i, j)) {}
		}
	}
	// cerr << "sq_val" << endl;
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < m; ++j) {
	// 		cerr << sq_val[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }
}

mt19937 rng(58);
ll mask[CC];

void gen_masks() {
	for (int i = 0; i < CC; ++i) {
		mask[i] = (rng() << 32) ^ rng();
	}
}

ll pref_mask[mx][mx];

void calc_pref_masks() {
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			pref_mask[i + 1][j] = (pref_mask[i][j] ^ mask[a[i][j]]);
		}
	}
}

ll ans;

void solve(int l, int r) {
	int cnt = 0;
	int k = r - l + 1;
	for (int i = 0; i < m; ++i) {
		if (i == 0 || (pref_mask[r + 1][i] ^ pref_mask[r + 1][i - 1] ^ pref_mask[l][i] ^ pref_mask[l][i - 1])) {
			cnt = 1;
		} else {
			cnt++;
		}
		if (cnt >= k && sq_val[l][i - k + 1] >= k) {
			ans++;
		}
	}
}

void solve() {
	ans = n * m;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			solve(i, j);
		}
	}
}

signed main() {
	fast_io();
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j ++) {
			a[i][j] = (int)s[2 * j] * C + (int)s[2 * j + 1];
		}
	}
	init_pw2();
	calc_hor_val();
	calc_vert_val();
	calc_sq_val();
	gen_masks();
	calc_pref_masks();
	solve();
	cout << ans << endl;
}
