#include <iostream>

using namespace std;

const int MAX_LET = 127 - 32 + 3;

inline int encode(char a, char b) {
    int aN = a - 32;
    int bN = b - 32;
    return aN + bN * MAX_LET;
}

const int ALPHA_SIZE = 10000;

struct Uniq{
    int diffCnt = 0;
    int cnt[ALPHA_SIZE];

    void add(int x) {
        if (cnt[x] == 0) {
            diffCnt++;
        }
        cnt[x]++;
    }

    void remove(int x) {
        cnt[x]--;
        if (cnt[x] == 0) {
            diffCnt--;
        }
    }

    void clear() {
        diffCnt = 0;
        fill(cnt, cnt + ALPHA_SIZE, 0);
    }
} un;

const int MAX_N = 2003;
int a[MAX_N][MAX_N];
Uniq iS[MAX_N];
Uniq jS[MAX_N];

int main() {
#ifdef LOCAL
    freopen("H.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int jReal = 0;
        for (int j = 0; j < 2* m; j += 2) {
            char aC, bC;
            cin >> aC >> bC;
            a[i][jReal] = encode(aC, bC);
            jReal++;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            un.clear();
            for (int k = 0; i + k < n && j + k < m; k++) {
                bool flag = true;
                for (int newI = i; newI < i + k;newI++) {
                    un.add(a[newI][j + k]);
                    iS[newI].add(a[newI][j + k]);
                    if (iS[newI].diffCnt != k + 1) {
                        flag = false;
                    }
                }
                for (int newJ = j; newJ < j + k;newJ++) {
                    un.add(a[i + k][newJ]);
                    jS[newJ].add(a[i + k][newJ]);
                    if (jS[newJ].diffCnt != k + 1) {
                        flag = false;
                    }
                }
                un.add(a[i + k][j + k]);
                if (un.diffCnt != k + 1) {
                    flag = false;
                }
                iS[i + k].clear();
                for (int newJ = j; newJ <= j + k;newJ++) {
                    iS[i + k].add(a[i + k][newJ]);
                }
                if (iS[i + k].diffCnt != k + 1) {
                    flag = false;
                }
                jS[j + k].clear();
                for (int newI = i; newI <= i + k;newI++) {
                    jS[j + k].add(a[newI][j + k]);
                }
                if (jS[j + k].diffCnt != k + 1) {
                    flag = false;
                }
                if (flag) {
                    ans++;
                }
            }
        }
    }
    cout << ans << "\n";

    return 0;
}