#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#include <cstring>
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
const int MAXN = 20; //507;
const int K    = 20;
const int MAXC = 100 * 100 + 7;
struct Hash {
	ll v[K];
	Hash() {
		memset(v, 0, sizeof(v));
	}
	Hash operator+(const Hash& other) const {
		Hash rez;
		for(int j = 0; j < K; ++j) rez.v[j] = v[j] + other.v[j];
		return rez;
	}
};
struct Rect {
	int xL, yL, xR, yR;
	Rect(): xL(-MAXN), xR(MAXN), yL(-MAXN), yR(MAXN) {}
};
int G[MAXN][MAXN];
Rect R[MAXN][MAXN];
ll answ = 0;
int n, m;
Hash T[MAXC];
mt19937 rng;
int getRand() {
	return rng();
}
int getLeft(int i, int j) {
	int v = G[i][j];
	--j;
	while(j >= 0 && G[i][j] != v) --j;
	return j;
}
int getRight(int i, int j) {
	int v = G[i][j];
	++j;
	while(j < m && G[i][j] != v) ++j;
	return j;
}
int getUp(int i, int j) {
	int v = G[i][j];
	--i;
	while(i >= 0 && G[i][j] != v) --i;
	return i;
}
int getDown(int i, int j) {
	int v = G[i][j];
	++i;
	while(i < n && G[i][j] != v) ++i;
	return i;
}
Rect intersect(const Rect& lhs, const Rect& rhs) {
	Rect rez;
	rez.xL = max(lhs.xL, rhs.xL);
	rez.xR = min(lhs.xR, rhs.xR);
	rez.yL = max(lhs.yL, rhs.yL);
	rez.yR = min(lhs.yR, rhs.yR);
	return rez;
}
Rect dp[MAXN][MAXN][MAXN];
int Check(int i, int j, int k) {
	Hash tot;
	for(int i2 = i; i2 < i + k; ++i2) for(int j2 = j; j2 < j + k; ++j2) {
		tot = tot + T[G[i2][j2]];
	}
	for(int jd = 0; jd < K; ++jd) if(tot.v[jd]%k != 0) return 0;
	return 1;
}
void solve() {
	cin >> n >> m;
	for(int i = 0; i < n; ++i) {
		for(int j = 0; j < m; ++j) {
			char c, d;
			cin >> c >> d;
			int C = c - 33;
			int D = d - 33;
			G[i][j] = C + 100 * D;
		}
	}
	for(int c = 0; c < MAXC; ++c) for(int j = 0; j < K; ++j) {
		T[c].v[j] = getRand()%((int)1e6);
	}
	for(int i = 0; i < n; ++i) for(int j = 0; j < m; ++j) {
		R[i][j].yL = getLeft(i, j) + 1;
		R[i][j].yR = getRight(i, j) - 1;
		R[i][j].xL = getUp(i, j) + 1;
		R[i][j].xR = getDown(i, j) - 1;
		dp[1][i][j] = R[i][j];
	}
	for(int k = 2; k <= n && k <= m; ++k)
		for(int i = 0; i + k - 1 < n; ++i) for(int j = 0; j + k - 1 < m; ++j) {
		dp[k][i][j] = dp[k - 1][i][j];
		dp[k][i][j] = intersect(dp[k][i][j], dp[k - 1][i + 1][j]);
		dp[k][i][j] = intersect(dp[k][i][j], dp[k - 1][i][j + 1]);
		dp[k][i][j] = intersect(dp[k][i][j], dp[k - 1][i + 1][j + 1]);
	}
	for(int k = 1; k <= n && k <= m; ++k) {
		for(int i = 0; i + k - 1 < n; ++i) for(int j = 0; j + k - 1 < m; ++j) {
			auto r = dp[k][i][j];
			DBG(r.xL); DBG(r.xR); DBG(r.yL); DBG(r.yR);
			if(i >= r.xL && j >= r.yL && i + k - 1 <= r.xR && j + k - 1 <= r.yR) {
				DBG(k); DBG(i); DBG(j);
				answ += Check(i, j, k);
			}
		}
	}
	cout << answ << '\n';
}
int main() {
	fastIO();
	solve();
	return 0;
}
