/*
 *   cCreated by Kazalika   for Zaoch 19-20
 */

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vint;
typedef vector<ll> vll;
#define forn(a, i, n) for (int i = a; i < n; ++i)
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
const int N = 2e3 + 5, LOG = 13;
const ll INF = 1e15;
const ldb EPS = 1e-8;

int n, m;
int arr[N][N];
int nearD[N][N], nearL[N][N];
int dpMaxD[N][N], dpMaxL[N][N];

struct sparse_table {
    vector <vector <int> > sp;
    vector <int> lg;
    sparse_table(vector <int> & v) {
        lg.resize(sz(v) + 1);
        lg[0] = lg[1] = 0;
        for (int i = 2; i <= sz(v); ++i)
            lg[i] = lg[i >> 1] + 1;
        sp.resize(LOG, vector <int> (sz(v), 0));
        for (int i = 0; i < sz(v); ++i)
            sp[0][i] = v[i];
        for (int flow = 1; flow < LOG; ++flow) {
            for (int l = 0; l < sz(v) - (1 << flow) + 1; ++l)
                sp[flow][l] = min(sp[flow - 1][l], sp[flow - 1][l + (1 << flow - 1)]);
        }
    }
    int getMin(int l, int r) {
        int flow = lg[r - l + 1];
        return min(sp[flow][l], sp[flow][r - (1 << flow) + 1]);
    }
};

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    forn(0, i, n) {
        forn(0, j, m) {
            char h1, h2;
            cin >> h1 >> h2;
            arr[i][j] = (h1 - 32) * 94 + (h2 - 32);
        }
    }

    vector <int> inds(10000, n);

    for (int j = 0; j < m; ++j) {
        fill(all(inds), n);
        for (int i = n - 1; i >= 0; --i) {
            nearD[i][j] = inds[arr[i][j]];
            inds[arr[i][j]] = i;
        }
    }
    for (int i = 0; i < n; ++i) {
        fill(all(inds), m);
        for (int j = m - 1; j >= 0; --j) {
            nearL[i][j] = inds[arr[i][j]];
            inds[arr[i][j]] = j;
        }
    }

    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            dpMaxD[i][j] = nearD[i][j] - i;
            if (i != n - 1)
                dpMaxD[i][j] = min(dpMaxD[i][j], dpMaxD[i + 1][j] + 1);
            dpMaxL[i][j] = nearL[i][j] - j;
            if (j != m - 1)
                dpMaxL[i][j] = min(dpMaxL[i][j], dpMaxL[i][j + 1] + 1);
        }
    }

    vector <sparse_table> forD, forL;
    for (int i = 0; i < n; ++i) {
        vector <int> pp(m);
        for (int j = 0; j < m; ++j)
            pp[j] = dpMaxD[i][j];
        forD.push_back(sparse_table(pp));
    }
    for (int j = 0; j < m; ++j) {
        vector <int> pp(n);
        for (int i = 0; i < n; ++i)
            pp[i] = dpMaxL[i][j];
        forL.push_back(sparse_table(pp));
    }
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int L = 0, R = min(dpMaxL[i][j], dpMaxD[i][j]) + 1;
            while (R - L > 1) {
                int MID = (R + L) >> 1;
                int DM = forD[i].getMin(j, j + MID - 1);
                int LM = forL[j].getMin(i, i + MID - 1);
                if (DM >= MID && LM >= MID)
                    L = MID;
                else
                    R = MID;
            }

            vector <int> cnt(10000);
            int nowcnt = 0;
            for (int k = 1; k <= L; ++k) {
                for (int i1 = i; i1 < i + k; ++i1) {
                    if (cnt[arr[i1][j + k - 1]] == 0)
                        nowcnt++;
                    cnt[arr[i1][j + k - 1]]++;
                }
                for (int j1 = j; j1 < j + k; ++j1) {
                    if (cnt[arr[i + k - 1][j1]] == 0)
                        nowcnt++;
                    cnt[arr[i + k - 1][j1]]++;
                }
                if (nowcnt == k)
                    res++;
            }

        }
    }
    cout << res;

}