#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int n, m;
vector<string> grid;

int getHash(char a, char b) {
    return 2 * (a - 32) + (b - 32);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m;
    grid.resize(n);
    for (auto &i : grid) {
        cin >> i;
    }

    bitset<300> usedSymbols;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            usedSymbols[getHash(grid[i][2 * j], grid[i][2 * j + 1])] = true;
        }
    }

    int to = min(n, min(m, (int)usedSymbols.count()));
    long long answer = n * m;
    for (int len = 2; len <= to; len++) {
        for (int startX = 0; startX <= n - len; startX++) {
            for (int startY = 0; startY <= m - len; startY++) {
                bool ok = true;
                usedSymbols.reset();
                for (int i = startX; i < startX + len; i++) {
                    for (int j = startY; j < startY + len; j++) {
                        usedSymbols[getHash(grid[i][2 * j], grid[i][2 * j + 1])] = true;
                    }
                }

                ok &= (usedSymbols.count() == len);

                for (int i = startX; i < startX + len; i++) {
                    usedSymbols.reset();
                    for (int j = startY; j < startY + len; j++) {
                        usedSymbols[getHash(grid[i][2 * j], grid[i][2 * j + 1])] = true;
                    }
                    ok &= (usedSymbols.count() == len);
                }

                for (int j = startY; j < startY + len; j++) {
                    usedSymbols.reset();
                    for (int i = startX; i < startX + len; i++) {
                        usedSymbols[getHash(grid[i][2 * j], grid[i][2 * j + 1])] = true;
                    }
                    ok &= (usedSymbols.count() == len);
                }

                answer += ok;
            }
        }
    }

    cout << answer << endl;

    return EXIT_SUCCESS;
}
