//#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <sstream>
#include <random>
#include <bitset>
#include <time.h>

using namespace std;

#define int ll
#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
typedef long long ll;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

struct fenwick {
    int n;
    vector<int> f;
    fenwick (int _n) {
        n = _n;
        f.assign(n,0);
    }
    void update(int i, int v) {
        for (; i <= n; i += i & (-i)) {
            f[i] += v;
        }
    }
    int get_sum(int i) {
        int s = 0;
        for (; i > 0; i -= i & (-i)) {
            s += f[i];
        }
        return s;
    }
    int get(int L, int R) {
        return get_sum(R) - get_sum(L - 1);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    vector<vector<string>> a(n, vector<string> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c1, c2;
            cin >> c1 >> c2;
            s = c1;
            s += c2;
            a[i][j] = s;
        }
    }
    int ans = 0;
    for (int k = 1; k <= min(n, m); ++k) {
        for (int i = 0; i < n - k + 1; ++i) {
            for (int j = 0; j < m - k + 1; ++j) {
                set<string> seg, full;
                int f = 1;
                for (int x = i; x < i + k; ++x) {
                    for (int y = j; y < j + k; ++y) {
                        seg.insert(a[x][y]);
                        full.insert(a[x][y]);
                    }
                    if (seg.size() != k) f = 0;
                    seg.clear();
                }
                for (int y = j; y < j + k; ++y) {
                    for (int x = i; x < i + k; ++x) {
                        seg.insert(a[x][y]);
                    }
                    if (seg.size() != k) f = 0;
                    seg.clear();
                }
                if (f && full.size() == k) ++ans;
            }
        }
    }
    cout << ans << en;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    srand(time(0));
    int D = 10, t = (D ? 2 : 1);
    //cin >> t;
    while (t--) solve();
    return 0;
}