#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>
#include <random>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long

vector<vector<int>> a;
vector<vector<int>> maxright, maxdown;
int bigrow, bigcolumn, bigall, usd;
vector<int> kolvo;

inline int check(int length)
{
    if (bigrow == 0 && bigcolumn == 0 && bigall == 0 && usd == length) return 1;
    return 0;
}

inline void moveright(int i, int j, int length)
{
    if (maxdown[i][j] < length) bigcolumn--;
    if (maxdown[i][j + length] < length) bigcolumn++;

    for (int ii = i; ii < i + length; ii++)
    {
        if (maxright[ii][j] < length) bigrow--;
        if (maxright[ii][j + 1] < length) bigrow++;
        
        kolvo[a[ii][j]]--;
        if (kolvo[a[ii][j]] == 0) usd--;
        if (kolvo[a[ii][j]] == length) bigall--;
        
        if (kolvo[a[ii][j + length]] == 0) usd++;
        if (kolvo[a[ii][j + length]] == length) bigall++;
        kolvo[a[ii][j + length]]++;
    }
}

inline void movedown(int i, int j, int length)
{
    if (maxright[i][j] < length) bigrow--;
    if (maxright[i + length][j] < length) bigrow++;

    for (int jj = j; jj < j + length; jj++)
    {
        if (maxdown[i][jj] < length) bigcolumn--;
        if (maxdown[i + 1][jj] < length) bigcolumn++;
        kolvo[a[i][jj]]--;
        if (kolvo[a[i][jj]] == length) bigall--;
        if (kolvo[a[i][jj]] == 0) usd--;

        if (kolvo[a[i + length][jj]] == 0) usd++;
        if (kolvo[a[i + length][jj]] == length) bigall++;
        kolvo[a[i + length][jj]]++;
    }
}


int32_t main()
{
    cin.tie(NULL);
    cout.tie(NULL);
    ios::sync_with_stdio(false);

    int n, m;
    int ans = 0;
    cin >> n >> m;
    vector<string> t(n);
    for (int i = 0; i < n; i++) cin >> t[i];

    a.resize(n, vector<int>(m, 0));
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            a[i][j] = ((int)t[i][2 * j] - 33);
            a[i][j] *= 94;
            a[i][j] += ((int)t[i][2 * j + 1] - 33);
        }
    }

    
    maxright.resize(n, vector<int>(m, 3000));
    maxdown.resize(n, vector<int>(m, 3000));
    
    vector<int> last(10000);
    for (int i = 0; i < n; i++)
    {
        for (int k = 0; k < 10000; k++) last[k] = m;
        int curr = 0;
        for (int j = m - 1; j >= 0; j--)
        {
            if (j != m - 1) maxright[i][j] = maxright[i][j + 1] + 1;
            maxright[i][j] = min(maxright[i][j], last[a[i][j]] - j);
            last[a[i][j]] = j;
        }
    }

    for (int j = 0; j < m; j++)
    {
        for (int k = 0; k < 10000; k++) last[k] = n;
        for (int i = n - 1; i >= 0; i--)
        {
            if (i != n - 1) maxdown[i][j] = maxdown[i + 1][j] + 1;
            maxdown[i][j] = min(maxdown[i][j], last[a[i][j]] - i);
            last[a[i][j]] = i;
        }
    }

 
    int ttt = min(n, m);
    bigrow = bigcolumn = bigall = 0;
    kolvo.resize(10000, 0);

    int bigr, bigc, biga;
    vector<int> tmp;

    for (int length = 1; length <= ttt; length++)
    {
        for (int i = 0; i < 10000; i++) kolvo[i] = 0;
        usd = 0;
        bigrow = 0;
        bigcolumn = 0;
        bigall = 0;

        for (int i = 0; i < length; i++)
        {
            for (int j = 0; j < length; j++)
            {
                if (kolvo[a[i][j]] == length) bigall++;
                if (kolvo[a[i][j]] == 0) usd++;
                kolvo[a[i][j]]++;
            }
        }
        for (int i = 0; i < length; i++)
        {
            if (maxright[i][0] < length) bigrow++;
            if (maxdown[0][i] < length) bigcolumn++;
        }
        tmp = kolvo;
        bigc = bigcolumn;
        bigr = bigrow;
        biga = bigall;

        for (int i = 0; i + length < n; i++)
        {
            ans += check(length);
            for (int j = 0; j + length < m; j++)
            {
                
                moveright(i, j, length);
                ans += check(length);
            }
            kolvo = tmp;
            bigcolumn = bigc;
            bigrow = bigr;
            bigall = biga;
            movedown(i, 0, length);
            tmp = kolvo;
            bigc = bigcolumn;
            bigr = bigrow;
            biga = bigall;
        }

        ans += check(length);
        for (int j = 0; j + length < m; j++)
        {
            moveright(n - length, j, length);
            ans += check(length);
        }

    }

    cout << ans;
    return 0;
}

//OPTIMIZE: MIN, UPDATE NOT 10000, BUT N/M(BACK)