#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <bitset>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef int ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            char x, y;
            cin >> x >> y;
            a[i][j] = (ll) (x - 33) * 94 + (ll) (y - 33);
        }
    }
    vector<vector<vector<ll>>> b(n, vector<vector<ll>>(m, vector<ll>(8836)));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            b[i][j][a[i][j]]++;
        }
    }
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            for (ll k = 0; k < 8836; k++) {
                b[i][j][k] += j == 0 ? 0 : b[i][j - 1][k];
            }
        }
    }
    for (ll j = 0; j < m; j++) {
        for (ll i = 0; i < n; i++) {
            for (ll k = 0; k < 8836; k++) {
                b[i][j][k] += i == 0 ? 0 : b[i - 1][j][k];
            }
        }
    }
    auto f = [&](ll x1, ll y1, ll x2, ll y2) {
        vector<ll> o(8836);
        for (ll k = 0; k < 8836; k++) {
            o[k] += b[x2][y2][k];
            if (x1 != 0) {
                o[k] -= b[x1 - 1][y2][k];
            }
            if (y1 != 0) {
                o[k] -= b[x2][y1 - 1][k];
            }
            if (x1 != 0 && y1 != 0) {
                o[k] += b[x1 - 1][y1 - 1][k];
            }
        }
        return o;
    };
    ll o = 0;
    for (ll s = 1; s <= min(n, m); s++) {
        vector<vector<char>> g(n, vector<char>(m, true));
        for (ll j = 0; j <= m - s; j++) {
            for (ll x = 0; x < n; x++) {
                vector<ll> v = f(x, j, x, j + s - 1);
                if (count(v.begin(), v.end(), (ll) 1) != s) {
                    g[x][j] = false;
                }
            }
        }
        vector<vector<char>> h(n, vector<char>(m, true));
        for (ll i = 0; i <= n - s; i++) {
            for (ll y = 0; y < m; y++) {
                vector<ll> v = f(i, y, i + s - 1, y);
                if (count(v.begin(), v.end(), (ll) 1) != s) {
                    h[i][y] = false;
                }
            }
        }
        for (ll i = 0; i <= n - s; i++) {
            for (ll j = 0; j <= m - s; j++) {
                vector<ll> u = f(i, j, i + s - 1, j + s - 1);
                if (count(u.begin(), u.end(), (ll) s) != s) {
                    continue;
                }
                bool f = false;
                for (ll x = i; x < i + s; x++) {
                    if (!g[x][j]) {
                        f = true;
                    }
                }
                if (f) {
                    continue;
                }
                for (ll y = j; y < j + s; y++) {
                    if (!h[i][y]) {
                        f = true;
                    }
                }
                if (f) {
                    continue;
                }
                o++;
            }
        }
    }
    cout << o << endl;
    return 0;
}
