#define _CRT_SECURE_NO_WARNINGS
#define REL

#pragma GCC optimize ("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <bitset>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <algorithm> 
#include <queue>
#include <deque>

using namespace std;

#define endl "\n"
#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T>
bool uin(T &a, const T &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uax(T &a, const T &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

mt19937_64 rnd;

const int LOG = 25;
const LL LINF = 1e18;
const int N = (int)1e2 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e5 + 7;

///////////////////////////////////////////////////////////////////////

int p = 998244353, m1 = (int)1e9 + 7, m2 = (int)1e9 + 9;
int p1[MAXN], p2[MAXN];

void precalc() {
	p1[0] = p2[0] = 1;
	for (int i = 1; i < MAXN; i++) {
		p1[i] = 1LL * p1[i - 1] * p % m1;
		p2[i] = 1LL * p2[i - 1] * p % m2;
	}
}

struct Hash {
	int r1, r2;
	Hash() {};
	Hash(int r1, int r2) :
		r1(r1), r2(r2) {};
};

bool operator == (const Hash &a, const Hash &b) {
	return mp(a.r1, a.r2) == mp(b.r1, b.r2);
}

bool operator < (const Hash &a, const Hash &b) {
	return mp(a.r1, a.r2) < mp(b.r1, b.r2);
}

Hash operator + (const Hash & a, const Hash & b) {
	return Hash(a.r1 + b.r1 - m1 * (a.r1 + b.r1 >= m1), a.r2 + b.r2 - m2 * (a.r2 + b.r2 >= m2));
}

Hash operator * (const Hash &a, int x) {
	return Hash(1LL * a.r1 * p1[x] % m1, 1LL * a.r2 * p2[x] % m2);
}

Hash h[N][N][N];
int used[MAXN], tim = 0;
int n, m, a[N][N], mxr[N][N], mxc[N][N];

Hash get_hash(const vector <int> &v) {
	Hash res(0, 0);
	for (int i = 0; i < size(v); i++) {
		Hash cur(v[i], v[i]);
		cur = cur * i;
		res = res + cur;
	}
	return res;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	rnd.seed(time(0));
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	precalc();
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char x, y;
			cin >> x >> y;
			a[i][j] = (x - 32) * 100 + (y - 32);
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			vector <int> val;
			for (int k = j; k < m; k++) {
				int pos = size(val);
				for (int p = 0; p < size(val); p++) {
					if (val[p] >= a[i][k]) {
						pos = p;
						break;
					}
				}
				val.insert(val.begin() + pos, a[i][k]);
				h[i][j][k] = get_hash(val);
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			mxr[i][j] = m - j;
			mxc[i][j] = n - i;
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			tim++;
			for (int k = j; k < m; k++) {
				if (used[a[i][k]] == tim) {
					mxr[i][j] = k - j;
					break;
				}
				used[a[i][k]] = tim;
			}
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			tim++;
			for (int k = j; k < n; k++) {
				if (used[a[k][i]] == tim) {
					mxc[j][i] = k - j;
					break;
				}
				used[a[k][i]] = tim;
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int mn = INF;
			for (int k = i; k < n; k++) {
				int len = k - i + 1;
				if (j + len - 1 == m)
					break;
				uin(mn, mxr[i + len - 1][j]);
				uin(mn, mxc[i][j + len - 1]);
				if (mn < len)
					break;
				bool fl = true;
				Hash val = h[i][j][j + len - 1];
				for (int p = i; p < i + len; p++) {
					if (h[p][j][j + len - 1] == val)
						continue;
					fl = false;
					break;
				}
				ans += fl;
			}
		}
	}
	cout << ans;
}