#include<iostream>
#include<random>
#include<map>
#include<set>

using namespace std;

const int MAXN = 505;

mt19937 rnd(222);

int n, m;
pair <char, char> a[MAXN][MAXN];

long long sum[MAXN][MAXN];
int downVal[MAXN][MAXN], rightVal[MAXN][MAXN];

int L[MAXN];
int sparseRowDown[MAXN][20][MAXN], sparseRowRight[MAXN][20][MAXN];
int sparseColDown[MAXN][20][MAXN], sparseColRight[MAXN][20][MAXN];

long long getSum(int r1, int c1, int r2, int c2)
{
    if(r1==0 && c1==0) return sum[r2][c2];
    if(r1==0) return sum[r2][c2] - sum[r2][c1-1];
    if(c1==0) return sum[r2][c2] - sum[r1-1][c2];
    return sum[r2][c2] - sum[r1-1][c2] - sum[r2][c1-1] + sum[r1-1][c1-1];
}


void Init()
{
    int val = 0;
    for(int i = 1;i<MAXN;i++)
    {
        if((1<<val)*2==i) val++;
        L[i] = val;
    }

    map <pair <char, char>, long long> code;
    for(char c1 = 33;c1<=126;c1++)
    {
        for(char c2 = 33;c2<=126;c2++)
        {
            code[{c1, c2}] = rnd();
            //cout << c1 << " " << c2 << " -> " << code[{c1, c2}] << '\n';
        }
    }

    sum[0][0] = code[ a[0][0] ];
    for(int i = 1;i<n;i++)
    {
        sum[i][0] = sum[i-1][0] + code[ a[i][0] ];
    }
    for(int j = 1;j<m;j++)
    {
        sum[0][j] = sum[0][j-1] + code[ a[0][j] ];
    }
    for(int i = 1;i<n;i++)
    {
        for(int j = 1;j<m;j++)
        {
            sum[i][j] = sum[i-1][j] + sum[i][j-1] - sum[i-1][j-1] + code[ a[i][j] ];
        }
    }


    for(int j = 0;j<m;j++)
    {
        map <pair <char, char>, int> last;
        for(int i = n-1;i>=0;i--)
        {
            if(last.count(a[i][j])==false)
            {
                downVal[i][j] = n;
            }
            else
            {
                downVal[i][j] = last[ a[i][j] ];
            }

            last[ a[i][j] ] = i;
        }
    }

    for(int i = 0;i<n;i++)
    {
        map <pair <char, char>, int> last;
        for(int j = m-1;j>=0;j--)
        {
            if(last.count(a[i][j])==false)
            {
                rightVal[i][j] = m;
            }
            else
            {
                rightVal[i][j] = last[ a[i][j] ];
            }

            last[ a[i][j] ] = j;
        }
    }

    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<m;j++)
        {
            sparseRowDown[i][0][j] = downVal[i][j];
            sparseRowRight[i][0][j] = rightVal[i][j];
        }
        for(int bit = 1;bit<15;bit++)
        {
            for(int j = 0;j<m;j++)
            {
                if(j+(1<<(bit-1))<m)
                {
                    sparseRowDown[i][bit][j] = min(sparseRowDown[i][bit-1][j], sparseRowDown[i][bit-1][ j + (1<<(bit-1)) ]);
                    sparseRowRight[i][bit][j] = min(sparseRowRight[i][bit-1][j], sparseRowRight[i][bit-1][ j + (1<<(bit-1)) ]);
                }
                else
                {
                    sparseRowRight[i][bit][j] = sparseRowRight[i-1][bit][j];
                }
            }
        }
    }

    for(int j = 0;j<m;j++)
    {
        for(int i = 0;i<n;i++)
        {
            sparseColDown[j][0][i] = downVal[i][j];
            sparseColRight[j][0][i] = rightVal[i][j];
        }
        for(int bit = 1;bit<15;bit++)
        {
            for(int i = 0;i<n;i++)
            {
                if(i+(1<<(bit-1))<n)
                {
                    sparseColDown[j][bit][i] = min(sparseColDown[j][bit-1][i], sparseColDown[j][bit-1][ i + (1<<(bit-1)) ]);
                    sparseColRight[j][bit][i] = min(sparseColRight[j][bit-1][i], sparseColRight[j][bit-1][ i + (1<<(bit-1)) ]);
                }
            }
        }
    }
}

int getMin(int l, int r, int sparse[20][MAXN])
{
    return min(sparse[ L[r-l+1] ][l], sparse[ L[r-l+1] ][ r - (1<<(L[r-l+1])) + 1 ]);
}

bool check(int x, int y, int side)
{
    set <pair <char, char>> all;
    for(int i = x;i<x+side;i++)
    {
        for(int j = y;j<y+side;j++)
        {
            all.insert(a[i][j]);
        }
    }
    if(all.size()!=side)
    {
        return false;
    }

    /*
    for(int i = x;i<x+side;i++)
    {
        set <pair <char, char>> curr;
        for(int j = y;j<y+side;j++)
        {
            if(curr.count(a[i][j])==true) return false;
            curr.insert(a[i][j]);
        }
    }

    for(int j = y;j<y+side;j++)
    {
        int minVal = MAXN;
        for(int i = x;i<x+side;i++)
        {
            minVal = min(minVal, downVal[i][j]);
        }

        if(minVal<x+side) return false;
    }
    */

    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m;
    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<m;j++)
        {
            cin >> a[i][j].first >> a[i][j].second;
        }
    }
    Init();

    int answer = 0;
    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<m;j++)
        {
            int minRight = MAXN, minDown = MAXN;
            for(int p = j;p<m && i+p-j<n;p++)
            {
                //cout << i << " " << j << " -> " << p << '\n';
                minDown = min(minDown, getMin(j, p, sparseRowDown[i+p-j]));
                minRight = min(minRight, getMin(j, p, sparseRowRight[i+p-j]));

                minDown = min(minDown, getMin(i, i+p-j, sparseColDown[p]));
                minRight = min(minRight, getMin(i, i+p-j, sparseColRight[p]));

                if(minRight<=p || minDown<=i+p-j) break;

                long long squareSum = getSum(i, j, i+p-j, p);
                long long rowSum = getSum(i, j, i, p);

                if(squareSum%rowSum==0 && squareSum/rowSum==p-j+1)
                {
                    //if(j!=p) cout << i << " " << j << " -> " << p << '\n';
                    answer++;
                }
            }
        }
    }

    cout << answer << '\n';
}
