#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back
#define mp make_pair
#define mt make_tuple

template <class T>
inline void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
inline void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

ll n, m;
vector<vector<ll>> mx;

void solve() {
    /// troubles de la tete
    cin >> n >> m;
    mx.assign(n, vector<ll>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            char a, b;
            cin >> a >> b;
            mx[i][j] = (ll(a) << 32) + ll(b);
        }
    }
#ifdef Debug
    forEach(mx) {
        forEach(it) cout << it << " ";
        cout << "\n";
    }
#endif
    ll ans = n * m;
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            map<ll, ll> cnt{{mx[i][j], 1LL}};
            for (ll d = 2; i + d <= n && j + d <= m; d++) {
                unordered_set<ll> s1;
                unordered_set<ll> s2;
                ll maxI = i + d - 1;
                ll maxJ = j + d - 1;
                for (ll I = i; I <= maxI; I++) {
                    s1.insert(mx[I][maxJ]);
                    cnt[mx[I][maxJ]]++;
                }
                for (ll J = j; J <= maxJ; J++) {
                    s2.insert(mx[maxI][J]);
                    cnt[mx[maxI][J]]++;
                }
                cnt[mx[maxI][maxJ]]--;
                if (s1.size() != d) continue;
                if (s2.size() != d) continue;
                if (any_of(all(cnt), [=](const pll &it) { return it.S != d; })) continue;
                if (cnt.size() != d) continue;
                ans++;
                break;
            }
        }
    }
    cout << ans << "\n";
}

int main() {
#ifndef Debug
    FASTIO
#endif
    solve();
    return 0;
}