#include <iostream>
#include <random>
#include <algorithm>
#include <unordered_map>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++) {
        run();
    }
}

bool sq(int **t, int i, int j, int k) {
    vector<int*> a(k);
    for (int r = i; r < i + k; r++) {
        a[r - i] = arr<int>(k);
        for (int c = j; c < j + k; c++) {
            a[r - i][c - j] = t[r][c];
        }
        sort(a[r - i], a[r - i] + k);
    }
    for (int l = 1; l < k; l++) {
        for (int p = 0; p < k; p++) {
            if (a[l][p] != a[l - 1][p])
                return false;
        }
    }
    for (int c = j; c < j + k; c++) {
        for (int r = i; r < i + k; r++) {
            a[c - j][r - i] = t[r][c];
        }
        sort(a[c - j], a[c - j] + k);
    }
    for (int l = 1; l < k; l++) {
        for (int p = 0; p < k; p++) {
            if (a[l][p] != a[l - 1][p])
                return false;
        }
    }
    return true;
}

void run() {
    int n, m;
    cin >> n >> m;
    auto t = arr<int*>(n);
    for (int i = 0; i < n; i++) {
        t[i] = arr<int>(m);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c1, c2;
            cin >> c1 >> c2;
            t[i][j] = (c1 - 33) * 100 + (c2 - 33);
            //cerr << t[i][j] << ' ';
        }
        //cerr << endl;
    }
    //cerr << sq(t, 0, 1, 2) << endl;
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int k = 1; i + k <= n && j + k <= m; k++) {
                ans += sq(t, i, j, k);
            }
        }
    }
    cout << ans << endl;
}
