#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>
#include <random>
#include <cassert>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <map>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <iomanip>
#include <bitset>
#include <stack>
#include <list>

#pragma warning (disable : 4996)
using namespace std;

#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define nl '\n'
#define sz(a) (int)(a).size()
#define maxeq(a, b) (a) = max(a, b);
#define mineq(a, b) (a) = min(a, b);

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
const dl PI = acos(-1);
mt19937 rnd(5625445);
mt19937_64 rnd64(3465467567);

template <typename T, typename D>
istream &operator >> (istream &in, pair<T, D> &a) {
	in >> a.first >> a.second;
	return in;
}

template <typename T, typename D>
ostream &operator << (ostream &out, pair<T, D> &a) {
	out << a.first << " " << a.second;
	return out;
}

template <typename T>
istream &operator >> (istream &in, vector<T> &a) {
	for (auto &i : a)
		in >> i;
	return in;
}

void IO() {
#ifdef _SEVA
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _SEVA
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = 2000 + 10;
const int K = (int)1e5;
const int M = (int)1e9 + 21;
const int p = 32771;

int field[N][N];

int getNum(char a, char b) {
	return (a - 33) * (127 - 33) + (b - 33);
}

int hsg[N][N], hsv[N][N];

int p_pow[N];

int add(int hs, int val) {
	return (hs + p_pow[val]) % M;
}

int remove(int hs, int val) {
	return (hs + M - p_pow[val]) % M;
}

int getHsg(int i, int jdn, int jup) {
	if (jdn == 0)
		return hsg[i][jup];
	return (hsg[i][jup] + M - hsg[i][jdn - 1]) % M;
}

int getHsv(int idn, int iup, int j) {
	if (idn == 0)
		return hsv[iup][j];
	return (hsv[iup][j] + M - hsv[idn - 1][j]) % M;
}

void solve(int n, int m) {

	hsg[0][0] = hsv[0][0] = add(0, field[0][0]);

	for (int i = 1; i < n; i++) {
		hsv[i][0] = add(hsv[i - 1][0], field[i][0]);
		hsg[i][0] = add(0, field[i][0]);
	}
	for (int j = 1; j < m; j++) {
		hsg[0][j] = add(hsg[0][j - 1], field[0][j]);
		hsv[0][j] = add(0, field[0][j]);
	}

	for (int i = 1; i < n; i++) {
		for (int j = 1; j < m; j++) {
			hsv[i][j] = add(hsv[i - 1][j], field[i][j]);
			hsg[i][j] = add(hsg[i][j - 1], field[i][j]);
		}
	}

	ll ans = ll(n) * m;
	for (int k = 2; k <= min(n, m); k++) {
		for (int i = 0; i + k <= n; i++) {
			for (int j = 1, d = 1; j < m; j++) {
				int hs1 = getHsv(i, i + k - 1, j);
				int hs2 = getHsv(i, i + k - 1, j - 1);
				if (hs1 == hs2) {
					d++;
				}
				else
					d = 1;
				ans += d >= k;
			}
		}
	}
	cout << ans << nl;
}

void solve1(int n, int m) {

	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int k = 1; i + k <= n && j + k <= m; k++) {
				set<int> st1;
				for (int t = i; t < i + k; t++) {
					st1.insert(field[t][j]);
				}
				if (sz(st1) != k)
					continue;
				bool lans = true;
				for (int t = i; t < i + k; t++) {
					set<int> st;
					for (int u = j; u < j + k; u++) {
						st.insert(field[t][u]);
					}
					lans &= st == st1;
				}
				for (int u = j; u < j + k; u++) {
					set<int> st;
					for (int t = i; t < i + k; t++) {
						st.insert(field[t][u]);
					}
					lans &= st == st1;
				}
				ans += lans;
			}
		}
	}
	cout << ans << nl;
}

int main() {
	IO();

	p_pow[0] = 1;
	p_pow[1] = p;
	for (int i = 2; i < K; i++)
		p_pow[i] = (ll(p_pow[i - 1]) * ll(p)) % ll(M);

	int n, m;
	cin >> n >> m;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char a, b;
			cin >> a >> b;
			field[i][j] = getNum(a, b);
		}
	}

	if (n <= 20 && m <= 20) {
		solve1(n, m);
	}
	else
		solve(n, m);
	return 0;
}
