#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <random>
#include <queue>
using namespace std;

#pragma GCC optimize("inline-functions")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)
#define chkmin(x, y) x = min(x, y)

const int N = 1e6;
mt19937 gen;
ll h[N];
const int M = 505;

ll Ver[M][M], Hor[M][M];

inline ll hor(int x, int l, int len) {
    return (Hor[x][l + len] - Hor[x][l]);
}


inline ll ver(int x, int l, int len) {
    return (Ver[l][x + len] - Ver[l][x]);
}

int used[N];
int tt = 1;
int ans;
int ord[N];

inline void check(int x, int y, int len) {
    if (hor(x, y, len) != ver(x, y, len))
        return;
    int p1 = 1, p2 = 1;
    int bb = 0;
    while (p1 < len || p2 < len) {
        int turn = ord[bb];
        if (turn == 0 && p1 == len) turn ^= 1;
        else if (turn == 1 && p2 == len) turn ^= 1;
        if (turn == 0) {
            if (hor(x, y, len) != hor(x + p1, y, len)) return;
            p1++;
        } else {
            if (ver(x, y, len) != ver(x, y + p2, len)) return;
            p2++;
        }
    }
   // cout << "good " << x << ' ' << y << ' ' << len << '\n';
    ++ans;
    return;
}

void run() {
    gen.seed(time(0));
    for (int i = 0; i < N; i++) {
        ord[i] = gen() & 1;
    }
    for (int i = 0; i < N; i++) {
        h[i] = gen();
    }
    int n, m;
    cin >> n >> m;
    vector<vector<ll>> a(n, vector<ll>(m));
    for (int i = 0; i < n; i++) {
        string t;
        for(int j = 0; j < 2 * m; j++) {
          char c;
          cin >> c;
          t += c;
        }
        for (int j = 0; j < 2 * m; j += 2) {
            a[i][j / 2] = h[t[j] * 1000 + t[j + 1]];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            Hor[i][j + 1] = Hor[i][j] + a[i][j];
        }
    }
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            Ver[j][i + 1] = Ver[j][i] + a[i][j];
        }
    }
    vector<ll> xs;
    for (auto q : a) for (auto w : q) xs.push_back(w);
    sort(all(xs));
    xs.resize(unique(all(xs)) - xs.begin());
    auto d = a;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            d[i][j] = lower_bound(all(xs), a[i][j]) - xs.begin();
        }
    }
    ans = n * m;
    for (int len = 2; len <= min(n, m); len++) {
        for (int i = 0; i + len <= n; i++) {
            fill(used, used + size(xs) + 1, 0);
            int bad_count = 0;
            for (int j = 0; j < len; j++) {
                used[d[i][j]]++;
                if (used[d[i][j]] == 2) {
                    bad_count++;
                }
            }
            if (!bad_count) {
                check(i, 0, len);
            }
            for (int j = 1; j + len <= m; j++) {
                used[d[i][j - 1]]--;
                if (used[d[i][j - 1]] == 1) {
                    bad_count--;
                }
                used[d[i][j + len - 1]]++;
                if (used[d[i][j + len - 1]] == 2) {
                    bad_count++;
                }
                if (!bad_count) {
                    check(i, j, len);
                }
            }
        }
    }
    cout << ans;

}

int main() {
#ifdef _DEBUG
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    run();
}
