#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;

typedef pair <char, char> cc;
vector <vector <cc> > tab;

bool Check(int a, int b, int c, int d, bool& key){
	key = true;
	int len = c - a + 1;
	set <cc> t;
	for (int i = b; i <= d; i++)
		t.insert(tab[a][i]);
	if (t.size() != len){
		key = false;
		return false;
	}
	for (int i = a; i <= c; i++){
		set <cc> cur;
		for (int j = b; j <= d; j++)
			cur.insert(tab[i][j]);
		if (cur.size() != len) key = false;
		if (cur != t) return false;
	}
	for (int i = b; i <= d; i++){
		set <cc> cur;
		for (int j = a; j <= c; j++)
			cur.insert(tab[j][i]);
		if (cur.size() != len) key = false;
		if (cur != t) return false;
	}
	return true;
}

int main()
{

	fstream cin("input.txt");
	ofstream cout("output.txt");

	ios::sync_with_stdio(false);
	cin.tie(NULL);

	int n, m, ans = 0; cin >> n >> m;
	tab.resize(n, vector <cc>(m));

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			cin >> tab[i][j].first >> tab[i][j].second;

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++){
			bool key = false;
			for (int c = 1; i + c < n && j + c < m; c++)
				if (Check(i, j, i + c, j + c, key))
					ans++;
				else if(!key) break;
		}
		
	cout << ans + n * m;
		

}