#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("O3")

vector<vector<int> > tree1;
vector<vector<int> > tree2;
vector<vector<int> > bar;
vector<vector<int> > bar2;

void build1(int v, int i, int l, int r)
{
	if (l == r - 1){
		tree1[i][v] = bar2[i][l];
		return;
	}
	int m = (l + r) / 2;
	build1(2 * v + 1, i, l, m);
	build1(2 * v + 2, i, m, r);
	tree1[i][v] = min(tree1[i][2 * v + 1], tree1[i][2 * v + 2]);
}

void build2(int v, int i, int l, int r)
{
	if (l == r - 1){
		tree2[i][v] = bar[i][l];
		return;
	}
	int m = (l + r) / 2;
	build2(2 * v + 1, i, l, m);
	build2(2 * v + 2, i, m, r);
	tree2[i][v] = min(tree2[i][2 * v + 1], tree2[i][2 * v + 2]);
}

int get1(int v, int i, int l, int r, int ql, int qr)
{
	if (n > 500 || m > 500)
		return 1e9;
	if (l >= qr || r <= ql)
		return 1e9;
	if (ql <= l && qr >= r)
		return tree1[i][v];
	int m = (l + r) / 2;
	return min(get1(2 * v + 1, i, l, m, ql, qr), get1(2 * v + 2, i, m, r, ql, qr));
}

int get2(int v, int i, int l, int r, int ql, int qr)
{
	if (n > 500 || m > 500)
		return 1e9;
	if (l >= qr || r <= ql)
		return 1e9;
	if (ql <= l && qr >= r)
		return tree2[i][v];
	int m = (l + r) / 2;
	return min(get2(2 * v + 1, i, l, m, ql, qr), get2(2 * v + 2, i, m, r, ql, qr));
}

signed main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<vector<int> > ar(n, vector<int>());
	char c = 33;
	for (int i = 0; i < n; ++i)
	{
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j)
		{
			ar[i].push_back((s[2 * j] - ' ') * 97 + (s[2 * j + 1] - ' '));
		}
	}
	vector<vector<int> > hashh(n, vector<int>(m + 1, 0));
	bar = vector<vector<int> >(n, vector<int>(m, 1e9));
	bar2 = vector<vector<int> >(m, vector<int>(n, 1e9));
	tree1 = vector<vector<int> >(m, vector<int>(4 * n, 1e9));
	tree2 = vector<vector<int> >(n, vector<int>(4 * m, 1e9));
	vector<vector<int> > hashh2(m, vector<int>(n + 1, 0));
	for (int i = 0; i < n; ++i)
	{
		for (int j = 1; j <= m; ++j)
		{
			hashh[i][j] = hashh[i][j - 1] + int((ar[i][j - 1]));
		}
	}
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			int q = i + 1;
			while (q < n && ar[q][j] != ar[i][j])
			{
				++q;
			}
			if (q != n)
			{
				bar2[j][i] = q;
			}
		}
	}
	for (int j = 0; j < m; ++j)
	{
		for (int i = 0; i < n; ++i)
		{
			int z = j + 1;
			while (z < m && ar[i][z] != ar[i][j])
			{
				++z;
			}
			if (z != m)
				bar[i][j] = z;
		}
	}
	for (int j = 0; j < m; ++j)
	{
		for (int i = 1; i <= n; ++i)
		{
			hashh2[j][i] = hashh2[j][i - 1] + (ar[i - 1][j]);
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			for (int k = 1; k <= min(n - i, m - j); ++k)
			{
				int normhash = hashh2[j][i + k] - hashh2[j][i];
				int per = 0;
				for (int q = i; q < i + k; ++q)
				{
					if (hashh[q][j + k] - hashh[q][j] != normhash || get2(0, q, 0, m, j, j + k) < j + k){
						per = 1;
						break;
					}
				}
				if (per == 1)
					continue;
				for (int q = j; q < j + k; ++q)
				{
					if (hashh2[q][i + k] - hashh2[q][i] != normhash || get1(0, q, 0, n, i, i + k) < i + k){
						per = 1;
						break;
					}
				}
				if (per == 0){
					ans++;
				}
			}
		}
	}
	cout << ans << endl;
}
