#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = 2047;


void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}



void Solve() {
	int n, m;
	cin >> n >> m;
	vector <string> u(n);
	vector <vector <int>> v(n, vector <int>(m));
	for (int i = 0; i < n; i++) {
		cin >> u[i];
		for (int j = 0; j < m; j++) {
			v[i][j] = 100 * (u[i][2 * j] - 32) + u[i][2 * j + 1] - 32;
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			bitset <1 << 14> s;
			vector <bitset <(1 << 14)>> col(m);
			vector <bitset <(1 << 14)>> str(n);
			for (int k = 0; k + i < n && k + j < m; k++) {
				for (int l = 0; l <= k; l++) {
					s[v[i + k][j + l]] = true;
					col[j + l][v[i + k][(j + l)]] = true;
					str[i + k][v[i + k][(j + l)]] = true;
				}
				for (int l = 0; l <= k; l++) {
					s[v[i + l][(j + k)]] = true;
					col[j + k][v[i + l][(j + k)]] = true;
					str[i + l][v[i + l][(j + k)]] = true;
				}
				bool flag = true;
				for (int i = 0; i < m; i++) {
					if (col[i].count() != k + 1 && col[i].count() != 0)
						flag = false;
				}
				for (int i = 0; i < n; i++) {
					if (str[i].count() != k + 1 && str[i].count() != 0)
						flag = false;
				}
				if (s.count() != k + 1)
					flag = false;
				if (flag)
					ans++;
			}

		}
	}
	cout << ans;
}

int main() {
	IOOptimize();
	Solve();
}