#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
using namespace std;

template<typename T>
class trie {
	vector<T> tree;
	vector<T> a;
	int n = 0;
	void _build(int v, int l, int r) {
		if (r - l == 1) {
			tree[v] = a[l];
			return;
		}
		int m = (l + r) / 2;
		_build(2 * v, l, m);
		_build(2 * v + 1, m, r);
		tree[v] = min(tree[2 * v], tree[2 * v + 1]);
	}
	T _get(int v, int l, int r, int tl, int tr) {
		if (l <= tl && tr <= r) {
			return tree[v];
		}
		if (tr <= l || r <= tl) {
			return 1e9;
		}
		int m = (tl + tr) / 2;
		return min(_get(2 * v, l, r, tl, m), _get(2 * v + 1, l, r, m, tr));
	}
	void _update(int v, int l, int r, int pos, const T& x) {
		if (r - l == 1) {
			tree[v] = x;
			a[v] = x;
			return;
		}
		int m = (l + r) / 2;
		if (pos < m) {
			_update(2 * v, l, m, pos, x);
		}
		else {
			_update(2 * v + 1, m, r, pos, x);
		}
		tree[v] = min(tree[2 * v], tree[2 * v + 1]);
	}
	void _add(int v, int l, int r, int pos, const T& x) {
		if (r - l == 1) {
			tree[v] += x;
			a[l] += x;
			return;
		}
		int m = (l + r) / 2;
		if (pos < m) {
			_add(2 * v, l, m, pos, x);
		}
		else {
			_add(2 * v + 1, m, r, pos, x);
		}
		tree[v] = min(tree[2 * v], tree[2 * v + 1]);
	}
public:
	trie() {};
	trie(int _n) {
		n = _n;
		tree.resize(4 * n);
		a.resize(n);
	};
	void build(const vector<T>& _a) {
		a = _a;
		n = a.size();
		tree.resize(4 * n);
		_build(1, 0, n);
	};
	T get(int l, int r) {
		return _get(1, l, r + 1, 0, n);
	};
	void update(int pos, const T& x) {
		_update(1, 0, n, pos, x);
	}
	void add(int pos, const T& x) {
		_add(1, 0, n, pos, x);
	}
	T get(int i) {
		return get(i, i);
	}
};

int main() {
	int n, m;
	cin >> n >> m;
	vector<vector<pair<char, char>>> A(n, vector<pair<char, char>>(m));
	vector<vector<int>> cnt(127, vector<int>(127,0));
	bool good = true;
	for (int i = 0; i < n; i++) {
		string str;
		cin >> str;
		for (int j = 0; j < m; j++) {
			A[i][j] = { str[2 * j], str[2 * j + 1] };
			cnt[A[i][j].first][A[i][j].second]++;
			if (cnt[A[i][j].first][A[i][j].second] > 1) {
				good = false;
			}
		}
	}
	long long result = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int cnt1 = 0;
			
			vector<vector<int>> cnt2(127, vector<int>(127, 0));
			for (int k = 1; k + j - 1 < m && k + i - 1 < n; k++) {
				bool ok = true;
				vector<vector<int>> cnt3(127, vector<int>(127, 0));
				for (int y = i; y < i + k; y++) {
					cnt3[A[y][j + k - 1].first][A[y][j + k - 1].second]++;
					if (cnt3[A[y][j + k - 1].first][A[y][j + k - 1].second] > 1) {
						ok = false;
					}
					if (cnt2[A[y][j + k - 1].first][A[y][j + k - 1].second] == 0) {
						cnt1++;
					}
					cnt2[A[y][j + k - 1].first][A[y][j + k - 1].second]++;
				}
				vector<vector<int>> cnt4(127, vector<int>(127, 0));
				for (int x = j; x < j + k; x++) {
					cnt4[A[i + k - 1][x].first][A[i + k - 1][x].second]++;
					if (cnt4[A[i + k - 1][x].first][A[i + k - 1][x].second] > 1) {
						ok = false;
					}
					if (cnt2[A[i + k - 1][x].first][A[i + k - 1][x].second] == 0) {
						cnt1++;
					}
					cnt2[A[i + k - 1][x].first][A[i + k - 1][x].second]++;
				}
				if (cnt1 == k && ok) {
					result++;
				}
			}
		}
	}
	cout << result;
}