#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>
#include <queue>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

const int INF = 2e9;
const int MB = 20;
const int MOD = 1e9 + 7;

using namespace std;

struct SparseTable {
    vector<vector<int>> t;
    vector<int> log;
    SparseTable(int n, vector<int> &a) {
        t.resize(MB, vector<int>(n));
        for (int i = 0; i < n; i++) {
            t[0][i] = a[i];
        }
        for (int bit = 0; bit < MB - 1; bit++) {
            for (int i = 0, h = (1 << bit), j = i + h; j + h <= n; i++, j++) {
                t[bit + 1][i] = min(t[bit][i], t[bit][j]);
            }
        }

        log.resize(n + 1);
        for (int i = 2; i <= n; i++) {
            log[i] = log[i / 2] + 1;
        }
    }

    int get(int l, int r) {
        int b = log[r - l + 1];
        r = r - (1 << b) + 1;
        return min(t[b][l], t[b][r]);
    }
};

int fast(int n, int m, vector<vector<pair<char, char>>>& a) {
    vector<vector<bool>> left(n, vector<bool>(m)), right(n, vector<bool>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i && j && a[i][j] == a[i - 1][j - 1]) left[i][j] = true;
            if (i && j < m - 1 && a[i][j] == a[i - 1][j + 1]) right[i][j] = true;
        }
    }

    vector<vector<int>> prefLeftCol(n, vector<int>(m)), prefLeftRow(n, vector<int>(m)), prefRightCol(n, vector<int>(m)), prefRightRow(n, vector<int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            prefLeftCol[i][j] = prefLeftRow[i][j] = left[i][j];
            if(i) prefLeftCol[i][j] += prefLeftCol[i - 1][j];
            if (j) prefLeftRow[i][j] += prefLeftRow[i][j - 1];
        }
    }

    for (int i = 0; i < n;i++) {
        for (int j = m - 1; j >= 0; j--) {
            prefRightCol[i][j] = prefRightRow[i][j] = right[i][j];
            if (i) prefRightCol[i][j] += prefRightCol[i - 1][j];
            if (j < m - 1) prefRightRow[i][j] += prefRightRow[i][j + 1];
        }
    }

    vector<vector<int>> mxLeft(n, vector<int>(m, 1));
    for (int i = 0; i < n; i++) {
        map<pair<char, char>, int> mp;
        mp[a[i][0]] = 0;
        for (int j = 1; j < m; j++) {
            int d = mp.count(a[i][j]) ? j - mp[a[i][j]] : INF;
            mxLeft[i][j] = min(mxLeft[i][j - 1] + 1, d);
            mp[a[i][j]] = j;
        }
    }

    vector<vector<int>> mxRight(n, vector<int>(m, 1));
    for (int i = 0; i < n; i++) {
        map<pair<char, char>, int> mp;
        mp[a[i][m - 1]] = m - 1;
        for (int j = m - 2; j >= 0;j--) {
            int d = mp.count(a[i][j]) ? mp[a[i][j]] - j : INF;
            mxRight[i][j] = min(mxRight[i][j + 1] + 1, d);
            mp[a[i][j]] = j;
        }
    }

    vector<vector<int>> mxUp(n, vector<int>(m, 1));
    for (int j = 0; j < m; j++) {
        map<pair<char, char>, int> mp;
        mp[a[0][j]] = 0;
        for (int i = 1; i < n; i++) {
            int d = mp.count(a[i][j]) ? i - mp[a[i][j]] : INF;
            mxUp[i][j] = min(mxUp[i - 1][j] + 1, d);
            mp[a[i][j]] = i;
        }
    }

    vector<SparseTable*> sparseLeft(m), sparseRight(m), sparseUp(n);

    for (int i = 0; i < n; i++) {
        sparseUp[i] = new SparseTable(m, mxUp[i]);
    }

    for (int j = 0; j < m; j++) {
        vector<int> b(n);
        for (int i = 0; i < n; i++) b[i] = mxLeft[i][j];
        sparseLeft[j] = new SparseTable(n, b);
        for (int i = 0; i < n; i++) b[i] = mxRight[i][j];
        sparseRight[j] = new SparseTable(n, b);
    }

    int ans = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            map<pair<char, char>, int> mp;
            int now = 0;
            for (int d = 1; i + d <= n && j + d <= m && d < min(n, m) + 1; d++) {
                int x = i + d - 1;
                int y = j + d - 1;

                int one = sparseUp[x]->get(j, y);
                int two = sparseLeft[y]->get(i, x);
                if (one < d || two < d) break;

                bool good = true;
                if (prefLeftCol[x][y] - prefLeftCol[i][y] < d - 1) good = false;
                if (prefLeftRow[x][y] - prefLeftRow[x][j] < d - 1) good = false;
                if (!good) break;
                if (d > 1 && (a[x][j] == a[i][j] || a[i][y] == a[i][j])) break;
                mp[a[i][y]]++;
                if (mp[a[i][y]] == 1) now++;
                else if (mp[a[i][y]] == 2) now--;
                else break;

                if (d != 1) {
                    mp[a[x][j]]++;
                    if (mp[a[x][j]] == 1) now++;
                    else if (mp[a[x][j]] == 2) now--;
                    else break;
                }
                
                if (now == 1 && mp.size() == d) ans++;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            map<pair<char, char>, int> mp;
            int now = 0;
            for (int d = 1;i + d - 1 < n && j - d + 1 >= 0 && d < min(n, m) + 1; d++) {
                int x = i + d - 1;
                int y = j - d + 1;
                
                int one = sparseUp[x]->get(y, j);
                int two = sparseRight[y]->get(i, x);
                if (one < d || two < d) break;

                bool good = true;
                if (prefRightCol[x][y] - prefRightCol[i][y] < d - 1) good = false;
                if (prefRightRow[x][y] - prefRightRow[x][j] < d - 1) good = false;
                if (!good) break;

                mp[a[x][j]]++;
                if (mp[a[x][j]] == 1) now++;
                else if (mp[a[x][j]] == 2) now--;
                else break;

                if (d > 1 && (a[x][j] == a[i][j] || a[i][y] == a[i][j])) break;

                if (d > 1) {
                    mp[a[i][y]]++;
                    if (mp[a[i][y]] == 1) now++;
                    else if (mp[a[i][y]] == 2) now--;
                    else break;
                }
               

                if(now == 1 && d > 2 && mp.size() == d) ans++;
            }
        }
    }

    return ans;
}

int slow(int n, int m, vector<vector<pair<char, char>>> &a) {
    int ans = 0;
    for (int x1 = 0; x1 < n; x1++) {
        for (int y1 = 0; y1 < m; y1++) {
            vector < set<pair<int, int>>> col(m), row(n);
            set<pair<int, int>> help;
            bool good = true;
            for (int d = 1; x1 + d <= n && y1 + d <= m && good; d++) {
                for (int i = x1; i < x1 + d; i++) {
                    if (col[y1 + d - 1].count(a[i][y1 + d - 1])) good = false;
                    col[y1 + d - 1].insert(a[i][y1 + d - 1]);
                    if (row[i].count(a[i][y1 + d - 1])) good = false;
                    row[i].insert(a[i][y1 + d - 1]);
                    help.insert(a[i][y1 + d - 1]);
                }
                for (int j = y1; j < y1 + d - 1; j++) {
                    if (row[x1 + d - 1].count(a[x1 + d - 1][j])) good = false;
                    row[x1 + d - 1].insert(a[x1 + d - 1][j]);
                    if (col[j].count(a[x1 + d - 1][j])) good = false;
                    col[j].insert(a[x1 + d - 1][j]);
                    help.insert(a[x1 + d - 1][j]);
                }
                if (help.size() == d && good) ans++;
            }
        }
    }
    return ans;
}

void check() {
    for (int i = 0; i < 10000; i++) {
        int n = rand() % 5 + 1;
        int m = rand() % 5 + 1;
        vector<vector<pair<char, char>>> a(n, vector<pair<char, char>>(m));
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                char c = rand() % 4 + 'A';
                a[i][j] = { c, c };
            }
        }
        int ft = fast(n, m, a);
        int sl = slow(n, m, a);
        if (ft != sl) {
            cout << n << " " << m << '\n';
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    cout << a[i][j].first << a[i][j].second;
                }
                cout << '\n';
            }
            cout << "fast - " << ft << '\n' << "slow - " << sl;
            return;
        }
    }
}

void normal() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<char, char>>> a(n, vector<pair<char, char>>(m));
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0, c = 0; j < m * 2; j += 2, c++) {
            a[i][c] = { s[j], s[j + 1] };
        }
    }
    cout << fast(n, m, a);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    normal();
}

/*
    Спокойствие, только спокойствие!
*/