#include <iostream>
#include <algorithm>
#include <vector>

#pragma GCC optimization("Ofast")
#pragma GCC target("avx2")

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int n = 0, m = 0;
    cin >> n >> m;

    int table[500][500] = {};
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            char a = 0, b = 0;
            cin >> a >> b;

            table[i][j] = ((int) a - 33) * 94 + (int) b - 33;
        }
    }

    bool h[500][500][501] = {};
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            int unique = 0;
            int cnt[8836] = {};
            for (int len = 1; j + len <= m; ++len)
            {
                if (cnt[table[i][j + len - 1]] == 0)
                    ++unique;
                ++cnt[table[i][j + len - 1]];
                h[i][j][len] = (unique == len);
            }
        }
    }

    bool v[500][500][501] = {};
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            int unique = 0;
            int cnt[8836] = {};
            for (int height = 1; i + height <= n; ++height)
            {
                if (cnt[table[i + height - 1][j]] == 0)
                    ++unique;
                ++cnt[table[i + height - 1][j]];
                v[i][j][height] = (unique == height);
            }
        }
    }

    int ans = m * n;
    for (int k = 2; k <= min(m, n); ++k)
    {
        for (int i = 0; i + k <= n; ++i)
        {
            for (int j = 0; j + k <= m; ++j)
            {
                int cnt[8836] = {};
                int unique = 0;
                for (int ii = 0; ii < k; ++ii)
                    for (int jj = 0; jj < k; ++jj)
                    {
                        if (cnt[table[i + ii][j + jj]] == 0)
                            ++unique;
                        ++cnt[table[i + ii][j + jj]];
                    }
                if (unique != k)
                    continue;

                bool correct = true;
                for (int ii = 0; ii < k; ++ii)
                    if (!h[i + ii][j][k] || !v[i][j + ii][k])
                    {
                        correct = false;
                        break;
                    }

                if (correct)
                    ++ans;
            }
        }
    }

    cout << ans;

    return 0;
}