#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <iterator>
#include <iomanip>
#include <utility>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <climits>
#include <numeric>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <cassert>
using namespace std;
#define int short int
vector<bool> used, covered;
vector<int> matched;
vector<vector<int>> g;
bool trykuhn(int v) {
	used[v] = true;
	for (auto x : g[v]) {
		if (matched[x] == -1 || !used[matched[x]]) {
			used[x] = true;
			if (matched[x] == -1 || trykuhn(matched[x])) {
				matched[x] = v;
				return true;
			}
		}
	}
	return false;
}
struct fenwick {
	int n;
	vector<int> f;
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
	void add(int i, int val) {
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i)
			ans += f[i];
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
};
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n, m;
	cin >> n >> m;
	vector<vector<int>> a(n, vector<int>(m));
	string s;
	getline(cin, s);
	for (int i = 0; i < n; ++i) {
		getline(cin, s);
		for (int k = 0; k < s.size(); k += 2) {
			a[i][k / 2] = (int)s[k] * 200 + (int)s[k + 1];
		}
	}
	vector<vector<vector<set<int>>>> line(n, vector<vector<set<int>>>(m, vector<set<int>>(m)));
	vector<vector<vector<set<int>>>> stolb(m, vector<vector<set<int>>>(n, vector<set<int>>(n)));
	for (int i = 0; i < n; ++i) {
		for (int L = 0; L < m; ++L) {
			set<int> kek;
			for (int R = L; R < m; ++R) {
				kek.insert(a[i][R]);
				line[i][L][R] = kek;
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		for (int L = 0; L < n; ++L) {
			set<int> kek;
			if (n > 80 || m > 80) {
				assert(i == m - 1);
			}
			for (int R = L; R < n; ++R) {
				kek.insert(a[R][i]);
				stolb[i][L][R] = kek;
			}
		}
	}
	int ans = 0;
	for (int side = 1; side <= min(n, m); ++side) {
		for (int i = 0; i + side - 1 < n; ++i) {
			for (int j = 0; j + side - 1 < m; ++j) {
				bool isok = 1;
				set<int> cur;
				for (int k = i; k <= i + side - 1; ++k) {
					if (line[k][j][j + side - 1].size() < side) {
						isok = false;
						break;
					}
					set_union(cur.begin(), cur.end(), line[k][j][j + side - 1].begin(), line[k][j][j + side - 1].end(), inserter(cur, cur.begin()));
				}
				if (!isok) continue;
				for (int k = j; k <= j + side - 1; ++k) {
					if (stolb[k][i][i + side - 1].size() < side) {
						isok = false;
						break;
					}
					set_union(cur.begin(), cur.end(), stolb[k][i][i + side - 1].begin(), stolb[k][i][i + side - 1].end(), inserter(cur, cur.begin()));
				}
				if (isok && cur.size() == side) ans++;
			}
		}
	}
	cout << ans;
}