#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


#define int long long


const int MAXN = 2001;
const int ALP = 94;
const int MAXS = ALP * ALP + 1;


int a[MAXN][MAXN];
int hhash[MAXN][MAXN];
int vhash[MAXN][MAXN];


const int M = (int)1e9 + 7;
const int P = 179;

int PPOW[MAXS];


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


int hh(int i, int j, int len) {
    return mod(hhash[i][j + len] - hhash[i][j]);
}

int vh(int i, int j, int len) {
    return mod(vhash[i + len][j] - vhash[i][j]);
}


short ***phh, ***pvh;


signed main() {
    PPOW[0] = 1;
    for (int i = 1; i < MAXS; ++i) {
        PPOW[i] = PPOW[i - 1] * P % M;
    }

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    bool flip = false;
    if (n > m) {
        flip = true;
    }

    char c1, c2;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> c1 >> c2;
            
            c1 -= 33;
            c2 -= 33;

            if (!flip) {
                a[i][j] = 1 + c1 * ALP + c2;
            } else {
                a[j][i] = 1 + c1 * ALP + c2;
            }
        }
    }

    if (flip) {
        swap(n, m);
    }

    int s1 = n + 1;
    int s2 = m + 1;
    int s3 = n + 1;

    phh = new short **[s1];
    pvh = new short **[s1];
    for (int i = 0; i < s1; ++i) {
        phh[i] = new short *[s2];
        pvh[i] = new short *[s2];
        for (int j = 0; j < s2; ++j) {
            phh[i][j] = new short[s3];
            pvh[i][j] = new short[s3];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int cur = a[i][j];

            hhash[i][j + 1] = (hhash[i][j] + cur * PPOW[cur]) % M;
            vhash[i + 1][j] = (vhash[i][j] + cur * PPOW[cur]) % M;
        }
    }

    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 1; k <= min(n, m - j); ++k) {
                phh[i + 1][j][k] = phh[i][j][k] + (hh(i, j, k) != hh(i + 1, j, k));
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m - 1; ++j) {
            for (int k = 0; k <= n - i; ++k) {
                pvh[i][j + 1][k] = pvh[i][j][k] + (vh(i, j, k) != vh(i, j + 1, k));
            }
        }
    }

    int answ = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            vector<int> used(MAXS);

            for (int k = 1; k <= min(n - i, m - j); ++k) {
                int cur = a[i][j + k - 1];

                if (used[cur]) {
                    break;
                }

                used[cur] = 1;

                answ += ((phh[i + k - 1][j][k] == phh[i][j][k]) && (pvh[i][j + k - 1][k] == pvh[i][j][k]));
            }
        }
    }

    cout << answ;

    return 0;
}
