#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

#define nl '\n'
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//comments
/*
	1) 
*/
int n, m;
struct node1
{
	int left, right;
	node1 *child_left, *child_right;
	vector<pair<int, int>> s;

	node1(int left = 0, int right = 0) : left(left), right(right), child_left(0), child_right(0) {};
};

struct node
{
	int left, right;
	node *child_left, *child_right;
	node1 *nn;

	node(int left = 0, int right = 0) : left(left), right(right), child_left(0), child_right(0), nn(0) {};
};

void union_v(vector<pair<int, int>> &a, vector<pair<int, int>> &b, vector<pair<int, int>> &c)
{
	auto it1 = a.begin();
	auto it2 = b.begin();
	while (it1 != a.end() || it2 != b.end())
	{
		if (it1 == a.end())
		{
			c.push_back(*it2);
			++it2;
		}
		else if (it2 == b.end())
		{
			c.push_back(*it1);
			++it1;
		}
		else
		{
			if (c.size() && *it1 == c.back())
				++it1;
			else if (c.size() && *it2 == c.back())
				++it2;
			else
			{
				if (*it1 < *it2)
				{
					c.push_back(*it1);
					++it1;
				}
				else
				{
					c.push_back(*it2);
					++it2;
				}
			}
		}

	}
}

node1 *build1(int left, int right, vector<pair<int, int>> &v)
{
	if (left > right)
		return 0;
	node1 *res = new node1(left, right);
	if (left == right)
	{
		res->s.push_back(v[left]);
	}
	else
	{
		int mid = left + right >> 1;
		res->child_left = build1(left, mid, v);
		res->child_right = build1(mid + 1, right, v);

		
		union_v(res->child_left->s, res->child_right->s, res->s);
	}
	return res;
}

node *build(int left, int right, vector<vector<pair<int, int>>> &v)
{
	if (left > right)
		return 0;
	node *res = new node(left, right);

	if (left == right)
	{
		res->nn = build1(0, m - 1, v[left]);
	}
	else
	{
		int mid = left + right >> 1;
		res->child_left = build(left, mid, v);
		res->child_right = build(mid + 1, right, v);

		vector<pair<int, int>> temp;
		union_v(res->child_left->nn->s, res->child_right->nn->s, temp);
		res->nn = build1(0, m - 1, temp);
	}
	return res;
}

int query1(node1 *root, int left, int right)
{
	if (root->left > right || root->right < left)
		return 0;
	if (root->left >= left && root->right <= right)
		return root->s.size();
	return query1(root->child_left, left, right) + query1(root->child_right, left, right);
}

int query(node *root, int leftx, int rightx, int lefty, int righty)
{
	if (root->left > rightx || root->right < leftx)
		return 0;
	if (root->left >= leftx && root->right <= rightx)
	{
		return query1(root->nn, lefty, righty);
	}
	return query(root->child_left, leftx, rightx, lefty, righty) +
		query(root->child_right, leftx, rightx, lefty, righty);
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	freopen("input.txt", "r", stdin);
	
	
	cin >> n >> m;
	vector<vector<pair<int, int>>> v(n, vector<pair<int, int>>(m));

	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < m; ++j)
		{
			char a, b;
			cin >> a >> b;
			v[i][j] = { a, b };
		}
	}

	int ans = n * m;

	node *root = build(0, n - 1, v);
	for (int k = 2; k <= min(n, m); ++k)
	{
		for (int i = 0; i <= n - k + 1; ++i)
		{
			for (int j = 0; j <= m - k + 1; ++j)
			{
				if (query(root, i, i + k - 1, j, j + k - 1) == k)
					++ans;
			}
		}
	}
	cout << ans;
	return 0;
}