#include <iostream>
#include <random>
#include <algorithm>
#include <unordered_map>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    for (int i = 0; i < t; i++) {
        run();
    }
}

pair<bool, bool> sq(int **t, int i, int j, int k) {
    vector<vector<int>> a(k, vector<int>(k));
    for (int r = i; r < i + k; r++) {
        for (int c = j; c < j + k; c++) {
            a[r - i][c - j] = t[r][c];
        }
        sort(a[r - i].begin(), a[r - i].end());
    }
    for (int l = 1; l < k; l++) {
        if (a[l] != a[l - 1])
            return {false, false};
    }
    for (int c = j; c < j + k; c++) {
        for (int r = i; r < i + k; r++) {
            a[c - j][r - i] = t[r][c];
        }
        sort(a[c - j].begin(), a[c - j].end());
    }
    for (int l = 1; l < k; l++) {
        if (a[l] != a[l - 1])
            return {false, false};
    }
    return {true, true};
}

void run() {
    int n, m;
    cin >> n >> m;
    auto t = arr<int*>(n);
    for (int i = 0; i < n; i++) {
        t[i] = arr<int>(m);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c1, c2;
            cin >> c1 >> c2;
            t[i][j] = c1 * 1000 + c2;
            //cerr << t[i][j] << ' ';
        }
        //cerr << endl;
    }
    //cerr << sq(t, 0, 1, 2) << endl;
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans++;
            unordered_map<int, int> was;
            for (int k = 2; i + k <= n && j + k <= m; k++) {
                for (int r = 0; r < k; r++)
                    was[t[i + r][j + k - 1]]++;
                for (int c = 0; c < k - 1; c++)
                    was[t[i + k - 1][j + c]]++;
                if (was.size() != k)
                    continue;
                ans += sq(t, i, j, k).first;
            }
        }
    }
    cout << ans << endl;
}
