#define PYHAEM_S_NOGI 4

#if PYHAEM_S_NOGI >= 1
#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native,sse,sse2,sse3,avx,mmx")
#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math")
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long

#if PYHAEM_S_NOGI >= 2
const int BUFFER_SIZE = 65536;
char read_buffer[BUFFER_SIZE];
char* read_buffer_ptr = read_buffer;
char* read_buffer_end = read_buffer;
int getc_buffered() {
	if(read_buffer_ptr == read_buffer_end) {
		read_buffer_ptr = read_buffer;
		read_buffer_end = read_buffer + fread(read_buffer, 1, BUFFER_SIZE, stdin);
	 	if(read_buffer_ptr == read_buffer_end) {
			return -1;
		}
	}
	return *read_buffer_ptr++;
}
int readint() {
	int n = 0;
	int sign = 1;
	char c;
	do {
		c = getc_buffered();
	} while(!(('0' <= c && c <= '9') || c == '-'));
	if(c == '-') {
		sign = -1;
		c = getc_buffered();
	}
	do {
		n = n * 10 + (c - '0');
		c = getc_buffered();
	} while('0' <= c && c <= '9');
	return n;
}
char readchar() {
	char c;
	do {
		c = getc_buffered();
	} while(c == ' ' || c == '\n' || c == '\t' || c == '\r');
	return c;
}
#else
int readint() {
	int n;
	cin >> n;
	return n;
}
#endif

#if PYHAEM_S_NOGI >= 3
const int MAX_MEMORY = 800 * 1024 * 1024;
char MEMORY[MAX_MEMORY];
char* memory_ptr = MEMORY;

void* operator new(size_t sz) {
	void* res = memory_ptr;
	memory_ptr += sz;
	assert(memory_ptr < MEMORY + MAX_MEMORY);
	return res;
}

void operator delete(void*) {}
#endif

const int POW = 54757;
const int MOD = 1000000009LL;
const int MAXN = 500;
int a[MAXN][MAXN];
int fright[MAXN][MAXN];
int down[MAXN][MAXN];
int frighthash[MAXN][MAXN];
int downhash[MAXN][MAXN];
int pows[256 * 256];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n = readint();
	int m = readint();

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			char c1 = readchar();
			char c2 = readchar();
			a[i][j] = c1 * 256 + c2;
		}
	}

	pows[0] = 1;
	for(int i = 1; i < 256 * 256; i++) {
		pows[i] = pows[i - 1] * POW % MOD;
	}

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			set<int> s;
			int k;
			for(k = i; k < n; k++) {
				if(s.count(a[k][j])) {
					break;
				}
				s.insert(a[k][j]);
			}
			down[i][j] = k - i;
			downhash[i][j] = (i == 0 ? 0 : downhash[i - 1][j]) + pows[a[i][j]];
		}
	}
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			set<int> s;
			int k;
			for(k = j; k < m; k++) {
				if(s.count(a[i][k])) {
					break;
				}
				s.insert(a[i][k]);
			}
			fright[i][j] = k - j;
			frighthash[i][j] = (j == 0 ? 0 : frighthash[i][j - 1]) + pows[a[i][j]];
		}
	}

	int ans = 0;
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < m; j++) {
			for(int k = 1; i + k <= n && j + k <= m; k++) {
				bool ok = fright[i][j] >= k && down[i][j] >= k;
				for(int p = 0; p < k; p++) {
					ok = ok && (
						MOD
						+ frighthash[i + p][j + k - 1]
						- (j == 0 ? 0 : frighthash[i + p][j - 1])
					) % MOD == (
						MOD
						+ frighthash[i][j + k - 1]
						- (j == 0 ? 0 : frighthash[i][j - 1])
					) % MOD;
					ok = ok && (
						MOD
						+ downhash[i + k - 1][j + p]
						- (i == 0 ? 0 : downhash[i - 1][j + p])
					) % MOD == (
						MOD
						+ downhash[i + k - 1][j]
						- (i == 0 ? 0 : downhash[i - 1][j])
					) % MOD;
				}
				if(ok) {
					ans++;
				}
			}
		}
	}
	cout << ans << endl;

#if PYHAEM_S_NOGI >= 3
	cerr << endl << endl << "Memory used: " << (double)((memory_ptr - MEMORY) * 10000 / MAX_MEMORY) / 100 << "%" << endl;
#endif

	return 0;
}