#define _CRT_SECURE_NO_WARNINGS
#define USE_MATH_DEFINES
#include <iostream>
#include <map>
#include <vector>
#include <stack>
#include <cassert>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <set>

#pragma GCC optimize("Ofast")
#pragma GCC target("sse")

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

struct izm {
	int x, row;
	char c;//r, c
	izm() {}
	izm(int _x, int _row, char _c) {
		x = _x;
		row = _row;
		c = _c;
	}
};

int n, m, a[2000][2000], NOW = 0, NROW[2000], NCOL[2000];
bool used[10000], row[2000][10000], col[2000][10000];
stack <izm> changes;

void otkat() {
	while (!changes.empty()) {
		used[changes.top().x] = false;
		if (changes.top().c == 'r') {
			row[changes.top().row][changes.top().x] = false;
			NROW[changes.top().row] = 0;
		} else {
			col[changes.top().row][changes.top().x] = false;
			NCOL[changes.top().row] = 0;
		}
		changes.pop();
	}
	NOW = 0;
}

void update(char c, int row, int x) {
	if (x >= 10000)
		x = x;
	if (c == 'c') {
		if (col[row][x] == false) {
			changes.push(izm(x, row, 'c'));
			col[row][x] = true;
			NCOL[row]++;
			if (!used[x]) {
				used[x] = true;
				NOW++;
			}
		}
	} else {
		if (::row[row][x] == false) {
			changes.push(izm(x, row, 'r'));
			::row[row][x] = true;
			NROW[row]++;
			if (!used[x]) {
				used[x] = true;
				NOW++;
			}
		}
	}
}

const int MOD1 = 1e9 + 7, MOD2 = 2147483647;
const ll p1 = 31, p2 = 29;

struct Hash
{
	ll x1, x2;
	Hash() {}
	Hash(ll _x1, ll _x2)
	{
		x1 = _x1;
		x2 = _x2;
	}
	Hash operator +(const Hash& x) const
	{
		ll res1 = x1 + x.x1, res2 = x2 + x.x2;
		while (res1 >= MOD1)
			res1 -= MOD1;
		while (res2 >= MOD2)
			res2 -= MOD2;
		return Hash(res1, res2);
	}
	Hash operator -(const Hash& x) const
	{
		ll res1 = x1 - x.x1, res2 = x2 - x.x2;
		while (res1 < 0)
			res1 += MOD1;
		while (res2 < 0)
			res2 += MOD2;
		return Hash(res1, res2);
	}
	bool operator ==(const Hash& x) const
	{
		return x1 == x.x1 && x2 == x.x2;
	}
};

vector <Hash> roww[2020], coll[2020];

Hash get_hash(char c, int row, int l, int r)
{
	if (c == 'r') 
	{
		if (l == 0)
			return ::roww[row][r];
		return ::roww[row][r] - ::roww[row][l - 1];
	}
	if (l == 0)
		return coll[row][r];
	return coll[row][r] - coll[row][l - 1];
}

ll solution_with_hashes()
{
	Hash st_2[10010];
	st_2[0].x1 = st_2[0].x2 = 1;
	for (int i = 1; i < 10000; i++) 		
		st_2[i] = st_2[i - 1] + st_2[i - 1];
	for(int i = 0; i < n; i++)
	{
		roww[i].reserve(m);
		Hash cur = st_2[a[i][0]];
		roww[i].pb(cur);
		for(int j = 1; j < m; j++)
		{
			cur = cur + st_2[a[i][j]];
			roww[i].pb(cur);
		}
	}
	for(int j = 0; j < m; j++)
	{
		coll[j].reserve(n);
		Hash cur = st_2[a[0][j]];
		coll[j].pb(cur);
		for(int i = 1; i < n; i++)
		{
			cur = cur + st_2[a[i][j]];
			coll[j].pb(cur);
		}
	}
	ll ans = 0;
	for(int i = 0; i < n; i++)
		for(int j = 0; j < m; j++)
		{
			ans++;
			for (int add = 1; add + i < n && add + j < m; add++) 
			{
				bool ch = true;
				Hash cur = get_hash('r', i, j, j + add);
				for (int row = i + 1; row <= i + add; row++) 
				{
					Hash govno = get_hash('r', row, j, j + add);
					ch &= (cur == govno);
					if (!ch)
						break;
				}
				if (!ch)
					continue;
				Hash blin = get_hash('c', j, i, i + add);
				ch &= (cur == blin);
				cur = blin;
				for(int col = j + 1; col <= j + add; col++)
				{
					Hash govno = get_hash('c', col, i, i + add);
					ch &= (cur == govno);
					if (!ch)
						break;
				}
				ans += ch;
			}
		}
	return ans;
	exit(0);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	//cout << (1ll << 31) - 1 << '\n';
	/*cout << int('’');
	char c1, c2;
	cin >> c1 >> c2;
	cout << int((c1 - 33) * 100 + (c2 - 33));
	return 0;*/
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c1, c2;
			cin >> c1 >> c2;
			if (c1 == '’')
				c1 = 39;
			if (c2 == '’')
				c2 = 39;
			if (c1 == -111)
				c1 = 96;
			if (c2 == -111)
				c2 = 96;
			c1 -= 33;
			c2 -= 33;
			a[i][j] = c1 * 100 + c2;
		}
	}
/*	bool ch = true;
	for (int i = 0; i < n; i++) {
		set <int> have;
		for (int j = 0; j < m; j++) {
			if (have.find(a[i][j]) != have.end())
				ch = false;
			have.insert(a[i][j]);
		}
	}
	for (int j = 0; j < m; j++) {
		set <int> have;
		for (int i = 0; i < n; i++) {
			if (have.find(a[i][j]) != have.end())
				ch = false;
			have.insert(a[i][j]);
		}
	}
	if (ch)*/
	ll res1=	solution_with_hashes(), res2 = 0;
	//return 0;
	//if (n <= 100 && m <= 100) 
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++) {
				res2++;
				otkat();
				update('r', i, a[i][j]);
				update('c', j, a[i][j]);
				int MAX_ADD = min(n - i, m - j) - 1;
				for (int add = 1; add <= MAX_ADD; add++) {
					if (NOW > MAX_ADD + 1)
						break;
					bool ch_col = true, ch_row = true;
					for (int jj = j; jj < j + add; jj++) {
						update('c', jj, a[i + add][jj]);
						ch_col &= (NCOL[jj] == add + 1);
					}
					if (NOW > MAX_ADD + 1)
						break;
					for (int ii = i; ii < i + add; ii++) {
						update('r', ii, a[ii][j + add]);
						ch_row &= (NROW[ii] == add + 1);
					}
					if (NOW > MAX_ADD + 1)
						break;
					for (int jj = j; jj <= j + add; jj++)
						update('r', i + add, a[i + add][jj]);
					if (NOW > MAX_ADD + 1)
						break;
					for (int ii = i; ii <= i + add; ii++)
						update('c', j + add, a[ii][j + add]);
					if (NOW > MAX_ADD + 1)
						break;
					if (ch_row && ch_col && NOW == add + 1 && NROW[i + add] == add + 1 && NCOL[j + add] == add + 1)
						res2++;
				}
			}

	if(res1 == res2)
	{
		cout 
			<< res1;
		return 0;
	}
	if (res2 == 0)
		cout << res1;
	else
		cout << res2;
	return 0;
}


