#include <bits/stdc++.h>

using namespace std;

const int kN = 4e5 + 7;
const int kMax = 10;/*1e7 + 7*/
#define cd complex<double>
const double PI = acos(-1);

void fft(vector<cd> &a, bool invert){
    int n = a.size();
    for(int i = 1, j = 0; i < n; ++i){
        int bit = n / 2;
        for(; j & bit; bit /= 2)
            j ^= bit;
        j ^= bit;

        if(i < j)
            swap(a[i], a[j]);
    }

    for(int len = 2; len <= n; len *= 2){
        double ang = 2 * PI / len * (invert ? -1 : 1);
        cd wlen(cos(ang), sin(ang));
        for(int i = 0; i < n; i += len){
            cd w(1);
            for(int j = 0; j < len / 2; ++j){
                cd u = a[i + j], v = a[i + j + len / 2] * w;
                a[i + j] = u + v;
                a[i + j + len / 2] = u - v;
                w *= wlen;
            }
        }
    }

    if(invert){
        for(cd &x: a)
            x /= n;
    }
}

vector<int> multiply(vector<int> &a, vector<int> &b){
    vector<cd> fa(a.begin(), a.end()), fb(b.begin(), b.end());
    int n = 1;
    while(n < a.size() + b.size())
        n *= 2;

    fa.resize(n);
    fb.resize(n);

    fft(fa, false);
    fft(fb, false);

    for(int i = 0; i < n; ++i)
        fa[i] *= fb[i];

    fft(fa, true);

    vector<int> ans(n);
    for(int i = 0; i < n; ++i)
        ans[i] = round(fa[i].real());

    return ans;
}

int a[kN];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    vector<int> cnt(kMax, 0);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        ++cnt[a[i]];
    }

    vector<int> cnt2 = multiply(cnt, cnt);
    for(int i = 0; i < n; ++i)
        --cnt2[2 * a[i]];
    for(int &x: cnt2)
        x /= 2;

    int ans = 0;
    for(int i = 0; i < cnt2.size(); ++i)
        if(cnt2[i] & 1)
            ans ^= i;

    cout << ans << "\n";
}
