#include <bits/stdc++.h>

using namespace std;

const int maxnum = 1e6 + 3;
const int maxn = 4e5 + 3;

using cd = complex <long double>;
const double PI = acos(-1);

void fft(vector <cd> &a, bool invert)
{
    int n = a.size();
    for (int i = 1, j = 0; i < n; i++)
    {
        int bit = n >> 1;
        for (; j & bit; bit >>= 1)
            j ^= bit;

        j ^= bit;

        if (i < j)
            swap(a[i], a[j]);
    }

    for (int len = 2; len <= n; len <<= 1)
    {
        double ang = 2 * PI / len * (invert ? -1: 1);
        cd wlen(cos(ang), sin(ang));

        for (int i = 0; i < n; i += len)
        {
            cd w(1);
            for (int j = 0; j < len / 2; j++)
            {
                cd u = a[i+j], v = a[i+j+len/2] * w;
                a[i+j] = u + v;
                a[i+j+len/2] = u - v;
                w *= wlen;
            }
        }
    }

    if (invert)
    {
        for (cd &x: a)
            x /= n;
    }
}

vector <long long> multiply(vector <int> &a, vector <int> &b)
{
    vector <cd> fa(a.begin(), a.end()), fb(b.begin(), b.end());
    int n = 1;
    while (n < a.size() + b.size())
        n <<= 1;

    fa.resize(n);
    fb.resize(n);

    fft(fa, false);
    fft(fb, false);


    for (int i = 0; i < n; i++)
        fa[i] *= fb[i];

    fft(fa, true);

    vector <long long> result(n);
    for (int i = 0; i < n; i++)
        result[i] = round(fa[i].real());

    return result;
}

int n, a[maxn];
vector <int> v;
void read()
{
    v.resize(maxnum);
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        v[a[i]]++;
    }
}

void solve()
{
    auto ans = multiply(v, v);
    for (int i = 1; i <= n; i++)
        ans[a[i]+a[i]]--;

    int sz = ans.size();
    int res = 0;
    for (int i = 0; i < sz; i++)
        if ((ans[i] / 2) & 1)
        res ^= i;

    cout << res << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
