#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
using namespace std;
const int MAXA = 1e4 + 1;

int rev(int x, int log_n)
{
    int res = 0;
    for(int i = 0; i < log_n; i++)
        if(x & (1 << i))
            res |= (1 << (log_n - 1 - i));

    return res;
}

typedef complex <double> base;
const double PI = acos(-1);

void FFT(vector <base> &a, bool invert)
{
    int n = (int)a.size(), log_n = 0;
    while((1 << log_n) < n)
        log_n++;

    for(int i = 0; i < n; i++)
        if(i < rev(i, log_n))
            swap(a[i], a[rev(i, log_n)]);

    for(int len = 2; len <= n; len *= 2)
    {
        double ang = ( 2 * PI / len) * (invert ? -1 : 1);
        base wlen(cos(ang), sin(ang));
        for(int i = 0; i < n; i += len)
        {
            base w(1, 0);
            for(int j = 0; j < len / 2; j++)
            {
                base u = a[i + j], v = a[i + j + len / 2] * w;
                a[i + j] = u + v;
                a[i + j + len / 2] = u - v;
                w *= wlen;
            }
        }
    }

    if(invert)
        for(int i = 0; i < n; i++)
            a[i] /= n;
}

vector <int> mult(vector <int> a, vector <int> b)
{
    vector <base> fa(a.begin(), a.end()), fb(b.begin(), b.end());
    int n = 1;
    while(n < max(a.size(), b.size()))
        n *= 2;
    fa.resize(n); fb.resize(n);

    FFT(fa, 0);
    FFT(fb, 0);
    for(int i = 0; i < n; i++)
        fa[i] = fa[i] * fb[i];
    FFT(fa, 1);

    vector <int> res(n);
    for(int i = 0; i < n; i++)
        res[i] = (int)(fa[i].real() + 0.5);

    return res;
}


int n;
int inp[400005];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    vector <int> cnt(MAXA);
    int x;

    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> inp[i];
        cnt[inp[i]]++;
    }


    vector <int> res = mult(cnt, cnt);
    for(int i = 1; i <= n; i++)
        res[2 * inp[i]]--;

    int ans = 0;
    for(int i = 0; i < (int)res.size(); i++)
    {
        if((res[i] / 2) & 1)
            ans ^= i;
    }

    cout << ans << endl;

    return 0;
}

/*

3
1 2 3

*/
