#include <iostream>
#include <assert.h>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

struct Node
{
    ll l, r, val, push;

    Node()
    {
        l = -1, r = -1, val = 0, push = 0;
    }
};

struct SegmentTree
{
    vector<Node> d;

    void create(ll n)
    {
        d.resize(4 * n);
        build(1, 0, n);
    }

    void build(ll i, ll l, ll r)
    {
        if (l >= r)
            return;

        d[i].l = l;
        d[i].r = r;

        if (l == r - 1)
            return;

        ll m = l + (r - l) / 2;
        build(i * 2, l, m);
        build(i * 2 + 1, m, r);
    }

    void update(ll i)
    {
        if(d[i].l != d[i].r - 1)
        {
            d[i * 2].push += d[i].push;
            d[i * 2 + 1].push += d[i].push;
        }
        d[i].val += (d[i].push * (d[i].r - d[i].l));
        d[i].push = 0;
    }

    void ad(ll i, ll l, ll r, ll x)
    {
        update(i);

        if(d[i].l >= r || d[i].r <= l)
            return;

        if(d[i].l >= l && d[i].r <= r)
        {
            d[i].push += x;
            update(i);
            return;
        }

        ad(i * 2, l, r, x);
        ad(i * 2 + 1, l, r, x);
        update(i * 2);
        update(i * 2 + 1);
        d[i].val = d[i * 2].val + d[i * 2 + 1].val;
    }

    ll get(ll i, ll l, ll r)
    {
        update(i);

        if(d[i].l >= r || d[i].r <= l)
            return 0;

        if(d[i].l >= l && d[i].r <= r)
            return d[i].val;

        return get(i * 2, l, r) + get(i * 2 + 1, l, r);
    }
};
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;

    vll a(n);
    for(int i = 0; i < n; i++)
        cin >> a[i];

    bool isDebug = 0;

    if(n <= 1000 && !isDebug)
    {
        ll answ = 0;
        for(int i = 0; i < n; i++)
        {
            ll temp = 0;
            for(int j = i + 1; j < n; j++)
            {
                temp ^= (a[i] + a[j]);
            }
            answ ^= temp;
        }
        cout << answ << endl;
        return 0;
    }

    vector<SegmentTree> trees(101);
    for(int i = 0; i < trees.size(); i++)
        trees[i].create(n);

    for(int i = 0; i < n - 1; i++)
    {
        trees[a[i]].ad(1, i + 1, n, 1);
    }

    ll answ = 0;
    for(int i = 0; i < trees.size(); i++)
    {
        for(int j = 0; j < n; j++)
        {
            if(trees[i].get(1, j, j + 1) % 2 == 1)
                answ ^= (i + a[j]);
        }
    }
    cout << answ << endl;
    return 0;
}