#include <bits/stdc++.h>

using namespace std;

const int kN = 4e5 + 7;
const int kMax = 100 + 7;

/*struct cd{
    double im, re;
    cd(){
        im = 0;
        re = 0;
    }
    cd(int re){
        im = 0;
        this->re = re;
    }
};*/

#define cd complex<double>
const double PI = acos(-1);

short cnt[4 * kMax];

void fft(vector<cd> &a, bool invert){
    int n = a.size();
    for(int i = 1, j = 0; i < n; ++i){
        int bit = n / 2;
        for(; j & bit; bit /= 2)
            j ^= bit;
        j ^= bit;

        if(i < j)
            swap(a[i], a[j]);
    }

    for(int len = 2; len <= n; len *= 2){
        double ang = 2 * PI / len * (invert ? -1 : 1);
        cd wlen(cos(ang), sin(ang));
        for(int i = 0; i < n; i += len){
            cd w(1);
            for(int j = 0; j < len / 2; ++j){
                cd u = a[i + j], v = a[i + j + len / 2] * w;
                a[i + j] = u + v;
                a[i + j + len / 2] = u - v;
                w *= wlen;
            }
        }
    }

    if(invert){
        for(cd &x: a)
            x /= n;
    }
}

void multiply(){
    vector<cd> fa(kMax);
    for(int i = 0; i < kMax; ++i)
        fa[i] = cnt[i];
    int n = 1;
    while(n < 2 * kMax)
        n *= 2;

    fa.resize(n);

    fft(fa, false);

    for(int i = 0; i < n; ++i)
        fa[i] *= fa[i];

    fft(fa, true);

    for(int i = 0; i < n; ++i)
        cnt[i] = round(fa[i].real());
}

int a[kN];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    for(int i = 0; i < n; ++i){
        cin >> a[i];
        ++cnt[a[i]];
    }

    multiply();
    for(int i = 0; i < n; ++i)
        --cnt[2 * a[i]];
    for(short &x: cnt){
        x /= 2;
        x &= 1;
    }

    int ans = 0;
    for(int i = 0; i < 2 * kMax; ++i)
        if(cnt[i] & 1)
            ans ^= i;

    cout << ans << "\n";
}
