#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
#include <map>
#include <vector>
//#include <unordered_set>
#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
#include <queue>
//#include <utility>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

using ll = long long;
#define all(c) c.begin(),c.end()

size_t const ALLOC_MEM_CNT = 480 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_CNT];
size_t ALLOC_POS = ALLOC_MEM_CNT;

void *operator new(size_t n) {
    ALLOC_POS -= n;
    return ALLOC_MEM + ALLOC_POS;
}

void operator delete(void *) noexcept {}


void _tmain([[maybe_unused]] int test_id) {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int &x : a) { cin >> x; }
    int ans = 0;
    int max_val = 0;
    for (int x : a) {
        max_val = max(max_val, x);
    }
    for (int h = 0; (1 << h) <= 2 * max_val; ++h) {
        __gnu_pbds::tree<pair<int, int>, __gnu_pbds::null_type, less<>,
                __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update> b_with, b_without;
        ll k = 0;
        int const lim = (1 << h);
        vector<pair<int, bool>> data;
        for (int i = 0; i < n; ++i) {
            bool has_cur = (a[i] & (1 << h));
            int low = (a[i] & ((1 << h) - 1));
            data.emplace_back(low, has_cur);
        }
        int cntr = 0;
        ll cnt_less[2]={0, 0};
        ll cnt_eq[2] = {0, 0};
        for (auto [low, has_cur]: data) {
            if (2*low < lim) {++cnt_less[has_cur];}
            if (2*low == lim) {++cnt_eq[has_cur];}
            if (2*low <= lim) {
                if (has_cur) {
                    b_with.insert({low,cntr++});
                } else {
                    b_without.insert({low, cntr++});
                }
            }
        }
        k += cnt_less[0] * cnt_less[1];
        k += cnt_less[0] * cnt_eq[1];
        k += cnt_less[1] * cnt_eq[0];
        k += cnt_eq[0] * (cnt_eq[0]-1)/2;
        k += cnt_eq[1] * (cnt_eq[1]-1)/2;
        int cur_cnt_big = 0;
        for (auto[low, has_cur]: data) {
            if (2*low <= lim) {continue;}
            int const i = cntr++;
            auto const kk = make_pair(lim - low, -1);
            if (has_cur) {
                k += cur_cnt_big + b_with.size() - b_with.order_of_key(kk);
                k += b_without.order_of_key(kk);
            } else {
                k += b_with.order_of_key(kk);
                k += cur_cnt_big + b_without.size() - b_without.order_of_key(kk);
            }
            cur_cnt_big++;
        }
        ans += int(k % 2ll) * (1 << h);
    }
    cout << ans << "\n";

    int corr = 0;
    for (int i = 0; i < n;++i) {
        for (int j = i+1; j < n; ++j) {
            corr ^= (a[i] + a[j]);
        }
    }
    assert(ans == corr);
}
