#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    int *t;
    int default_value = 0;
    int n;

    int merge(int a, int b) {
        return a + b;
    }

private:
    void build(int v, int l, int r, int *arr) {
        if (r == l + 1) {
            t[v] = arr[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, arr);
        build(v * 2 + 1, m, r, arr);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos < l || pos >= r) {
            return;
        }
        if (r == l + 1) {
            t[v] = pos;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int al, int ar) {
        if (al <= l && r <= ar) {
            return t[v];
        }
        if (ar <= l || r <= al) {
            return default_value;
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, al, ar),
                     get(v * 2 + 1, m, r, al, ar));
    }

public:
    DO(int n, int *arr) : n(n) {
        t = new int[4 * n];
        build(1, 0, n, arr);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

};

void solve1000(int n) {

    int ans = 0;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int j = 0; j < n; ++j) {
        for (int i = j + 1; i < n; ++i) {
            ans = ans ^ (a[i] + a[j]);
        }
    }
    cout << ans;
}

#define MAX_BIT 23
#define INF 100000000

void solve100(int n) {
    map<int, int> cnts[MAX_BIT];
    int ones[MAX_BIT];
    memset(ones, 0, sizeof(ones));
    for (int j = 0; j < n; ++j) {
        int x;
        cin >> x;
        int cur = 0;
        for (int i = 0; i < MAX_BIT; ++i) {
            cnts[i][cur]++;
            cur += (((x >> i) & 1) << i);
            ones[i] += ((x >> i) & 1);
        }
    }
    int ans = 0;
    for (int i = 0; i < MAX_BIT; ++i) {
        int cnt = 0;
        for (auto e:cnts[i]) {
            for (auto g:cnts[i]) {
                if (e == g) {
                    continue;
                }
                if (e.first + g.first >= (1LL << i)) {
                    cnt += (e.second) * (g.second);
                }
            }
            if (e.first * 2 >= (1LL << i)) {
                cnt += e.second * (e.second - 1);
            }
        }
        cnt /= 2;
        ans += (1LL << i) * ((ones[i] * (n - ones) + cnt) & 1);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    if (n <= 1000) {
        solve1000(n);
    } else {

        solve100(n);
    }
    return 0;
}