#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>
#include <random>
#include <cassert>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <map>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <iomanip>
#include <bitset>
#include <stack>
#include <list>

#pragma warning (disable : 4996)
using namespace std;

#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define nl '\n'
#define sz(a) (int)(a).size()
#define maxeq(a, b) (a) = max(a, b);
#define mineq(a, b) (a) = min(a, b);

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
const dl PI = acos(-1);
mt19937 rnd(5625445);
mt19937_64 rnd64(3465467567);

template <typename T, typename D>
istream &operator >> (istream &in, pair<T, D> &a) {
	in >> a.first >> a.second;
	return in;
}

template <typename T, typename D>
ostream &operator << (ostream &out, pair<T, D> &a) {
	out << a.first << " " << a.second;
	return out;
}

template <typename T>
istream &operator >> (istream &in, vector<T> &a) {
	for (auto &i : a)
		in >> i;
	return in;
}

void IO() {
#ifdef _SEVA
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _SEVA
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

void solve1(int n, const vector<int> &a) {
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			ans ^= a[i] + a[j];
		}
	}
	cout << ans << nl;
}

void solve2(int n, const vector<int>& a) {
	map<int, int> mp;
	for (int i = 0; i < n; i++) {
		int k = a[i];
		mp[k]++;
	}
	ll ans = 0;
	for (auto it1 = mp.begin(); it1 != mp.end(); it1++) {
		int v1 = it1->first;
		int cnt1 = it1->second;
		if (((cnt1 + (cnt1 - 1)) >> 1) & 1)
			ans ^= v1 + v1;
		if (!(cnt1 & 1))
			continue;
		for (auto it2 = next(it1); it2 != mp.end(); it2++) {
			int v2 = it2->first;
			int cnt2 = it2->second;
			if (!(cnt2 & 1))
				continue;
			ans ^= v1 + v2;
		}
	}
	cout << ans << nl;
}

int main() {
	IO();
	int n;
	cin >> n;
	vector<int> a(n);
	cin >> a;
	if (n <= 1000)
		solve1(n, a);
	else
		solve2(n, a);
	return 0;
}
