#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

const int kN = 4e5 + 7;
const int kMax = 1e7 + 7;

struct cd{
    double im, re;
    cd(){
        im = 0;
        re = 0;
    }
    cd(int re){
        im = 0;
        this->re = re;
    }
    cd(double re, double im){
        this->re = re;
        this->im = im;
    }

    friend cd operator*(cd &a, cd &b){
        cd ret;
        ret.im = a.re * b.im + b.re * a.im;
        ret.re= a.re * b.re - a.im * b.im;
        return ret;
    }

    friend cd operator+(cd &a, cd &b){
        cd ret;
        ret.im = a.im + b.im;
        ret.re= a.re + b.re;
        return ret;
    }

    friend cd operator-(cd &a, cd &b){
        cd ret;
        ret.im = a.im - b.im;
        ret.re= a.re - b.re;
        return ret;
    }

    friend cd operator/(cd &a, int &b){
        cd ret;
        ret.im = a.im / (double)b;
        ret.re= a.re / (double)b;
        return ret;
    }
};

//#define cd complex<double>
const double PI = acos(-1);

short cnt[4 * kMax];
cd fa[4 * kMax];

void fft(int n, bool invert){
    for(int i = 1, j = 0; i < n; ++i){
        int bit = (n >> 1);
        for(; j & bit; bit >>= 1)
            j ^= bit;
        j ^= bit;

        if(i < j)
            swap(fa[i], fa[j]);
    }

    for(int len = 2; len <= n; len <<= 1){
        double ang = 2 * PI / len * (invert ? -1 : 1);
        cd wlen(cos(ang), sin(ang));
        for(int i = 0; i < n; i += len){
            cd w(1);
            for(int j = 0; j < len >> 1; ++j){
                cd u = fa[i + j], v = fa[i + j + (len >> 1)] * w;
                fa[i + j] = u + v;
                fa[i + j + (len >> 1)] = u - v;
                w = w * wlen;
            }
        }
    }

    if(invert){
        for(cd &x: fa)
            x = x / n;
    }
}

void multiply(){
    for(int i = 0; i < kMax; ++i)
        fa[i] = cnt[i];
    int n = 1;
    while(n < (kMax << 1))
        n <<= 1;

    fft(n, false);

    for(int i = 0; i < n; ++i)
        fa[i] = fa[i] * fa[i];

    fft(n, true);

    for(int i = 0; i < n; ++i)
        cnt[i] = (short)round(fa[i].re) & 3;
}

int a[kN];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    for(int i = 0; i < n; ++i)
        cin >> a[i];

    if(n <= 1000){
        int ans = 0;
        for(int i = 0; i < n; ++i)
            for(int j = i + 1; j < n; ++j)
                ans ^= a[i] + a[j];

        cout << ans << "\n";
        return 0;
    }

    for(int i = 0; i < n; ++i){
        ++cnt[a[i]];
        cnt[a[i]] &= 3;
    }

    //for(int i = 0; i < kMax; ++i)
    //    cnt[a[i]] &= 3;

    multiply();
    for(int i = 0; i < n; ++i)
        --cnt[(a[i] << 1)];
    for(short &x: cnt)
        x >>= 1;

    int ans = 0;
    for(int i = 0; i < (kMax << 1); ++i)
        if(cnt[i] & 1)
            ans ^= i;

    cout << ans << "\n";
}
