#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <set>
#include <stack>
#include <queue>

using namespace std;

typedef long long ll;

const int N = 500010;

#ifdef _DEBUG
const int bits = 5;
#else
const int bits = 25;
#endif

#ifdef _DEBUG
const int M = 10010;
#else
const int M = (1 << (bits + 1)) + 1;
#endif

const int INF = (int)1e9 + 10;

int a[N];

int ans = 0;

int mx = -1;

int pref[1 << bits];

struct fenwick {
	vector < int > t;
	int n;
	void build(int nn) {
		n = nn;
		t.resize(n + 1);
		for (int i = 1; i <= n; ++i) {
			t[i] = pref[i] - pref[i - (i & -i)];
		}
	}
	int query(int l, int r) {
		int res = 0;
		++l, ++r;
		for (int i = r; i > 0; i -= i & -i) {
			res += t[i];
		}
		for (int i = l - 1; i > 0; i -= i & -i) {
			res -= t[i];
		}
		return res;
	}
	void upd(int ind, int x) {
		++ind;
		for (int i = ind; i <= n; i += i & -i) {
			t[i] += x;
		}
	}
} fenw[bits + 1];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		
	}
	for (int j = bits; j >= 1; --j) {
		for (int i = 1; i <= n; ++i) {
			pref[a[i] % (1 << j) + 1]++;
		}
		for (int i = 1; i <= (1 << j); ++i) {
			pref[i] += pref[i - 1];
		}
		fenw[j].build(1 << j);
		for (int i = 1; i <= (1 << j); ++i) {
			pref[i] = 0;
		}
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = bits; j >= 1; --j) {
			fenw[j].upd(a[i] % (1 << j), -1);
			int sum = 0;
			int l = (1 << (j - 1)) - (a[i] % (1 << j));
			int r = (1 << j) - (a[i] % (1 << j)) - 1;
			while (l < 0)
				l += 1 << j;
			while (r < 0)
				r += 1 << j;
			while (r >= (1 << j))
				r -= 1 << j;
			while (l >= (1 << j))
				l -= 1 << j;
			if (l <= r)
				sum += fenw[j].query(l, r);
			else
				sum += fenw[j].query(0, r) + fenw[j].query(l, (1 << j) - 1);
			if (sum & 1)
				ans ^= 1 << (j - 1);
		}
	}
	cout << ans;
}