#include <bits/stdc++.h>

using namespace std;

void QuickStart(){
    ios_base::sync_with_stdio(0); cin.tie(0);
}

typedef long long ll;

int n;
vector<int>a;

struct tnode{
    ll y, sz, sum, val;
    ll add;
    tnode* l, *r;
};

ll get_sz(tnode* root){
    return (!root ? 0 : root->sz);
}

ll get_sum(tnode* root){
    return (!root ? 0 : root->sum);
}

void update(tnode* root){
    if(!root) return;
    root->sum = root->val ^ get_sum(root->l) ^ get_sum(root->r);
    root->sz = get_sz(root->l) + get_sz(root->r) + 1;
}

void push(tnode* root){
    if(!root){
        return;
    }
    if(root->add){
        root->val += root->add;
        if(root->l){
            root->l->add = root->add;
        }
        if(root->r){
            root->r->add = root->add;
        }
        root->add = 0;
    }
}

tnode* new_node(int val){
    tnode* res = new tnode;
    res->val = val, res->y = (rand() << 15) + rand(), res->sz = 1, res->add = 0, res->sum = val;
    res->l = res->r = nullptr;
    return res;
}

tnode* merge(tnode* a, tnode* b){
    push(a);
    push(b);
    if(!a) return b;
    if(!b) return a;
    if(a->y > b->y){
        a->r = merge(a->r, b);
        update(a);
        return a;
    }
    else{
        b->l = merge(a, b->l);
        update(b);
        return b;
    }
}

pair<tnode*, tnode*>split(tnode* root, ll k){
    push(root);
    if(!root) return {nullptr, nullptr};
    if(get_sz(root->l) >= k){
        auto t = split(root->l, k);
        root->l = t.second;
        update(root);
        return {t.first, root};
    }
    else{
        k -= get_sz(root->l) + 1;
        auto t = split(root->r, k);
        root->r = t.first;
        update(root);
        return {root, t.second};
    }
}

tnode* insert(tnode* root, ll k, ll val){
    tnode* new_ = new_node(val);
    auto t = split(root, k);
    return merge(t.first, merge(new_, t.second));
}

ll sum(tnode* root, int l, int r){
    auto t = split(root, l);
    auto tt = split(t.second, r - l + 1);
    int ans = tt.first->sum;
    root = merge(t.first, merge(tt.first, tt.second));
    return ans;
}

tnode* upd(tnode* root, int l, int r, int x){
    auto t = split(root, l);
    auto tt = split(t.second, r - l + 1);
    tt.first->add = x;
    return merge(t.first, merge(tt.first, tt.second));
}

void array_(tnode* root){
    if(!root) return;
    array_(root->l);
    cout << root->val << ' ';
    array_(root->r);
}

void solve(){
    tnode* root = nullptr;
    for(int i = 0; i < n; i++){
        root = insert(root, i, a[i]);
    }
    ll ans = 0;
    for(int i = n - 2; i >= 0; i--){
        upd(root, i + 1, n - 1, a[i]);
        ans ^= sum(root, i + 1, n - 1);
        upd(root, i + 1, n - 1, -a[i]);
    }
    cout << ans << endl;
}

int main()
{
    QuickStart();
    cin >> n;
    a.resize(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    solve();
    return 0;
}
