#include <iostream>
#include <list>
#define endl '\n'

using namespace std;

const int MAXN = 4e5;
const int MAXLG = 20;
const int MAXA = 1e7;
int n;
int a[MAXN+10], ft[MAXA+10];
int bt[MAXLG+10];
int mx = 0, lg;
int ans;

void input()
{
    cin>>n;
    for (int i=0; i<n; i++)
    {
        cin>>a[i];
        mx = max(a[i], mx);
    }
}

void output()
{
    cout<<ans<<endl;
}

void printArray(const int a[], const int n)
{
    for (int i=0; i<n; i++)
    {
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void printList(const list<pair<int, int>> &l)
{
    auto id = l.begin();
    while (id != l.end())
    {
        cout<<(*id).first<<' '<<(*id).second<<endl;
        id++;
    }
    cout<<endl;
}

void update(int curr)
{
    while (curr <= mx)
    {
        ft[curr]++;
        curr += curr&(-curr);
    }
}

int sum(int curr)
{
    int sm = 0;
    while (curr > 0)
    {
        sm += ft[curr];
        curr -= curr&(-curr);
    }
    return sm;
}

void solve()
{
    ans = 0;

    mx = 256; lg = 8;
    for (int i=0; i<n; i++)
        update(a[i]);

    list<pair<int, int>> l;
    l.push_back({0, 128});
    l.push_back({128, 256});

    for (int j=lg-1; j>=0; j--)
    {
        for (int i=0; i<n; i++)
        {
            auto id = l.begin();
            while (id != l.end())
            {
                id++;
                int f = (*id).first - a[i];
                int s = (*id).second - a[i] - 1;

                if (s <= 0)
                {
                    id++;
                    continue;
                }

                bt[j] += sum(s) - sum(f-1);
                if (a[i] >= f && a[i] <= s) bt[j]--;
                id++;
            }
        }
        auto id = l.begin();
        auto o_id = l.begin();
        while (id != l.end())
        {
            int f = (*id).first;
            int s = (*id).second;
            int mid = (f+s)/2;
            (*id).first = mid;
            l.insert(id, {f, mid});
            id++;
        }
        //printList(l);
    }

    //printArray(bt, 10);

    int p_pow = 1;
    for (int i=0; i<MAXLG; i++)
    {
        bt[i] /= 2;
        ans += (bt[i] % 2) * p_pow;
        p_pow <<= 1;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}



