#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;

struct Stupid {
    vector<int> a;
    int n;

    Stupid(vector<int> a): a(a) {
        n = a.size();
    }

    int solve() {
        int res = 0;
        for(int i = 0; i < n; ++i)
            for(int j = i+1; j < n; ++j)
                res ^= a[i]+a[j];

        return res;
    }
};

struct Solver {
    vector<int> a;
    int n;

    Solver(vector<int> a): a(a) {
        n = a.size();
    }

    int solve_1() {
        int res = 0;
        for(int i = 0; i < n; ++i)
            for(int j = i+1; j < n; ++j)
                res ^= a[i]+a[j];

        return res;
    }

    int solve_2() {
        const int m = 1e3;
        vector<int> b(m, 0);

        for(int i : a)
            b[i]++;

        int res = 0;
        for(int i = 0; i < m; ++i) {
            if(b[i] == 0) continue;
            if((b[i]*(b[i]-1)/2) % 2)
                res ^= 2*i;
        }

        for(int i = 0; i < m; ++i) {
            for(int j = i+1; j < m; ++j) {
                if(b[i]*b[j] % 2)
                    res ^= (i+j);
            }
        }

        return res;
    }

    int solve() {
        if(n <= 1000) return solve_1();
        return solve_2();
    }
};

vector<int> get_a(int n, int m) {
    vector<int> a(n, 0);
    for(int i = 0; i < n; ++i)
        a[i] = 1 + (rand() % m);

    return a;
}

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = (stress ? 100 : 1);
    if((local) && (!stress)) cin >> tests;

    while(tests--) {
        if(!stress) {
            int n;
            cin >> n;

            vector<int> a(n, 0);
            for(int i = 0; i < n; ++i)
                cin >> a[i];

            Solver solver(a);
            int res = solver.solve();

            cout << res << "\n";

        } else {
            int n = 3;
            vector<int> a = get_a(n, 5);

            Solver solver(a);
            int res = solver.solve();

            Stupid stupid(a);
            int tres = stupid.solve();

            if(res !=  tres) {
                cout << "MDA: ";
                for(int i : a) cout << i << " ";
                cout << "\n";
                cout << res << " " << tres << "\n\n";
            }
        }
    }

    return 0;
}
