#include <iostream>
#include <cstdint>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <cstring>
#include <cassert>
using namespace std;

class sol1
{
private:
    vector<uint32_t> a;
public:
    sol1 (uint32_t n)
    {
        a.resize(n);
        for(uint32_t i=0; i<n; i++)
            cin>>a[i];
    }

    uint32_t solve()
    {
        uint32_t res=0;
        for(uint32_t i=0; i<a.size(); i++)
        {
            for(uint32_t j=i+1; j<a.size(); j++)
            {
                res^=(a[i]+a[j]);
            }
        }
        return res;
    }
};

class sol2
{
private:
    uint32_t na[101];
public:
    sol2 (uint32_t n)
    {
        memset(na, 0, sizeof(na));
        uint32_t a;
        for(uint32_t i=0; i<n; i++)
        {
            cin>>a;
            assert(a<=100);
            na[a]++;
        }
    }

    uint32_t solve()
    {
        uint32_t res=0;
        for(uint32_t i=0; i<=100; i++)
        {
            uint32_t nm=(na[i]*(na[i]-1))/2;
            if(nm&1)
                res^=i;
        }

        for(uint32_t i=0; i<=100; i++)
        {
            for(uint32_t j=i+1; j<=100; j++)
            {
                uint32_t  nm=na[i]*na[j];
                if(nm&1)
                    res^=(i+j);
            }
        }

        return res;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n;
    cin>>n;

    if(n<=1000)
    {
        sol1 sol(n);
        cout<<sol.solve()<<'\n';
    }
    else
    {
        sol2 sol(n);
        cout<<sol.solve()<<'\n';
    }

    return 0;
}