#include <iostream>
#include <cstdint>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <cstring>
#include <cassert>
#include <ctime>
using namespace std;

class sol1
{
private:
    vector<uint32_t> a;
public:
    sol1 (const vector<uint32_t> &a):a(a)
    {

    }

    uint32_t solve()
    {
        uint32_t res=0;
        for(uint32_t i=0; i<a.size(); i++)
        {
            for(uint32_t j=i+1; j<a.size(); j++)
            {
                res^=(a[i]+a[j]);
            }
        }
        return res;
    }
};

class sol2
{
private:
    uint32_t na[101];
public:
    sol2 (const vector<uint32_t> &a)
    {
        memset(na, 0, sizeof(na));
        for(uint32_t i=0; i<a.size(); i++)
        {
            assert(1<=a[i]<=100);
            na[a[i]]++;
        }
    }

    uint32_t solve()
    {
        uint32_t res=0;
        for(uint32_t i=1; i<=100; i++)
        {
            uint32_t nm=(na[i]*(na[i]-1))/2;
            if(nm&1)
                res^=(i+i);
        }

        for(uint32_t i=1; i<=100; i++)
        {
            for(uint32_t j=i+1; j<=100; j++)
            {
                uint32_t  nm=na[i]*na[j];
                if(nm&1)
                    res^=(i+j);
            }
        }

        return res;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n;
    cin>>n;
    vector<uint32_t> a;
    a.resize(n);

    for(uint32_t i=0; i<n; i++)
        cin>>a[i];

    if(n<=1000)
    {
        sol1 sol(a);
        cout<<sol.solve()<<'\n';
    }
    else
    {
        sol2 sol(a);
        cout<<sol.solve()<<'\n';
    }

//    while (true)
//    {
//        srand(time(NULL));
//        vector<uint32_t> test;
//        test.clear();
//        for(uint32_t i=0; i<5; i++)
//            test.push_back(rand()%20+1);
//
//        sol1 s1(test);
//        sol2 s2(test);
////        cout<<s1.solve()<<endl;
////        cout<<s2.solve()<<endl;
//        if(s1.solve() != s2.solve())
//        {
//            for(uint32_t i=0; i<test.size(); i++)
//                cout<<test[i]<<' ';
//            cout<<endl;
//
//            break;
//        }
//    }

    return 0;
}