#include <iostream>
#include <random>
#include <algorithm>
#include <unordered_set>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run(int n, int *a);

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    int n;
    cin >> n;
    auto a = arr<int>(n);
    bool to_100 = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        to_100 = to_100 && a[i] <= 100;
    }
    run(n, a);
}

void run(int n, int *a) {
    int res = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            res ^= a[i] + a[j];
        }
    }
    cout << res << endl;
}

void small(int n, int *a) {
    auto cnt = arr<int>(101, 0);
    for (int i = 0; i < n; i++) {
        cnt[a[i]]++;
    }
    int ans = 0;
    for (int i = 0; i <= 100; i++) {
        long long k = (long long) cnt[i] * (cnt[i] - 1) / 2;
        if (k % 2 == 1)
            ans ^= i * 2;
        for (int j = i + 1; j <= 100; j++) {
            k = (long long) cnt[i] * cnt[j];
            if (k % 2 == 1)
                ans ^= i + j;
        }
    }
    cout << ans << endl;
}