#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
#include <cassert>
#include <set>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 5e5, INF = 1e9, MOD = 1e9 + 21, P = 31;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

int solve_a100(vector<int> const& v) {
	vector<int> cnt(101);
	vector<long long> cnt2(101);
	for (int i : v) {
		cnt[i] ^= 1;
		++cnt2[i];
	}

	int res = 0;
	for (int i = 1; i <= 100; i++) {
		if ((((cnt2[i] * (cnt2[i] - 1)) / 2) & 1)) {
			res ^= (i + i);
		}
		for (int j = i + 1; j <= 100; j++) {
			if (cnt[i] & cnt[j]) {
				res ^= (i + j);
			}
		}
	}
	return res;
}

int solve(int n, vector<int> const& v) {
	int res = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			res ^= (v[i] + v[j]);
		}
	}

	return res;
}

int main() {
	int n;
	cin >> n;
	vector<int> v(n);
	if (*max_element(v.begin(), v.end()) <= 100) {
		cout << solve_a100(v) << '\n';
	} else {
		cout << solve(n, v) << '\n';
	}
}