#include "bits/stdc++.h"

#define ll long long
#define vi vector<ll>
#define ld long double
#define vvi vector<vi>
#define mp make_pair
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<ll, ll>
#define mx(a, b) a = max(a, b)
const ll MAXN = 201;
const ll inf = (ll)1e18;
const ld PI = acos(-1);

using namespace std;

template<class T>
void read(vector<T> &a) {
    for (auto &i : a) cin >> i;
}

template<class T>
void write(vector<T> &a) {
    for (auto i : a) cout << i << " ";
    cout << "\n";
}

typedef complex<double> base;

void fft(vector<base> &f, bool invert) {
    if (f.size() == 1) return;
    ll n = f.size();
    vector<base> f0(n / 2), f1(n / 2);
    for (ll i = 0; i < n; i += 2) {
        f0[i / 2] = f[i];
        f1[i / 2] = f[i + 1];
    }
    fft(f0, invert), fft(f1, invert);
    ld ang = 2 * PI / n * (invert? -1: 1);
    base w1 = base(cos(ang), sin(ang));
    base wn = 1;
    for (ll k = 0; k < n; ++k) {
        ll kx = k < n / 2? k: k - n / 2;
        f[k] = f0[kx] + wn * f1[kx];
        wn *= w1;
    }
}

void square(vi &a) {
    ll n = 1;
    while (n < a.size()) n <<= 1;
    n <<= 1;
    vector<base> p(n); a.resize(n);
    for (ll i = 0; i < n; ++i) p[i] = a[i];
    fft(p, 0);
    for (ll i = 0; i < n; ++i) {
        p[i] *= p[i];
    }
    fft(p, 1);
    a.resize(n);
    for (ll i = 0; i < n; ++i) {
        a[i] = (ll)(p[i].real() + 0.1) / n;
    }
}

void solve() {
    ll n, m; cin >> n >> m;
    vi c(n); read(c);
    vvi graph(n);
    for (ll i = 0; i < m; ++i) {
        ll v, u; cin >> v >> u;
        v--, u--;
        graph[v].push_back(u);
    }
    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            set<ll> cnt;
            for (ll u : graph[i]) cnt.insert(u);
            for (ll u : graph[j]) cnt.insert(u);
            ll sum = 0;
            for (ll i : cnt) sum += c[i];
            ans = __gcd(sum, ans);
        }
    }
    cout << ans << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    ll t; cin >> t;
    while(t--)
    solve();

    return 0;
}