#include <bits/stdc++.h>

using namespace std;

#define ll int
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

mt19937 gen(0);

struct node {
    ll val, pr, sz;
    node *l;
    node *r;

    node() {}

    node(ll x) {
        l = r = nullptr;
        val = x, pr = gen() * 13;
        sz = 1;
    }
};

ll get_size(node *v) {
    if (v == nullptr)
        return 0;
    return v->sz;
}
ll get_val(node *v) {
    if (v == nullptr)
        return -1;
    return v->val;
}

node *update(node *v) {
    if (v == nullptr)
        return v;
    v->sz = 1 + get_size(v->l) + get_size(v->r);
    return v;
}

pair<node *, node *> split(node *now, ll value) {
    if (now == nullptr) {
        return {nullptr, nullptr};
    }
    if (value > now->val) {
        auto[a, b] = split(now->r, value);
        a = update(a), b = update(b);
        now->r = a;
        now = update(now);
        return {now, b};
    } else {
        auto[a, b] = split(now->l, value);
        a = update(a), b = update(b);
        now->l = b;
        now = update(now);
        return {a, now};
    }
}

node *merge(node *a, node *b) {
    if (a == nullptr)
        return b;
    if (b == nullptr)
        return a;
    if (a->pr > b->pr) {
        node *v = merge(a->r, b);
        v = update(v);
        a->r = v;
        a = update(a);
        return a;
    } else {
        node *v = merge(a, b->l);
        v = update(v);
        b->l = v;
        b = update(b);
        return b;
    }
}

inline node *add(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    node *nw = new node(v);
    node *tmp = merge(r1, nw);
    root = merge(tmp, r2);
    return root;
}

inline pair<ll, node *> get_less(node *root, ll v) {
    auto[r1, r2] = split(root, v);
//    cout << v << ' ' << get_val(r1) << ' ' << get_val(r2) << ' ' << get_size(r1) << ' ' << get_size(r2) << endl;
    ll ans = get_size(r1);
    root = merge(r1, r2);
    return {ans, root};
}

inline pair<ll, node *> get_gr_or_eq(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    ll ans = get_size(r2);
    root = merge(r1, r2);
    return {ans, root};
}

void print(node*root) {
    if(root == nullptr)
        return;
    print(root->l);
    cout << root->val << ' ' << root->pr << '\n';
    print(root->r);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    ll size = 25;
    if(n > 1000)
        size = 7;
    vector<ll> num_here(size, 0);
    vector<ll> a(n);
    bool second_group = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        second_group &= (a[i] <= 100);
    }
    if(second_group) {
        reverse(a.begin(), a.end());
        ll ans = 0;
        vector <ll> cnt(101, 0);
        for(int i = 0; i < n; ++i) {
            for(int j = 1; j <= 100; ++j) {
                if(cnt[j] % 2) {
                    ans ^= (a[i] + j);
                }
            }
            cnt[a[i]]++;
        }
        cout << ans;
        return 0;
    }
    vector<node*> bits0(size, nullptr);
    vector<node*> bits1(size, nullptr);
    reverse(a.begin(), a.end());
    for (int i = 0; i < n; ++i) {
        ll now_sum = 0;
        for (int j = 0; j < size; ++j) {
//            if(j == 1) {
//                cout << i << ' ' << a[i] << ' ' << endl;
//                print(bits1[j]);
//            }
            if ((a[i] & (1 << j))) {
                pair <ll, node*> tmp = get_less(bits0[j], (1 << j) - now_sum);
                ll good = tmp.first;
                bits0[j] = tmp.second;
//                if(j == 0) {
//                    cout << i << ' ' << a[i] << ' ' << (1 << j) - now_sum << ' ' << good << '\n';
//                    print(bits0[j]);
//                    return 0;
//                }
                num_here[j] += good;


                tmp = get_gr_or_eq(bits1[j], (1 << j) - now_sum);
                good = tmp.first;
                bits1[j] = tmp.second;
                num_here[j] += good;

                now_sum += (1 << j);
            } else {
                pair <ll, node*> tmp = get_gr_or_eq(bits0[j], (1 << j) - now_sum);
                ll good = tmp.first;
                bits0[j] = tmp.second;
                num_here[j] += good;


                tmp = get_less(bits1[j], (1 << j) - now_sum);
                good = tmp.first;
                bits1[j] = tmp.second;
                num_here[j] += good;

            }
        }
//        cout << i << endl;
        ll sum = 0;
        for (int j = 0; j < size; ++j) {
            if ((a[i] & (1 << j))) {
                bits1[j] = add(bits1[j], sum);
                sum += (1 << j);
            } else {
                bits0[j] = add(bits0[j], sum);
            }
        }
    }

    ll ans = 0;
    for (int i = 0; i < num_here.size(); ++i) {
        if (num_here[i] % 2) {
            ans += (1 << i);
        }
    }
    cout << ans;
}