#include<bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;

const int MAXN = 4e5 + 5;
const int LOG = 25;
const int MAXC = 1e7 + 5;

int a[MAXN];
int n;

bool check_bit(int mask, int bit) {
	return mask & (1 << bit);
}

vector<int> renum;
int tree0[4 * MAXC];
int tree1[4 * MAXC];

int lson(int v) {
	return 2 * v + 1;
}

int rson(int v) {
	return 2 * v + 2;
}

void update(int x, int tree[], int v = 0, int tl = 0, int tr = MAXC - 1) {
	if (tl == tr) {
		tree[v] += 1;
		return;
	}
	int tm = (tl + tr) / 2;
	if (x <= tm) update(x, tree, lson(v), tl, tm);
	else update(x, tree, rson(v), tm + 1, tr);
	tree[v] = tree[lson(v)] + tree[rson(v)];
}

int find_kth(int k, int tree[], int v = 0, int tl = 0, int tr = MAXC - 1) {
	if (tl == tr) {
		return tl;
	}
	int tm = (tl + tr) / 2;
	int lsum = tree[lson(v)];
	if (lsum <= k) return find_kth(k - lsum, tree, rson(v), tm + 1, tr);
	else return find_kth(k, tree, lson(v), tl, tm);
}

void solve2() {
	int res = 0;
	for (int bit = 0; bit < LOG; ++bit) {
		memset(tree0, 0, sizeof tree0);
		memset(tree1, 0, sizeof tree1);
		for (int j = 0; j < n; ++j) {
			if (check_bit(a[j], bit)) {
				//zero
				int l = -1, r = tree0[0];
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = find_kth(mid, tree0) + a[j];
					if (check_bit(sum, bit)) l = mid;
					else r = mid;
				}
				int cur = l + 1;
				if (cur % 2) res ^= (1 << bit);
				// one
				 l = -1; r = tree1[0];
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = find_kth(mid, tree1) + a[j];
					if (check_bit(sum, bit)) r = mid;
					else l = mid;
				}
				cur = tree1[0] - r;
				if (cur % 2) res ^= (1 << bit);
				int val = (a[j] & ((1 << (bit + 1)) - 1));
				update(val, tree1);
				//ones.push_back(a[j] & ((1 << (bit + 1)) - 1));
			} else {
				// zeros
				int l = -1, r = tree0[0];
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = find_kth(mid, tree0) + a[j];
					if (check_bit(sum, bit)) r = mid;
					else l = mid;
				}
				int cur = tree0[0] - r;
				if (cur % 2) res ^= (1 << bit);
				// ones
				l = -1; r = tree1[0];
				while (r - l > 1) {
					int mid = (l + r) / 2;
					int sum = find_kth(mid, tree1) + a[j];
					if (check_bit(sum, bit)) l = mid;  
					else r = mid;
				}
				cur = l + 1;
				if (cur % 2) res ^= (1 << bit);
				int val = (a[j] & ((1 << (bit + 1)) - 1));
				update(val, tree0);
				//zeros.push_back(a[j] & ((1 << (bit + 1)) - 1));
			}
		}
	}
	cout << res << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		renum.push_back(a[i]);
	}
	/*sort(renum.begin(), renum.end());
	renum.resize(int(unique(renum.begin(), renum.end()) - renum.begin()));
	for (int i = 0; i < n; ++i) {
		int ind = int(lower_bound(renum.begin(), renum.end(), a[i]) - renum.begin());
		a[i] = ind;
	}*/
	solve2();
	//if (n <= 1000) solve();
	//else solve1();
	return 0;
}