#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

mt19937 gen(0);

struct node {
    ll val, pr, sz;
    node *l;
    node *r;

    node() {}

    node(ll x) {
        l = r = nullptr;
        val = x, pr = gen() * 13;
        sz = 1;
    }
};

ll get_size(node *v) {
    if (v == nullptr)
        return 0;
    return v->sz;
}

ll get_val(node *v) {
    if (v == nullptr)
        return -1;
    return v->val;
}

node *update(node *v) {
    if (v == nullptr)
        return v;
    v->sz = 1 + get_size(v->l) + get_size(v->r);
    return v;
}

pair<node *, node *> split(node *now, ll value) {
    if (now == nullptr) {
        return {nullptr, nullptr};
    }
    if (value > now->val) {
        auto[a, b] = split(now->r, value);
        a = update(a), b = update(b);
        now->r = a;
        now = update(now);
        return {now, b};
    } else {
        auto[a, b] = split(now->l, value);
        a = update(a), b = update(b);
        now->l = b;
        now = update(now);
        return {a, now};
    }
}

node *merge(node *a, node *b) {
    if (a == nullptr)
        return b;
    if (b == nullptr)
        return a;
    if (a->pr > b->pr) {
        node *v = merge(a->r, b);
        v = update(v);
        a->r = v;
        a = update(a);
        return a;
    } else {
        node *v = merge(a, b->l);
        v = update(v);
        b->l = v;
        b = update(b);
        return b;
    }
}

inline node *add(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    node *nw = new node(v);
    node *tmp = merge(r1, nw);
    root = merge(tmp, r2);
    return root;
}

inline pair<ll, node *> get_less(node *root, ll v) {
    auto[r1, r2] = split(root, v);
//    cout << v << ' ' << get_val(r1) << ' ' << get_val(r2) << ' ' << get_size(r1) << ' ' << get_size(r2) << endl;
    ll ans = get_size(r1);
    root = merge(r1, r2);
    return {ans, root};
}

inline pair<ll, node *> get_gr_or_eq(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    ll ans = get_size(r2);
    root = merge(r1, r2);
    return {ans, root};
}

void print(node *root) {
    if (root == nullptr)
        return;
    print(root->l);
    cout << root->val << ' ' << root->pr << '\n';
    print(root->r);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector<ll> a(n);
    bool second_group = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        second_group &= (a[i] <= 100);
    }
    reverse(a.begin(), a.end());
    second_group = false;
    if (second_group) {
        ll ans = 0;
        vector<ll> cnt(101, 0);
        for (int i = 0; i < n; ++i) {
            for (int j = 1; j <= 100; ++j) {
                if (cnt[j] % 2) {
                    ans ^= (a[i] + j);
                }
            }
            cnt[a[i]]++;
        }
        cout << ans;
        return 0;
    }
    vector<ll> num_here(25, 0);
    vector<ll> now(n, 0);
    for (int bit = 0; bit < 25; ++bit) {
        vector<pair<ll, ll>> bits0, bits1;
        for (int i = 0; i < n; ++i) {
            if ((a[i] & (1 << bit))) {
                bits1.push_back({now[i], i});
            } else
                bits0.push_back({now[i], i});
        }
        sort(bits0.begin(), bits0.end());
        sort(bits1.begin(), bits1.end());
        for (int i = 0; i < n; ++i) {
            if ((a[i] & (1 << bit))) {
                int l = 0, r = bits0.size() - 1, good = -1;
                while (l <= r) {
                    int mid = (l + r) / 2;
                    if (bits0[mid].first + now[i] < (1 << bit)) {
                        good = max(good, mid);
                        l = mid + 1;
                    } else {
                        r = mid - 1;
                    }
                }
                num_here[bit] += good + 1;

                l = 0, r = bits1.size() - 1, good = bits1.size();
                while (l <= r) {
                    int mid = (l + r) / 2;
                    if (bits1[mid].first + now[i] >= (1 << bit)) {
                        good = min(good, mid);
                        r = mid - 1;
                    } else {
                        l = mid + 1;
                    }
                }
                ll can = bits1.size() - good - (now[i] + now[i] >= (1 << bit));
                num_here[bit] += can;
            } else {
                int l = 0, r = bits1.size() - 1, good = -1;
                while (l <= r) {
                    int mid = (l + r) / 2;
                    if (bits1[mid].first + now[i] < (1 << bit)) {
                        good = max(good, mid);
                        l = mid + 1;
                    } else {
                        r = mid - 1;
                    }
                }
                num_here[bit] += good + 1;

                l = 0, r = bits0.size() - 1, good = bits0.size();
                while (l <= r) {
                    int mid = (l + r) / 2;
                    if (bits0[mid].first + now[i] >= (1 << bit)) {
                        good = min(good, mid);
                        r = mid - 1;
                    } else {
                        l = mid + 1;
                    }
                }
                ll can = bits0.size() - good - (now[i] + now[i] >= (1 << bit));
                num_here[bit] += can;
            }
        }
        for(int i = 0; i < n; ++i) {
            now[i] += (a[i] & (1 << bit));
        }
    }
    ll ans = 0;
    for(int i = 0; i < 25; ++i) {
        num_here[i] /= 2;
        if(num_here[i] % 2) {
            ans += (1 << i);
        }
    }
    cout << ans;
}