#include <bits/stdc++.h>

const int32_t MAX_A = 100;

const double PI = acos(-1);
int64_t poly[MAX_A + 5], res[2 * MAX_A + 5];

void fft(std::vector< std::complex< double > > &a, bool inverse) {
	int32_t n = a.size();

	if(n == 1) {
		return;
	}

	std::vector< std::complex< double > > a0(n / 2), a1(n / 2);
	for(int32_t i = 0; i < n / 2; i++) {
		a0[i] = a[2 * i];
		a1[i] = a[2 * i + 1];
	}

	fft(a0, inverse);
	fft(a1, inverse);

	double ang = 2 * PI / n * (inverse ? -1 : 1);
	std::complex< double > w(1), wn(cos(ang), sin(ang));

	for(int32_t i = 0; i < n / 2; i++) {
		a[i] = a0[i] + w * a1[i];
		a[i + n / 2] = a0[i] - w * a1[i];

		if(inverse) {
			a[i] /= 2;
			a[i + n / 2] /= 2;
		}

		w *= wn;
	}
}

void multiply() {
	std::vector< std::complex< double > > fa(MAX_A + 1);
	for(int32_t i = 1; i <= MAX_A; i++) {
		fa[i] = poly[i];
	}	

	int32_t n = 1;
	while(n < 2 * MAX_A) {
		n <<= 1;
	}

	fa.resize(n);

	fft(fa, false);

	for(int32_t i = 0; i < n; i++) {
		fa[i] *= fa[i];
	}

	fft(fa, true);

	for(int32_t i = 0; i < n; i++) {
		res[i] = round(fa[i].real());
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t n;
	std::cin >> n;
	
	for(int32_t i = 0; i < n; i++) {
		int32_t x;
		std::cin >> x;

		poly[x]++;
	}

	multiply();

	int32_t ans = 0;
	for(int32_t i = 1; i <= 2 * MAX_A; i++) {
		res[i] /= 2;
		if(i % 2 == 0) {
			res[i] -= (int64_t) poly[i] * (poly[i - 1]) / 2;
		}

		if(res[i] % 2 != 0) {
			ans ^= i;
		}
	}

	std::cout << ans << '\n';
}