#include <iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
using namespace std;
struct Node {
	Node* left;
	Node* right;
	int cnt;
	int priority;
	int a;
	int sum;
	Node(int a) :
		left(0),
		right(0),
		cnt(1),
		priority(rand()),
		a(a),
		sum(1){}
};
void update(Node* &v)
{
    if(!v)
    {
        return;
    }
	v->sum = v->cnt;
	if(!v ->left)
	{
	}
	else
	{
		v->sum += v->left->sum;
	}
	if (!v->right)
	{

	}
	else
	{
		v->sum += v->right->sum;
	}
}
void split(Node* root, Node* &l, Node* &r, int a)
{
	if (!root)
	{
		l = r = NULL;
		return;
	}
	if (root->a < a)
	{
		split(root->right, root->right, r, a);
		l = root;
		update(l);
	}
	else
	{
		split(root->left, l, root->left, a);
		r = root;
		update(r);
	}
}
void merge(Node* &l, Node* &r, Node* &v)
{
	if (!l)
	{
		v = r;
		update(v);
		return;
	}
	else if(!r)
	{
		v = l;
		update(v);
		return;
	}
	if (l->priority > r-> priority)
	{
		merge(l->right, r, l->right);
		v = l;
		update(v);
	}
	else
	{
		merge(l, r->left, r->left);
		v = r;
		update(v);
	}
}
bool find(Node* &root, int a)
{
	if (!root)
	{
		return false;
	}
    bool flag;
	if (root->a == a)
	{
		root->cnt++;
		root->sum++;
		return true;
	}
	if (root->a < a)
	{
		flag =  find(root->right, a);
	}
	else
	{
		flag = find(root->left, a);
	}
	update(root);
	return flag;
}
void dfs(Node* v)
{
    if(!v)
    {
        return;
    }
    dfs(v -> left);
    cout << v -> a << " ";
    dfs(v -> right);
}
void add(Node* &root, int j, int fl, int a)
{
    if(!root)
    {
        root = new Node(a);
        return;
    }
	if (find(root, a))
	{
		return;
	}
	Node* L;
	Node* R;
	split(root, L, R, a);
	Node*v = new Node(a);
	Node* L1;
	Node* R1;
	merge(L, v, L1);
	merge(L1, R, R1);
    root = R1;
}
int anstree(Node* root, int l, int r)
{
    if(l > r)
    {
        return 0;
    }
	Node* L;
	Node* R;
	Node* L1;
	Node* R1;
	split(root, L, R, r + 1);
	split(L, L1, R1, l);
	int ans = 0;
	if (!R1)
	{
		ans = 0;
	}
	else{
        ans = R1 -> sum;
	}
	merge(L1, R1, L);
	merge(L, R, root);
	return ans;

}
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector <int> A(n);
	for (int i = 0; i < n; i++)
	{
		cin >> A[i];
	}
	int ans = 0;
	vector <pair <Node*, Node*> > root(24);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j <= 23; j++)
		{
			int k = pow(2, j + 1);
			int cnt = 0;
			int e = k / 2;
            if (A[i] % k >= k / 2)
			{
				cnt = anstree(root[j].second, 0, k / 2 - (A[i] % e) - 1) + anstree(root[j].first, k / 2 - (A[i] %e), 1e9);
			}
			else
			{
				cnt = anstree(root[j].first, 0, k / 2 - (A[i] % e) - 1) + anstree(root[j].second, k / 2 - (A[i] % e), 1e9);
			}
			if(cnt == 0)
            {
                continue;
            }
			if (cnt % 2 == 1)
			{
				ans = (ans ^ (e));
			}
		}
		for (int j = 0; j <= 23; j++)
		{
			int k = pow(2, j + 1);
			int e = k / 2;
			if (A[i] % k >= k / 2)
			{
				add(root[j].first, j, 1, A[i] % e);
			}
			else
			{
				add(root[j].second, j, 0, A[i] % e);
			}
		}
	}
	cout << ans;
	//system("pause");
	return 0;
}
