//#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <sstream>
#include <random>
#include <bitset>
#include <time.h>

using namespace std;

#define int ll
#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
typedef long long ll;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

struct fenwick {
    int n;
    vector<int> f;
    fenwick (int _n) {
        n = _n;
        f.assign(n,0);
    }
    void update(int i, int v) {
        for (; i <= n; i += i & (-i)) {
            f[i] += v;
        }
    }
    int get_sum(int i) {
        int s = 0;
        for (; i > 0; i -= i & (-i)) {
            s += f[i];
        }
        return s;
    }
    int get(int L, int R) {
        return get_sum(R) - get_sum(L - 1);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> l(n), s(n), c(n + m);
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n + m; ++i) {
        cin >> c[i];
    }
    map<int, int> a;
    int pay = 0, raise = 0, ans = -INF, mx = 0, sum;
    for (int beg = 0; beg < n; ++beg) {
        pay = 0;
        raise = 0;
        mx = l[beg];
        for (int i = beg; i < n; ++i) {
            if (l[i] > mx || s[i] > c[l[i] - 1]) continue;
            int power = l[i];
            pay += s[i];
            raise += c[power - 1];
            ++a[power];
            while (a[power] > 1) {
                a[power] -= 2;
                ++power;
                ++a[power];
                raise += c[power - 1];
            }
            mx = max(mx, power);
        }
        sum = raise - pay;
        ans = max(ans, sum);
    }
    cout << ans << en;
    cout << en << en;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    srand(time(0));
    int D = 0, t = (D ? 3: 1);
    //cin >> t;
    while (t--) solve();
    return 0;
}