#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e9;
const int mx = 2010;
int n, m, l[mx], s[mx], c[mx], state_id_ptr;
vector<int> dp;
vector<vector<int> > state_id;

void update_dp(int ag, int cnt, int val) {
	// cerr << "update_dp " << ag << " " << cnt << " " << val << endl;
	while (state_id[ag].size() <= cnt) {
		dp.push_back(-INF);
		state_id[ag].push_back(state_id_ptr++);
	}
	chkmax(dp[state_id[ag][cnt]], val);
}

int get_dp(int ag, int cnt) {
	// cerr << "get_dp " << ag << " " << cnt << endl;
	if (state_id[ag].size() <= cnt) {
		return -INF;
	} else {
		return dp[state_id[ag][cnt]];
	}
}

void go() {
	for (int ag = 1; ag < n + m; ++ag) {
		for (int cnt = 0; cnt < state_id[ag].size(); ++cnt) {
			update_dp(ag + 1, cnt / 2, get_dp(ag, cnt) + c[ag + 1] * (cnt / 2));
		}
	}
}

void recalc_dp(int ag, int s) {
	// cerr << "recalc_dp " << ag << " " << s << endl;
	int max_cnt = (int)state_id[ag].size() - 1;
	for (int i = max_cnt; i >= 0; --i) {
		update_dp(ag, i + 1, get_dp(ag, i) - s + c[ag]);
	}
	go();
}

signed main() {
	fast_io();
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n + m; ++i) {
		cin >> c[i];
	}
	state_id.resize(n + m + 1);
	for (int i = 1; i <= n + m; ++i) {
		state_id[i] = {i - 1};
	}
	dp.resize(n + m, -INF);
	state_id_ptr = n + m;
	update_dp(1, 0, 0);
	go();
	for (int i = n - 1; i >= 0; --i) {
		recalc_dp(l[i], s[i]);
	}
	int ans = 0;
	for (int i = 1; i <= n + m; ++i) {
		for (int j = 0; j <= 1; ++j) {
			chkmax(ans, get_dp(i, j));
		}
	}
	cout << ans << endl; 
}
