#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    int *t;
    int default_value = 0;
    int n;

    int merge(int a, int b) {
        return a + b;
    }

private:
    void build(int v, int l, int r, int *arr) {
        if (r == l + 1) {
            t[v] = arr[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, arr);
        build(v * 2 + 1, m, r, arr);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos < l || pos >= r) {
            return;
        }
        if (r == l + 1) {
            t[v] = pos;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int al, int ar) {
        if (al <= l && r <= ar) {
            return t[v];
        }
        if (ar <= l || r <= al) {
            return default_value;
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, al, ar),
                     get(v * 2 + 1, m, r, al, ar));
    }

public:
    DO(int n, int *arr) : n(n) {
        t = new int[4 * n];
        build(1, 0, n, arr);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

};


int *clone(int *a, int n) {
    int *res = new int[n];
    for (int i = 0; i < n; ++i) {
        res[i] = a[i];
    }
    return res;
}

#define INF 100000
int n, m;
int *c;

int simulate(int *a) {
    int ans = 0;
    for (int i = 0; i < n + m; ++i) {
        ans += c[i + 1] * (a[i] / 2);
        a[i + 1] += a[i] / 2;
        a[i] %= 2;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    int l[n + 1];
    l[0] = INF;
    int s[n + 1];
    c = new int[n + m+5];
    for (int i = 1; i <= n; ++i) {
        cin >> l[i];
    }
    for (int j = 1; j <= n; ++j) {
        cin >> s[j];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    int dp1[n + 1];
    int *dp2[n + 1];
    memset(dp1, 0, sizeof(dp1));
    for (int i = 0; i <= n; ++i) {
        dp2[i] = new int[n + m + 5];
        for (int j = 0; j < n+m+5; ++j) {
            dp2[i][j] = 0;
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (l[j] < l[i]) {
                continue;
            }
            int *cp = clone(dp2[j], n + m + 5);
            cp[l[i]]++;
            int res = simulate(cp);
            res += c[l[i]];
            res -= s[i];
            res += dp1[j];
            if (dp1[i] < res) {
                dp1[i] = res;
                dp2[i] = cp;
            }
        }
        ans = max(ans,dp1[i]);
    }
    cout << ans;


    return 0;
}