#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

mt19937 gen(0);

struct node {
    ll val, pr, sz;
    node *l;
    node *r;

    node() {}

    node(ll x) {
        l = r = nullptr;
        val = x, pr = gen();
        sz = 1;
    }
};

ll get_size(node *v) {
    if (v == nullptr)
        return 0;
    return v->sz;
}
ll get_val(node *v) {
    if (v == nullptr)
        return -1;
    return v->val;
}

node *update(node *v) {
    if (v == nullptr)
        return v;
    v->sz = 1 + get_size(v->l) + get_size(v->r);
    return v;
}

pair<node *, node *> split(node *now, ll value) {
    if (now == nullptr) {
        return {nullptr, nullptr};
    }
    if (value > now->val) {
        auto[a, b] = split(now->r, value);
        a = update(a), b = update(b);
        now->r = a;
        now = update(now);
        return {now, b};
    } else {
        auto[a, b] = split(now->l, value);
        a = update(a), b = update(b);
        now->l = b;
        now = update(now);
        return {a, now};
    }
}

node *merge(node *a, node *b) {
    if (a == nullptr)
        return b;
    if (b == nullptr)
        return a;
    if (a->pr > b->pr) {
        node *v = merge(a->r, b);
        v = update(v);
        a->r = v;
        a = update(a);
        return a;
    } else {
        node *v = merge(a, b->l);
        v = update(v);
        b->l = v;
        b = update(b);
        return b;
    }
}

node *add(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    node *nw = new node(v);
    node *tmp = merge(r1, nw);
    root = merge(tmp, r2);
    return root;
}

pair<ll, node *> get_less(node *root, ll v) {
    auto[r1, r2] = split(root, v);
//    cout << v << ' ' << get_val(r1) << ' ' << get_val(r2) << ' ' << get_size(r1) << ' ' << get_size(r2) << endl;
    ll ans = get_size(r1);
    root = merge(r1, r2);
    return {ans, root};
}

pair<ll, node *> get_gr_or_eq(node *root, ll v) {
    auto[r1, r2] = split(root, v);
    ll ans = get_size(r2);
    root = merge(r1, r2);
    return {ans, root};
}

void print(node*root) {
    if(root == nullptr)
        return;
    print(root->l);
    cout << root->val << ' ' << root->pr << '\n';
    print(root->r);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    vector <ll> l(n), s(n);
    for(int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for(int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector <ll> c(n + m + 1);
    for(int i = 0; i < n + m; ++i) {
        cin >> c[i + 1];
    }
//    cout << "OK" << endl;
    m += 11;
    vector <ll> dp[6];
    for(int i = 0; i < 6; ++i) {
        dp[i].resize((1 << m));
        for(int j = 0; j < (1 << m); ++j) {
            dp[i][j] = -INF;
        }
    }
    dp[5][0] = 0;
    ll ans = 0;
    for(int chel = 0; chel < n; ++chel) {
        vector <ll> nw[6];
        for(int i = 0; i < 6; ++i) {
            nw[i].resize((1 << m));
            for(int j = 0; j < (1 << m); ++j) {
                nw[i][j] = -INF;
            }
        }
        for(int maxim = 5; maxim > 0; --maxim) {
            for (int mask = 0; mask < (1 << m); ++mask) {
                nw[maxim][mask] = max(dp[maxim][mask], nw[maxim][mask]);
                if(dp[maxim][mask] != -INF && maxim >= l[chel]) {
                    ll can = dp[maxim][mask];
                    ll new_mask = mask + (1 << (l[chel] - 1));

                    can += c[l[chel]];
                    ll nowa = l[chel];
                    for(int id = l[chel] - 1; id < m; ++id) {
                        if((mask & (1 << id)) == 0) {
                            break;
                        }
                        ++nowa;
                        can += c[nowa];
                    }
                    can -= s[chel];
//                    cout << chel << ' ' << maxim << ' ' << mask << ' ' << new_mask << ' ' << can << ' ' << dp[maxim][mask] << ' ' << nowa << ' ' << c[nowa] << '\n';
                    nw[l[chel]][new_mask] = max(nw[l[chel]][new_mask], can);
                    ans = max(ans, can);
                }
            }
        }
        swap(nw, dp);
    }
    cout << ans;
}