#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#define data ___BCVUIVRUIE
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
const int MAXN = 207;
const int MAXM = 207;
struct Person {
	int agr, cost;
};
int n, m;
Person data[MAXN];
ll dp[MAXN + MAXM][MAXN][MAXN]; // dp[val][cnt][rightmost]
vector<int> byAgr[MAXN + MAXM];
ll agrCost[MAXN + MAXM];
void relax(ll& x, ll y) {
	if(y > x) x = y;
}
void solve() {
	cin >> n >> m;
	for(int i = 0; i < n; ++i) cin >> data[i].agr;
	for(int i = 0; i < n; ++i) cin >> data[i].cost;
	for(int i = 1; i <= n + m; ++i) cin >> agrCost[i];
	reverse(data, data + n);
	for(int i = 0; i < n; ++i) {
		byAgr[data[i].agr].emplace_back(i);
	}
	for(int i = 0; i < MAXN + MAXM; ++i) {
		for(int j = 0; j < MAXN; ++j) {
			for(int k = 0; k < MAXN; ++k) {
				dp[i][j][k] = -LL_INF;
			}
		}
	}
	dp[0][0][0] = 0;
	for(int val = 0; val <= n + m; ++val) {
		for(int cnt = 0; cnt <= n; ++cnt) {
			for(int rightmost = 0; rightmost <= n; ++rightmost) {
				ll cur = dp[val][cnt][rightmost];
				if(cur <= -LL_INF) continue;
				if(val + 1 <= n + m) relax(dp[val + 1][cnt/2][rightmost], cur + (cnt/2) * agrCost[val + 1]);
				for(auto& i: byAgr[val]) {
					if(i >= rightmost) {
						relax(dp[val][cnt + 1][i + 1], cur - data[i].cost + agrCost[val]);
					} 
				}
			}
		}
	}
	ll answ = 0;
	for(int cnt = 0; cnt <= n; ++cnt) {
		for(int rightmost = 0; rightmost <= n; ++rightmost) {
			relax(answ, dp[n + m][cnt][rightmost]);
		}
	}
	cout << answ << '\n';
}
int main() {
	fastIO();
	solve();
	return 0;
}
