#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <cmath>

#define is(a, b) (a & (1 << b))

using namespace std;
using ll = long long;
using ld = long double;

const int INF = (int)1e9;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
    
	int n = 0, m = 0;
	cin >> n >> m;

	vector<int> l(n);
	for (int i = 0; i < n; ++i)
		cin >> l[i];

	vector<int> s(n);
	for (int i = 0; i < n; ++i)
		cin >> s[i];

	vector<int> c(n + m + 1);
	for (int i = 1; i <= n + m; ++i)
		cin >> c[i];

	if (m == 1)
	{
		sort(s.begin(), s.end());

		int maxSum = 0, paid = 0;
		for (int num = 0; num < n; ++num)
		{
			paid += s[num];
			int sum = -paid + c[1] * num;
			
			int left = num, cur = 1;
			while (left > 1)
			{
				left >>= 1;
				sum += c[cur + 1] * left;
			}
			maxSum = max(maxSum, sum);
		}

		cout << maxSum << endl;
		return 0;
	}

	int maxAns = 0;
	for (int mask = 0; mask < (1 << n); ++mask)
	{
		int sum = 0, minL = INF;
		bool ok = true;
		for (int i = 0; i < n; ++i)
		{
			if (is(mask, i))
			{
				if (l[i] > minL)
				{
					ok = false;
					break;
				}
				else
				{
					sum -= s[i];
					minL = l[i];
				}
			}
		}

		if (!ok)
			continue;

		vector<int> agr(m + 1);
		for (int i = 0; i < n; ++i)
			if (is(mask, i))
				agr[l[i]]++, sum += c[l[i]];

		for (int i = 0; i < agr.size(); ++i)
		{
			if (agr[i] > 1)
			{
				int cnt = (agr[i] >> 1);
				sum += c[i + 1] * cnt;
				if (i == agr.size() - 1)
					agr.push_back(0);

				agr[i + 1] += cnt;
			}
		}

		maxAns = max(maxAns, sum);
	}

	cout << maxAns << endl;

	return 0;
}