#include<bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;

const int MAXN = 2e3 + 5;
const int MAXBIT = 13;
const int MAXM = 5;

int n, m;
int agr[MAXN];
int cost[MAXN];
int benefit[2 * MAXN];

bool cmp(int i, int j) {
	return cost[i] < cost[j];
}

bool check_bit(int mask, int bit) {
	return mask & (1 << bit);
}

void solve() {
	int ans = 0;
	for (int mask = 1; mask < (1 << n); ++mask) {
		vector<int> counter(n + m + 2);
		int curcost = 0;
		int prev = 1e9;
		bool ok = true;
		for (int i = 0; i < n; ++i) {
			if (check_bit(mask, i)) {
				if (agr[i] > prev) ok = false;
				prev = agr[i];
				counter[agr[i]]++;
				curcost -= cost[i];
			}
		}
		if (!ok) continue;
		for (int i = 0; i <= n + m; ++i) {
			if (counter[i] == 0) continue;
			curcost += benefit[i] * counter[i];
			counter[i] /= 2;
			counter[i + 1] += counter[i];
		}
		ans = max(ans, curcost);
	}
	cout << ans << endl;
}

ll dp[MAXM][(1 << MAXBIT)];
ll newdp[MAXM][(1 << MAXBIT)];	

ll trans(int mask, int newagr) {
	int newmask = mask + (1 << newagr);
	ll res = 0;
	for (int i = 0; i < MAXBIT; ++i) {
		if (check_bit(mask, i) != check_bit(newmask, i)) res += benefit[i];
	}
	return res;
}

void outmask(int mask) {  
	for (int i = 0; i < 12; ++i) {
		if (check_bit(mask, i)) {
			cout << "i: " << i << endl;
		}
	}
	
}

ll transcost[(1 << MAXBIT)][MAXN];

void precalc() {
	for (int mask = 0; mask < (1 << MAXBIT); ++mask) {
		for (int i = 0; i < n - 1; ++i) {
			transcost[mask][i] = trans(mask, agr[i + 1]);
		}
	}
}

void solve1() {
	for (int j = 0; j < MAXM; ++j) {
		for (int mask = 0; mask < (1 << MAXBIT); ++mask) {
			dp[j][mask] = -1e18;
			newdp[j][mask] = -1e18;
		}
	}
	precalc();
	dp[agr[0]][(1 << agr[0])] = -cost[0] + benefit[agr[0]];
	dp[MAXM - 1][0] = 0;
	for (int i = 0; i < n - 1; ++i) {
		for (int j = 0; j < MAXM; ++j) {
			for (int mask = 0; mask < (1 << MAXBIT); ++mask) {
				if (dp[j][mask] == (ll) -1e18) continue;
				newdp[j][mask] = max(newdp[j][mask], dp[j][mask]);
				if (agr[i + 1] > j) continue;
				ll adding = transcost[mask][i];
				int newmask = mask + (1 << agr[i + 1]);
				if (newmask >= (1 << MAXBIT)) continue;
				newdp[agr[i + 1]][newmask] = max(newdp[agr[i + 1]][newmask], 
					dp[j][mask] + adding - (ll) cost[i + 1]);
			}
		}
		for (int j = 0; j < MAXM; ++j) {
			for (int mask = 0; mask < (1 << MAXBIT); ++mask) {
				dp[j][mask] = newdp[j][mask];
			}
		}
	}
	ll ans = 0;
	for (int j = 0; j < MAXM; ++j) {
		for (int mask = 0; mask < (1 << MAXBIT); ++mask) {
			ans = max(ans, dp[j][mask]);
		}
	}
	cout << ans << endl;
}

int main() {	
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> agr[i];
		--agr[i];
	}
	for (int i = 0; i < n; ++i) cin >> cost[i];
	for (int i = 0; i < n + m; ++i) {
		cin >> benefit[i];

	}
	//solve1();
	if (n <= 15 && m <= 15) solve();
	else solve1();
	return 0;
}