#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>

using namespace std;

vector <int> prof;

int fight(const vector <int>& agr) {
    vector <bool> app(4001);
    int pr = 0;

    for (int i : agr) {
        pr += prof[i - 1];
        while (app[i]) {
            app[i] = false;
            i++;
            pr += prof[i - 1];
        }
        app[i] = true;
    }

    return pr;
}

void slow_sol(int n, int m) {
    vector <int> agr(n);
    for (int& i : agr)
        cin >> i;

    vector <int> price(n);
    for (int& i : price)
        cin >> i;

    prof.resize(n + m);
    for (int& i : prof)
        cin >> i;

    int ans = 0;

    for (int mask = 0; mask < (1 << n); mask++) {
        vector <int> take;
        int now = 0;
        int mn = INT_MAX;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                if (agr[i] <= mn) {
                    take.push_back(agr[i]);
                    now -= price[i];
                    mn = min(mn, agr[i]);
                }
            }
        }

        ans = max(ans, fight(take) + now);
    }
    cout << ans << endl;
    exit(0);
}

signed main() {
    int n, m;
    cin >> n >> m;

    if (m != 1) {
        slow_sol(n, m);
    }

    vector <int> agr(n);
    for (int& i : agr)
        cin >> i;

    vector <int> price(n);
    for (int& i : price)
        cin >> i;

    sort(price.begin(), price.end());

    prof.resize(n + m);
    for (int& i : prof)
        cin >> i;

    int ans = 0;
    int pr = 0;
    vector <bool> app(4001);

    for (int i = 0; i < n; i++) {
        pr -= price[i];
        pr += prof[agr[i] - 1];
        while (app[i]) {
            app[agr[i]] = false;
            agr[i]++;
            pr += prof[agr[i] - 1];
        }
        app[i] = true;
        ans = max(ans, pr);
    }
    cout << ans << endl;
    return 0;
}
