#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 2000;
const int MAXC = 5000;

const int INF = 1000000000000000000;

int n, m;
int l[MAXN], s[MAXC], c[2 * MAXN + 7];

int tr(int mask) {
    vector<int> part;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            if (!part.empty() && part.back() < l[i]) {
                return -INF;
            }
            part.push_back(l[i]);
            ans -= s[i];
            ans += c[l[i]];
        }
    }
    while (!part.empty()) {
        int k = part.back();
        int cnt_k = 1;
        part.pop_back();
        while (!part.empty() && part.back() == k) {
            ++cnt_k;
            part.pop_back();
        }
        ans += c[k + 1] * (cnt_k / 2);
        for (int i = 0; i < cnt_k / 2; ++i) {
            part.push_back(k + 1);
        }
    }
    return ans;
}

void solve1() {
    int ans = -INF;
    for (int mask = 0; mask < 1 << n; ++mask) {
        ans = max(ans, tr(mask));
    }
    cout << ans << '\n';
}

int e5[207][407][207];
int dp[MAXN][MAXN];

void cmpt_e5() {
    for (int i = 1; i <= m; ++i) {
        for (int j = i + 1; j <= n + m; ++j) {
            for (int k = 1; k <= n; ++k) {
                e5[i][j][k] = e5[i][j - 1][k] + c[j] * (k >> (j - i));
            }
        }
    }
}

void go_dp5() {
    for (int i = 0; i <= n; ++i) {
        dp[0][i] = e5[l[0]][n + m][i];
        dp[0][i] += c[l[0]];
        dp[0][i] -= s[0];
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j < n; ++j) {
            dp[i][j] = e5[l[i]][n + m][j];
            for (int x = i - 1; x >= 0; --x) {
                if (l[x] - l[i] >= 0) {
                    dp[i][j] = max(dp[i][j], dp[x][1 + (j >> (l[x] - l[i]))] + e5[l[i]][l[x]][j]);
                }
            }
            dp[i][j] += c[l[i]];
            dp[i][j] -= s[i];
        }
    }

}

void solve5() {
    cmpt_e5();
    go_dp5();
    int ans = -INF;
    for (int i = 0; i < n; ++i) {
        ans = max(ans, dp[i][1]);
    }
    cout << ans << '\n';
}

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    if (n <= 15) {
        solve5();
        return 0;
    }
    solve5();
    return 0;
}