﻿#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

const int lg = 8;

void cut(vector<int> &mask) {
    int pos = (int)mask.size() - 1;
    for (int i = lg; i < (int)mask.size(); i++) {
        if (mask[i] == 0) {
            pos = i;
            break;
        }
    }
    mask.resize(pos + 1);
}

void print(vector<int> &mask) {
    for (int i = 0; i < (int)mask.size(); i++) cout << mask[i] << ' ';
    cout << endl;
}

void extend(vector<int> &mask, int delta) {
    reverse(mask.begin(), mask.end());
    for (int i = 0; i < delta; i++) mask.push_back(0);
    reverse(mask.begin(), mask.end());
    cut(mask);
}

int plus1(vector<int> &mask) {
    int pos = (int)mask.size();
    for (int i = 0; i < (int)mask.size(); i++) {
        if (mask[i] == 1) mask[i] = 0;
        else {
            mask[i] = 1;
            pos = i;
            break;
        }
    }
    cut(mask);
    return pos;
}

int main()
{
    //ifstream cin("input.txt");
    int n, m;
    cin >> n >> m;
    vector<int> l(n + 1, m);
    for (int i = 0; i < n; i++) cin >> l[i + 1], l[i + 1]--;
    vector<int> s(n);
    for (int i = 0; i < n; i++) cin >> s[i];
    vector<int> c(n + m);
    for (int i = 0; i < n + m; i++) cin >> c[i];
    vector<ll> pref(n + m + 1);
    for (int i = 0; i < n + m; i++) {
        pref[i + 1] = pref[i] + c[i];
    }
    vector<vector<int> > sets(m + 1);
    for (int i = 0; i <= n; i++) {
        sets[l[i]].push_back(i);
    }
    vector<map<vector<int>, ll> > dp(n + 1);
    vector<int> mask0(lg);
    dp[0][mask0] = 0;
    for (int i = 0; i < n; i++) {
        //cout << "i = " << i << endl;
        for (auto &elem : dp[i]) {
            auto mask = elem.first;
            //cout << "mask: ";
            //print(mask);
            ll val = elem.second;
            for (int nxt = l[i]; nxt >= 0; nxt--) {
            /*for (int j = i + 1; j <= n; j++) {*/
                int ind = upper_bound(sets[nxt].begin(), sets[nxt].end(), i) - sets[nxt].begin();
                if (ind == sets[nxt].size()) continue;
                int j = sets[nxt][ind];
                //if (l[j] > l[i]) continue;
                auto mask1 = mask;
                extend(mask1, l[i] - l[j]);
                int len = plus1(mask1);
                //cout << "mask1: ";
                //print(mask1);
                ll delta = pref[l[j] + len + 1] - pref[l[j]] - s[j - 1];
                if (dp[j].find(mask1) == dp[j].end() || dp[j][mask1] < val + delta) {
                    dp[j][mask1] = val + delta;
                }
            }
        }
    }
    ll ans = 0;
    for (int i = 0; i <= n; i++) {
        for (auto &elem : dp[i]) {
            ans = max(ans, elem.second);
        }
    }
    cout << ans << endl;
}
