#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


const int INF = (int)1e9;


const int MAXN = 201;


int loss[MAXN];
int dp[MAXN][MAXN][MAXN];
vector<int> a, s, c;


int ones(int i) {
    int res = 0;
    int cur = i;
    int pow = 0;
    while (cur) {
        res += c[pow] * cur;

        cur /= 2;
        ++pow;
    }

    return res;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    a.resize(n);
    s.resize(n);
    c.resize(n + m);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];

        --a[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    for (int i = 0; i < n + m; ++i) {
        cin >> c[i];
    }

    reverse(a.begin(), a.end());
    reverse(s.begin(), s.end());

    for (int i = 1; i < MAXN; ++i) {
        for (int j = 1; j <= i; ++j) {
            loss[i] += (1 << j) * c[i - j];
        }
    }

    for (int i = 0; i < n; ++i) {
        s[i] += loss[a[i]];
    }

    for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            for (int k = 0; k < MAXN; ++k) {
                dp[i][j][k] = -INF;
            }
        }
    }

    dp[0][0][0] = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] < j) {
                continue;
            }

            int nj = a[i];
            int ni = i + 1;

            for (int k = 0; k < MAXN; ++k) {
                dp[ni][j][k] = dp[i][j][k];

                int nk = k + (1 << a[i]);

                dp[ni][nj][nk] = max(dp[ni][nj][nk], dp[i][j][k] + ones(nk));
            }
        }
    }

    int answ = 0;
    for (int j = 0; j < MAXN; ++j) {
        for (int k = 0; k < MAXN; ++k) {
            answ = max(answ, dp[n][j][k]);
        }
    }

    cout << answ;

    return 0;
}

/*

5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -100 -5 3 10 -4

*/