#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>

using ll = long long;
using namespace std;

//#define int long long
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define per(i, a, b) for (int i = (a) - 1; i >= (b); --i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair

vector<ll> l, s, c;
int n, m;

void slow() {
    int M = (1 << (n + 1));
    ll ans = 0;
    rep(mask, 0, M) {
        vector<int> pos;
        rep(j, 0, n) if ((mask >> j) % 2) pos.pb(j);
        bool ok = true;
        per(j, pos.size() - 1, 0) if (l[pos[j + 1]] > l[pos[j]]) ok = false;
        if (!ok) continue;
        vector<int> cnt(n + m, 0);
        rep(j, 0, pos.size()) cnt[l[pos[j]]]++;
        ll cur = 0;
        rep(j, 0, pos.size()) cur -= s[pos[j]];
        cur += cnt[0] * c[0];
        rep(j, 1, n + m) {
            cnt[j] += cnt[j - 1] / 2;
            cur += cnt[j] * c[j];
        }
        ans = max(ans, cur);
    }
    cout << ans << '\n';
}

vector<ll> model(vector<ll>& cur, ll val) {
    vector<int> cnt(n + m, 0);
    rep(i, 0, cur.size()) cnt[cur[i]]++;
    while (cnt[val] >= 1) cnt[val] = 0, val++;
    cnt[val] = 1;
    vector<ll> ans;
    rep(i, 0, n + m) if (cnt[i] != 0) ans.pb(i);
    return ans;
}

ll get(vector<ll>& cur, ll val) {
    vector<int> cnt(n + m, 0);
    rep(i, 0, cur.size()) cnt[cur[i]]++;
    ll ans = c[val];
    while (cnt[val] >= 1) cnt[val] = 0, val++, ans += c[val];
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    cin >> n >> m;
    l.resize(n);
    s.resize(n);
    c.resize(n + m);
    rep(i, 0, n) cin >> l[i], l[i]--;
    rep(i, 0, n) cin >> s[i];
    rep(i, 0, n + m) cin >> c[i];
    if (n <= 15) return slow(), 0;
    vector<ll> dp(n);
    vector<vector<ll>> last(n);
    dp[n - 1] = c[l[n - 1]] - s[n - 1];
    last[n - 1] = { l[n - 1] };
    per(i, n - 1, 0) {
        dp[i] = c[l[i]] - s[i];
        last[i] = { l[i] };
        rep(j, i + 1, n) {
            if (l[j] > l[i]) continue;
            ll cur = get(last[j], l[i]) + dp[j] - s[i];
            if (dp[i] <= cur) {
                dp[i] = cur;
                last[i] = model(last[j], l[i]);
            }
        }
    }
    ll ans = max(0LL, *max_element(dp.begin(), dp.end()));
    rep(i, 0, n) ans = max(ans, c[l[i]] - s[i]);
    cout << ans << '\n';
}
