#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

const int inf = 1e18;

struct Solver {
    int n, m;
    vector<int> l, s, c;

    Solver(auto n, auto m, auto l, auto s, auto c):
           n(n), m(m), l(l), s(s), c(c) {
    }

    vector<int> stupid_mask(int mask) {
        vector<int> v;
        for(int i = 0; i < n; ++i) {
            if(mask % 2) v.push_back(i);
            mask /= 2;
        }

        int mn = m;
        for(int i : v) {
            if(l[i] > mn) return {};
            mn = min(mn, l[i]);
        }

        return v;
    }

    int stupid_simulate(vector<int> p) {
        int sum = 0;
        for(int i : p)
            sum -= s[i];

        set<int> scene;

        for(int i0 : p) {
            int i = l[i0];

            while(scene.count(i)) {
                sum += c[i];
                scene.erase(i);
                i++;
            }

            scene.insert(i);
            sum += c[i];
        }

        return sum;
    }

    int stupid() {
        int res = 0;
        for(int i = 0; i < pow(2, n); ++i) {
            vector<int> p = stupid_mask(i);
            if(p.empty()) continue;
            int cur = stupid_simulate(p);
            res = max(res, cur);
        }

        return res;
    }

    int solve() {
        return stupid();
    }
};

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = (stress ? 100 : 1);
    if((local) && (!stress)) cin >> tests;

    while(tests--) {
        if(!stress) {
            int n, m;
            cin >> n >> m;

            vector<int> l(n);
            for(int i = 0; i < n; ++i)
                cin >> l[i], l[i]--;

            vector<int> s(n);
            for(int i = 0; i < n; ++i)
                cin >> s[i];

            vector<int> c(n+m);
            for(int i = 0; i < n+m; ++i)
                cin >> c[i];

            Solver solver(n, m, l, s, c);
            int res = solver.solve();
            cout << res << "\n";

        } else {}
    }

    return 0;
}
