#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct DO {
    int *t;
    int default_value = 0;
    int n;

    int merge(int a, int b) {
        return a + b;
    }

private:
    void build(int v, int l, int r, int *arr) {
        if (r == l + 1) {
            t[v] = arr[l];
            return;
        }
        int m = (r + l) / 2;
        build(v * 2, l, m, arr);
        build(v * 2 + 1, m, r, arr);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (pos < l || pos >= r) {
            return;
        }
        if (r == l + 1) {
            t[v] = pos;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, pos, val);
        update(v * 2 + 1, m, r, pos, val);
        t[v] = merge(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int al, int ar) {
        if (al <= l && r <= ar) {
            return t[v];
        }
        if (ar <= l || r <= al) {
            return default_value;
        }
        int m = (r + l) / 2;
        return merge(get(v * 2, l, m, al, ar),
                     get(v * 2 + 1, m, r, al, ar));
    }

public:
    DO(int n, int *arr) : n(n) {
        t = new int[4 * n];
        build(1, 0, n, arr);
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    void update(int pos, int val) {
        update(1, 0, n, pos, val);
    }

};

#define INF 1000
int n, m;
vector<int> l, s, c;

vector<int> cur;
vector<int> cnt;
int ans = 0;

void done() {
    int res = 0;
    for (int i = 0; i < n; ++i) {
        if (!cur[i]) {
            continue;
        }
        res += c[l[i]];
        res -= s[i];
        cnt[l[i]]++;

        int ind = l[i];
        while (cnt[ind] == 2) {
            res += c[ind + 1];
            cnt[ind] = 0;
            cnt[ind + 1]++;
            ind++;
        }
    }
    fill(cnt.begin(), cnt.end(), 0);
    ans = max(ans, res);

}

void gen(int x, int mx = INF) {
    if (x == n) {
        done();
        return;
    }
    if (l[x] <= mx) {
        cur[x] = 1;
        gen(x + 1, l[x]);
    }
    cur[x] = 0;
    gen(x + 1, mx);

}

void solve0() {
    cnt.resize(n + m + 5);
    cur.resize(n);
    gen(0);
    cout << ans;
}

void solve1() {
    sort(s.begin(), s.end());
    cnt.resize(n + m + 5);
    int res = 0;
    for (int i = 0; i < n; ++i) {
        res += c[l[i]];
        res -= s[i];
        cnt[l[i]]++;

        int ind = l[i];
        while (cnt[ind] == 2) {
            res += c[ind + 1];
            cnt[ind] = 0;
            cnt[ind + 1]++;
            ind++;
        }
        ans = max(ans, res);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    l.resize(n);
    s.resize(n);
    c.resize(n + m + 5);
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int j = 0; j < n; ++j) {
        cin >> s[j];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    if (m != 1) {
        solve0();
    } else {
        solve1();
    };


    return 0;
}