#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll solve(vector<ll> &value, vector<ll> &price)
{
    vector<ll> vsum(value.size());
    vsum[0] = value[0];
    for (int i = 1; i < value.size(); i++)
        vsum[i] = vsum[i - 1] + value[i];

    sort(price.begin(), price.end());
    ll psum = 0;
    ll csum = 0;
    ll ans = 0;
    for (int i = 0; i < price.size(); i++)
    {
        psum += price[i];
        for (int j = 0; j < 30; j++)
        {
            if ((i + 1) & (1 << j))
            {
                csum += vsum[j];
                ans = max(ans, csum - psum);
                break;
            }
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<ll> agg(n);
    for (int i = 0; i < n; i++)
    {
        cin >> agg[i];
        agg[i]--;
    }

    vector<ll> price(n);
    for (int i = 0; i < n; i++)
        cin >> price[i];

    vector<ll> value(n + m);
    for (int i = 0; i < n + m; i++)
        cin >> value[i];

    if (m == 1)
        return cout << solve(value, price) << endl, 0;

    if (m == 2)
    {
        vector<ll> mvalue;
        for (int i = 1; i < n + m; i++)
            mvalue.push_back(value[i]);

        ll ans = 0;
        vector<ll> mprice;
        for (int i = 0; i < n; i++)
        {
            if (agg[i] == 1)
            {
                vector<ll> rprice;
                for (int j = i; j < n; j++)
                    if (agg[j] == 1)
                        rprice.push_back(price[j]);

                ans = max(ans, solve(mvalue, mprice) + solve(value, rprice));
            }
            else
                mprice.push_back(price[i]);
        }

        cout << max(ans, solve(mvalue, mprice)) << endl;
        return 0;
    }

    ll ans = -9e18;
    for (int mask = 0; mask < (1 << n); mask++)
    {
        ll cur = 0;
        vector<int> stage(n + m, 0);
        ll ltook = 9e18;
        for (int i = 0; i < n; i++)
        {
            if (((1 << i) & mask) == 0)
                continue;
            if (agg[i] > ltook)
                cur = -9e18;

            stage[agg[i]]++;
            ltook = agg[i];
            cur += value[agg[i]];
            cur -= price[i];

            for (int j = 0; j < n + m - 1; j++)
            {
                if (stage[j] == 2)
                {
                    stage[j] = 0;
                    stage[j + 1]++;
                    cur += value[j + 1];
                }
            }
        }

        ans = max(ans, cur);
    }

    cout << ans << endl;

    return 0;
}