#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <iterator>
#include <iomanip>
#include <utility>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <climits>
#include <numeric>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
using namespace std;
#define int long long
vector<bool> used, covered;
vector<int> matched;
vector<vector<int>> g;
bool trykuhn(int v) {
	used[v] = true;
	for (auto x : g[v]) {
		if (matched[x] == -1 || !used[matched[x]]) {
			used[x] = true;
			if (matched[x] == -1 || trykuhn(matched[x])) {
				matched[x] = v;
				return true;
			}
		}
	}
	return false;
}
struct fenwick {
	int n;
	vector<int> f;
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
	void add(int i, int val) {
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i)
			ans += f[i];
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
};
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	srand(time(0));
	int n, m;
	cin >> n >> m;
	vector<int> l(n), s(n), c(n + m + 1);
	for (int i = 0; i < n; ++i) cin >> l[i];
	for (int i = 0; i < n; ++i) cin >> s[i];
	for (int i = 1; i <= n + m; ++i) cin >> c[i];
	if (m == 1) {
		int ans = 0, sum = 0;
		sort(s.begin(), s.end());
		vector<int> cnt(n + m + 1, 0);
		for (int i = 0; i < n; ++i) {
			sum -= s[i];
			int kek = l[i];
			cnt[kek]++;
			sum += c[kek];
			while (cnt[kek] > 1) {
				cnt[kek] = 0;
				kek++;
				cnt[kek]++;
				sum += c[kek];
			}
			ans = max(ans, sum);
		}
		cout << ans;
	}
	else if (m == 2) {
		int ans = 0;
		vector<vector<int>> rage(3);
		for (int i = 0; i < n; ++i) {
			rage[l[i]].push_back(s[i]);
		}
		vector<int> cnt(n + m + 1,0);
		sort(rage[1].begin(), rage[1].end());
		sort(rage[2].begin(), rage[2].end());
		for (int k1 = 0; k1 <= rage[1].size(); ++k1) {
			for (int k2 = 0; k2 <= rage[2].size(); ++k2){
				int sum = 0;
				for (int i = 0; i < k1; ++i) {
					sum -= rage[1][i];
					int kek = 1;
					cnt[kek]++;
					sum += c[kek];
					while (cnt[kek] > 1) {
						cnt[kek] = 0;
						kek++;
						cnt[kek]++;
						sum += c[kek];
					}
					ans = max(ans, sum);
				}
				for (int i = 0; i < k2; ++i) {
					sum -= rage[2][i];
					int kek = 2;
					cnt[kek]++;
					sum += c[kek];
					while (cnt[kek] > 1) {
						cnt[kek] = 0;
						kek++;
						cnt[kek]++;
						sum += c[kek];
					}
					ans = max(ans, sum);
				}
			}
		}
		cout << ans;
	}
	else {
		int ans = 0;
		for (int mask = 0; mask < ((int)1 << n); ++mask) {
			int sum = 0, mi = 1e9;
			vector<int> cnt(n + m + 1, 0);
			for (int i = 0; i < n; ++i) {
				if (!(mask & (1 << i))) continue;
				if (l[i] > mi) continue;
				mi = min(mi, l[i]);
				sum -= s[i];
				int kek = l[i];
				cnt[kek]++;
				sum += c[kek];
				while (cnt[kek] > 1) {
					cnt[kek] = 0;
					kek++;
					cnt[kek]++;
					sum += c[kek];
				}
			}
			ans = max(ans, sum);
		}
		cout << ans;
	}
}