#include <bits/stdc++.h>

using namespace std;

#define int long long

class SegmentTree {
public:
	vector<int> a;
	int n;

	SegmentTree(int sz) {
		n = sz;
		a.resize(4 * n);
	}

	int get(int v, int vl, int vr, int l, int r) {
		if(vl == l && vr == r) {
			return a[v];
		}
		int vm = (vl + vr) / 2;
		if(r <= vm) {
			return get(v * 2, vl, vm, l, r);
		} else if(l >= vm) {
			return get(v * 2 + 1, vm, vr, l, r);
		} else {
			return max(get(v * 2, vl, vm, l, vm), get(v * 2 + 1, vm, vr, vm, r));
		}
	}
	int get(int l, int r) {
		return get(1, 0, n, l, r);
	}
	int get(int i) {
		return get(i, i + 1);
	}

	void set(int v, int vl, int vr, int i, int x) {
		if(vr - vl == 1) {
			a[v] = x;
			return;
		}
		int vm = (vl + vr) / 2;
		if(i < vm) {
			set(v * 2, vl, vm, i, x);
		} else {
			set(v * 2 + 1, vm, vr, i, x);
		}
		a[v] = max(a[v * 2], a[v * 2 + 1]);
	}
	void set(int i, int x) {
		set(1, 0, n, i, x);
	}
};

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<int> l(n), s(n);
	for(int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for(int i = 0; i < n; i++) {
		cin >> s[i];
	}
	vector<int> c(n + m + 1);
	for(int i = 1; i <= n + m; i++) {
		cin >> c[i];
	}

	vector< vector<int> > dp(n, vector<int>(n + 1));
	vector< vector<int> > ltobest(n + 1, vector<int>(m + 1, -1000000000000000LL));
	vector<SegmentTree> ltobestst(n + 1, m + 1);

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < n; j++) {
			int cur = 0;
			int cnt = j + 1;
			for(int curl = l[i]; cnt > 0; curl++) {
				cur += c[curl] * cnt;
				cnt /= 2;
			}
			dp[i][j] = cur;
		}

		for(int j = 0; j < n; j++) {
			dp[i][j] = max(dp[i][j], ltobest[j + 1][l[i]]);
		}

		for(int j = 0; j < n; j++) {
			int cur = 0;
			int cnt = j + 1;
			int curl;
			for(curl = l[i]; cnt > 0; curl++) {
				if(curl > l[i] && curl <= m) {
					dp[i][j] = max(dp[i][j], ltobest[cnt][curl] + cur);
				}
				cur += c[curl] * cnt;
				cnt /= 2;
			}

			if(curl < m + 1) {
				int s = ltobestst[cnt].get(curl, m + 1);
				dp[i][j] = max(dp[i][j], s + cur);
			}
		}

		for(int j = 0; j < n; j++) {
			dp[i][j] -= s[i];
		}

		for(int j = 0; j < n; j++) {
			ltobest[j][l[i]] = max(ltobest[j][l[i]], dp[i][j]);
			ltobestst[j].set(l[i], ltobest[j][l[i]]);
		}
	}

	int ans = 0;
	for(int i = 0; i < n; i++) {
		ans = max(ans, dp[i][0]);
	}
	cout << ans << endl;

	return 0;
}