#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>
#include <functional>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

struct Fen {
    int n;
    vector<int> t;

    Fen(int n) : n(n), t(n) {}

    void clear() {
        t.assign(n, 0);
    }

    void upd(int i, int v) {
        for (; i < n; i = (i | (i + 1))) {
            t[i] += v;
        }
    }

    int get(int i) {
        int res = 0;
        for (i = min(i, n - 1); i >= 0; i = (i & (i + 1)) - 1) {
            res += t[i];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    int m = input();

    vector<int> l(n), s(n), c(n + m);
    for (int &i : l) {
        i = input() - 1;
    }
    for (int &i : s) {
        cin >> i;
    }
    for (int &i : c) {
        cin >> i;
    }
    if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            bool good = true;
            int res = 0;
            vector<int> cur;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) {
                    if (cur.empty() || cur.back() >= l[i]) {
                        cur.emplace_back(l[i]);
                        res -= s[i];
                    } else {
                        good = false;
                        break;
                    }
                }
            }
            vector<int> st;
            for (int agr : cur) {
                res += c[agr];
                while (!st.empty() && st.back() == agr) {
                    st.pop_back();
                    ++agr;
                    res += c[agr];
                }
                st.emplace_back(agr);
            }
            if (good) {
                ans = max(ans, res);
            }
        }
        cout << ans << endl;
        return 0;
    }
}
