#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native,sse,sse2,sse3,avx,mmx")
#pragma GCC optimize("unroll-loops,no-stack-protector,btr-bb-exclusive,fast-math")

#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2000;

class SegmentTree {
public:
	int a[4 * (MAXN + 1)];
	int n;

	SegmentTree() {
		n = MAXN + 1;
		for(int i = 0; i < 4 * n; i++) {
			a[i] = -1000000000;
		}
	}

	int get(int v, int vl, int vr, int l, int r) {
		if(vl == l && vr == r) {
			return a[v];
		}
		int vm = (vl + vr) / 2;
		if(r <= vm) {
			return get(v * 2, vl, vm, l, r);
		} else if(l >= vm) {
			return get(v * 2 + 1, vm, vr, l, r);
		} else {
			return max(get(v * 2, vl, vm, l, vm), get(v * 2 + 1, vm, vr, vm, r));
		}
	}
	int get(int l, int r) {
		return get(1, 0, n, l, r);
	}
	int get(int i) {
		return get(i, i + 1);
	}

	void set(int v, int vl, int vr, int i, int x) {
		if(vr - vl == 1) {
			a[v] = x;
			return;
		}
		int vm = (vl + vr) / 2;
		if(i < vm) {
			set(v * 2, vl, vm, i, x);
		} else {
			set(v * 2 + 1, vm, vr, i, x);
		}
		a[v] = max(a[v * 2], a[v * 2 + 1]);
	}
	void set(int i, int x) {
		set(1, 0, n, i, x);
	}
};

int l[MAXN];
int s[MAXN];
int c[MAXN * 2 + 1];
int dp[MAXN][MAXN];
int ltobest[MAXN + 1][MAXN + 1];
SegmentTree ltobestst;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	for(int i = 0; i < n; i++) {
		cin >> l[i];
	}
	for(int i = 0; i < n; i++) {
		cin >> s[i];
	}
	for(int i = 1; i <= n + m; i++) {
		cin >> c[i];
	}

	for(int i = 0; i <= n; i++) {
		for(int j = 0; j <= n; j++) {
			ltobest[i][j] = -1000000000;
		}
	}

	for(int i = 0; i < n; i++) {
		for(int j = 0; j < n; j++) {
			int cur = 0;
			int cnt = j + 1;
			for(int curl = l[i]; cnt > 0; curl++) {
				cur += c[curl] * cnt;
				cnt /= 2;
			}
			dp[i][j] = cur;
		}

		for(int j = 0; j < n; j++) {
			dp[i][j] = max(dp[i][j], ltobest[j + 1][l[i]]);
		}

		for(int j = 0; j < n; j++) {
			int cur = 0;
			int cnt = j + 1;
			int curl;
			for(curl = l[i]; cnt > 0; curl++) {
				if(curl > l[i] && curl <= m) {
					dp[i][j] = max(dp[i][j], ltobest[cnt][curl] + cur);
				}
				cur += c[curl] * cnt;
				cnt /= 2;
			}

			if(curl < m + 1) {
				int s = ltobestst.get(curl, m + 1);
				dp[i][j] = max(dp[i][j], s + cur);
			}
		}

		for(int j = 0; j < n; j++) {
			dp[i][j] -= s[i];
		}

		for(int j = 0; j < n; j++) {
			ltobest[j][l[i]] = max(ltobest[j][l[i]], dp[i][j]);
		}
		ltobestst.set(l[i], ltobest[0][l[i]]);
	}

	int ans = 0;
	for(int i = 0; i < n; i++) {
		ans = max(ans, dp[i][0]);
	}
	cout << ans << endl;

	return 0;
}