#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

int solve1(int n, int m){
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        a[i]--;
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }
    sort(s.begin(), s.end());
    vector<int> c(n + m);
    for (int i = 0; i < n + m; i++){
        cin >> c[i];
    }

    int ans = 0;
    int sum = 0;
    for (int i = 0; i < n; i++){
        sum -= s[i];
        int cur = sum;
        int cnt = i + 1;
        int now = 0;
        while (cnt > 0){
            cur += (cnt * c[now]);
            now++;
            cnt /= 2;
        }
        ans = max(ans, cur);
    }
    return ans;
}

int solve2(int n, int m){
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        a[i]--;
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }
    vector<int> c(n + m);
    for (int i = 0; i < n + m; i++){
        cin >> c[i];
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++){
        int mn = 1e9;
        bool good = true;
        int cur = 0;
        vector<int> cnt(n + m, 0);
        for (int i = 0; i < n; i++){
            if ((mask >> i) & 1){
                if (a[i] > mn){
                    good = false;
                    break;
                }
                mn = min(mn, a[i]);
                cur -= s[i];
                cnt[a[i]]++;
            }
        }
        if (!good){
            continue;
        }
        for (int i = 0; i < n + m; i++){
            cur += (cnt[i] * c[i]);
            if (i < n + m - 1){
                cnt[i + 1] += (cnt[i] / 2);
            }
        }
        ans = max(ans, cur);
    }
    return ans;
}

int count(vector<int> cnt, vector<int> & c){
    int ans = 0;
    for (int i = 0; i < cnt.size(); i++){
        ans += c[i] * cnt[i];
        if (i < cnt.size() - 1){
            cnt[i + 1] += cnt[i] / 2;
        }
    }
    return ans;
}

int solve3(int n, int m){
    vector<int> a(n);
    vector<int> s(n);
    vector<int> c(n + m);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }
    for (int i = 0; i < n + m; i++){
        cin >> c[i];
    }
    vector<vector<pair<int, vector<int> > > > dp(n + 1, vector<pair<int, vector<int> > >(m + 1));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            dp[i][j] = {0, vector<int>(n + m)};
        }
    }
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            dp[i + 1][j] = dp[i][j];
        }
        for (int j = a[i]; j < m; j++){
            vector<int> sup = dp[i][j].second;
            sup[a[i]]++;
            int now = dp[i][j].first - s[i] + count(sup, c);
            if (now > dp[i + 1][a[i]].first + count(dp[i + 1][a[i]].second, c)){
                dp[i + 1][a[i]] = {dp[i][j].first - s[i], sup};
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < m + 1; i++){
        ans = max(ans, dp[n][i].first + count(dp[n][i].second, c));
    }
    return ans;
}

signed main()
{
    freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    //solve3(n, m);
    if (m == 1){
        cout << solve1(n, m);
    }else if (n <= 15 && m <= 15){
        cout << solve2(n, m);
    }else{
        cout << solve3(n, m);
    }
    return 0;
}
