#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int n, m;
vector<ll> agg;
vector<ll> price;
vector<ll> value;

ll profit(vector<ll> num)
{
    ll ans = 0;

    for (int i = 0; i < num.size(); i++)
    {
        ans += num[i] * value[i];
        if (i != num.size() - 1)
            num[i + 1] += num[i] / 2;
    }

    return ans;
}

ll solve_for_price(vector<ll> p, int idx)
{
    sort(p.begin(), p.end());

    ll ans = 0;
    ll psum = 0;
    for (int i = 0; i < p.size(); i++)
    {
        psum += p[i];

        vector<ll> num(m + 20);
        num[idx] = i + 1;

        ans = max(ans, profit(num) - psum);
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;

    agg.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> agg[i];
        agg[i]--;
    }

    price.resize(n);
    for (int i = 0; i < n; i++)
        cin >> price[i];

    value.resize(n + m);
    for (int i = 0; i < n + m; i++)
        cin >> value[i];

    if (m == 1)
        return cout << solve_for_price(price, 0) << endl, 0;

    if (m == 2)
    {
        ll ans = 0;
        vector<ll> mprice;
        for (int i = 0; i < n; i++)
        {
            if (agg[i] == 0)
            {
                vector<ll> rprice;
                for (int j = i; j < n; j++)
                    if (agg[j] == 1)
                        rprice.push_back(price[j]);

                ans = max(ans, solve_for_price(mprice, 1) +
                               solve_for_price(rprice, 0));
            }
            else
                mprice.push_back(price[i]);
        }

        cout << max(ans, solve_for_price(mprice, 1)) << endl;
        return 0;
    }

    ll ans = -9e18;
    for (int mask = 0; mask < (1 << n); mask++)
    {
        ll cur = 0;
        vector<int> stage(n + m, 0);
        ll ltook = 9e18;
        for (int i = 0; i < n; i++)
        {
            if (((1 << i) & mask) == 0)
                continue;
            if (agg[i] > ltook)
                cur = -9e18;

            stage[agg[i]]++;
            ltook = agg[i];
            cur += value[agg[i]];
            cur -= price[i];

            for (int j = 0; j < n + m - 1; j++)
            {
                if (stage[j] == 2)
                {
                    stage[j] = 0;
                    stage[j + 1]++;
                    cur += value[j + 1];
                }
            }
        }

        ans = max(ans, cur);
    }

    cout << ans << endl;

    return 0;
}