#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define INF 0x7fffffffffffffffLL;

template <class T>
inline void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
inline void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

bool bit(ll m, ll v) {
    return (m >> v) & 1;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> angry(n);
    forEach(angry) {
        cin >> it;
        it--;
    }
    vector<ll> cost(n);
    forEach(cost) cin >> it;
    vector<ll> add(n + m);
    forEach(add) cin >> it;
    for (ll i = 0; i < n; i++) {
        cost[i] = add[angry[i]] - cost[i];
    }
    ll ans = 0;
    for (ll ms = 0; ms < (1LL << n); ms++) {
        ll maxVal = INF;
        bool possible = true;
        for (ll k = 0; k < n; k++) {
            if (bit(ms, k)) {
                if (angry[k] > maxVal) {
                    possible = false;
                } else {
                    chMin(maxVal, angry[k]);
                }
            }
        }
        if (!possible) continue;
        map<ll, ll> cnt;
        ll nans = 0;
        for (ll k = 0; k < n; k++) {
            if (!bit(ms, k)) continue;
            nans += cost[k];
            ll anger = angry[k];
            while (cnt[anger]) {
                cnt[anger]--;
                nans += add[anger + 1];
                anger++;
            }
            cnt[anger]++;
        }
        chMax(ans, nans);
    }
    cout << ans << "\n";
}

int main() {
    FASTIO
    solve();
    return 0;
}