#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto tstart = chrono::high_resolution_clock::now();
#define tend chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(tend - tstart).count()

int n, m;
vector<int> li, si, ci;

bool pos(int mask) {
    vector<int> a;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            a.push_back(li[i]);
        }
    }
    for (int i = 0; i + 1 < a.size(); ++i) {
        if (a[i + 1] > a[i]) {
            return false;
        }
    }
    return true;
}

int getSi(int mask) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            ans += si[i];
        }
    }
    return ans;
}

void solve1() {
    cin >> n >> m;
    li.resize(n);
    si.resize(n);
    ci.resize(n + m);
    for (int &i : li) {
        cin >> i;
    }
    for (int &j : si) {
        cin >> j;
    }
    for (int &c : ci) {
        cin >> c;
    }
    int mx = 0;
    for (int mask = 0; mask < (1LL << (n + 1)); ++mask) {
        int pi = 0;
        if (pos(mask)) {
            //cout << "START\n";
            int s = getSi(mask);
            //cout << "Si: " << s << '\n';
            pi -= s;
            set<int> stage;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) {
                    //cout << i + 1 << ' ';
                    pi += ci[li[i] - 1];
                    int cur = li[i] - 1;
                    while (stage.find(cur) != stage.end()) {
                        stage.erase(cur);
                        cur++;
                        pi += ci[cur];
                    }
                    stage.insert(cur);
                }
            }
        }
       // cout << "\nPi: " << pi << '\n';
        mx = max(mx, pi);
    }
    cout << mx << '\n';
}

void solve2() {
    cin >> n >> m;
    li.resize(n);
    si.resize(n);
    ci.resize(n + m);
    for (int &i : li) {
        cin >> i;
    }
    for (int &j : si) {
        cin >> j;
    }
    for (int &c : ci) {
        cin >> c;
    }
    int mx = 0;
    sort(si.begin(), si.end());
    for (int i = 0; i < n; ++i) {
        int am = i;
        int s = 0;
        int cnt = 1;
        while (am != 0) {
            s += am * ci[cnt];
            am /= 2;
        }
        //cout << i << ' ' << s << '\n';
        mx = max(mx, s);
    }
    cout << mx;
}

void solve() {
    if (n <= 15 && m <= 15) {
        solve1();
    } else {
        solve2();
    }

}

int main() {
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
}