#include <iostream>
#include <vector>
#include <cstring>

using namespace std;

const int N = 2007, K = 16, L = 5, INF = 1e9 + 7;
int c[2 * N], dp[L][1 << K];
int a[N], s[N];

pair <int, int> eval(int mask, int pos) {
    int cost = c[a[pos]] - s[pos];
    for (int i = a[pos]; i < K; i++) {
        if (mask & (1 << i)) {
            cost += c[i + 1]; 
            mask -= (1 << i);
        } else {
            mask |= (1 << i);
            break;
        }
    }
    return {mask, cost};
}

void lazy(int n, int m) {
    int best = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        int cur = 0;
        vector <int> st;
        bool flag = 1;
        int mini = 100;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                if (a[i] > mini) {
                    flag = 0;
                    break;
                }
                mini = a[i];
                st.push_back(a[i]);
                cur += c[a[i]] - s[i];
                while ((int) st.size() >= 2) {
                    int sz = st.size();
                    if (st[sz - 1] == st[sz - 2]) {
                        int v = st[sz - 1];
                        st.pop_back();
                        st.pop_back();
                        st.push_back(v + 1);
                        cur += c[v + 1];
                    } else break;
                }
            }
        }
        if (flag) best = max(best, cur);
    }
    cout << best << endl;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int ans = 0;
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n + m; i++) cin >> c[i];
    if (n <= 15 && m <= 15) {
        lazy(n, m);
        return 0;
    }
    for (int i = 0; i < L; i++) {
        for (int j = 0; j < (1 << K); j++) {
            dp[i][j] = -INF;
        }
    }
    dp[4][0] = 0;
    for (int i = 0; i < n; i++) {
        for (int mask = (1 << K) - 1; mask >= 0; mask--) {
            auto [nmask, dans] = eval(mask, i);
            //cout << mask << ' ' << nmask << endl;
            for (int t = 0; t < L; t++) {
                if (a[i] > t || dp[t][mask] == -INF) continue;
                //cout << i << ' ' << t << ' ' << mask << ' ' << dp[t][mask] << endl;
                dp[a[i]][nmask] = max(dp[a[i]][nmask], dp[t][mask] + dans);
                ans = max(ans, dp[t][mask] + dans); 
            }
        }
    }
    cout << ans << endl;
    return 0;
}
