#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
#include <map>
#include <vector>
//#include <unordered_set>
#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
#include <queue>
//#include <utility>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

using ll = long long;
#define all(c) c.begin(),c.end()

size_t const ALLOC_MEM_CNT = 480 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_CNT];
size_t ALLOC_POS = ALLOC_MEM_CNT;

void *operator new(size_t n) {
    ALLOC_POS -= n;
    return ALLOC_MEM + ALLOC_POS;
}

void operator delete(void *) noexcept {}


//mt19937_64 rng(228);

void _tmain([[maybe_unused]] int test_id) {
    int n, m;
    cin >> n >> m;
    vector<int> hei(n);
    for (int &x : hei) {
        cin >> x;
        --x;
    }
    vector<int> cost(n);
    for (int &x: cost) { cin >> x; }
    vector<int> profit(n + m);
    for (int &x : profit) { cin >> x; }
    int ans = 0;
    if (n <= 15 && !DEV) {
        for (int mask = 0; mask < (1 << n); ++mask) {
            int res = 0;
            int cap = n + m + 1;

            vector<int> sk;

            for (int i = 0; i < n; ++i) {
                if (!(mask & (1 << i))) {
                    continue;
                }
                if (hei[i] > cap) {
                    res = -1e9;
                    break;
                }
                cap = hei[i];
                res -= cost[i];
                res += profit[hei[i]];
                int t = hei[i];
                while (!sk.empty() && sk.back() == t) {
                    sk.pop_back();
                    ++t;
                    res += profit[t];
                }
                sk.push_back(t);
            }
            ans = max(ans, res);
        }

        cout << ans << "\n";
        return;
    }
    sort(all(cost));
    int cur = 0;
    vector<int> stack;
    for (int c : cost) {
        cur -= c;
        cur += profit[0];
        int t = 0;
        while (stack.size() && stack.back() == t) {
            stack.pop_back();
            ++t;
            cur += profit[t];
        }
        stack.push_back(t);
        ans = max(ans, cur);
    }
    cout << ans << "\n";
}
