#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define INF32 2000000228
#define INF64 2e18
#define endl '\n'

const ll A1 = 1000000009,
         B1 = 1042022869;

int n, m;
vector<int> p;
vector<ll> a, t, h1, p1;
vector<bool> used;
vector< vector<int> > g;

void build(int v, int tl, int tr)
{
    if(tl == tr)
        t[v] = a[tl];
    else
    {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

ll get(int v, int tl, int tr, int l, int r)
{
    if(l > r)
        return 0;

    if(tl == l && tr == r)
        return t[v];

    int tm = (tl + tr) / 2;
    return (get(v * 2, tl, tm, l, min(r, tm)) +
            get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

void update(int v, int tl, int tr, int pos, ll val)
{
    if(tl == tr)
        t[v] = val;
    else
    {
        int tm = (tl + tr) / 2;
        if(pos <= tm)
            update(v * 2, tl, tm, pos, val);
        else
            update(v * 2 + 1, tm + 1, tr, pos, val);

        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

void segment_tree_main()
{
    cin >> n;
    a.resize(n);
    t.resize(4 * n);

    for(int i = 0; i < n; i++)
        cin >> a[i];

    build(1, 0, n - 1);

    cin >> m;
    while(m--)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int l, r;
            cin >> l >> r;
            l--; r--;
            cout << get(1, 0, n - 1, l, r) << endl;
        }
        else
        {
            int pos;
            ll val;
            cin >> pos >> val;
            pos--;
            update(1, 0, n - 1, pos, val);
        }
    }
}

void dfs(int v)
{
    cout << v + 1 << endl;
    used[v] = true;
    for(int i = 0; i < g[v].size(); i++)
        if(!used[ g[v][i] ])
            dfs(g[v][i]);
}

void dfs_main()
{
    for(int i = 0; i < n; i++)
        if(!used[i])
            dfs(i);
}

void bfs(int s)
{
    used[s] = true;
    vector<int> p(n, -1);
    vector<int> d(n, INF32);
    d[s] = 0;
    queue<int> q;
    q.push(s);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for(int i = 0; i < g[v].size(); i++)
        {
            int to = g[v][i];
            if(!used[to])
            {
                d[to] = d[v] + 1;
                p[to] = v;
                used[to] = true;
                q.push(to);
            }
        }
    }
}

void read_graph(bool oriented = false)
{
    cin >> n >> m;
    g.resize(n, vector<int>(0));
    used.resize(n, false);
    for(int i = 0; i < m; i++)
    {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        if(!oriented)
            g[v].push_back(u);
    }
}

int find_set(int v)
{
    if(v == p[v])
        return v;

    return v = find_set(p[v]);
}

void dsu_unit(int a, int b)
{
    a = find_set(a);
    b = find_set(b);

    if(a > b)
        swap(a, b);

    p[b] = a;
}

void dsu_main()
{
    cin >> n;
    p.resize(n);
    for(int i = 0; i < n; i++)
        p[i] = i;

    for(int i = 0; i < n; i++)
    {
        int a, b;
        cin >> a >> b;
        a--; b--;
        dsu_unit(a, b);
    }
}

bool isPrime(int x)
{
    for(int i = 2; i * i <= x; i++)
        if(x % i == 0)
            return false;

    return true;
}

void hash1(string s)
{
    h1.resize(n);
    p1.resize(n);
    p1[0] = 1;

    for(int i = 0; i < n; i++)
    {
        if(i)
            p1[i] = (p1[i - 1] * A1) % B1;
        h1[i] = (((ll)s[i] * p1[i]) + (i ? h1[i - 1] : (ll)0)) % B1;
    }
}

vector<int> l, c, s;
int arr[16][31][40001];
stack<int> f;

int dp(int i, int j, int mask)
{
    if(arr[i][j][mask])
        return arr[i][j][mask];

    if(i == n)
    {
        int ans = 0;
        int best = ans;
        if(l[n] <= j)
        {
            ans += c[ l[n] ];
            ans -= s[i];
            int cur = l[n];
            while(!f.empty() && cur == f.top())
            {
                cur++;
                ans += c[cur];
                f.pop();
            }
            f.push(cur);
        }

        arr[i][j][mask] = max(ans, best);
        return arr[i][j][mask];
    }

    if(l[i] > j)
    {
        arr[i][j][mask] = dp(i + 1, j, mask);
        return dp(i + 1, j, mask);
    }

    stack<int> cf = f;

    int ans = c[ l[i] ];
    ans -= s[i];
    int cur = l[i];
    while(!f.empty() && cur == f.top())
    {
        cur++;
        ans += c[cur];
        f.pop();
    }
    f.push(cur);

    ans += dp(i + 1, l[i], mask | (1 << (i - 1)));

    f = cf;
    arr[i][j][mask] = max(ans, dp(i + 1, j, mask));
    return arr[i][j][mask];
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    l.resize(n + 1);
    c.resize(n + m + 1);
    s.resize(n + 1);

    for(int i = 1; i <= n; i++)
        cin >> l[i];
    for(int i = 1; i <= n; i++)
        cin >> s[i];
    for(int i = 1; i <= n + m; i++)
        cin >> c[i];

    cout << dp(1, m, 0) << endl;

//    for(int i = 1; i <= n; i++)
//    {
//        for(int j = 1; j <= m; j++)
//            cout << arr[i][j] << ' ';
//        cout << endl;
//    }

    return 0;
}

/*
5 4
4 3 2 1 1
0 2 6 7 4
12 12 12 6 -3 -5 3 10 -4
*/

/*
5 4
4 3 1 2 1
1 2 1 2 1
1 2 3 4 5 6 7 8 9
*/
