#include <iostream>
#include <algorithm>
#include <queue>
#include <vector>
#include <set>
#include <map>

#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 2000;
const int MAXC = 5000;

const int INF = 1000000000000000000;

int n, m;
int l[MAXN], s[MAXC], c[2 * MAXN + 7];

int tr(int mask) {
    vector<int> part;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if ((mask >> i) & 1) {
            if (!part.empty() && part.back() < l[i]) {
                return -INF;
            }
            part.push_back(l[i]);
            ans -= s[i];
            ans += c[l[i]];
        }
    }
    while (!part.empty()) {
        int k = part.back();
        int cnt_k = 1;
        part.pop_back();
        while (!part.empty() && part.back() == k) {
            ++cnt_k;
            part.pop_back();
        }
        ans += c[k + 1] * (cnt_k / 2);
        for (int i = 0; i < cnt_k / 2; ++i) {
            part.push_back(k + 1);
        }
    }
    return ans;
}

void solve1() {
    int ans = -INF;
    for (int mask = 0; mask < 1 << n; ++mask) {
        ans = max(ans, tr(mask));
    }
    cout << ans << '\n';
}

void solve2() {
    sort(s, s + n);
    int ans = 0;
    int sum = 0;
    queue<int> q;
    int cur_ans = 0;
    for (int i = 0; i < n; ++i) {
        sum += s[i];
        int cur_c = 1;
        while (!q.empty() && q.front() == cur_c) {
            q.pop();
            ++cur_c;
            cur_ans += c[cur_c];
        }
        q.push(cur_c);
        if (cur_c == 1) {
            cur_ans += c[1];
        }
        ans = max(ans, cur_ans - sum);
    }
    cout << ans << '\n';
}

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    //freopen("input.txt", "r", stdin);
    cin >> n >> m;

    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i <= n + m; ++i) {
        cin >> c[i];
    }
    if (m == 1) {
        solve2();
        return 0;
    }
    solve1();
    return 0;
}