#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("O3")
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
#include <map>
#include <vector>
//#include <unordered_set>
#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
#include <queue>
//#include <utility>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

using ll = long long;
#define all(c) c.begin(),c.end()

//mt19937_64 rng(228);

int n, m;
vector<int> hei, cost, profit;

int ans;

void solve(int pos, int cap, vector<int> st, int cur) {
    if (cur > ans) {
        ans = cur;
    }
    if (pos == n) {
        return;
    }
    solve(pos + 1, cap, st, cur);
    if (cap < hei[pos]) { return; }
    int t = hei[pos];
    cur -= cost[pos];
    cur += profit[t];
    while (!st.empty() && st.back() == t) {
        st.pop_back();
        ++t;
        cur += profit[t];
    }
    st.push_back(t);
    solve(pos + 1, hei[pos], st, cur);

}

void _tmain([[maybe_unused]] int test_id) {
    $ {
        hei.clear();
        cost.clear();
        profit.clear();
        ans = 0;
    }
    cin >> n >> m;
    hei.resize(n);
    for (int &x : hei) {
        cin >> x;
        --x;
    }
    cost.resize(n);
    for (int &x: cost) { cin >> x; }
    profit.resize(n + m);
    for (int &x : profit) { cin >> x; }
    if (m > 1) {
        solve(0, n + m + 1, vector<int>(), 0);

        cout << ans << "\n";
        return;
    }
    sort(all(cost));
    int cur = 0;
    vector<int> stack;
    for (int c : cost) {
        cur -= c;
        cur += profit[0];
        int t = 0;
        while (stack.size() && stack.back() == t) {
            stack.pop_back();
            ++t;
            cur += profit[t];
        }
        stack.push_back(t);
        ans = max(ans, cur);
    }
    cout << ans << "\n";
}
