#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <ctime>

using namespace std;

typedef int64_t ll;

const ll N = 30;

ll n, m;
vector<ll> id;
vector<ll> s;
vector<ll> a;
vector<ll> c;

struct Kek {
	bitset<N> used;
	ll cost, last;

	Kek() {
		cost = 0;
		last = 1e9;
	}

	Kek(Kek& kek, ll id) {
		used = kek.used;
		cost = kek.cost;
		last = a[id];
		ll t = a[id];
		cost += c[t];
		cost -= s[id];
		while (used[t]) {
			used[t] = 0;
			++t;
			cost += c[t];
		}
		used[t] = 1;
	}

	bool operator <(const Kek& other) const {
		for (ll i = 0; i < N; ++i) {
			if (used[i] != other.used[i]) {
				return used[i];
			}
		}
		return cost > other.cost;
	}

	bool operator ==(const Kek& other) {
		return used == other.used;
	}
};

ll solve() {
	vector<Kek> dp(1);
	for (ll i = 0; i < n; ++i) {
		ll sz = (ll)dp.size();
		for (ll j = 0; j < sz; ++j) {
			if (dp[j].last < a[i]) {
				continue;
			}
			dp.emplace_back(dp[j], i);
		}
		stable_sort(dp.begin(), dp.end());
		dp.resize(unique(dp.begin(), dp.end()) - dp.begin());
		if (dp.size() > 1'666) {
			sort(dp.begin(), dp.end(), [](Kek a, Kek b) {
				return a.cost > b.cost;
			});
		}
		dp.resize(1'666);
	}
	ll result = 0;
	for (auto& i : dp) {
		result = max(result, i.cost);
	}
	return result;
}

ll solve1() {
	Kek null;
	ll result = 0;
	for (ll st = 0; st < n; ++st) {
		if (clock() > CLOCKS_PER_SEC * 1.6) {
			break;
		}
		vector<Kek> dp(1, Kek(null, st));
		for (ll i = st + 1; i < n; ++i) {
			if (clock() > CLOCKS_PER_SEC * 1.6) {
				break;
			}
			ll sz = (ll)dp.size();
			for (ll j = 0; j < sz; ++j) {
				if (dp[j].last < a[i]) {
					continue;
				}
				dp.emplace_back(dp[j], i);
			}
			stable_sort(dp.begin(), dp.end());
			dp.resize(unique(dp.begin(), dp.end()) - dp.begin());
			if (dp.size() > 666) {
				sort(dp.begin(), dp.end(), [](Kek a, Kek b) {
					return a.cost > b.cost;
				});
				dp.resize(333);
			}
		}
		for (auto& i : dp) {
			result = max(result, i.cost);
		}
	}
	return result;
}

int main() {
	cin >> n >> m;
	a.resize(n);
	for (ll& i : a) {
		cin >> i;
		--i;
	}
	s.resize(n);
	for (ll& i : s) {
		cin >> i;
	}
	c.resize(n + m);
	for (ll& i : c) {
		cin >> i;
	}

	cout << max(solve(), solve1()) << endl;

	return 0;
}