﻿#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

const int lg = 2;

struct kek {
    vector<int> mask;
    int len1;
    kek() {
        mask.resize(lg);
        len1 = 0;
    }
    void cut() {
        int pos = -1;
        for (int i = lg; i < (int)mask.size(); i++) {
            if (mask[i] == 0) {
                pos = i;
                break;
            }
        }
        if (pos != -1) len1 = pos - lg;
        else len1 += (int)mask.size() - lg;
        mask.resize(lg);
    }
    void extend(int delta) {
        reverse(mask.begin(), mask.end());
        mask.resize(mask.size() + min(delta, lg));
        /*for (int i = 0; i < min(delta, lg + 2); i++) mask.push_back(0);*/
        reverse(mask.begin(), mask.end());
        cut();
    }
    int plus1() {
        int pos = -1;
        for (int i = 0; i < lg; i++) {
            if (mask[i] == 1) mask[i] = 0;
            else {
                mask[i] = 1;
                pos = i;
                break;
            }
        }
        if (pos == -1) {
            pos = lg + len1;
            len1 = 0;
        }
        else {
            cut();
        }
        return pos;
    }
};

bool operator <(kek a, kek b) {
    return make_pair(a.mask, a.len1) < make_pair(b.mask, b.len1);
}

//void print(vector<int> &mask) {
//    for (int i = 0; i < (int)mask.size(); i++) cout << mask[i] << ' ';
//    cout << endl;
//}

int main()
{
    //ifstream cin("input.txt");
    int n, m;
    cin >> n >> m;
    vector<int> l(n + 1, m);
    for (int i = 0; i < n; i++) cin >> l[i + 1], l[i + 1]--;
    vector<int> s(n);
    for (int i = 0; i < n; i++) cin >> s[i];
    vector<int> c(n + m);
    for (int i = 0; i < n + m; i++) cin >> c[i];
    vector<ll> pref(n + m + 1);
    for (int i = 0; i < n + m; i++) {
        pref[i + 1] = pref[i] + c[i];
    }
    vector<map<kek, ll> > dp(n + 1);
    kek mask0;
    dp[0][mask0] = 0;
    for (int i = 0; i < n; i++) {
        //cout << "i = " << i << endl;
        int cnt = 0;
        for (auto &elem : dp[i]) {
            cnt++;
            if (cnt > 50) break;
            auto mask = elem.first;
            //cout << "mask: ";
            //print(mask);
            ll val = elem.second;
            /*for (int nxt = l[i]; nxt >= 0; nxt--) {*/
            for (int j = i + 1; j <= n; j++) {
                if (l[j] > l[i]) continue;
                auto mask1 = mask;
                mask1.extend(l[i] - l[j]);
                int len = mask1.plus1();
                //cout << "mask1: ";
                //print(mask1);
                ll delta = pref[l[j] + len + 1] - pref[l[j]] - s[j - 1];
                if (dp[j].find(mask1) == dp[j].end() || dp[j][mask1] < val + delta) {
                    dp[j][mask1] = val + delta;
                }
            }
        }
    }
    ll ans = 0;
    for (int i = 0; i <= n; i++) {
        for (auto &elem : dp[i]) {
            ans = max(ans, elem.second);
        }
    }
    cout << ans << endl;
}
