#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <string>
#include <ctime>

using namespace std;

const int INF = 1'000'000'000;

long long get_cost(int cnt_uno, vector <int>& c) {
	long long ans = 0;
	int pos = 0;
	while (cnt_uno > 0) {
		ans += c[pos++] * cnt_uno;
		cnt_uno /= 2;
	}
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector <int> l(n), s(n);
	for (auto& u : l)
		cin >> u, u--;
	for (auto& u : s)
		cin >> u;
	vector <int> c(n + m);
	for (auto& u : c)
		cin >> u;
	if (n <= 15) {
		long long ans = 0;
		for (int mask = 0; mask < (1 << n); mask++) {
			long long cost = 0;
			int prev = 20'001;
			bool cor = 1;
			for (int i = 0; i < n; i++) {
				if (mask & (1 << i)) {
					if (l[i] > prev)
						cor = 0;
					prev = l[i];
				}
			}
			if (!cor) continue;
			for (int i = 0; i < n; i++) {
				if (mask & (1 << i))
					cost -= s[i];
			}
			vector <int> st;
			for (int i = 0; i < n; i++) {
				if (mask & (1 << i)) {
					cost += c[l[i]];
					int val = l[i];
					while (st.size() && st.back() == val) {
						st.pop_back();
						cost += c[++val];
					}
					st.push_back(val);
				}
			}
			ans = max(ans, cost);
		}
		cout << ans;
		return 0;
	}
	if (m == 1) {
		sort(s.begin(), s.end());
		long long ans = 0, sum = 0;
		for (int i = 0; i < n; i++) {
			sum += s[i];
			long long cur_ans = -sum;
			int cnt = i + 1, pos = 0;
			while (cnt > 0) {
				cur_ans += c[pos++] * cnt;
				cnt /= 2;
			}
			ans = max(ans, cur_ans);
		}
		cout << ans;
		return 0;
	}
	
	vector <int> min_cost2(2 * n + 1, INF);
	vector <int> min_cost1(2 * n + 1, INF);
	for (int i = 0; i < n; i++) {
		if (l[i] == 1) {
			int cost = s[i] + 2 * c[0];
			for (int i = 2; i < min_cost2.size(); i++) {
				min_cost2[i] = min(min_cost2[i - 2] + cost, min_cost2[i]);
			}
		}
		else {
			int cost = s[i];
			for (int i = 1; i < min_cost1.size(); i++) {
				min_cost1[i] = min(min_cost1[i - 1] + cost, min_cost1[i]);
				min_cost1[i] = min(min_cost2[i - 1] + cost, min_cost1[i]);
			}
		}
	}
	long long ans = 0;
	for (int i = 0; i < 2 * n + 1; i++) {
		ans = max(ans, get_cost(i, c) - min(min_cost1[i], min_cost2[i]));
	}
	cout << ans;
}