#include <iostream>
#include <cstdint>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <vector>
#include <cassert>
#include <unordered_set>
using namespace std;

class solver1
{
private:
    vector<int32_t> l, s, c;

public:
    solver1 (uint32_t n, uint32_t m)
    {
        assert(n<=15 && m<=15);

        l.resize(n);
        s.resize(n);
        c.resize(n+m);

        for(uint32_t i=0; i<n; i++)
            cin>>l[i];

        for(uint32_t i=0; i<n; i++)
            cin>>s[i];

        for(uint32_t i=0; i<n+m; i++)
            cin>>c[i];
    }

    int32_t solve (uint32_t n=0, int32_t max_agr=INT32_MAX, unordered_set<int32_t> us={})
    {
        if(n==l.size())
            return 0;

        int32_t res=solve(n+1, max_agr, us);

        if(max_agr>=l[n])
        {
            int32_t cur = c[l[n]-1] - s[n];
            auto it = us.find(l[n]);
            if(it != us.end())
            {
                us.erase(it);
                us.insert(l[n]+1);
                cur += c[l[n]+1-1];
                if(max_agr==INT32_MAX)
                    max_agr=l[n]+1;
                else
                    max_agr = max<int32_t>(max_agr, l[n]+1);
            }
            else
            {
                us.insert(l[n]);
                if(max_agr==INT32_MAX)
                    max_agr=l[n];
                else
                max_agr = max<int32_t>(max_agr, l[n]);
            }
            cur += solve(n+1, max_agr, us);

            res = max(res, cur);
        }

        return res;
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n, m;
    cin>>n>>m;

    solver1 sol(n, m);
    cout<<sol.solve()<<endl;

    return 0;
}