#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int n, m;
vector<ll> agg;
vector<ll> price;
vector<ll> value;

ll profit(ll big, ll small)
{
    ll ans = 0;

    vector<ll> num(m + 20, 0);
    num[1] = big;
    ans += big * value[1];

    for (int i = 0; i < num.size(); i++)
    {
        num[i + 1] += num[i] / 2;
        ans += (num[i] / 2) * value[i + 1];
    }

    num[0] += small;
    ans += small * value[0];

    for (int i = 0; i < num.size(); i++)
    {
        num[i + 1] += num[i] / 2;
        ans += (num[i] / 2) * value[i + 1];
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;

    agg.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> agg[i];
        agg[i]--;
    }

    price.resize(n);
    for (int i = 0; i < n; i++)
        cin >> price[i];

    value.resize(n + m);
    for (int i = 0; i < n + m; i++)
        cin >> value[i];

    if (m == 1)
    {
        sort(price.begin(), price.end());

        ll ans = 0;
        ll psum = 0;
        for (int i = 0; i < n; i++)
        {
            psum += price[i];
            ans = max(ans, profit(0, i + 1) - psum);
        }

        cout << ans << endl;
        return 0;
    }

    if (m == 2)
    {
        vector<vector<vector<ll>>> dp(n + 1,
                vector<vector<ll>>(1 << 16, vector<ll>(2, -9e18)));
        dp[0][0][1] = 0;

        vector<ll> pfx(n + m + 1, 0);
        for (int i = 0; i < n + m; i++)
            pfx[i + 1] = pfx[i] + value[i];

        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < (1 << 16); j++)
            {
                if (dp[i][j][0] == -9e18 && dp[i][j][1] == -9e18)
                    continue;

                dp[i + 1][j][0] = max(dp[i + 1][j][0], dp[i][j][0]);
                dp[i + 1][j][1] = max(dp[i + 1][j][1], dp[i][j][1]);

                if (j + (1 << agg[i]) < (1 << 16))
                {
                    ll delta = -price[i];
                    ll ones = 0;
                    for (int k = agg[i];; k++)
                    {
                        if (j & (1 << k))
                            ones++;
                        else
                            break;
                    }

                    delta += pfx[min((ll)(n + m), agg[i] + ones + 1)] - pfx[agg[i]];

                    if (agg[i] == 0)
                    {
                        dp[i + 1][j + (1 << agg[i])][0] = max(
                                dp[i + 1][j + (1 << agg[i])][0], dp[i][j][0] + delta);
                        dp[i + 1][j + (1 << agg[i])][0] = max(
                                dp[i + 1][j + (1 << agg[i])][0], dp[i][j][1] + delta);
                    }
                    else
                    {
                        dp[i + 1][j + (1 << agg[i])][1] = max(
                                dp[i + 1][j + (1 << agg[i])][1], dp[i][j][1] + delta);
                    }
                }
            }
        }

        ll ans = 0;
        for (int j = 0; j < (1 << 16); j++)
            for (int k = 0; k < 2; k++)
                ans = max(ans, dp[n][j][k]);

        cout << ans << endl;
        return 0;
    }

    ll ans = -9e18;
    for (int mask = 0; mask < (1 << n); mask++)
    {
        ll cur = 0;
        vector<int> stage(n + m, 0);
        ll ltook = 9e18;
        for (int i = 0; i < n; i++)
        {
            if (((1 << i) & mask) == 0)
                continue;
            if (agg[i] > ltook)
                cur = -9e18;

            stage[agg[i]]++;
            ltook = agg[i];
            cur += value[agg[i]];
            cur -= price[i];

            for (int j = 0; j < n + m - 1; j++)
            {
                if (stage[j] == 2)
                {
                    stage[j] = 0;
                    stage[j + 1]++;
                    cur += value[j + 1];
                }
            }
        }

        ans = max(ans, cur);
    }

    cout << ans << endl;

    return 0;
}