#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>
#include <functional>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}
constexpr int INF = 1e9;
constexpr int N = 2001;

struct Fen {
    int n;
    vector<int> t;

    Fen(int n) : n(n), t(n) {}

    void clear() {
        t.assign(n, 0);
    }

    void upd(int i, int v) {
        for (; i < n; i = (i | (i + 1))) {
            t[i] += v;
        }
    }

    int get(int i) {
        int res = 0;
        for (i = min(i, n - 1); i >= 0; i = (i & (i + 1)) - 1) {
            res += t[i];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Tree {
    int n;
    vector<int> t;

    Tree() : n(N), t(2 * N, INF) {}

    void upd(int i, int val) {
        i += n;
        t[i] = val;
        for (i /= 2; i > 0; i /= 2) {
            t[i] = min(t[2 * i], t[2 * i + 1]);
        }
    }

    int get(int l, int r) {
        int res = INF;
        for (l += n, r += n; l < r; l /= 2, r /= 2) {
            if (l % 2) {
                res = min(res, t[l++]);
            }
            if (r % 2) {
                res = min(res, t[--r]);
            }
        }
        return res;
    }
} trees[N];


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    int m = input();

    vector<int> l(n), s(n), c(n + m);
    for (int &i : l) {
        i = input() - 1;
    }
    for (int &i : s) {
        cin >> i;
    }
    for (int &i : c) {
        cin >> i;
    }
    if (n <= 15) {
        int ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask) {
            bool good = true;
            int res = 0;
            vector<int> cur;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) {
                    if (cur.empty() || cur.back() >= l[i]) {
                        cur.emplace_back(l[i]);
                        res -= s[i];
                    } else {
                        good = false;
                        break;
                    }
                }
            }
            vector<int> st;
            for (int agr : cur) {
                res += c[agr];
                while (!st.empty() && st.back() == agr) {
                    st.pop_back();
                    ++agr;
                    res += c[agr];
                }
                st.emplace_back(agr);
            }
            if (good) {
                ans = max(ans, res);
            }
        }
        cout << ans << endl;
        return 0;
    }

    vector<int> sum(n + 1);
    vector<int> cur;
    for (int cnt = 1; cnt <= n; ++cnt) {
        sum[cnt] = sum[cnt - 1];
        int agr = 0;
        sum[cnt] += c[agr];
        while (!cur.empty() && cur.back() == agr) {
            cur.pop_back();
            ++agr;
            sum[cnt] += c[agr];
        }
    }
    int ans = 0;
    trees[0].t.assign(2 * N, 0);
    for (int i = 0; i < n; ++i) {
        for (int cnt = 1; cnt <= n; ++cnt) {
            int min_val = trees[cnt - 1].get(l[i], m + 1) + s[i];
            trees[cnt].upd(l[i], min_val);
            ans = max(ans, sum[cnt] - min_val);
        }
    }
    cout << ans << endl;
}
